#ifndef DRAW_ANIMATE
#define DRAW_ANIMATE

#pragma once
#include "stdafx.h"

class CDrawAnimate :
	public hgeItemContainer
{
protected:
	MySprite	*m_pSprite;
private:
	float		m_fSpriteWidth;
	float		m_fSpriteHeight;
	float       m_fFrameWidth;
	float		m_fFrameHeight;
	DWORD		m_dwFrame;
	DWORD		m_dwSpeed;
	BYTE		m_cbShowFrame;
protected:
	hgePoint	m_hgePoint;
	bool		m_bStart;
	bool		m_bRun;
	bool		m_bSice;
	bool		m_bShowFrame;
protected:
	bool		m_bInit;
	std::string		m_StrFile;
	HGE			*m_phge;				//hge
	HTEXTURE	m_Texture;
public:
	FEvent_Void       _IsStop;
public:
	CDrawAnimate(const tstring& strName);
public:
	~CDrawAnimate(void);
public:
	void InitAnimate(HTEXTURE tex,float nWidth,float nHeight,DWORD dwFrame,bool bRun=true,bool bSice=false);
	void InitAnimate(const char*  StrFile,float nWidth,float nHeight,DWORD dwFrame);
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	void SetPoint(hgePoint point);
	DWORD UpData();
	void Stop();
	void Start();
	void SetShowFrame(bool bShowFrame,BYTE cbShowFrame);
	void FrameFree();
	bool IsStart(){return m_bStart;}
};
#endif