#include "StdAfx.h"
#include "DrawAnimateEx.h"

CDrawAnimateEx::CDrawAnimateEx(void)
{
	m_dwXFrame=0;
	m_dwYFrame=0;
	m_dwXIndex=0;
	m_dwYIndex=0;
	m_dwItemWidth=0;
	m_dwItemHeight=0;
	m_bShowAnimate=false;
}

CDrawAnimateEx::~CDrawAnimateEx(void)
{
}
void CDrawAnimateEx::InitAnimate(const char *filename,DWORD dwRow,DWORD dwTier)
{
	m_ImageAnimate.LoadImage(filename);
	m_dwXFrame=dwRow;
	m_dwYFrame=dwTier;
	m_dwItemWidth=m_ImageAnimate.GetWidth()/m_dwXFrame;
	m_dwItemHeight=m_ImageAnimate.GetHeight()/m_dwYFrame;
}
void CDrawAnimateEx::DrawAnimate(float dwXPos,float dwYPos)
{
	if(m_bShowAnimate)
	{
		m_ImageAnimate.DrawImage(dwXPos,dwYPos,m_dwItemWidth,m_dwItemHeight,m_dwItemWidth*m_dwXIndex,
			m_dwItemHeight*m_dwYIndex);
	}
}
bool CDrawAnimateEx::UpData(bool bRun)
{
	if(!m_bShowAnimate)
		return false;
	m_dwXIndex++;
	if(m_dwXIndex==m_dwXFrame)
	{
		m_dwYIndex++;
		m_dwXIndex=0;
		if(m_dwYIndex==m_dwYFrame)
		{
			m_dwXIndex=0;
			m_dwYIndex=0;
			if(!bRun)
			{
				m_bShowAnimate=false;
				return true;
			}
		}
	}

	return false;
}
void CDrawAnimateEx::ShowAnimate()
{
	m_bShowAnimate=true;
}
void CDrawAnimateEx::HideAnimate()
{
	m_dwXIndex=0;
	m_dwYIndex=0;
	m_bShowAnimate=false;
}