#ifndef DRAW_ANIMATE_EX
#define DRAW_ANIMATE_EX

#pragma once

class CDrawAnimateEx
{
protected:
	CHgeImage		m_ImageAnimate;
	DWORD			m_dwXFrame;
	DWORD			m_dwYFrame;
	DWORD			m_dwXIndex;
	DWORD			m_dwYIndex;
	float			m_dwItemWidth;
	float			m_dwItemHeight;
public:
	bool			m_bShowAnimate;
public:
	CDrawAnimateEx(void);
	~CDrawAnimateEx(void);
public:
	void InitAnimate(const char *filename,DWORD dwRow,DWORD dwTier);
	void DrawAnimate(float dwXPos,float dwYPos);
	bool UpData(bool bRun=false);
public:
	void ShowAnimate();
	void HideAnimate();
	bool GetShow(){return m_bShowAnimate;}
	float GetItemWidth(){return m_dwItemWidth;}
	float GetItemHeight(){return m_dwItemHeight;}
};
#endif