#include "StdAfx.h"
#include "DrawBell.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////////
//캯
CBellFlash::CBellFlash()
{
	m_nItemWidth=0;
	m_nItemHeight=0;
	m_pBellImage=NULL;
}

//
CBellFlash::~CBellFlash()
{
}
//Դ
bool CBellFlash::LoadResource(HTEXTURE tex,float cbWidth,float cbHeight)
{

	//Դ
	m_pBellImage=new MySprite(tex,0,0,cbWidth,cbHeight);

	//ñ
	m_nItemHeight=(int)m_pBellImage->GetHeight();
	m_nItemWidth=(int)(m_pBellImage->GetWidth()/12);
	m_pBellImage->SetBlendMode(BLEND_DEFAULT);

	return true;
}

//ͷԴ
bool CBellFlash::DestroyResource()
{
	//ñ
	m_nItemWidth=0;
	m_nItemHeight=0;

	if(m_pBellImage)
		delete m_pBellImage;
	return true;
}

//滭˿
bool CBellFlash::DrawCardItem(BYTE cbIndex, float xDest, float yDest)
{
	m_pBellImage->SetTextureRect((float)((cbIndex)*m_nItemWidth),0,
		(float)m_nItemWidth,(float)m_nItemHeight);
	m_pBellImage->Render(xDest,yDest);

	return true;
}
//
//////////////////////////////////////////////////////////////////////////
//캯
CBellResource::CBellResource()
{
}

//
CBellResource::~CBellResource()
{
}
//Դ
bool CBellResource::LoadResource()
{
	HTEXTURE tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexBell");
	m_BellFlash.LoadResource(tex,1200,80);
	return true;
}

//Դ
bool CBellResource::DestroyResource()
{
	m_BellFlash.DestroyResource();
	return true;
}
//////////////////////////////////////////////////////////////////////////
CDrawBell::CDrawBell(const tstring& strName)
: hgeItemContainer(strName)
{
	m_dwFrame=12;
	m_dwSpeed=0;
	m_hgePoint=hgePoint(0,0);
	m_bStart=false;
	m_bStop=false;
}

CDrawBell::~CDrawBell(void)
{
}
void CDrawBell::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	g_BellResource.m_BellFlash.DrawCardItem(m_dwSpeed,m_hgePoint.x,m_hgePoint.y);
}
void CDrawBell::SetPoint(hgePoint point)
{
	m_hgePoint=point;
}
void CDrawBell::UpData()
{
	if(m_bStart)
	{
		m_dwSpeed++;
		if(m_dwSpeed>=m_dwFrame)
		{
			m_dwSpeed=0;
			if(m_bStop)
				m_bStart=false;
		}
	}
}
void CDrawBell::Start()
{
	m_bStart=true;
	m_dwSpeed=0;
	m_bStop=false;
}
void CDrawBell::Stop()
{
	m_bStop=true;
	m_dwSpeed=0;
}

//////////////////////////////////////////////////////////////////////////

//
 CBellResource				g_BellResource;						//˿Դ

//////////////////////////////////////////////////////////////////////////