#ifndef DARW_TIMER
#define DARW_TIMER

#pragma once
#include "Stdafx.h"
#include "Resource.h"
#include "DrawAnimate.h"

class CDrawTimer :
	public hgeItemContainer
{
	CDrawAnimate *m_pSTimeBack;
	MySprite *m_pSTimeNumber;
	hgePoint m_HgeTimePoint;
	MySprite *m_pMeNumber;
	MySprite *m_pNTimeBack;
	MySprite *m_pNTimeNumber;
	bool	m_bEndPlay;
	UINT	m_nTimer[GAME_PLAYER];
public:
	CDrawTimer(const tstring& strName);
public:
	~CDrawTimer(void);
	void InitTime();
	void UpDataTimer(WORD wTime,WORD wChairID,bool bEndPlay);
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	void UpData();
	void SetTimePoint(hgePoint hPoint);
	void DrawTimer(float nXPos,float nYPos,WORD wTime);
	void DrawNTimer(float nXPos,float nYPos,WORD wTime);
	void DrawMeTimer(float nXPos,float nYPos,WORD wTime);
};
#endif