#pragma once

typedef hgeAnimate<hgeItemFrames>			FramesAnimate;
typedef hgeAnimate<hgeItemBase>				ItemBaseAnimate;
typedef hgeAnimate<hgeItemImageLabel>    ImageLabelAnimate;
typedef hgeAnimate<hgeItemImage>           SingleImageAnimate;


class  TL_FrameAnimate
{
    DECLARE_SIMPLE_SINGLETON(TL_FrameAnimate)

public:
    TL_FrameAnimate();

	//@@õ֡
    hgeAnimateController * GetFramesAnimate( hgeItemBase * pRef, const std::string & id, FramesAnimate * pAni );

    hgeAnimateController * GetFramesAnimate( const hgePoint & pos, const std::string & id, FramesAnimate * pAni );

    const std::string GetAniID( int effId ) const;

	//@@ һͼƬ
    SingleImageAnimate * CreateSingleImageAni( const std::string & defineName, const std::string & aniName = "", 
        const std::string & widgetName = "", const ParaList * paras = NULL, bool bManaged = true );

private:
    FramesAnimate * GetFramesAni();

    hgeAnimateController * GetFramesAnimate( hgeAnimateController * pAni, const std::string & id, const ParaList * paras );

private:
    FramesAnimate * m_pFrameAni;
};


