
/*
:˵
*/

#pragma  once

#include "CardFile.h"
#include "DrawTimer.h"
#include "SiceContainer.h"
#include "ControlWnd.h"
#include "GameScore.h"
#include "DrawAnimate.h"
#include "GfxFont.h"
#include "FrameAnimate.h"
#include "GroupAnimate.h"
#include "DrawBell.h"
#include "GameOption.h"
#include "DrawMessage.h"
#include "SetCellScore.h"
#include "EndPlay.h"
#include "DrawAnimateEx.h"

//////////////////////////////////////////////////////////////////////////
//ͼλ
#define MYSELF_VIEW_ID				1									//ͼλ
//////////////////////////////////////////////////////////////////////////

struct tagMoveCardItem
{
	CPoint			ptFrom;												//ʼλ
	CPoint			ptTo;												//λ
	WORD			wViewChairId;										//ƻͼλ
	BYTE			cbCardData;											//ƻ
	BYTE			cbCardCount;										//
	float			fScaleStart;
	float			fScaleEnd;
};
struct tagTingInfo
{
	BYTE			cbCardData;
	DWORD			cbFan;
	BYTE			cbCardCount;
};
class  TL_GBaseContainer :public hgeItemContainerEx
{
public:
	TL_GBaseContainer(const tstring &strname, const std::string & group );
	~TL_GBaseContainer();
private:
	HGE							*m_phge;				//hge
	ULONG						m_nTestTimerID;			//ʱID
	ULONG						m_nTrusteeID;
//	ULONG						m_nMoveCardID;
//	ULONG						m_nEfectID;
	//ULONG						m_nDiscID;
	ULONG						m_nCutCardID;
	ULONG						m_nUpDataID;
	ULONG						m_nActionID;
	ULONG						m_nActionBackID;
	ULONG						m_nCardActionID;
	ULONG						m_nChiHuID;
	ULONG						m_nZiMoID;
	ULONG						m_nUserFlashID;
	ULONG						m_nUserActionID;
	ULONG						m_nSystemID;
	ULONG						m_nShowSystemID;
	//ULONG						m_nBGM1ID;
	//ULONG						m_nBGM2ID;
	//ULONG						m_nBGM3ID;
	ULONG						m_nFlashID;
	ULONG						m_nMyFlashID;
	ULONG						m_nTingID[GAME_PLAYER];
	bool						m_bMoveCardID;
public:
	BYTE						m_cbRobotUpdata;
	BYTE						m_cbRobotIndex;
	BYTE						m_cbUserFlash;
	BYTE						m_cbUserIndex;
	BYTE						m_cbUserType;
private:
	float						m_wCount;
	float						m_fWidth;
	float						m_fHeight;
	//UINT						m_nTimer[GAME_PLAYER];
	//GfxFont						*m_pGfxNameFont;
protected:
	hgeItemImage				*m_pViewFront;
public:
	FEvent_Void					m_ActionFinish;
	FEvent_Void					m_Trustee;
	FEvent_Void					m_Continue;
	FEvent_Void					m_Esc;
	FEvent_Void					m_RightButtonDown;
	FEvent_Void					m_MyRedOver;
	FEvent_PInt					m_Redouble;
private:
	MySprite					*m_pUserReady;
//	MySprite					*m_pUserTrustee;
//	MySprite					*m_pUserTrusteeS;
	MySprite					*m_pUserFlag;
	MySprite					*m_pOutCard;
	MySprite					*m_pWaitOther;
	MySprite					*m_pHuangZhuang;
	MySprite					*m_pCellBack;
	MySprite					*m_pCellInfo;
	MySprite					*m_pCellNumber;
	MySprite					*m_pWhiteNumber;
	MySprite					*m_pYellowNumber;
	MySprite					*m_pReplaceCard;
	MySprite					*m_pReplaceNum;
	MySprite					*m_pNameBack;
	//MySprite					*m_pBelle[2];
private:
	GfxFont						*m_pGfxFont;
	GfxFont						*m_pGfxNameFont;
	GfxFont						*m_pNumberFont;
public:
	//frame btns start
	hgeItemButton				*m_pframebtnEmotion;
	hgeItemButton				*m_pframebtnBugle;
	hgePoint					m_ptEmotion;
	hgeRect						m_rcEmotion;
	hgePoint					m_ptBugle;
	hgeRect						m_rcBugle;
	hgePoint					m_ptStartStustee;
	hgeRect						m_rcStartStustee;
	hgePoint					m_ptStopStustee;
	hgeRect						m_rcStopStustee;
	hgeRect						m_rcSetCell;
	//frame btns end

	hgeItemButton				*m_pStartButton;
	CWeaveCard					*m_pWeaveCard[GAME_PLAYER][MAX_WEAVE];
	CUserCard					*m_pUserCard;
	CDiscardCard				*m_pDiscardCard[GAME_PLAYER];
	CTableCard					*m_pTableCard[GAME_PLAYER];
	CHeapCard					*m_pHeadCard[GAME_PLAYER];
	CCardControl				*m_pHandCard;			//˿
	CSiceContainer				*m_pSiceContainer;
	CDrawTimer					*m_pUserTimer;
	CControlWnd					*m_pControlWnd;
	CGameOption					*m_pGameOption;
protected:
	bool						m_bShowHead;
public:
	CHgeButton					m_btStartStustee;
	CHgeButton					m_btStopStustee;
	CHgeButton					m_btChiHuCue;
private:
	CRect						m_rcChiHuCue;
	CRect						m_rcHandCard;
public:
	CHgeImage					m_ImageManOneS;
	CHgeImage					m_ImageManOneT;
	CHgeImage					m_ImageManTwoS;
	CHgeImage					m_ImageManTwoT;
	CHgeImage					m_ImageWomanOneS;
	CHgeImage					m_ImageWomanOneT;
	CHgeImage					m_ImageWomanTwoS;
	CHgeImage					m_ImageWomanTwoT;
	CHgeImage					m_ImageStartCue;
	CHgeImage					m_ImageNameBack;
public:
	CEndPlay					*m_pEndPlay;
	CGameScore					*m_pGameScore;
private:
	Util::FileConfigManager		m_SystemMessage;
	BYTE						m_cbSysIndex;
public:
	CDrawMessage				*m_pDrawMessage;
	CSetCellScore				*m_pSetCellScore;
public:
	CDrawAnimateEx				m_ActionBack;
	CDrawAnimateEx				m_ActionChiHu;
public:
	CHgeImage					m_ImageChi;
	CHgeImage					m_ImagePeng;
	CHgeImage					m_ImageGang;
	CHgeImage					m_ImageZiMo;
private:
	float						m_fXChi;
	float						m_fYChi;
private:
	const tagUserInfo			*m_pUserInfo[GAME_PLAYER];
private:
	hgePoint					m_ptMagicCard;
	hgePoint					m_ptReady[GAME_PLAYER];
	hgePoint					m_ptName[GAME_PLAYER];
	hgePoint					m_ptTrustee[GAME_PLAYER];
	hgePoint					m_ptFace[GAME_PLAYER];
	hgePoint					m_ptUserFlag[GAME_PLAYER];
	hgePoint					m_ptActionAni[GAME_PLAYER];
	hgePoint					m_ptActionBack[GAME_PLAYER];
	hgePoint					m_ptTimer[GAME_PLAYER];
	hgePoint					m_ptControl;
	hgePoint					m_ptUserPoint;
protected:
	LONGLONG					m_lCellScore;					//
	WORD						m_wDiscUser;					//û
	std::string					m_lpUserLevel[GAME_PLAYER];
protected:
	bool						m_bTrustee[GAME_PLAYER];		//Ƿй
	//bool						m_bBombEffect;					//Ч
	//BYTE						m_cbBombFrameIndex;				//֡
	BYTE						m_cbDiscFrameIndex;				//֡	
	BYTE						m_bPlusDisc;
	BYTE						m_cbCutCardData;
protected:
	WORD						m_wBankerUser;					//ׯû
	WORD						m_wCurrentUser;					//ǰû
	DWORD						m_cbUserAction[GAME_PLAYER];	//û
	BYTE						m_cbCardData;					//˿
	WORD						m_wOutCardUser;					//û
	WORD						m_wDrawUserType;
	DWORD						m_dwFanShu[GAME_PLAYER];
	//WORD						m_wChiHuUser;					//Ժû
	//WORD						m_wProvideUser;					//Ӧû
protected:
	bool							m_bOutCard;							//Ʊ־
	bool							m_bWaitOther;						//ȴ־
	bool							m_bHuangZhuang;						//ׯ־
public:
	bool							m_bGameEnd;
	bool							m_bShowWnd;
	bool							m_bShowOption;
	bool							m_bShowSetCell;
	bool							m_bScoreShow;
	bool							m_bTimerShow;
	bool							m_bStart;
	bool							m_bShowBelle;
	bool							m_bShowPlay;
	bool							m_bGameStart;
	bool							m_bZiMo;
	bool							m_bGameChiHu;
	//ƻƶ
protected:
	bool							m_bEnableAnimate;					//Ƿʾƶ
	bool							m_bPlaySound;
	bool							m_bBackSound;
	bool							m_bCardMoving;						//Ƿڶ
	int								m_nXStep;							//X
	int								m_nYStep;							//Y
	float							m_fScaleStep;
	int								m_nStepCount;						//ƶ
	enDirection						m_enMoveDirection;					//ƶ
	tagMoveCardItem					m_MoveCardItem;						//Ŀ
	int								m_nCutCardCount;
	hgePoint						m_cbCutFromPoint;
	hgePoint						m_cbCutToPoint;
	hgeRect							m_rcOption;
	int								m_nCutStep;
	bool							m_bShowCutCard;
	BYTE							m_cbCutType;
protected:
	CWHArray<tagTingInfo>		m_ArrayTingCard;
	bool							m_bDrawTingCard;
	MySprite						*m_pTingInfo;
	bool							m_bShowTing[GAME_PLAYER];
	BYTE							m_cbTingIndex[GAME_PLAYER];
	hgePoint						m_ptTing[GAME_PLAYER];
	CDrawAnimateEx					m_TingSign;
	CDrawAnimateEx					m_TingPoint;
	CHgeImage						m_ImageHintLeft;
	CHgeImage						m_ImageHintMiddle;
	CHgeImage						m_ImageHintRight;
	CHgeImage						m_ImageHintNumber;
	CHgeImage						m_ImageHintFan;
	CHgeImage						m_ImageDisc;
private:
	DWORD							m_dwMyFanShu;
	DWORD							m_dwOtherFanShu;
	bool							m_bShowRedouble;
	DWORD							m_dwFanCount;
	CHgeImage						m_RedoubleBack;
	CHgeImage						m_RedoubleNum;
	CHgeImage						m_MyRedouble;
	CHgeImage						m_MyRedoubleNum;
	//CDrawAnimateEx					m_MyRedAnimate;
	CDrawAnimateEx					m_RedLight;
	CHgeButton						m_btRedouble;
	CDrawAnimateEx					m_MyRedFlash;
	CDrawAnimateEx					m_OtherRedFlash;
public:
	CDrawAnimateEx					m_DrawThinking;
public:
	bool							m_bTingCard[GAME_PLAYER];
protected:
	LONGLONG						m_lUpScore;
	BYTE							m_cbHuaCardCount[GAME_PLAYER];
protected:
	//ʼ
	void						InitBaseContainer();
	void						InitCard();
	void						InitInfo();
	void						InitImage();
	void						InitAnimate();
	void						InitButton();
	void						RectifyGameView(int nWidth, int nHeight);
public:
	void						ReleaseGame();
public:
	//״̬
	VOID						SetControlInfo(DWORD cbAcitonMask,bool bShow=false);
	void						SetButtonShow(BOOL bShow);
	void						PlayGameSound(const tstring &strname );
	void						PlayBGMusic(BYTE cbIndex);
	void						StopBGMusic();
	void						SetUserLevel(WORD wChairID,const char* lpUserLevel);
	//ׯ
	void						SetHuangZhuang(bool bHuangZhuang);
	void						DrawTextString(LPCTSTR pszString,GfxFont *pFont,COLORREF crText,float nXPos,float nYPos);
	void						DrawNumberString(LONGLONG lNumber,GfxFont *pFont,COLORREF crText,float nXPos,float nYPos,bool bCenter);
	//滭
public:
	//
	void SetScoreInfo(const tagScoreInfo & ScoreInfo, const tagWeaveInfo & WeaveInfo, const CChiHuRight &ChiHuRight,
		const CChiHuRight &ChiHuHigh,const CChiHuRight &ChiHuNew,const BYTE cbMingGangCount,
		const BYTE cbAnGangCount,LONG lCellScore,WORD wMeChairID);
private:
	//ʱ
	void						OnTimer(unsigned long iID);
	//º
	void						Update(DWORD dwDelTick);
	//Ⱦǰֻλ
	void						Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
public:
	//Ϣ
	void						UpdateUserInfo(const tagUserInfo * pUserData,WORD wChairID);
	//õʱ
	void						SetGameTimer(WORD wChairID,WORD nElapse,bool bEndPlay=false);
protected:
	//¼ӦϢ
	void						ClickTest(hgeItemBase  *p); 
	//갴
	void						OnLButtonDown(UINT nFlags, const hgePoint& point);
	//Ҽ
	void						OnRButtonDown(UINT nFlags, const hgePoint& point);
	//̧
	void						OnLButtonUp( UINT nFlags, const hgePoint & point );
	//ƶ
	void						OnMouseMove(UINT nFlags, const hgePoint& point);
	//滭,bHasSignʾλͼǷ
	VOID						DrawGoldString( LONGLONG lNumber, float nXPos, float nYPos, MySprite *pSprite,
													float nWidth,float nHeight,bool bGlod);
	VOID						DrawCellString( LONGLONG lNumber, float nXPos, float nYPos, MySprite *pSprite,
													float nWidth,float nHeight);
	VOID						DrawCellString( LONGLONG lNumber, float nXPos, float nYPos, MySprite *pSprite,
													float nWidth,float nHeight,bool bDrawCenter );
	void						DrawCellInfo(float fXPos,float fYPos);
	//һ֣ػƺλãƣ
	float						DrawNumber(LONGLONG lNumber, float fXPos, float fYPos, MySprite* pNumSprite,
									int nCellWidth, int nCellHeight);
	//滭,bHasSignʾλͼǷ
	VOID						DrawNumberString( LONGLONG lNumber, float nXPos, float nYPos, MySprite *pSprite,
													float nWidth,float nHeight, bool bHasSign, bool bDrawCenter=false );
	void						DrawNumberString(LONGLONG lNumber,INT nXPos,INT nYPos,CHgeImage &HgeNumber,bool bHasSign,
									bool bDrawCenter=false,bool bDrawTael=false);
public:
	//ƶ
	void						PlayCutCard(BYTE cbCard,CPoint ptFrom,CPoint ptTo);
	//
	void						SetCellScore(LONGLONG lCellScore);
	//й
	void						SetTrustee(WORD wTrusteeUser,bool bTrustee);
	//û
	void						SetDiscUser(WORD wDiscUser);
	//ׯû
	void						SetBankerUser(WORD wBankerUser);
	//ʾƶ
	void						SetShowHead(bool bShowHead);
	//˿˶
	void						OnMoveCardItem( const tagMoveCardItem &MoveCardItem,bool bShowItem=true);
	//Ƿ񶯻
	bool						IsMovingCard() { return m_bCardMoving; }
	//滭˿˶
	void						DrawMoveCardItem();
	//ֹͣƻƶ
	bool						StopMoveCard();
	//
	void						EnableAnimate( bool bAnimate );
	//Ƿ
	bool						IsEnableAnimate() { return m_bEnableAnimate; }
	//
	void						OnActionFinish();
	//״̬־
	void						SetStatusFlag(bool bOutCard, bool bWaitOther);
	//ʱ
	void						SetCurrentUser(WORD wCurrentUser);
	//Ϣ
	void						SetUserAction(WORD wViewChairID, DWORD bUserAction,WORD wProvideUser,bool bZiMo=false);
	//Ϣ
	void						SetOutCardInfo(WORD wViewChairID, BYTE cbCardData);
	//Ϣ
	void						SetTingInfo(CWHArray<tagTingInfo> &tCard);
	//
	void						UpDataTingInfo(CWHArray<tagTingInfo> &tCard);
	//˿
	void						SetFanCount(DWORD dwFanCount,bool bShowRedouble);
	DWORD						GetFanCount(){return m_dwFanCount;}
	void						SetUpScore(LONGLONG lUpScore);
	void						SetFanShu(WORD wChairID,DWORD dwFanShu);
	void						SetUserFanShu();
	void						ShowRedAnimate(WORD wChairID);
	void						ReleaseTingInfo();
	void						StopTing(WORD wChairID);
	//ö
	//bool						SetBombEffect(bool bBombEffect);
	//ʾ
	void						ShowScore();
	void						SetHuaCount(WORD wChairID,BYTE cbCardCount);
	BYTE						GetHuaCount(WORD wChairID);
	void						ResetDarw();
public:
	void						ChangeDrawType();
	void						DrawUser(float fXPos,float fYPos);
	//ťϢ
protected:
	//Ϣ
	VOID						OnContinue(hgeItemBase *p);
	//˳Ϣ
	VOID						OnEsc(hgeItemBase *p);
	//йܰť
	VOID						OnStartTrustee(int n);
	//ȡй
	VOID						OnStopTrustee(int n);
	//ʾ
	VOID						OnChiHuCue(int n);
	//ȷť
	VOID						OnOkButton(hgeItemBase *p);
	//ȡť
	VOID						OnCancelButton(hgeItemBase *p);
	//޸
	VOID						OnRedouble(int n);

	void						OnBtnPressed(hgeItemBase  *pItemBase);
	void						OnStopGroupAnimate(int type);
};