/*====================================================================
Specification :		Manages all UI data.
====================================================================*/
#pragma once
#include "../include/hgefont.h"
#include "../include/hgeresource.h"


class  TL_GUIDataManager
{
public:	

	TL_GUIDataManager(void);

	~TL_GUIDataManager(void);

	static TL_GUIDataManager&	Instance();

	void					InitRes();																						// عԴ

	void                  InitGameRes(tstring ResFile,tstring ResFileAdd=(""));							// СϷԴ

	void                  LoadAniamateTextureXML(tstring ResFile);											// ض

	void					ReleaseRes();

	hgeResourceManager*		GetGameResManager();

	hgeFont*				GetHgeFont();

	hgeResourceManager*		GetNewResManager();

	tstring					GetWebAddress( tstring node );
	
private:

	bool LoadWebAddress(tstring  webAddress);

private:

	hgeResourceManager    * m_pGameResManager;

	hgeResourceManager    * m_pCommonResManager; 

	hgeFont*				_pFont;//

	HGE*				    _phge;

	TiXmlDocument*			m_pWebAddrDoc;

};

