#ifndef GAME_OPTION
#define GAME_OPTION

#pragma once

#include "Stdafx.h"
#include "Resource.h"

class CGameOption :
	public hgeItemContainer
{
protected:
	MySprite		*m_pBack;
	MySprite		*m_pCheckBox[4];
private:
	hgePoint		m_ptBack;
	hgePoint		m_ptCheckBox[4];
	hgeRect			m_rcCheckBox[4];
	hgePoint		m_ptTempPoint;
	hgePoint		m_ptOk;
	hgePoint		m_ptClose;
	hgePoint		m_ptCancel;
	hgeRect			m_rcOk;
	hgeRect			m_rcClose;
	hgeRect			m_rcCancel;
public:
	//bool			m_bLButtonDown;
	bool			m_bChechBox[4];
public:
	hgeItemButton	*m_pOk;
	hgeItemButton   *m_pCancel;
	hgeItemButton	*m_pClose;
public:
	bool			m_bEnableSound;						//
	bool			m_bAllowLookon;						//Թ
	bool			m_bEanbleAnimate;					//ʾ
	bool			m_bBackSound;
public:
	CGameOption(const tstring &strname);
public:
	~CGameOption(void);
public:
	void SetEnableLookOn(bool bEnableLookOn)
	{
		m_bChechBox[1]=bEnableLookOn;
		m_bAllowLookon=bEnableLookOn;
	}
	void Init();
	void SetPoint(hgePoint point);
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
public:
	hgePoint GetPoint(){return m_ptBack;}
public:
	void OnLButtonDown(UINT nFlags, const hgePoint& point);
	void OnLButtonUp(UINT nFlags, const hgePoint& point);
	void OnMouseMove(UINT nFlags, const hgePoint& point);
};
#endif