
#include "stdafx.h"
#include "GameWindow.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////////
#define IDI_START_GAME				200									//ʼʱ
#define IDI_OPERATE_CARD			201									//ʱ
#define IDI_CHI_HU					202
#define IDI_DUI_HUA					203
#define TIME_START_GAME				25									//ʼʱ
#define TIME_OPERATE_CARD			10									//ʱ

#define MAX_TIME_OUT				2									//ʱ
//////////////////////////////////////////////////////////////////////////

extern char g_szCurPath[MAX_PATH];
TL_Gwindow* g_pGWindow=NULL;

TL_Gwindow::TL_Gwindow()
{
	g_pGWindow = this;
	m_pGUIHanllComm = NULL;
	m_wTimerChair=INVALID_CHAIR;
	m_wBankerUser=INVALID_CHAIR;
	m_wCurrentUser=INVALID_CHAIR;
	m_wReplaceUser = INVALID_CHAIR;
	m_wListenUser=INVALID_CHAIR;
	m_cbLeftCardCount=0;
	m_cbActionMask = 0;
	m_bActionMask=false;
	m_cbActionCard = 0;
	m_lSiceCount=0;
	ZeroMemory(m_cbCardIndex,sizeof(m_cbCardIndex));
	m_bStustee=false;
	m_bHearStatus=false;
	m_cbListenStatus = 0;
	m_wTimeOutCount =0;
	m_bGameStart=false;
	m_bSort=false;
	m_cbSendCard=0;
	m_lReplaceCount=0;
	m_bReplace=false;
	m_bGameEnd=false;
	m_bWillHearStatus=false;
	m_lUpScore=0;
	m_cbHaiDiIndex=0;
	m_bHaiDiUpdata=false;
	m_bHaiDiHu=false;
	m_bDuiHuaStatus=false;
	m_bOutCard=false;
	m_wHeapHead = INVALID_CHAIR;
	m_wHeapTail = INVALID_CHAIR;
//	ZeroMemory( m_cbHeapCardInfo,sizeof(m_cbHeapCardInfo) );
	ZeroMemory(m_HeapCardInfo,sizeof(m_HeapCardInfo));

	//˿
	ZeroMemory(m_cbWeaveCount,sizeof(m_cbWeaveCount));
	ZeroMemory(m_WeaveItemArray,sizeof(m_WeaveItemArray));
	ZeroMemory(m_cbDiscardCount,sizeof(m_cbDiscardCount));
	ZeroMemory(m_cbDiscardCard,sizeof(m_cbDiscardCard));
}

TL_Gwindow::~TL_Gwindow()
{
	if (m_pGUIHanllComm)
		delete m_pGUIHanllComm;
	if( m_pUIHanllComm)
		delete m_pUIHanllComm;
	if (m_pUIEventCtl )
		delete m_pUIEventCtl;
	for(BYTE i=0;i<m_UserActionArray.GetCount();i++)
	{
		//ɾǰ
		tagUserAction *pUserAction = m_UserActionArray[i];
		pUserAction->ResetAction();
		delete pUserAction;
	}
	m_UserActionArray.RemoveAll();
	g_CardResource.DestroyResource();
}

void TL_Gwindow::ReleaseGame()
{
	m_wBankerUser=INVALID_CHAIR;
	m_wCurrentUser=INVALID_CHAIR;
	m_wReplaceUser = INVALID_CHAIR;
	m_wListenUser=INVALID_CHAIR;
	m_cbLeftCardCount=0;
	m_cbActionMask = 0;
	m_bActionMask=false;
	m_cbActionCard = 0;
	m_lSiceCount=0;
	ZeroMemory(m_cbCardIndex,sizeof(m_cbCardIndex));
	m_wHeapHead = INVALID_CHAIR;
	m_wHeapTail = INVALID_CHAIR;
	m_cbListenStatus = 0;
	m_wTimeOutCount =0;
	m_bGameStart=false;
	m_bSort=false;
	m_cbSendCard=0;
	m_lReplaceCount=0;
	m_bReplace=false;
	m_bGameEnd=false;
	m_bHearStatus=false;
	m_bWillHearStatus=false;
	m_cbHaiDiIndex=0;
	m_bHaiDiUpdata=false;
	m_bHaiDiHu=false;
	m_bDuiHuaStatus=false;
	m_bOutCard=false;
	m_pBas->m_pSetCellScore->ReleaseData();
	ZeroMemory(m_HeapCardInfo,sizeof(m_HeapCardInfo));
	//˿
	ZeroMemory(m_cbWeaveCount,sizeof(m_cbWeaveCount));
	ZeroMemory(m_WeaveItemArray,sizeof(m_WeaveItemArray));
	ZeroMemory(m_cbDiscardCount,sizeof(m_cbDiscardCount));
	ZeroMemory(m_cbDiscardCard,sizeof(m_cbDiscardCard));
}
bool TL_Gwindow::InitWnd()
{
	 __super::InitWnd();
//	 std::string strIcon;
//#ifdef  _UNICODE
//	 TCHAR* hIcon = MAKEINTRESOURCE(IDR_MAINFRAME);
//	 strIcon = ST2A(hIcon).Str();
//#else
//	 strIcon = MAKEINTRESOURCE(IDR_MAINFRAME);
//#endif
	 m_pFHge->System_SetState(HGE_ICON,MAKEINTRESOURCEA(IDR_MAINFRAME));

	 HTEXTURE tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexBackView");
	 hgeItemImage *_ImageViewBack=new hgeItemImage("ViewBack",tex,0,0,0,0);
	 _ImageViewBack->SetZOrder(0);
	 m_pHgeRootContainer->AddItem(_ImageViewBack);

	 tex =TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexExitButton");
	 hgeItemButton * _Exit=new hgeItemButton("Exit",tex,hgePoint(0,0),hgePoint(39,25),TRUE,4,TRUE);
	 _Exit->_OnPress=FEvent_PItemV2(this,&TL_Gwindow::CloseGAME);
	 _Exit->SetDoHitTest(true);
	 _Exit->SetShow(TRUE);
	 _Exit->SetPosition(hgePoint(1024-39-3,2));
	 _Exit->SetZOrder(1);
	 m_pHgeRootContainer->AddItem(_Exit);

	 tex =TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexMinButton");
	 hgeItemButton * _Min=new hgeItemButton("Min",tex,hgePoint(0,0),hgePoint(39,25),TRUE,4,TRUE);
	 _Min->_OnPress=FEvent_PItemV2(this,&TL_Gwindow::MinGAME);
	 _Min->SetDoHitTest(true);
	 _Min->SetShow(TRUE);
	 _Min->SetPosition(hgePoint(1024-39-39-3,2));
	 _Min->SetZOrder(1);
	 m_pHgeRootContainer->AddItem(_Min);

	 tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexFrame_HomePage");
	 hgeItemButton *_HomePage=new hgeItemButton("HomePage",tex,hgePoint(0,0),hgePoint(50,25),TRUE,4,TRUE);
	 _HomePage->_OnPress=FEvent_PItemV2(this,&TL_Gwindow::HomePage);
	 _HomePage->SetDoHitTest(true);
	 _HomePage->SetShow(TRUE);
	 _HomePage->SetPosition(hgePoint(1024-450,2));
	 _HomePage->SetZOrder(1);
	 m_pHgeRootContainer->AddItem(_HomePage);

	 tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexFrame_GameShop");
	 hgeItemButton *_GameShop=new hgeItemButton("GameShop",tex,hgePoint(0,0),hgePoint(64,25),TRUE,4,TRUE);
	 _GameShop->_OnPress=FEvent_PItemV2(this,&TL_Gwindow::GameShop);
	 _GameShop->SetDoHitTest(true);
	 _GameShop->SetShow(TRUE);
	 _GameShop->SetPosition(hgePoint(1024-450+50,2));
	 _GameShop->SetZOrder(1);
	 m_pHgeRootContainer->AddItem(_GameShop);

	 tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexFrame_GameSnap");
	 hgeItemButton *_GameSnap=new hgeItemButton("GameSnap",tex,hgePoint(0,0),hgePoint(71,25),TRUE,4,TRUE);
	 _GameSnap->_OnPress=FEvent_PItemV2(this,&TL_Gwindow::GameSnap);
	 _GameSnap->SetDoHitTest(true);
	 _GameSnap->SetShow(TRUE);
	 _GameSnap->SetPosition(hgePoint(1024-450+50+64,2));
	 _GameSnap->SetZOrder(1);
	 m_pHgeRootContainer->AddItem(_GameSnap);

	 tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexFrame_GetMoney");
	 hgeItemButton *_GetMoney=new hgeItemButton("GetMoney",tex,hgePoint(0,0),hgePoint(63,25),TRUE,4,TRUE);
	 _GetMoney->_OnPress=FEvent_PItemV2(this,&TL_Gwindow::GetMoney);
	 _GetMoney->SetDoHitTest(true);
	 _GetMoney->SetShow(TRUE);
	 _GetMoney->SetPosition(hgePoint(1024-450+50+64+71,2));
	 _GetMoney->SetZOrder(1);
	 m_pHgeRootContainer->AddItem(_GetMoney);

	 tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexFrame_GameSet");
	 hgeItemButton *_GameSet=new hgeItemButton("GameSet",tex,hgePoint(0,0),hgePoint(53,25),TRUE,4,TRUE);
	 _GameSet->_OnPress=FEvent_PItemV2(this,&TL_Gwindow::OnGameOptionSet);
	 _GameSet->SetDoHitTest(true);
	 _GameSet->SetShow(TRUE);
	 _GameSet->SetPosition(hgePoint(1024-450+50+64+71+63,2));
	 _GameSet->SetZOrder(1);
	 m_pHgeRootContainer->AddItem(_GameSet);

	 //@@@@
	 //@@DLLйõUI
	 m_pUIHanllComm = new TL_UIHallComm;
	 m_pUIHanllComm->CreateItems(m_pHgeRootContainer);
	 TL_UIChatContainer * chatContainer = m_pUIHanllComm->GetChatContainer();
	 hgePoint  Chatsize =chatContainer->GetSize();
	 chatContainer->SetPosition(hgePoint(WINDOW_DRAWWIDTH-1-Chatsize.x,WINDOW_DRAWHEIGHT-2-Chatsize.y));
	 chatContainer->SetShow(false);//chatadd
	 chatContainer->SetZOrder(6);
	 m_pUIEventCtl = new TL_UIEventController;
	 m_pUIEventCtl->InitController(m_pUIHanllComm);

	 //chatContainer->SetBugleCount(10);
	 BindSendChatEvent();
	 //@@@@

	 m_pGUIHanllComm=new TL_GUIHallComm;
	 m_pGUIHanllComm->CreateGUIItems(m_pHgeRootContainer);
	 m_pBas=m_pGUIHanllComm->GetBaseTContainer();
	 m_pBas->SetSize(hgePoint(1024,710));
	 m_pBas->SetPosition(hgePoint(0,30));
	 m_pBas->SetShow(TRUE);

	 m_pBas->m_pStartButton->_OnPress=FEvent_PItemV2(this,&TL_Gwindow::OnStart);
//	 m_pBas->m_pSort->_OnPress=FEvent_PItemV2(this,&TL_Gwindow::OnSort);
	 m_pBas->m_ActionFinish = BIND_THIS_METHOD(TL_Gwindow::OnUserActionFinish);
	 m_pBas->m_pControlWnd->m_pButtonIn=FEvent_PInt(this,&TL_Gwindow::OnUserAction);
	 m_pBas->m_pControlWnd->m_pTingIn=FEvent_PInt(this,&TL_Gwindow::OnListenCard);
	 m_pBas->m_pHandCard->m_OutCard=FEvent_PInt(this,&TL_Gwindow::OnOutCard);
	 m_pBas->m_pHandCard->m_CardOperate=BIND_THIS_METHOD(TL_Gwindow::OnCardOperate);
	 m_pBas->m_pHandCard->m_TingCard=FEvent_PInt(this,&TL_Gwindow::OnTingCard);
	 m_pBas->m_pSetCellScore->m_FPOk=FEvent_PInt(this,&TL_Gwindow::OnOKButton);
	 m_pBas->m_pSetCellScore->m_pCancel->_OnPress=FEvent_PItemV2(this,&TL_Gwindow::CloseGAME);
	 m_pBas->m_pSetCellScore->m_FPClose=FEvent_PItemV2(this,&TL_Gwindow::CloseGAME);
	// m_pBas->m_pGameScore->m_pButtonContinue->_OnPress=BIND_THIS_METHOD(TL_Gwindow::OnHitStart);
	 m_pBas->m_Continue=BIND_THIS_METHOD(TL_Gwindow::OnContinue);
	 m_pBas->m_Esc=BIND_THIS_METHOD(TL_Gwindow::OnEsc);
	 m_pBas->m_Trustee=BIND_THIS_METHOD(TL_Gwindow::OnStusteeControl);
	 m_pBas->m_Redouble=FEvent_PInt(this,&TL_Gwindow::OnRedouble);
	 m_pBas->m_pEndPlay->m_ShowCard=FEvent_PInt(this,&TL_Gwindow::OnShowCard);
	 m_pBas->m_RightButtonDown=BIND_THIS_METHOD(TL_Gwindow::OnRightButtonDown);
	 m_pBas->m_MyRedOver=BIND_THIS_METHOD(TL_Gwindow::OnMyFlashID);
	// m_pHgeRootContainer->InitButton();
	 RegisterRoot(m_pHgeRootContainer);

	int nWidth=1024;
	int nHeight=740;
	SetFlowerControlInfo(0,(nWidth/2)-58+8+50,53+9+60,0.7f);
	SetFlowerControlInfo(1,(nWidth/2)-58+8+50,(nHeight-177)+9+50,0.7f);

	MinGAME(NULL);
	HWND hWnd = m_pFHge->System_GetState(HGE_HWND);
	::SendMessage(hWnd,WM_SYSCOMMAND,SC_RESTORE,0);
	return false;
}

void TL_Gwindow::InitRes()
{
	char  temp[MAX_PATH];
	sprintf_s(temp,MAX_PATH,"%s//config.ini",g_szCurPath);
	__super::InitRes(temp);
	//
 	new hgeTextureManager();
 	// ʱϵͳ
 	new hgeTimerSys();
 	// ϵͳ
 	new hgeAnimateControllerManager();
	//@@СϷԴ
	sprintf_s(temp,MAX_PATH,"%s//config//texture//test.cfg",g_szCurPath);
	TL_GUIDataManager::Instance().InitGameRes(temp);
	// Դ
	sprintf_s(temp,MAX_PATH,"%s//config//Texture//Textures.xml",g_szCurPath);
	TL_GUIDataManager::Instance().LoadAniamateTextureXML(temp);
	//@@xmlļ
	LoadXML();
	;
	g_CardResource.LoadResource();
}

void TL_Gwindow::DrawWnd()
{
	__super::DrawWnd();
	hgeWindowlessManager::instance().Render( hgePoint(0,0), false, hgeRect(0, 0, 1024, 740) );
}
bool  TL_Gwindow::InsertUserChat(LPCTSTR pszSendName, LPCTSTR pszString, COLORREF crColor, UINT uSize)
{						    
	__super::InsertUserChat(pszSendName,pszString,crColor,uSize);

	std::string strString;
#ifdef _UNICODE
	strString = ST2A(pszString);
#else
	strString = pszString;
#endif
	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		if(GetUserData(i)->szNickName==pszSendName)
		{
			m_pBas->m_pDrawMessage->SetUserSay(ReturnReplaceString(strString.c_str()),SwitchViewChairID(i));
		}
	}


	return TRUE;
}
bool  TL_Gwindow::InsertUserChat(LPCTSTR pszSendName, LPCTSTR pszRecvName, LPCTSTR pszString, COLORREF crColor, UINT uSize)
{
	__super::InsertUserChat(pszSendName,pszRecvName,pszString,crColor,uSize);

	return TRUE;
}
void  TL_Gwindow::ResetGameFrame()
{
	m_pBas->ResetDarw();
	ResetTable();
}
void TL_Gwindow::ResetTable()
{
	ReleaseGame();
	m_pBas->ReleaseGame();
	//˿
	m_pBas->m_pUserCard->SetCardData(0,false);
	m_pBas->m_pHandCard->SetCardData(NULL,0,0);
	m_pBas->m_pHandCard->CutCardOver();
	m_pBas->m_pHandCard->SetShowCaiShen(false);
	m_pBas->m_pHandCard->ReleaseInfo();
	m_pBas->m_pGameScore->RestorationData();
	m_pBas->m_bStart=true;
	m_pBas->m_bGameStart=false;
	m_pBas->m_bShowBelle=(!m_pBas->m_bShowBelle);
	m_pBas->SetUpScore(m_lUpScore);

	//˿
	for (WORD i=0;i<GAME_PLAYER;i++)
	{
		m_pBas->m_pTableCard[i]->SetCardData(NULL,0);
		m_pBas->m_pTableCard[i]->SetProvideCard(0);
		m_pBas->m_pTableCard[i]->ResealeInfo();
		m_pBas->m_pDiscardCard[i]->SetCardData(NULL,0);
		for( BYTE j = 0; j < CountArray(m_pBas->m_pWeaveCard[i]); j++ )
		{
			m_pBas->m_pWeaveCard[i][j]->SetCardData(NULL,0,0);
			m_pBas->m_pWeaveCard[i][j]->ResealeInfo();
		}

		m_pBas->SetShowHead(false);
		m_pBas->m_pHeadCard[i]->ResetCardData();
		m_pBas->m_pHeadCard[i]->SetHeapCardInfo(0,0);
	}
}
void TL_Gwindow::RectifyControl( int nWidth, int nHeight )
{
	__super::RectifyControl(nWidth,nHeight);
}

bool TL_Gwindow::ProcMessage( UINT msg, WPARAM wparam, LPARAM lparam )
{
	if( msg == WM_SETCURSOR)
	{
		/*POINT ptMouse;
		bool bFlag=false;
		::GetCursorPos(&ptMouse);
		TL_UIChatContainer * chatContainer = m_pUIHanllComm->GetChatContainer();
		if( chatContainer)
		{
			hgePoint chatPos=chatContainer->GetPosition();
			hgePoint chatSize=chatContainer->GetSize();
			
			if( ptMouse.x>=chatPos.x && ptMouse.x<chatPos.x+chatSize.x &&
				ptMouse.y>=chatPos.y && ptMouse.y <chatPos.y+chatSize.y)
			{
				bFlag=true;
				::SetCursor(LoadCursor(NULL, IDC_IBEAM));
			}
		}
		if(!bFlag)
			::SetCursor(LoadCursor(NULL, IDC_ARROW));*/
	}
	return __super::ProcMessage(msg,wparam,lparam);
}

bool TL_Gwindow::Update()
{
	float dt = m_pFHge->Timer_GetDelta();
	// ʱϵͳ
	hgeTimerSys::instance().InjectTimer( dt );

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		const tagUserInfo * pUserData=GetUserData(i);
		if(!m_pBas->m_bStart)
		{
			if(pUserData!=NULL)//NULLʾ뿪
				m_pBas->UpdateUserInfo(pUserData,SwitchViewChairID(i));
		}
		else
		{
			//if(pUserData!=NULL)//NULLʾ뿪
				m_pBas->UpdateUserInfo(pUserData,SwitchViewChairID(i));
		}
	}
	if(m_bReplace)
	{
		m_lReplaceCount++;
		if(m_lReplaceCount==30)
		{
			m_bReplace=false;
			m_lReplaceCount=0;

			m_pBas->SetUserAction(INVALID_CHAIR,0,0);

			//Ѱ˿
			for(BYTE i=MAX_INDEX-MAX_HUA_CARD;i<MAX_INDEX;i++)
			{
				if(m_cbCardIndex[i]>0)
				{
					//
					BYTE cbReplaceCard=m_GameLogic.SwitchToCardData(i);
					if( !m_GameLogic.RemoveCard(m_cbCardIndex,cbReplaceCard) )
					{
						ASSERT( FALSE );
						return false;
					}

					//˿
					SetHandCardControl(m_cbCardIndex,0x00);

					//ý
					m_pBas->SetUserAction( MYSELF_VIEW_ID,WIK_REPLACE,0 );

					CMD_C_ReplaceCard ReplaceCard;
					ReplaceCard.cbCardData=cbReplaceCard;
					SendSocketData(SUB_C_REPLACE_CARD,&ReplaceCard,sizeof(ReplaceCard));

					break;
				}
			}
			return true;
		}
	}

	if(m_bHaiDiUpdata)
	{
		m_cbHaiDiIndex++;
		if(m_cbHaiDiIndex==50)
		{
			if(m_bHaiDiHu)
			{
				OnUserAction( WIK_CHI_HU );
				m_pBas->m_bShowPlay=false;
				m_pBas->m_pEndPlay->ResealeInfo();
			}
			else
			{
				m_pBas->m_pEndPlay->ResealeInfo();
				m_cbHaiDiIndex=0;
				m_bHaiDiUpdata=false;
				SendSocketData(SUB_C_HAIDI_CONTINUE);
			}
		}
	}
	return __super::Update();
}

//@@СϷXMLļ
void TL_Gwindow::LoadXML()
{
	__super::LoadXML();
	char  temp[MAX_PATH];
	sprintf_s(temp,MAX_PATH,"%s//config//UI//GUIHallComm.xml",g_szCurPath);
	LOAD_WIDGET_DEFINES(temp);
	sprintf_s(temp,MAX_PATH,"%s//config//UI//GUIBaseContainer.xml",g_szCurPath);
	LOAD_WIDGET_DEFINES(temp);
}
//@@ͷԴ
void TL_Gwindow::ReleaseRes()
{
	ResetGameFrame();
 	delete hgeAnimateControllerManager::instance_ptr();
 	delete hgeTimerSys::instance_ptr();
 	delete hgeTextureManager::instance_ptr();
	TL_GUIDataManager::Instance().ReleaseRes();
	__super::ReleaseRes();
}
void TL_Gwindow::OnContinue()
{
	OnStart(NULL);
}
void TL_Gwindow::OnEsc()
{
	CloseGAME(NULL);
}
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
void TL_Gwindow::OnStart(hgeItemBase  *p)
{
	const tagUserInfo* pMeUserData= GetMeUserData();
	if( !pMeUserData) return;
	
	ReleaseGame();
	m_pBas->ReleaseGame();
	//˿
	m_pBas->m_pUserCard->SetCardData(0,false);
	m_pBas->m_pHandCard->SetCardData(NULL,0,0);
	m_pBas->m_pHandCard->CutCardOver();
	m_pBas->m_pHandCard->SetShowCaiShen(false);
	m_pBas->m_pHandCard->ReleaseInfo();
	m_pBas->m_pGameScore->RestorationData();
	m_pBas->m_bStart=true;
	m_pBas->m_bShowBelle=(!m_pBas->m_bShowBelle);
	m_pBas->SetUpScore(m_lUpScore);
	m_pBas->SetDiscUser(INVALID_CHAIR);
	m_pBas->m_DrawThinking.HideAnimate();

	//˿
	for (WORD i=0;i<GAME_PLAYER;i++)
	{
		m_pBas->m_pTableCard[i]->SetCardData(NULL,0);
		m_pBas->m_pTableCard[i]->SetProvideCard(0);
		m_pBas->m_pTableCard[i]->ResealeInfo();
		m_pBas->m_pDiscardCard[i]->SetCardData(NULL,0);
		for( BYTE j = 0; j < CountArray(m_pBas->m_pWeaveCard[i]); j++ )
		{
			m_pBas->m_pWeaveCard[i][j]->SetCardData(NULL,0,0);
			m_pBas->m_pWeaveCard[i][j]->ResealeInfo();
		}
	}

	//˿
	for (WORD i=0;i<GAME_PLAYER;i++)
	{
		m_pBas->SetShowHead(false);
		m_pBas->m_pHeadCard[i]->ResetCardData();
		m_pBas->m_pHeadCard[i]->SetHeapCardInfo(0,0);
	}

	if( pMeUserData->cbUserStatus == US_LOOKON ) return;

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		if(GetUserData(i)!=NULL)
		{
			////Ƹȼ
			//if (GetServerType()==GAME_GENRE_GOLD || GetServerType()==GAME_GENRE_MATCH)
			//{
			//	LPCTSTR pszGameRank=m_GameRankManagerHelper->GetGoldLevelDescribe(GetUserData(i)->lGameGold);
			//	m_pBas->SetUserLevel(SwitchViewChairID(i),pszGameRank);
			//}
			////ֵȼ
			//if (GetServerType()==GAME_GENRE_SCORE)
			//{
			//	LPCTSTR pszGameRank=m_GameRankManagerHelper->GetLevelDescribe(GetUserData(i)->lScore);
			//	m_pBas->SetUserLevel(SwitchViewChairID(i),pszGameRank);

			//}
		}
	}

	//Ϣ
	SendUserReady(NULL, 0);
	m_pBas->m_pStartButton->SetShow(FALSE);
	KillGameTimerN(IDI_START_GAME);

	bool bBoy = (pMeUserData->cbGender == 2 ? false : true);
	if(bBoy)
		m_pBas->PlayGameSound("BOY_R");
	else
		m_pBas->PlayGameSound("Girl_R");
}
void TL_Gwindow::KillGameTimerN(UINT nTimerID)
{
	KillGameClock(nTimerID);
	if(m_wTimerChair!=INVALID_CHAIR)
	{
		m_pBas->SetGameTimer(SwitchViewChairID(m_wTimerChair),0);
	}
	m_wTimerChair=INVALID_CHAIR;
}
void TL_Gwindow::SetGameTimerN(WORD wChairID, UINT nTimerID, UINT nElapse)
{
	m_wTimerChair=wChairID;
	m_pBas->m_bTimerShow=false;
	SetGameClock(wChairID,nTimerID,nElapse);
}
// true ˳ false 
bool TL_Gwindow::RequestQuit()
{
	if(GetUserData(GetMeChairID())!=NULL)
	{
		if(GetUserData(GetMeChairID())->cbUserStatus==GS_MJ_PLAY)
		{
			
			INT nRet =MessageBox(m_hWnd,TEXT("Ϸʱ˳ܵͷҪ˳"),TEXT("ʾ"),MB_OKCANCEL);
			return (nRet==IDOK);
		}
	}

	return true;
}
//game logic

BYTE TL_Gwindow::InitGameFrame()
{
	return 0;
}
bool g_bInitOnce=true;
void TL_Gwindow::OnGameOptionSet(hgeItemBase *p)
{
	if(g_bInitOnce)
	{
		g_bInitOnce=false;
		m_pBas->m_pGameOption-> SetEnableLookOn(false);		//ǿ״βԹۣҷͲԹ
		
		//IsAllowLookon(false);
		
	}

	m_pBas->m_bShowOption=true;
}
//ʱϢ
bool TL_Gwindow::OnEventGameClockInfo(WORD wChairID, UINT nElapse, WORD wClockID)
{
	switch (wClockID)
	{
	case IDI_START_GAME:		//ʼϷ
		{
			m_pBas->SetGameTimer(SwitchViewChairID(wChairID),nElapse);
			if( m_bStustee && nElapse < TIME_START_GAME )
			{
				OnStart(NULL);
				return true;
			}
			if (nElapse==0)
			{
				CloseGAME(NULL);
				return true;
			}

			if (nElapse<=5)
			{
				m_pBas->PlayGameSound("Common_Warn");
			}

		}
	case IDI_OPERATE_CARD:
		{
			m_pBas->SetGameTimer(SwitchViewChairID(wChairID),nElapse);
			//Զ
			bool bAutoOutCard=false;
			if ((bAutoOutCard==true))
				bAutoOutCard=false;
			if((bAutoOutCard==false)&&(m_bStustee==true))
			{
				bAutoOutCard=true;
			}

			//ʱж
			if ( (IsLookonMode()==false)&&( nElapse==0  || (bAutoOutCard&&nElapse<=TIME_OPERATE_CARD)||(m_bHearStatus&&
				!m_bWillHearStatus&&nElapse<=TIME_OPERATE_CARD))&&(!m_bGameEnd) )
			{
				//ȡλ
				WORD wMeChairID=GetMeChairID();

				//
				if (wChairID==wMeChairID)
				{
					//δ,δй,ۼӳʱ
					if( m_bHearStatus == false && m_bStustee==false && ++m_wTimeOutCount>=MAX_TIME_OUT )
					{
						m_wTimeOutCount = 0;
						OnStusteeControl();
					}

					if (m_wCurrentUser==wMeChairID)
					{
						//ȡ˿
						BYTE cbCardData=m_pBas->m_pHandCard->GetCurrentCard();

						//״̬
						if( m_bHearStatus )
						{
							if( m_cbActionMask & WIK_CHI_HU||m_cbActionMask&WIK_GANG )
							{
								KillGameTimerN(IDI_OPERATE_CARD);
								SetGameTimerN(wChairID,IDI_CHI_HU,10);
								return true;
							}
						}
						//ڲģʽ
						if( m_pBas->m_pHandCard->GetSelectMode() )
						{
							OnCardOperate();
							return true;
						}
						//Ч
						if (VerdictOutCard(cbCardData)==false)
						{
							for (BYTE i=0;i<MAX_INDEX;i++)
							{
								//Ч
								if (m_cbCardIndex[i]==0) continue;
								if (VerdictOutCard(m_GameLogic.SwitchToCardData(i))==false) 
									continue;

								//ñ
								cbCardData=m_GameLogic.SwitchToCardData(i);
							}
						}

						//ƶ
						ASSERT( m_cbCardIndex[m_GameLogic.SwitchToCardIndex(cbCardData)] > 0 );
					//	SparrowCJDlg<<"IDI_OPERATE_CARD m_wCurrentUser==wMeChairID"<<endl;
						OnOutCard(cbCardData);
					}
					else 
					{
						//״̬,ڻ͵
						if( m_bHearStatus )
						{
							if( m_cbActionMask & WIK_CHI_HU||m_cbActionMask&WIK_GANG )
							{
								KillGameTimerN(IDI_OPERATE_CARD);
								SetGameTimerN(wChairID,IDI_CHI_HU,10);
								return true;
							}
						}
						//ڲģʽ
						if( m_pBas->m_pHandCard->GetSelectMode() )
						{
							OnCardOperate();
							return true;
						}
						OnUserAction(WIK_NULL);
					}
				}
				return true;
			}
			if((nElapse<=5)&&(IsLookonMode()==false))
			{
				m_pBas->m_bTimerShow=true;
			}

			//
			if ((nElapse<=3)&&(wChairID==GetMeChairID())&&(IsLookonMode()==false)) 
			{
				m_pBas->PlayGameSound("Common_Warn");
			}

			return true;
		}
	case IDI_CHI_HU:
		{
			m_pBas->SetGameTimer(SwitchViewChairID(wChairID),nElapse);

			//Զ
			bool bAutoOutCard=false;
			if ((bAutoOutCard==true))
				bAutoOutCard=false;
			if((bAutoOutCard==false)&&(m_bStustee==true))
			{
				bAutoOutCard=true;
			}
			if(IsLookonMode()==false&&(nElapse==0||(bAutoOutCard&&nElapse<=TIME_OPERATE_CARD)))
			{
				m_pBas->SetFanCount(0,false);
				WORD wMeChairID=GetMeChairID();
				if (m_wCurrentUser==wMeChairID)
				{
					//ȡ˿
					BYTE cbCardData=m_pBas->m_pHandCard->GetCurrentCard();

					if( m_cbActionMask & WIK_CHI_HU)
					{
						OnUserAction(WIK_CHI_HU);
						return true;
					}

					if( m_pBas->m_pHandCard->GetSelectMode() )
					{
						OnCardOperate();
						return true;
					}
					//Ч
					if (VerdictOutCard(cbCardData)==false)
					{
						for (BYTE i=0;i<MAX_INDEX;i++)
						{
							//Ч
							if (m_cbCardIndex[i]==0) continue;
							if (VerdictOutCard(m_GameLogic.SwitchToCardData(i))==false) 
								continue;

							//ñ
							cbCardData=m_GameLogic.SwitchToCardData(i);
						}
					}

					//ƶ
					ASSERT( m_cbCardIndex[m_GameLogic.SwitchToCardIndex(cbCardData)] > 0 );
//					SparrowCJDlg<<"IDI_CHI_HU m_wCurrentUser==wMeChairID"<<endl;
					OnOutCard(cbCardData);
				}
				else 
				{
					if( m_cbActionMask & WIK_CHI_HU )
					{
						OnUserAction(WIK_CHI_HU);
						return true;
					}
					OnUserAction(WIK_NULL);
				}
			}
			if((nElapse<=5)&&(IsLookonMode()==false))
			{
				m_pBas->m_bTimerShow=true;
			}

			//
			if ((nElapse<=5)&&(wChairID==GetMeChairID())&&(IsLookonMode()==false)) 
			{
				m_pBas->PlayGameSound("Common_Warn");
			}

			return true;
		}
	case IDI_DUI_HUA:
		{
			m_pBas->SetGameTimer(SwitchViewChairID(wChairID),nElapse,true);
			if(IsLookonMode()==false&&nElapse==0)
			{
				WORD wMeChairID=GetMeChairID();
				if (wChairID==wMeChairID)
				{
					m_pBas->m_pEndPlay->Stustee();
				}
			}

			//
			if ((nElapse<=3)&&(wChairID==GetMeChairID())&&(IsLookonMode()==false)) 
			{
				m_pBas->m_bTimerShow=true;
				m_pBas->PlayGameSound("Common_Warn");
			}

			return true;
		}
	}
	return true;
}
//Թ״̬
bool TL_Gwindow::OnEventLookonMode(VOID * pData, WORD wDataSize)
{
	if(m_pBas->m_pHandCard)
	m_pBas->m_pHandCard->SetDisplayItem(IsAllowLookon());
	return true;
}
//Ϣ
bool TL_Gwindow::OnEventGameMessage(WORD wSubCmdID, VOID * pBuffer, WORD wDataSize)
{
	switch(wSubCmdID)
	{
	case SUB_S_GAME_START:
		{
			return OnSubGameStart(pBuffer,wDataSize);
		}
	case SUB_S_OUT_CARD:
		{
			return OnSubOutCard(pBuffer,wDataSize);
		}
	case SUB_S_SEND_CARD:		//Ϣ
		{
			return OnSubSendCard(pBuffer,wDataSize);
		}
	case SUB_S_LISTEN:		//ƴ	
		{
			return OnSubListenCard(pBuffer,wDataSize);
		}
	case SUB_S_LISTEN_SET:
		{
			return OnSubListenSet(pBuffer,wDataSize);
		}
	case SUB_S_OPERATE_NOTIFY:	//ʾ
		{
			return OnSubOperateNotify(pBuffer,wDataSize);
		}
	case SUB_S_OPERATE_RESULT:	//
		{
			return OnSubOperateResult(pBuffer,wDataSize);
		}
	case SUB_S_GAME_END:		//Ϸ
		{
			return OnSubGameEnd(pBuffer,wDataSize);
		}
	case SUB_S_TRUSTEE:			//ûй
		{
			return OnSubTrustee(pBuffer,wDataSize);
		}
	case SUB_S_REPLACE_CARD:	//
		{
			return OnSubReplaceCard( pBuffer,wDataSize );
		}
	case SUB_S_SEND_CELL:
		{
			return OnSubSetCell(pBuffer,wDataSize);
		}
	case SUB_S_SEND_SET:
		{
			return OnSubShowSet(pBuffer,wDataSize);
		}
	case SUB_S_DUI_HUA:
		{
			return OnSubDuiHua(pBuffer,wDataSize);
		}
	case SUB_S_HAI_DI:
		{
			return OnSubHaiDi(pBuffer,wDataSize);
		}
	case SUB_S_SHOW_REDOUBLE:
		{
			return OnSubShowRedouble(pBuffer,wDataSize);
		}
	case SUB_S_REDOUBLE:
		{
			return OnSubRedouble(pBuffer,wDataSize);
		}
	case SUB_S_CONTINUE_DH:
		{
			return OnSubDuiHuaResult(pBuffer,wDataSize);
		}
	case SUB_S_CONTINUE_HD:
		{
			return OnSubHaiDiResult(pBuffer,wDataSize);
		}
	case SUB_S_SHOW_THINK:
		{
			return OnSubShowThink(pBuffer,wDataSize);
		}
	case SUB_S_UPDATA_TINFO:
		{
			return OnSubTingInfo(pBuffer,wDataSize);
		}
	case SUB_S_START_OVER:
		{
			return OnSubStartOver(pBuffer,wDataSize);
		}

	}
	return true;
}
//Ϸ
bool TL_Gwindow::OnEventSceneMessage(BYTE cbGameStatus, bool bLookonUser, VOID * pBuffer, WORD wDataSize)
{
	switch (cbGameStatus)
	{
	case GS_MJ_FREE:	//״̬
		{
			//Ч
			if (wDataSize!=sizeof(CMD_S_StatusFree)) return false;
			CMD_S_StatusFree * pStatusFree=(CMD_S_StatusFree *)pBuffer;

			m_wBankerUser=pStatusFree->wBankerUser;
			//й
			for (WORD i=0;i<GAME_PLAYER;i++)
			{
				m_pBas->SetTrustee(SwitchViewChairID(i),pStatusFree->bTrustee[i]);
			}
			m_pBas->m_pHandCard->SetDisplayItem(true);

			if(SparrowCJDlg.is_open())
				SparrowCJDlg.close();
			SYSTEMTIME pLocalTime;
			GetLocalTime(&pLocalTime);
			CString str;
			str.Format(TEXT("%s-%ld-%ld-%ld.log"),GetUserData(GetMeChairID())->szNickName,
				pLocalTime.wYear,pLocalTime.wMonth,pLocalTime.wDay);
			//if(!Androiout.is_open())
			SparrowCJDlg.open(str,ios::app|ios::out);
			SparrowCJDlg<<pLocalTime.wYear<<"--"<<pLocalTime.wMonth<<"--"<<pLocalTime.wDay<<endl;
			SparrowCJDlg<<"GS_MJ_FREE"<<endl;

			for(BYTE i=0;i<GAME_PLAYER;i++)
			{
				if(GetUserData(i)!=NULL)
				{
					////Ƹȼ
					//if (GetServerType()==GAME_GENRE_GOLD || GetServerType()==GAME_GENRE_MATCH)
					//{
					//	LPCTSTR pszGameRank=m_GameRankManagerHelper->GetGoldLevelDescribe(GetUserData(i)->lGameGold);
					//	m_pBas->SetUserLevel(SwitchViewChairID(i),pszGameRank);
					//}
					////ֵȼ
					//if (GetServerType()==GAME_GENRE_SCORE)
					//{
					//	LPCTSTR pszGameRank=m_GameRankManagerHelper->GetLevelDescribe(GetUserData(i)->lScore);
					//	m_pBas->SetUserLevel(SwitchViewChairID(i),pszGameRank);
					//}
				}
			}

			m_pBas->SetShowHead(false);

			if (IsLookonMode()==false)
			{
				if(pStatusFree->bPlayerSitDown)
				{
					m_pBas->m_bShowSetCell=true;
					m_pBas->m_pSetCellScore->SetUserScore(GetUserData(GetMeChairID())->lScore);
				}
				else
				{
					if(pStatusFree->lCellScore==0)
					{
						m_pBas->m_bShowSetCell=true;
						m_pBas->m_pSetCellScore->SetWait();
					}
					else
					{
						if(pStatusFree->lCellScore*100>GetUserData(GetMeChairID())->lScore)
						{
							m_pBas->m_bShowSetCell=true;
							m_pBas->m_pSetCellScore->SetCellScore(pStatusFree->lCellScore,true);
						}
						else
						{
							m_pBas->m_bShowSetCell=true;
							m_pBas->m_pSetCellScore->SetCellScore(pStatusFree->lCellScore,false);
							m_pBas->SetCellScore(pStatusFree->lCellScore);
						}
					}
				}
				SetGameTimerN(GetMeChairID(),IDI_START_GAME,TIME_START_GAME);
			}

			m_pBas->SetDiscUser(INVALID_CHAIR);
		}
	case GS_MJ_PLAY:
		{
			//Ч
			if (wDataSize!=sizeof(CMD_S_StatusPlay)) return false;
			CMD_S_StatusPlay * pStatusPlay=(CMD_S_StatusPlay *)pBuffer;

			m_pBas->m_bStart=true;

			//
			WORD wMeChairID=GetMeChairID();
			WORD wViewChairID[GAME_PLAYER]={0,0};
			for (WORD i=0;i<GAME_PLAYER;i++) wViewChairID[i]=SwitchViewChairID(i);

			m_pBas->m_pStartButton->SetShow(FALSE);

			for(BYTE i=0;i<GAME_PLAYER;i++)
			{
				if(GetUserData(i)!=NULL)
				{
					////Ƹȼ
					//if (GetServerType()==GAME_GENRE_GOLD || GetServerType()==GAME_GENRE_MATCH)
					//{
					//	LPCTSTR pszGameRank=m_GameRankManagerHelper->GetGoldLevelDescribe(GetUserData(i)->lGameGold);
					//	m_pBas->SetUserLevel(SwitchViewChairID(i),pszGameRank);
					//}
					////ֵȼ
					//if (GetServerType()==GAME_GENRE_SCORE)
					//{
					//	LPCTSTR pszGameRank=m_GameRankManagerHelper->GetLevelDescribe(GetUserData(i)->lScore);
					//	m_pBas->SetUserLevel(SwitchViewChairID(i),pszGameRank);

					//}
				}
			}

			//ñ
			m_wBankerUser=pStatusPlay->wBankerUser;
			m_wCurrentUser=pStatusPlay->wCurrentUser;
			m_wReplaceUser=pStatusPlay->wReplaceUser;
			m_cbLeftCardCount=pStatusPlay->cbLeftCardCount;
			m_cbListenStatus = pStatusPlay->cbHearStatus[wMeChairID];
			m_bHearStatus = pStatusPlay->bHearStatus[wMeChairID];
			if(m_bHearStatus)
			{
				m_pBas->m_pHandCard->SetShowAnimate(true);
			}
			m_bWillHearStatus = pStatusPlay->bWillHearStatus;
			m_wHeapHead = pStatusPlay->wHeapHead;
			m_wHeapTail = pStatusPlay->wHeapTail;
			CopyMemory(m_HeapCardInfo,pStatusPlay->HeapCardInfo,sizeof(m_HeapCardInfo));
			m_pBas->m_bGameStart=true;
//			CopyMemory( m_cbHeapCardInfo,pStatusPlay->cbHeapCardInfo,sizeof(m_cbHeapCardInfo) );

			for(BYTE i=0;i<GAME_PLAYER;i++)
			{
				m_pBas->SetHuaCount(SwitchViewChairID(i),pStatusPlay->cbHuaCardCount[i]);
				m_pBas->SetFanShu(SwitchViewChairID(i),pStatusPlay->dwFanShu[i]);
			}

			m_pBas->SetUserFanShu();

			//û
			for( WORD i = 0; i < GAME_PLAYER; i++ )
			{
				const tagUserInfo * pUserData=GetUserData(i);
				ASSERT( pUserData != NULL );
				if( pUserData == NULL ) 
				{
					m_szAccounts[i][0] = 0;
					continue;
				}
				if(pUserData->szNickName[0]!=NULL)
					lstrcpy( m_szAccounts[i],pUserData->szNickName );
				else
					lstrcpy( m_szAccounts[i],pUserData->szNickName );
			}

			//Թ
			if( IsLookonMode()==true )
				m_pBas->m_pHandCard->SetDisplayItem(IsAllowLookon());

			//й
			for (WORD i=0;i<GAME_PLAYER;i++)
			{
				m_pBas->SetTrustee(SwitchViewChairID(i),pStatusPlay->bTrustee[i]);
			}

			if( pStatusPlay->bTrustee[wMeChairID] )
			{
				OnStusteeControl();
			}

			m_wTimeOutCount=0;

			//˿˱
			CopyMemory(m_cbWeaveCount,pStatusPlay->cbWeaveCount,sizeof(m_cbWeaveCount));
			CopyMemory(m_WeaveItemArray,pStatusPlay->WeaveItemArray,sizeof(m_WeaveItemArray));
			m_GameLogic.SwitchToCardIndex(pStatusPlay->cbCardData,pStatusPlay->cbCardCount,m_cbCardIndex);

			m_lSiceCount=pStatusPlay->lSiceCount;
			BYTE cbCardIndex;
			WORD wSice = WORD(m_lSiceCount&0xffff);
			{
				cbCardIndex = (((BYTE)HIBYTE(wSice))+((BYTE)LOBYTE(wSice))-1)*2;
			}

			//
			m_pBas->SetCellScore(pStatusPlay->lCellScore);
			m_pBas->SetBankerUser(wViewChairID[m_wBankerUser]);

			//˿
			for (WORD i=0;i<GAME_PLAYER;i++)
			{
				WORD wOperateViewID = SwitchViewChairID(i);
				for (BYTE j=0;j<m_cbWeaveCount[i];j++)
				{
					DWORD cbWeaveKind=m_WeaveItemArray[i][j].cbWeaveKind;
					BYTE cbCenterCard=m_WeaveItemArray[i][j].cbCenterCard;
					BYTE cbWeaveCardCount=(cbWeaveKind&(WIK_LEFT|WIK_CENTER|WIK_RIGHT|WIK_PENG))?3:4;
					m_pBas->m_pWeaveCard[wViewChairID[i]][j]->SetCardData(m_WeaveItemArray[i][j].cbCardData,cbWeaveCardCount,j);
					if ((cbWeaveKind&WIK_GANG)&&(m_WeaveItemArray[i][j].wProvideUser==i)) 
						m_pBas->m_pWeaveCard[wViewChairID[i]][j]->SetDisplayItem(false);
					WORD wProviderViewID = SwitchViewChairID(m_WeaveItemArray[i][j].wProvideUser);
					m_pBas->m_pWeaveCard[wOperateViewID][j]->SetDirectionCardPos((BYTE)wProviderViewID);
				}
			}

			m_pBas->SetShowHead(true);

			//û˿
			if (m_wCurrentUser==wMeChairID&&pStatusPlay->cbSendCardData!=0&&
				m_cbCardIndex[m_GameLogic.SwitchToCardIndex(pStatusPlay->cbSendCardData)] > 0 )
			{
				SetHandCardControl(m_cbCardIndex,pStatusPlay->cbSendCardData);
				m_cbSendCard=pStatusPlay->cbSendCardData;
			}
			else
			{
				SetHandCardControl(m_cbCardIndex,0x00);
				m_cbSendCard=0x00;
			}

			//˿
			for (WORD i=0;i<GAME_PLAYER;i++)
			{
				//û˿
				if (i!=wMeChairID)
				{
					BYTE cbCardCount=MAX_COUNT-m_cbWeaveCount[i]*3-1;
					m_pBas->m_pUserCard->SetCardData(cbCardCount,(m_wCurrentUser==i));
				}

				//˿
				m_pBas->m_pDiscardCard[wViewChairID[i]]->SetCardData(pStatusPlay->cbDiscardCard[i],
					pStatusPlay->cbDiscardCount[i]);
			}

			//Ч
			if(pStatusPlay->wOutCardUser != INVALID_CHAIR)
			{
				m_pBas->SetDiscUser(SwitchViewChairID(pStatusPlay->wOutCardUser));
				m_pBas->SetOutCardInfo( wViewChairID[pStatusPlay->wOutCardUser],pStatusPlay->cbOutCardData );
				m_pBas->m_pDiscardCard[wViewChairID[pStatusPlay->wOutCardUser]]->AddCardItem( pStatusPlay->cbOutCardData );
			}

			//
			if (IsLookonMode()==false) 
			{
				m_pBas->m_pHandCard->SetPositively(true);
				m_pBas->m_pHandCard->SetDisplayItem(true);
			}

			//
			for (WORD i=0;i<GAME_PLAYER;i++)
			{
				WORD wRemoveCount=m_HeapCardInfo[i].wRemoveCount;
				for(WORD j=0;j<wRemoveCount;j++)
				{
					m_HeapCardInfo[i].wStartIndex--;
					WORD wIndex=m_HeapCardInfo[i].wStartIndex;

					if( wIndex%2 != 0 )
					{
						m_pBas->m_pHeadCard[SwitchViewChairID(i)]->SetCardEmpty( wIndex-1,1 );
					}
					else 
					{
						m_pBas->m_pHeadCard[SwitchViewChairID(i)]->SetCardEmpty( wIndex+1,1 );
					}
				}
			}

			//
			if ((IsLookonMode()==false)&&(pStatusPlay->cbActionMask!=WIK_NULL))
			{
				//ȡ
				m_cbActionMask=pStatusPlay->cbActionMask;
				m_cbActionCard=pStatusPlay->cbActionCard;

				//ý
				if (m_wCurrentUser==INVALID_CHAIR)
				{
					SetGameTimerN(wMeChairID,IDI_OPERATE_CARD,10);
				}
				if (IsLookonMode()==false) 
				{
					m_pBas->SetControlInfo(m_cbActionMask);
					CMD_C_ShowThink ShowThink;
					ShowThink.bShowThink=true;
					SendSocketData(SUB_C_SHOW_THINK,&ShowThink,sizeof(ShowThink));
				}
				for(BYTE i=0;i<GAME_PLAYER;i++)
				{
					m_pBas->m_bTingCard[SwitchViewChairID(i)]=pStatusPlay->bHearStatus[i];
				}
			}
			else
			{
				//ʱ
				if (m_wCurrentUser!=INVALID_CHAIR)
				{
					//ʱ
					WORD wTimeCount=TIME_OPERATE_CARD;

					//ʱ
					SetGameTimerN(m_wCurrentUser,IDI_OPERATE_CARD,wTimeCount);
				}
				else if(m_wReplaceUser==wMeChairID&&!IsLookonMode())
					m_bReplace=true;
			}

			return true;
		}
	case GS_MJ_END:
		{
			//Ч
			if (wDataSize!=sizeof(CMD_S_StatusEnd)) return false;
			CMD_S_StatusEnd * pStatusEnd=(CMD_S_StatusEnd *)pBuffer;

			m_pBas->m_bStart=true;

			//
			WORD wMeChairID=GetMeChairID();
			WORD wViewChairID[GAME_PLAYER]={0,0};
			for (WORD i=0;i<GAME_PLAYER;i++) 
				wViewChairID[i]=SwitchViewChairID(i);

			m_pBas->m_pStartButton->SetShow(FALSE);

			for(BYTE i=0;i<GAME_PLAYER;i++)
			{
				if(GetUserData(i)!=NULL)
				{
					////Ƹȼ
					//if (GetServerType()==GAME_GENRE_GOLD || GetServerType()==GAME_GENRE_MATCH)
					//{
					//	LPCTSTR pszGameRank=m_GameRankManagerHelper->GetGoldLevelDescribe(GetUserData(i)->lGameGold);
					//	m_pBas->SetUserLevel(SwitchViewChairID(i),pszGameRank);
					//}
					////ֵȼ
					//if (GetServerType()==GAME_GENRE_SCORE)
					//{
					//	LPCTSTR pszGameRank=m_GameRankManagerHelper->GetLevelDescribe(GetUserData(i)->lScore);
					//	m_pBas->SetUserLevel(SwitchViewChairID(i),pszGameRank);

					//}
				}
			}

			//ñ
			m_wBankerUser=pStatusEnd->wBankerUser;
			m_wCurrentUser=pStatusEnd->wCurrentUser;
			m_wReplaceUser=pStatusEnd->wReplaceUser;
			m_cbLeftCardCount=pStatusEnd->cbLeftCardCount;
			m_cbListenStatus = pStatusEnd->cbHearStatus[wMeChairID];
			m_bHearStatus = pStatusEnd->bHearStatus[wMeChairID];
			m_bWillHearStatus = pStatusEnd->bWillHearStatus;

			for(BYTE i=0;i<GAME_PLAYER;i++)
			{
				m_pBas->SetHuaCount(SwitchViewChairID(i),pStatusEnd->cbHuaCardCount[i]);
			}

			//û
			for( WORD i = 0; i < GAME_PLAYER; i++ )
			{
				const tagUserInfo * pUserData=GetUserData(i);
				ASSERT( pUserData != NULL );
				if( pUserData == NULL ) 
				{
					m_szAccounts[i][0] = 0;
					continue;
				}
				if(pUserData->szNickName[0]!=NULL)
					lstrcpy( m_szAccounts[i],pUserData->szNickName );
				else
					lstrcpy( m_szAccounts[i],pUserData->szNickName );
			}

			//˿˱
			CopyMemory(m_cbWeaveCount,pStatusEnd->cbWeaveCount,sizeof(m_cbWeaveCount));
			CopyMemory(m_WeaveItemArray,pStatusEnd->WeaveItemArray,sizeof(m_WeaveItemArray));
			m_GameLogic.SwitchToCardIndex(pStatusEnd->cbCardData[wMeChairID],pStatusEnd->cbCardCount[wMeChairID],m_cbCardIndex);

			m_lSiceCount=pStatusEnd->lSiceCount;
			BYTE cbCardIndex;
			WORD wSice = WORD(m_lSiceCount&0xffff);
			{
				cbCardIndex = (((BYTE)HIBYTE(wSice))+((BYTE)LOBYTE(wSice))-1)*2;
			}

			//
			m_pBas->SetCellScore(pStatusEnd->lCellScore);
			m_pBas->SetBankerUser(wViewChairID[m_wBankerUser]);

			//˿
			for (WORD i=0;i<GAME_PLAYER;i++)
			{
				WORD wOperateViewID = SwitchViewChairID(i);
				for (BYTE j=0;j<m_cbWeaveCount[i];j++)
				{
					DWORD cbWeaveKind=m_WeaveItemArray[i][j].cbWeaveKind;
					BYTE cbCenterCard=m_WeaveItemArray[i][j].cbCenterCard;
					BYTE cbWeaveCardCount=(cbWeaveKind&(WIK_LEFT|WIK_CENTER|WIK_RIGHT|WIK_PENG))?3:4;
					m_pBas->m_pWeaveCard[wViewChairID[i]][j]->SetCardData(m_WeaveItemArray[i][j].cbCardData,cbWeaveCardCount,j);
					if ((cbWeaveKind&WIK_GANG)&&(m_WeaveItemArray[i][j].wProvideUser==i)) 
						m_pBas->m_pWeaveCard[wViewChairID[i]][j]->SetDisplayItem(false);
					WORD wProviderViewID = SwitchViewChairID(m_WeaveItemArray[i][j].wProvideUser);
					m_pBas->m_pWeaveCard[wOperateViewID][j]->SetDirectionCardPos((BYTE)wProviderViewID);

				}
			}
			m_pBas->SetShowHead(true);

			//˿
			for (WORD i=0;i<GAME_PLAYER;i++)
			{
				//˿
				m_pBas->m_pDiscardCard[wViewChairID[i]]->SetCardData(pStatusEnd->cbDiscardCard[i],pStatusEnd->cbDiscardCount[i]);
			}

			//Ч
			if(pStatusEnd->wOutCardUser != INVALID_CHAIR)
			{
				m_pBas->SetDiscUser(SwitchViewChairID(pStatusEnd->wOutCardUser));
				m_pBas->SetOutCardInfo( wViewChairID[pStatusEnd->wOutCardUser],pStatusEnd->cbOutCardData );
				m_pBas->m_pDiscardCard[wViewChairID[pStatusEnd->wOutCardUser]]->AddCardItem( pStatusEnd->cbOutCardData );
			}

			//
			if (IsLookonMode()==false) 
			{
				m_pBas->m_pHandCard->SetPositively(true);
				m_pBas->m_pHandCard->SetDisplayItem(true);
			}

			//
			for (WORD i=0;i<GAME_PLAYER;i++)
			{
//				m_pBas->m_pHeadCard[SwitchViewChairID(i)]->SetHeapCardInfo(m_cbHeapCardInfo[i][0],m_cbHeapCardInfo[i][1]);
			}

			if(pStatusEnd->bDuiHuaStatus)
			{
				//û˿
				for (WORD i=0;i<GAME_PLAYER;i++)
				{
					WORD wViewChairID=SwitchViewChairID(i);
					m_pBas->m_pTableCard[wViewChairID]->SetCardData(pStatusEnd->cbCardData[i],pStatusEnd->cbCardCount[i]);
				}

				m_pBas->m_pTableCard[SwitchViewChairID(pStatusEnd->wEndChairID)]->SetProvideCard(pStatusEnd->cbProvideCard);

				WORD wEndChairID=SwitchViewChairID(pStatusEnd->wEndChairID);
				for(BYTE i=0;i<10;i++)
				{
					if(pStatusEnd->cbShowPlayCard[i]!=0)
					{
						m_pBas->m_pTableCard[wEndChairID]->SetDuiHuaCard(pStatusEnd->cbShowPlayCard[i]);
						for(BYTE j=0;j<m_cbWeaveCount[pStatusEnd->wEndChairID];j++)
						{
							m_pBas->m_pWeaveCard[wEndChairID][j]->SetDuiHuaCard(pStatusEnd->cbShowPlayCard[i]);
						}
						m_pBas->m_pGameScore->SetDuiHuaCard(pStatusEnd->cbShowPlayCard[i]);
					}
				}

				//˿
				m_pBas->m_pUserCard->SetCardData(0,false);
				m_pBas->m_pHandCard->SetCardData(NULL,0,0);
				bool bShow=pStatusEnd->wEndChairID==GetMeChairID(),
					bLook=IsLookonMode();
				m_pBas->m_pEndPlay->SetPlayCard((bShow&&!bLook),true,pStatusEnd->cbEndPlayData);
				m_pBas->m_pEndPlay->SetShowCard(pStatusEnd->cbShowPlayCard);
				m_pBas->m_bShowPlay=true;
			}

			if(pStatusEnd->bHaiDiStatus)
			{
				//Թ
				if( IsLookonMode()==true )
					m_pBas->m_pHandCard->SetDisplayItem(IsAllowLookon());

				SetHandCardControl(m_cbCardIndex,0x00);
				m_cbSendCard=0x00;

				//˿
				for (WORD i=0;i<GAME_PLAYER;i++)
				{
					//û˿
					if (i!=wMeChairID)
					{
						BYTE cbCardCount=MAX_COUNT-m_cbWeaveCount[i]*3-1;
						m_pBas->m_pUserCard->SetCardData(cbCardCount,false);
					}
				}
				bool bShow=pStatusEnd->wEndChairID==GetMeChairID(),
					bLook=IsLookonMode();
				m_pBas->m_pEndPlay->SetPlayCard((bShow&&!bLook),false,pStatusEnd->cbEndPlayData);
				m_pBas->m_pEndPlay->SetShowCard(pStatusEnd->cbShowPlayCard);
				m_pBas->m_bShowPlay=true;
			}
			SetGameTimerN(pStatusEnd->wEndChairID,IDI_DUI_HUA,10);

			return true;
		}
	}
	
	return true;
}
bool TL_Gwindow::OnSubSetCell(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_SendCell));
	if (wDataSize!=sizeof(CMD_S_SendCell)) 
	{
		AfxMessageBox(TEXT("OnSubSetCell"));
		return false;
	}

	CMD_S_SendCell * pSendCell=(CMD_S_SendCell *)pBuffer;
	if(pSendCell->wChairID==GetMeChairID())
	{
		m_pBas->SetCellScore(pSendCell->lCellScore);
		OnStart(NULL);
	}
	else
	{
		if(pSendCell->lCellScore*100>GetUserData(GetMeChairID())->lScore)
			m_pBas->m_pSetCellScore->SetCellScore(pSendCell->lCellScore,true);
		else
			m_pBas->m_pSetCellScore->SetCellScore(pSendCell->lCellScore,false);
	}
	return true;
}

bool TL_Gwindow::OnSubShowSet(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_SendSet));
	if (wDataSize!=sizeof(CMD_S_SendSet)) 
	{
		return false;
	}

	CMD_S_SendSet * pSendSet=(CMD_S_SendSet *)pBuffer;

	if(pSendSet->wChairID==GetMeChairID())
	{
		m_pBas->m_pSetCellScore->ReleaseData();
		m_pBas->m_bShowSetCell=true;
		m_pBas->m_pSetCellScore->SetUserScore(GetUserData(GetMeChairID())->lScore);
	}

	return true;
}
bool TL_Gwindow::OnSubDuiHua(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_DuiHua));
	if(wDataSize!=sizeof(CMD_S_DuiHua))
		return false;
	CMD_S_DuiHua * pDuiHua=(CMD_S_DuiHua *)pBuffer;

	KillGameTimerN(IDI_OPERATE_CARD);
	KillGameTimerN(IDI_CHI_HU);

	SetGameStatus(GS_MJ_END);

	//״̬
	m_pBas->SetStatusFlag(false,false);

	//û˿
	for (WORD i=0;i<GAME_PLAYER;i++)
	{
		WORD wViewChairID=SwitchViewChairID(i);
		if (pDuiHua->dwChiHuKind[i]!=WIK_NULL)
		{
			m_pBas->SetUserAction(wViewChairID,WIK_CHI_HU,SwitchViewChairID(pDuiHua->wProvideUser),
				pDuiHua->wProvideUser==i);
			m_pBas->m_pTableCard[wViewChairID]->SetProvideCard(pDuiHua->cbProvideCard);
			PlayActionSound( i,WIK_CHI_HU,pDuiHua->wProvideUser==i);
		}
		m_pBas->m_pTableCard[wViewChairID]->SetCardData(pDuiHua->cbCardData[i],pDuiHua->cbCardCount[i]);
	}

	//˿
	m_pBas->m_pUserCard->SetCardData(0,false);
	m_pBas->m_pHandCard->SetCardData(NULL,0,0);
	m_bDuiHuaStatus=true;

	if(pDuiHua->wChairID==GetMeChairID()&&IsLookonMode()==false)
	{
		m_pBas->m_pEndPlay->SetPlayCard(true,true,pDuiHua->cbDuiHuaCard);
	}
	else
	{
		m_pBas->m_pEndPlay->SetPlayCard(false,true,pDuiHua->cbDuiHuaCard);
	}

	SetGameTimerN(pDuiHua->wChairID,IDI_DUI_HUA,10);

	return true;
}
bool TL_Gwindow::OnSubDuiHuaResult(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_ContinueDH));
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_ContinueDH));
	if(wDataSize!=sizeof(CMD_S_ContinueDH))
		return false;
	CMD_S_ContinueDH * pContinueDH=(CMD_S_ContinueDH *)pBuffer;

	if(pContinueDH->bContinue)
	{
		WORD wViewChairID=SwitchViewChairID(pContinueDH->wChairID);
		m_pBas->m_pTableCard[wViewChairID]->SetDuiHuaCard(pContinueDH->cbCardData);
		for(BYTE i=0;i<m_cbWeaveCount[pContinueDH->wChairID];i++)
		{
			m_pBas->m_pWeaveCard[wViewChairID][i]->SetDuiHuaCard(pContinueDH->cbCardData);
		}
		m_pBas->m_pGameScore->SetDuiHuaCard(pContinueDH->cbCardData);
		SetGameTimerN(pContinueDH->wChairID,IDI_DUI_HUA,10);
	}

	if(IsLookonMode()==false)
		m_pBas->m_pEndPlay->SetCanDown(pContinueDH->bContinue);


	return true;
}
bool TL_Gwindow::OnSubHaiDi(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_HaiDi));
	if(wDataSize!=sizeof(CMD_S_HaiDi))
		return false;
	CMD_S_HaiDi * pHaiDi=(CMD_S_HaiDi *)pBuffer;

	KillGameTimerN(IDI_OPERATE_CARD);
	KillGameTimerN(IDI_CHI_HU);

	SetGameStatus(GS_MJ_END);

	//״̬
	m_pBas->SetStatusFlag(false,false);

	if(pHaiDi->wChairID==GetMeChairID()&&IsLookonMode()==false)
	{
		m_pBas->m_pEndPlay->SetPlayCard(true,false,pHaiDi->cbHaiDiCard);
		m_pBas->m_bShowPlay=true;
		m_pBas->m_pEndPlay->SetStart();
	}
	else
	{
		m_pBas->m_pEndPlay->SetPlayCard(false,false,pHaiDi->cbHaiDiCard);
		m_pBas->m_bShowPlay=true;
		m_pBas->m_pEndPlay->SetCanDown(false);
	}

	SetGameTimerN(pHaiDi->wChairID,IDI_DUI_HUA,10);
	return true;
}
bool TL_Gwindow::OnSubRedouble(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_Redouble));
	if(wDataSize!=sizeof(CMD_S_Redouble))
		return false;
	CMD_S_Redouble * pRedouble=(CMD_S_Redouble *)pBuffer;

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		m_pBas->SetFanShu(SwitchViewChairID(i),pRedouble->dwFanShu[i]);
	}

	m_pBas->m_DrawThinking.HideAnimate();

	m_pBas->ShowRedAnimate(SwitchViewChairID(pRedouble->wChairID));

	if(pRedouble->wChairID!=GetMeChairID())
	{
		const tagUserInfo* pUserData= GetUserData(pRedouble->wChairID);
		if(pUserData!=NULL)
		{
			bool bBoy = (pUserData->cbGender == 2 ? false : true);
			if(bBoy)
				m_pBas->PlayGameSound("BOY_RM");
			else
				m_pBas->PlayGameSound("Girl_RF");
		}
	}

	return true;
}
bool TL_Gwindow::OnSubShowRedouble(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_ShowRedouble));
	if(wDataSize!=sizeof(CMD_S_ShowRedouble))
		return false;
	CMD_S_ShowRedouble * pShowRedouble=(CMD_S_ShowRedouble *)pBuffer;

	if(pShowRedouble->wChairID==GetMeChairID())
	{
		m_pBas->SetFanCount(pShowRedouble->dwFanCount,true);
	}

	return true;
}
bool TL_Gwindow::OnSubShowThink(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_ShowThink));
	if(wDataSize!=sizeof(CMD_S_ShowThink))
		return false;
	CMD_S_ShowThink * pShowThink=(CMD_S_ShowThink *)pBuffer;

	if(pShowThink->wChairID!=GetMeChairID())
	{
		if(pShowThink->bShowThink)
			m_pBas->m_DrawThinking.ShowAnimate();
		else
			m_pBas->m_DrawThinking.HideAnimate();
	}

	return true;
}
bool TL_Gwindow::OnSubTingInfo(const void * pBuffer,WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_UpDataTInfo));
	if(wDataSize!=sizeof(CMD_S_UpDataTInfo))
		return false;
	CMD_S_UpDataTInfo * pUpDataTInfo=(CMD_S_UpDataTInfo *)pBuffer;

	CWHArray<tagTingInfo> tempCard;
	tempCard.RemoveAll();

	tagTingInfo TingInfo;
	for(BYTE i=0;i<pUpDataTInfo->cbInfoCount;i++)
	{
		TingInfo.cbCardCount=pUpDataTInfo->cbCount[i];
		TingInfo.cbCardData=pUpDataTInfo->cbCardData[i];
		TingInfo.cbFan=pUpDataTInfo->dwFanShu[i];
		tempCard.Add(TingInfo);
	}

	m_pBas->UpDataTingInfo(tempCard);

	if(!m_pBas->m_btChiHuCue.GetState())
	{
		m_pBas->m_btChiHuCue.SetState(true);
	}

	return true;
}
bool TL_Gwindow::OnSubStartOver(const void * pBuffer, WORD wDataSize)
{
	WORD wMeChairId=GetMeChairID();
	//Ʋ
	if (!IsLookonMode()&&(m_wReplaceUser==wMeChairId))
	{
		if(m_bOutCard)
		{
			//ʱ
			m_bReplace=true;
		}
		else
		{
			m_bReplace=false;
			m_lReplaceCount=0;

			m_pBas->SetUserAction(INVALID_CHAIR,0,0);

			//Ѱ˿
			for(BYTE i=MAX_INDEX-MAX_HUA_CARD;i<MAX_INDEX;i++)
			{
				if(m_cbCardIndex[i]>0)
				{
					//
					BYTE cbReplaceCard=m_GameLogic.SwitchToCardData(i);
					if( !m_GameLogic.RemoveCard(m_cbCardIndex,cbReplaceCard) )
					{
						ASSERT( FALSE );
						return false;
					}

					//˿
					SetHandCardControl(m_cbCardIndex,0x00);

					//ý
					m_pBas->SetUserAction( MYSELF_VIEW_ID,WIK_REPLACE,0 );

					CMD_C_ReplaceCard ReplaceCard;
					ReplaceCard.cbCardData=cbReplaceCard;
					SendSocketData(SUB_C_REPLACE_CARD,&ReplaceCard,sizeof(ReplaceCard));

					break;
				}
			}
		}
	}

	SparrowCJDlg<<"OnSubStartOver cbCardData: "<<endl;
	for(BYTE j=0;j<MAX_INDEX;j++)
	{
		for(BYTE w=0;w<m_cbCardIndex[j];w++)
		{
			SparrowCJDlg<<(WORD)m_GameLogic.SwitchToCardData(j)<<" ";
		}
	}
	SparrowCJDlg<<endl;

	//ʾ,
	if (!IsLookonMode()&&(m_wCurrentUser==wMeChairId))
	{
		m_pBas->SetStatusFlag(true,false);

		if( m_cbActionMask != WIK_NULL )
		{
			m_pBas->SetControlInfo(m_cbActionMask);
			CMD_C_ShowThink ShowThink;
			ShowThink.bShowThink=true;
			SendSocketData(SUB_C_SHOW_THINK,&ShowThink,sizeof(ShowThink));
		}
	}
	else if( m_wCurrentUser != wMeChairId && m_wCurrentUser != INVALID_CHAIR )
		m_pBas->SetStatusFlag(false,true);

	if(!IsLookonMode())
	{
		m_pBas->m_btStartStustee.SetState(true);
		m_pBas->m_btStopStustee.SetState(true);
		//m_pBas->m_pSort->SetState(eItemStateNormal);
	}

	//ʱ
	if (m_wCurrentUser!=INVALID_CHAIR)
	{
		m_pBas->SetCurrentUser(SwitchViewChairID(m_wCurrentUser));
		SetGameTimerN(m_wCurrentUser,IDI_OPERATE_CARD,TIME_OPERATE_CARD);
	}

	m_bGameStart=true;
	m_pBas->m_pHandCard->CutCardOver();
	return true;
}
bool TL_Gwindow::OnSubHaiDiResult(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_ContinueHD));
	if(wDataSize!=sizeof(CMD_S_ContinueHD))
		return false;
	CMD_S_ContinueHD * pContinueHD=(CMD_S_ContinueHD *)pBuffer;

	if(pContinueHD->wChiarID==GetMeChairID())
	{
		if(!pContinueHD->bHaiDiOver)
		{
			if(!pContinueHD->bContinue)
			{
				m_cbHaiDiIndex=0;
				m_bHaiDiUpdata=true;
				m_bHaiDiHu=true;
				m_pBas->m_pEndPlay->SetAllShow();
				m_pBas->m_pEndPlay->SetCanDown(false);
			}
		}
		else
		{
			m_cbHaiDiIndex=0;
			m_bHaiDiUpdata=true;
			m_bHaiDiHu=false;
			m_pBas->m_pEndPlay->SetAllShow();
			m_pBas->m_pEndPlay->SetCanDown(false);
		}
	}

	if(pContinueHD->bContinue)
	{
		SetGameTimerN(pContinueHD->wChiarID,IDI_DUI_HUA,10);
	}

	return true;
}
bool TL_Gwindow::OnSubReplaceCard(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_ReplaceCard));
	if (wDataSize!=sizeof(CMD_S_ReplaceCard))
	{
		return false;
	}

	//
	CMD_S_ReplaceCard * pReplaceCard=(CMD_S_ReplaceCard *)pBuffer;

	WORD wReplaceUser = pReplaceCard->wReplaceUser;
	WORD wReplaceUserViewId = SwitchViewChairID(wReplaceUser);
	BYTE cbReplaceCard = pReplaceCard->cbReplaceCard;

	if(pReplaceCard->bOutCardData)
		PlayActionSound(pReplaceCard->wReplaceUser,WIK_REPLACE);

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		m_pBas->SetHuaCount(SwitchViewChairID(i),pReplaceCard->cbHuaCardCount[i]);
	}

	if(IsLookonMode()||pReplaceCard->wReplaceUser!=GetMeChairID())
	{
		//ö
		m_pBas->SetOutCardInfo(INVALID_CHAIR,0);

		//˿
		if (wReplaceUserViewId==MYSELF_VIEW_ID)
		{
			//ɾ˿
			if( !m_GameLogic.RemoveCard(m_cbCardIndex,cbReplaceCard) )
			{
				ASSERT( FALSE );
				return false;
			}

			//˿
			SetHandCardControl(m_cbCardIndex,0x00);
		}
		else
		{
			//˿
			WORD wUserIndex=(wReplaceUserViewId>2)?2:wReplaceUserViewId;
			if( m_pBas->m_pUserCard->IsHaveCurrentCard() )
				m_pBas->m_pUserCard->SetCurrentCard(false);
			else
			{
				WORD wCardCount = m_pBas->m_pUserCard->GetCardCount();
				m_pBas->m_pUserCard->SetCardData(wCardCount-1,false);
			}
		}
	}

	return true;
}
//Ϸʼ
bool TL_Gwindow::OnSubGameStart(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_GameStart));
	if (wDataSize!=sizeof(CMD_S_GameStart)) 
	{
		AfxMessageBox(TEXT("OnSubGameStart"));
		return false;
	}

	KillGameTimerN(IDI_OPERATE_CARD);

	CMD_S_GameStart * pGameStart=(CMD_S_GameStart *)pBuffer;

	if(IsLookonMode())
	{
		ReleaseGame();
		m_pBas->ReleaseGame();
		//˿
		m_pBas->m_pUserCard->SetCardData(0,false);
		m_pBas->m_pHandCard->SetCardData(NULL,0,0);
		m_pBas->m_pHandCard->CutCardOver();
		m_pBas->m_pHandCard->ReleaseInfo();
		m_pBas->m_pGameScore->RestorationData();
		m_pBas->m_bStart=true;
		m_pBas->m_bShowBelle=(!m_pBas->m_bShowBelle);
		m_pBas->SetUpScore(m_lUpScore);
		m_pBas->SetDiscUser(INVALID_CHAIR);

		//˿
		for (WORD i=0;i<GAME_PLAYER;i++)
		{
			m_pBas->m_pTableCard[i]->SetCardData(NULL,0);
			m_pBas->m_pTableCard[i]->SetProvideCard(0);
			m_pBas->m_pTableCard[i]->ResealeInfo();
			m_pBas->m_pDiscardCard[i]->SetCardData(NULL,0);
			for( BYTE j = 0; j < CountArray(m_pBas->m_pWeaveCard[i]); j++ )
			{
				m_pBas->m_pWeaveCard[i][j]->SetCardData(NULL,0,0);
				m_pBas->m_pWeaveCard[i][j]->ResealeInfo();
			}
		}

		//˿
		for (WORD i=0;i<GAME_PLAYER;i++)
		{
			m_pBas->m_pHeadCard[i]->ResetCardData();
			m_pBas->m_pHeadCard[i]->SetHeapCardInfo(0,0);
		}


		KillGameTimerN(IDI_START_GAME);
	}



	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		if(GetUserData(i)!=NULL)
		{
			////Ƹȼ
			//if (GetServerType()==GAME_GENRE_GOLD || GetServerType()==GAME_GENRE_MATCH)
			//{
			//	LPCTSTR pszGameRank=m_GameRankManagerHelper->GetGoldLevelDescribe(GetUserData(i)->lGameGold);
			//	m_pBas->SetUserLevel(SwitchViewChairID(i),pszGameRank);
			//}
			////ֵȼ
			//if (GetServerType()==GAME_GENRE_SCORE)
			//{
			//	LPCTSTR pszGameRank=m_GameRankManagerHelper->GetLevelDescribe(GetUserData(i)->lScore);
			//	m_pBas->SetUserLevel(SwitchViewChairID(i),pszGameRank);

			//}
		}
	}

	//û
	for( WORD i = 0; i < GAME_PLAYER; i++ )
	{
		const tagUserInfo * pUserData=GetUserData(i);
		ASSERT( pUserData != NULL );
		if( pUserData == NULL ) 
		{
			m_szAccounts[i][0] = 0;
			continue;
		}
		if(pUserData->szNickName[0]!=NULL)
			lstrcpy( m_szAccounts[i],pUserData->szNickName );
		else
			lstrcpy( m_szAccounts[i],pUserData->szNickName );
	}

	//״̬
	SetGameStatus(GS_MJ_PLAY);

	srand( (unsigned)time( NULL ) );
	m_pBas->PlayBGMusic(rand()%3);

	m_pBas->m_bGameStart=true;

	//ñ
	m_bHearStatus=false;
	m_bWillHearStatus=false;
	m_wBankerUser=pGameStart->wBankerUser;
	m_wCurrentUser=pGameStart->wCurrentUser;
	m_wReplaceUser=pGameStart->wReplaceUser;
	m_cbLeftCardCount=MAX_REPERTORY-GAME_PLAYER*(MAX_COUNT-1)-1;
	m_cbActionMask = pGameStart->cbUserAction;
	m_lSiceCount = pGameStart->lSiceCount;
	m_bOutCard=pGameStart->bOutCardData;

	BYTE cbCardCount=(GetMeChairID()==m_wBankerUser)?MAX_COUNT:(MAX_COUNT-1);
	m_GameLogic.SwitchToCardIndex(pGameStart->cbCardData,cbCardCount,m_cbCardIndex);

	//öͷβ
	m_wHeapHead = pGameStart->wHeapHead;
	m_wHeapTail = pGameStart->wHeapTail;
//	CopyMemory( m_cbHeapCardInfo,pGameStart->cbHeapCardInfo,sizeof(m_cbHeapCardInfo) );
	CopyMemory(m_HeapCardInfo,pGameStart->HeapCardInfo,sizeof(m_HeapCardInfo));

	m_pBas->SetBankerUser(SwitchViewChairID(m_wBankerUser));

	m_pBas->PlayGameSound("Common_Start");

	if(pGameStart->lSiceCount!=0)
	{
		tagActionSice *pActionSice=(tagActionSice *)ActiveUserAction(AK_Sice);
		ASSERT(pActionSice);
		if(!pActionSice) return false;
		pActionSice->lSiceCount=pGameStart->lSiceCount;

		m_UserActionArray.Add(pActionSice);
	}

	//ƶ
	WORD wMeChairID=GetMeChairID();
	BYTE cbHandCardData[MAX_COUNT];
	m_GameLogic.SwitchToCardData(m_cbCardIndex,cbHandCardData);
	m_GameLogic.RandCardData(cbHandCardData,(m_wBankerUser==wMeChairID)?MAX_COUNT:MAX_COUNT-1,cbHandCardData);
	WORD wHeapId = m_wHeapTail;
	WORD wHeapCardIndex = m_HeapCardInfo[m_wHeapTail].wStartIndex-1;
	//4Ȧ1Ȧһ
	for( BYTE i = 0; i < 4; i++ )
	{
		//ׯҿʼ
		WORD wId = m_wBankerUser;
		for( WORD j = 0; j < GAME_PLAYER; j++ )
		{
			WORD wChairId = (wId+GAME_PLAYER-j)%GAME_PLAYER;

			//Ŀ
			tagActionStartCard *pStartCardItem = (tagActionStartCard *)ActiveUserAction(AK_StartCard);
			ASSERT( pStartCardItem );
			if( !pStartCardItem ) return false;

			//
			pStartCardItem->cbCardCount = i<3?4:1;
			//ֵ
			if( wChairId == wMeChairID )
				CopyMemory( pStartCardItem->cbCardData,&cbHandCardData[i*4],sizeof(BYTE)*(i<3?4:1) );
			//
			pStartCardItem->wChairId = wChairId;
			//λ
			pStartCardItem->wHeapId = wHeapId;
			//λ
			pStartCardItem->wHeapCardIndex = wHeapCardIndex;

			pStartCardItem->bLastItem = false;
			//붯
			m_UserActionArray.Add(pStartCardItem);

			//ƽ
			if( i < 3 )
			{
				if( wHeapCardIndex <= 3 )
				{
					m_HeapCardInfo[wHeapId].wStartIndex=wHeapCardIndex;
					wHeapId = (wHeapId+1)%GAME_PLAYER;
					wHeapCardIndex = HEAP_FULL_COUNT-(3-wHeapCardIndex)-1;
				}
				else 
					wHeapCardIndex -= 4;
			}
			else
			{
				if( wHeapCardIndex == 0 )
				{
					m_HeapCardInfo[wHeapId].wStartIndex=wHeapCardIndex;
					wHeapId = (wHeapId+1)%GAME_PLAYER;
					wHeapCardIndex = HEAP_FULL_COUNT-1;
				}
				else 
					wHeapCardIndex--;
			}
		}
	}
	//һţׯ
	tagActionStartCard *pStartCardItem = (tagActionStartCard *)ActiveUserAction(AK_StartCard);
	ASSERT( pStartCardItem );
	if( !pStartCardItem ) return false;
	//
	pStartCardItem->cbCardCount = 1;
	//ֵ
	if( m_wBankerUser == wMeChairID )
		pStartCardItem->cbCardData[0] = cbHandCardData[MAX_COUNT-1];
	//
	pStartCardItem->wChairId = m_wBankerUser;
	//λ
	pStartCardItem->wHeapId = wHeapId;
	//λ
	pStartCardItem->wHeapCardIndex = wHeapCardIndex;
	//һ
	pStartCardItem->bLastItem = true;
	//붯
	m_UserActionArray.Add(pStartCardItem);

	m_HeapCardInfo[wHeapId].wStartIndex=wHeapCardIndex;

	m_pBas->m_pHandCard->CutCardOver();

	//ʼ
	BeginUserAction();

	return true;
}
bool TL_Gwindow::OnSubOutCard(const void * pBuffer, WORD wDataSize)
{
	//ЧϢ
	ASSERT(wDataSize==sizeof(CMD_S_OutCard));
	if (wDataSize!=sizeof(CMD_S_OutCard))
	{
		AfxMessageBox(TEXT("OnSubOutCard"));
		return false;
	}

	//Ϣ
	CMD_S_OutCard * pOutCard=(CMD_S_OutCard *)pBuffer;

	if( IsLookonMode() || pOutCard->wOutCardUser != GetMeChairID() )
	{
		tagActionOutCard *pActionOutCard = (tagActionOutCard *)ActiveUserAction(AK_OutCard);
		ASSERT(pActionOutCard);
		if( !pActionOutCard ) return false;

		pActionOutCard->cbOutCardData = pOutCard->cbOutCardData;
		pActionOutCard->wOutCardUser = pOutCard->wOutCardUser;
		pActionOutCard->bCurrentTing=pOutCard->bCurrentTing;

		//Ӷ
		m_UserActionArray.Add(pActionOutCard);

		//ʼ
		BeginUserAction();
	}

	return true;
}
bool TL_Gwindow::OnSubSendCard(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_SendCard));
	if (wDataSize!=sizeof(CMD_S_SendCard))
	{
		AfxMessageBox(TEXT("OnSubSendCard"));
		return false;
	}

	//Ϣ
	CMD_S_SendCard * pSendCard=(CMD_S_SendCard *)pBuffer;

	tagActionSendCard *pActionSendCard = (tagActionSendCard *)ActiveUserAction(AK_SendCard);
	ASSERT(pActionSendCard);
	if( !pActionSendCard ) return false;

	pActionSendCard->bTail = pSendCard->bTail;
	pActionSendCard->cbCardCount=pSendCard->cbCardCount;
	pActionSendCard->cbActionMask = pSendCard->cbActionMask;
	pActionSendCard->cbCardData = pSendCard->cbCardData;
	pActionSendCard->wCurrentUser = pSendCard->wCurrentUser;
	pActionSendCard->wSendCardUser = pSendCard->wSendCardUser;
	pActionSendCard->wReplaceUser = pSendCard->wReplaceUser;
	pActionSendCard->bReplace=pSendCard->bReplaceCard;
	pActionSendCard->bOutCard=pSendCard->bOutCardData;
	pActionSendCard->bCurrentTing=pSendCard->bCurrentTing;

	//Ӷ
	m_UserActionArray.Add(pActionSendCard);

	//ʼ
	BeginUserAction();

	return true;
}

//û
bool TL_Gwindow::OnSubListenCard(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_Listen));
	if (wDataSize!=sizeof(CMD_S_Listen)) 
		return false;

	//
	CMD_S_Listen * pListenCard=(CMD_S_Listen *)pBuffer;

	//ý
	WORD wViewChairID=SwitchViewChairID(pListenCard->wChairId);
	//m_GameClientView.SetUserListenStatus(wViewChairID,true);
	KillGameTimerN(IDI_OPERATE_CARD);
	m_wListenUser=wViewChairID;

	ZeroMemory(m_cbDiscardCount,sizeof(m_cbDiscardCount));
	ZeroMemory(m_cbDiscardCard,sizeof(m_cbDiscardCard));
	CopyMemory(m_cbDiscardCount,pListenCard->cbDiscardCount,sizeof(m_cbDiscardCount));
	CopyMemory(m_cbDiscardCard,pListenCard->cbDiscardCard,sizeof(m_cbDiscardCard));

	if(pListenCard->wChairId == GetMeChairID())//------------Ƽ
	{
		BYTE bLeftCardCount = 0 ;					//ʣĿ
		BYTE bCardIndex[MAX_INDEX];				    //˿
		ZeroMemory(bCardIndex,sizeof(bCardIndex));

		BYTE cbCardData[MAX_COUNT];
		BYTE cbCardCount=m_GameLogic.SwitchToCardData(m_cbCardIndex,cbCardData);
		//m_GameClientView.m_HandCardControl.SetAllCardGray(true);
		m_pBas->m_pHandCard->SetAllCardGray(true);
		for ( int i = 0 ; i < cbCardCount ; i ++ )
		{
			if( VerdictOutCard( cbCardData[ i ] ) )
			{
				bCardIndex[ bLeftCardCount++ ] = cbCardData[ i ] ;
			}
		}
		//m_GameClientView.m_HandCardControl.SetCardGray(bCardIndex,bLeftCardCount,FALSE);
		m_pBas->m_pHandCard->SetCardGray(bCardIndex,bLeftCardCount,FALSE);
		m_pBas->m_pHandCard->SetListen(true);
		//CWHArray<BYTE> tempCard;
		//if(GetTingCard(tempCard))
		//	m_pBas->SetTingInfo(tempCard);
	}///Ƽ

	if(pListenCard->wChairId!=GetMeChairID())
	{
		m_pBas->m_DrawThinking.HideAnimate();
	}

	SetGameTimerN(pListenCard->wChairId,IDI_OPERATE_CARD,10);
	return true;
}
//
bool TL_Gwindow::OnSubListenSet(const void * pBuffer,WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_ListenSet));
	if (wDataSize!=sizeof(CMD_S_ListenSet)) 
		return false;

	//
	CMD_S_ListenSet * pListenSet=(CMD_S_ListenSet *)pBuffer;
	
	if(pListenSet->bListen)
	{
		m_pBas->SetUserAction(SwitchViewChairID(pListenSet->wChairID),WIK_LISTEN,0);
		if(pListenSet->wChairID==GetMeChairID())
		{
			m_pBas->m_pHandCard->SetShowAnimate(true);
			m_pBas->m_pHandCard->SetHearStatus(true);
			m_pBas->m_btChiHuCue.SetState(true);
		}
		PlayActionSound(pListenSet->wChairID,WIK_LISTEN);
	}
	else 
	{
		if(pListenSet->wChairID==GetMeChairID())
		{
			m_pBas->m_pHandCard->SetShowAnimate(false);
			m_pBas->m_pHandCard->SetHearStatus(false);
			m_pBas->m_btChiHuCue.SetState(false);
		}
		m_pBas->StopTing(SwitchViewChairID(pListenSet->wChairID));
	}

	return true;
}
//ȡ
bool TL_Gwindow::GetTingCard(BYTE cbCardData,CWHArray<tagTingInfo> &tCard)
{
	//ж
	if ((m_bHearStatus==true)||(m_bWillHearStatus==true))
	{
		//
		CChiHuRight chr;
		CChiHuRight chrhigh;
		CChiHuRight chrnew;
		WORD wMeChairID=GetMeChairID();
		BYTE cbWeaveCount=m_cbWeaveCount[wMeChairID];

		//˿
		BYTE cbCardIndexTemp[MAX_INDEX];
		CopyMemory(cbCardIndexTemp,m_cbCardIndex,sizeof(cbCardIndexTemp));

		//ɾ˿
		if( !m_GameLogic.RemoveCard(cbCardIndexTemp,cbCardData) )
		{
			ASSERT( FALSE );
			return false;
		}

		//ж
		BYTE i=0;
		tagTingInfo TingInfo;
		for (;i<MAX_INDEX;i++)
		{
			//Ʒ
			BYTE cbCurrentCard=m_GameLogic.SwitchToCardData(i);
			BYTE cbHuCardKind=m_GameLogic.AnalyseChiHuCard(cbCardIndexTemp,m_WeaveItemArray[wMeChairID],
				cbWeaveCount,cbCurrentCard,chr,chrhigh,chrnew);

			//ж
			if (cbHuCardKind!=WIK_NULL)
			{
				FiltrateRight(wMeChairID,cbCurrentCard,cbCardData,chr,chrhigh,chrnew);
				WORD wFanShuo=m_GameLogic.GetChiHuActionRank(chr,chrhigh,chrnew,cbCurrentCard);
				if(wFanShuo>=88)
					wFanShuo=88;
				TingInfo.cbCardData=m_GameLogic.SwitchToCardData(i);
				TingInfo.cbFan=wFanShuo;
				TingInfo.cbCardCount=4-GetDiscardCount(m_GameLogic.SwitchToCardData(i));
				tCard.Add(TingInfo);
			}
		}
		return tCard.GetCount()!=0;
	}

	return false;
}
//ʾ
bool TL_Gwindow::OnSubOperateNotify(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_OperateNotify));
	if (wDataSize!=sizeof(CMD_S_OperateNotify))
	{
		AfxMessageBox(TEXT("OnSubOperateNotify"));
		return false;
	}

	//
	CMD_S_OperateNotify * pOperateNotify=(CMD_S_OperateNotify *)pBuffer;

	//Ӷ
	tagActionActionNotify *pActionActionNotify = (tagActionActionNotify *)ActiveUserAction(AK_ActionNotify);
	ASSERT( pActionActionNotify );
	if( !pActionActionNotify ) return false;

	pActionActionNotify->cbActionCard = pOperateNotify->cbActionCard;
	pActionActionNotify->cbActionMask = pOperateNotify->cbActionMask;
	pActionActionNotify->bShow=pOperateNotify->bShow;

	m_UserActionArray.Add(pActionActionNotify);

	//ʼ
	BeginUserAction();

	return true;
}

//
bool TL_Gwindow::OnSubOperateResult(const void * pBuffer, WORD wDataSize)
{
	//ЧϢ
	ASSERT(wDataSize==sizeof(CMD_S_OperateResult));
	if (wDataSize!=sizeof(CMD_S_OperateResult)) 
	{
		AfxMessageBox(TEXT("OnSubOperateResult"));
		return false;
	}

	//Ϣ
	CMD_S_OperateResult * pOperateResult=(CMD_S_OperateResult *)pBuffer;

	//Ӷ
	tagActionActionResult *pActionActionResult = (tagActionActionResult *)ActiveUserAction(AK_ActionResult);
	ASSERT( pActionActionResult );
	if( !pActionActionResult ) return false;

	pActionActionResult->wOperateUser = pOperateResult->wOperateUser;
	pActionActionResult->wProvideUser = pOperateResult->wProvideUser;
	pActionActionResult->cbOperateCode = pOperateResult->cbOperateCode;
	CopyMemory( pActionActionResult->cbOperateCard,pOperateResult->cbOperateCard,
		sizeof(pOperateResult->cbOperateCard) );	

	m_UserActionArray.Add(pActionActionResult);	

	//ʼ
	BeginUserAction();

	return true;
}

//Ϸ
bool TL_Gwindow::OnSubGameEnd(const void * pBuffer, WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_GameEnd));
	if (wDataSize!=sizeof(CMD_S_GameEnd)) 
	{
		AfxMessageBox(TEXT("OnSubGameEnd"));
		return false;
	}

	KillGameTimerN(IDI_OPERATE_CARD);
	//Ϣ
	CMD_S_GameEnd * pGameEnd=(CMD_S_GameEnd *)pBuffer;

	//
	tagActionGameEnd *pActionGameEnd = (tagActionGameEnd *)ActiveUserAction(AK_GameEnd);
	CopyMemory( pActionGameEnd->cbCardCount,pGameEnd->cbCardCount,sizeof(pGameEnd->cbCardCount) );
	CopyMemory( pActionGameEnd->cbCardData,pGameEnd->cbCardData,sizeof(pGameEnd->cbCardData) );
	pActionGameEnd->cbProvideCard = pGameEnd->cbProvideCard;
	CopyMemory( pActionGameEnd->dwChiHuKind,pGameEnd->dwChiHuKind,sizeof(pGameEnd->dwChiHuKind) );
	CopyMemory( pActionGameEnd->dwChiHuRight,pGameEnd->dwChiHuRight,sizeof(pGameEnd->dwChiHuRight) );
	CopyMemory( pActionGameEnd->dwChiHuHigh,pGameEnd->dwChiHuHigh,sizeof(pGameEnd->dwChiHuHigh));
	CopyMemory( pActionGameEnd->dwChiHuNew,pGameEnd->dwChiHuNew,sizeof(pGameEnd->dwChiHuNew));
	CopyMemory( pActionGameEnd->lGameScore,pGameEnd->lGameScore,sizeof(pGameEnd->lGameScore) );
	CopyMemory( pActionGameEnd->lGameGold,pGameEnd->lGameGold,sizeof(pGameEnd->lGameGold) );
	pActionGameEnd->cbMingGangCount=pGameEnd->cbMingGangCount;
	pActionGameEnd->cbAnGangCount=pGameEnd->cbAnGangCount;
	pActionGameEnd->lCellScore = pGameEnd->lCellScore;
	pActionGameEnd->lGameTax = pGameEnd->lGameTax;
	pActionGameEnd->wProvideUser = pGameEnd->wProvideUser;
	pActionGameEnd->wChengBaoUser = pGameEnd->wChengBaoUser;
	pActionGameEnd->bUserOut=pGameEnd->bUserOut;
	pActionGameEnd->cbPaiMianCard=pGameEnd->cbPaiMianCard;
	pActionGameEnd->cbHuaCardCount=pGameEnd->cbHuaCardCount;
	pActionGameEnd->dwFanShu=pGameEnd->dwFanShu;

	m_UserActionArray.Add(pActionGameEnd);

	m_bGameEnd=true;
	if(!IsLookonMode())
	{
		//m_pBas->m_pSort->SetState(eItemStateDisable);
		m_pBas->m_pHandCard->m_bGameEnd=true;
	}
	BeginUserAction();

	return true;
}
bool TL_Gwindow::OnSubTrustee(const void * pBuffer,WORD wDataSize)
{
	//Ч
	ASSERT(wDataSize==sizeof(CMD_S_Trustee));
	if (wDataSize!=sizeof(CMD_S_Trustee))
	{
		AfxMessageBox(TEXT("OnSubTrustee"));
		return false;
	}

	//Ϣ
	CMD_S_Trustee * pTrustee=(CMD_S_Trustee *)pBuffer;
	m_pBas->SetTrustee(SwitchViewChairID(pTrustee->wChairID),pTrustee->bTrustee);

	return true;
}
//˿
void TL_Gwindow::SetHandCardControl(BYTE cbCardIndex[MAX_INDEX], BYTE cbAdvanceCard)
{
	//Ŀ
	WORD wMeChairID=GetMeChairID();
	BYTE cbWeaveCardCount=m_cbWeaveCount[wMeChairID]*3;

	//ת˿
	BYTE cbHandCardData[MAX_COUNT];
	BYTE cbCardCount=m_GameLogic.SwitchToCardData(cbCardIndex,cbHandCardData);

	//˿
	if ( (cbWeaveCardCount+cbCardCount)==MAX_COUNT )
	{
		if( cbAdvanceCard != 0x00 )
		{
			//ɾ˿
			BYTE cbRemoveCard[]={cbAdvanceCard};
			VERIFY( m_GameLogic.RemoveCard(cbHandCardData,cbCardCount,cbRemoveCard,1) );

			//˿
			cbHandCardData[cbCardCount-1]=cbAdvanceCard;
		}

		m_GameLogic.SortCardList(cbHandCardData,cbCardCount-1,!m_bSort);
		m_pBas->m_pHandCard->SetCardData(cbHandCardData,cbCardCount-1,cbHandCardData[cbCardCount-1]);
		m_pBas->m_pHandCard->SetShowCaiShen(true);
	}
	else 
	{
		m_GameLogic.SortCardList(cbHandCardData,cbCardCount,!m_bSort);
		m_pBas->m_pHandCard->SetCardData(cbHandCardData,cbCardCount,0x00);
		m_pBas->m_pHandCard->SetShowCaiShen(true);
	}

	return;
}

//
tagUserAction *TL_Gwindow::ActiveUserAction(enmActionKind enActionKind)
{
	//
	tagUserAction *pUserAction=NULL;

	//´
	switch( enActionKind )
	{
	case AK_StartCard:
		{
			pUserAction = new tagActionStartCard;
			return pUserAction;
		}
	case AK_OutCard:
		{
			pUserAction = new tagActionOutCard;
			return pUserAction;
		}
	case AK_SendCard:
		{
			pUserAction = new tagActionSendCard;
			return pUserAction;
		}
	case AK_ReplaceCard:
		{
			pUserAction = new tagActionReplaceCard;
			return pUserAction;
		}
	case AK_ActionNotify:
		{
			pUserAction = new tagActionActionNotify;
			return pUserAction;
		}
	case AK_ActionResult:
		{
			pUserAction = new tagActionActionResult;
			return pUserAction;
		}
	case AK_GameEnd:
		{
			pUserAction = new tagActionGameEnd;
			return pUserAction;
		}
	case AK_Sice:
		{
			pUserAction = new tagActionSice;
			return pUserAction;
		}
	default:
		{
			ASSERT(FALSE);
			break;
		}
	}

	return pUserAction;
}

bool TL_Gwindow::BeginUserAction()
{
	if(m_UserActionArray.GetCount()==0)
		return false;

	switch(m_UserActionArray[0]->enActionKind)
	{
	case AK_StartCard:				//
		return BeginActionStartCard();
	case AK_OutCard:				//
		return BeginActionOutCard();
	case AK_SendCard:				//ץ
		return BeginActionSendCard();
	case AK_ActionNotify:			//ʾ
		return BeginActionNotify();
	case AK_ActionResult:			//
		return BeginActionResult();
	case AK_Sice:					//ɫ
		return BeginActionSice();	
	case AK_GameEnd:
		return BeginActionGameEnd();
	default:
		return false;
	}

	return false;
}
//ƶ
bool TL_Gwindow::BeginActionStartCard()
{
	//Ч
	ASSERT( m_UserActionArray.GetCount() > 0 );
	if( m_UserActionArray.GetCount() == 0 ) return false;
	if( m_UserActionArray[0]->bHandleStatus ) return true;

	//
	tagActionStartCard *pStartCardItem = (tagActionStartCard *)m_UserActionArray[0];

	pStartCardItem->bHandleStatus = TRUE;

	//ʼ,
	CPoint ptFrom,ptTo;
	//λ
	WORD wHeapId = pStartCardItem->wHeapId;
	WORD wHeapViewId = SwitchViewChairID(wHeapId);
	//λ
	WORD wHeapCardIndex = pStartCardItem->wHeapCardIndex;
	if( pStartCardItem->cbCardCount > wHeapCardIndex+1 )
	{
		ASSERT( pStartCardItem->cbCardCount == 4 );
		//ɾǰĶ
		m_pBas->m_pHeadCard[wHeapViewId]->SetCardEmpty( wHeapCardIndex,wHeapCardIndex+1 );

		wHeapId = (wHeapId+1)%GAME_PLAYER;
		wHeapViewId = SwitchViewChairID(wHeapId);
		wHeapCardIndex = HEAP_FULL_COUNT-(4-(wHeapCardIndex+1))-1;

		//ȡʼ
		ptFrom = m_pBas->m_pHeadCard[wHeapViewId]->GetDispatchCardPos(WORD(wHeapCardIndex-1));

		//ɾ
		m_pBas->m_pHeadCard[wHeapViewId]->SetCardEmpty( HEAP_FULL_COUNT-1,
			pStartCardItem->cbCardCount-pStartCardItem->wHeapCardIndex-1 );

	}
	else
	{
		WORD wHeapPos = wHeapCardIndex;
		if( pStartCardItem->cbCardCount == 4 )
			wHeapPos -= 3;
		else
		{
			ASSERT( pStartCardItem->cbCardCount == 1 );
			if( wHeapPos%2 != 0 ) wHeapPos--;
			else wHeapPos++;
		}
		//ȡʼ
		ptFrom = m_pBas->m_pHeadCard[wHeapViewId]->GetDispatchCardPos(wHeapPos);

		//ɾ
		if( pStartCardItem->cbCardCount == 4 )
			m_pBas->m_pHeadCard[wHeapViewId]->SetCardEmpty( wHeapCardIndex,4 );
		else
		{
			ASSERT( pStartCardItem->cbCardCount == 1 );
			if( wHeapCardIndex%2 != 0 )
				m_pBas->m_pHeadCard[wHeapViewId]->SetCardEmpty( wHeapCardIndex-1,pStartCardItem->cbCardCount );
			else 
				m_pBas->m_pHeadCard[wHeapViewId]->SetCardEmpty( wHeapCardIndex+1,pStartCardItem->cbCardCount );
		}
	}

	//ȡ
	WORD wViewChairId = SwitchViewChairID(pStartCardItem->wChairId);
	if( wViewChairId == MYSELF_VIEW_ID )
		ptTo = m_pBas->m_pHandCard->GetDispatchCardPos();
	else
	{
		WORD wUserIndex = wViewChairId>2?2:wViewChairId;
		ptTo = m_pBas->m_pUserCard->GetDispatchCardPos();
	}

	//춯
	tagMoveCardItem mci;
	mci.ptFrom = ptFrom;
	mci.ptTo = ptTo;
	mci.cbCardCount = pStartCardItem->cbCardCount;
	mci.cbCardData = 0;
	mci.wViewChairId = wViewChairId;
	mci.fScaleStart=m_pBas->m_pHeadCard[wViewChairId]->GetScaleCard();
	if(wViewChairId==0)
	{
		mci.fScaleEnd=0.75f;
	}
	else
	{
		mci.fScaleEnd=1.4f;
	}
	m_pBas->OnMoveCardItem( mci );

	return true;
}

//ɫ
bool TL_Gwindow::BeginActionSice()
{
	//Ч
	ASSERT( m_UserActionArray.GetCount() > 0 );
	if( m_UserActionArray.GetCount() == 0 ) return false;
	if( m_UserActionArray[0]->bHandleStatus ) return true;

	//
	tagActionSice *pActionSice = (tagActionSice *)m_UserActionArray[0];

	pActionSice->bHandleStatus = TRUE;

	m_pBas->PlayGameSound("Common_Sice");

	//ҡɫӶ
	m_pBas->m_pSiceContainer->SetSiceInfo((WORD)(pActionSice->lSiceCount));

	m_pBas->m_pSiceContainer->SetShow(TRUE);

	return true;
}
//ƶ
bool TL_Gwindow::BeginActionOutCard()
{
	//Ч
	ASSERT( m_UserActionArray.GetCount() > 0 );
	if( m_UserActionArray.GetCount() == 0 ) return false;
	if( m_UserActionArray[0]->bHandleStatus ) return true;

	//
	tagActionOutCard *pOutCardItem = (tagActionOutCard *)m_UserActionArray[0];

	pOutCardItem->bHandleStatus = TRUE;

	//
	WORD wMeChairId = GetMeChairID();
	WORD wOutCardUser = pOutCardItem->wOutCardUser;
	WORD wViewOutCardUser = SwitchViewChairID(wOutCardUser);
	BYTE cbOutCardData = pOutCardItem->cbOutCardData;

	//
	KillGameTimerN(IDI_OPERATE_CARD);
	KillGameTimerN(IDI_CHI_HU);

	//ñ
	m_wCurrentUser=INVALID_CHAIR;
	m_cbActionMask = 0;
	m_cbActionCard = 0;

	//ʼ,
	CPoint ptFrom,ptTo;
	if( wOutCardUser == wMeChairId )
		ptFrom = m_pBas->m_pHandCard->GetDispatchCardPos(m_cbWeaveCount[GetMeChairID()]);
	else
	{
		WORD wViewId = wViewOutCardUser>=3?2:wViewOutCardUser;
		ptFrom = m_pBas->m_pUserCard->GetDispatchCardPos();
	}
	ptTo = m_pBas->m_pDiscardCard[wViewOutCardUser]->GetDispatchCardPos();

	PlayCardSound(wOutCardUser,cbOutCardData);

	//ý
	m_pBas->SetCurrentUser( INVALID_CHAIR );
	m_pBas->SetUserAction(INVALID_CHAIR,0,0);
	//ӵѶ
	//m_pBas->m_pDiscardCard[wViewOutCardUser]->AddCardItem( cbOutCardData );
	//m_pBas->SetStatusFlag(false,false);

	//˿
	if (wViewOutCardUser==MYSELF_VIEW_ID)
	{
		//ɾ˿
		if( !m_GameLogic.RemoveCard(m_cbCardIndex,cbOutCardData) )
		{
			ASSERT( FALSE );
			return false;
		}

		SetHandCardControl( m_cbCardIndex,0x00 );
		m_cbSendCard=0x00;
		CPoint ptTemp=m_pBas->m_pHandCard->GetCutPos(m_cbWeaveCount[GetMeChairID()]);
		if(m_pBas->m_pHandCard->GetSendData()!=0)
		{
			if(m_pBas->m_pHandCard->GetShowPlay()&&IsLookonMode()==false&&m_bStustee==false&&!m_bHearStatus)
				m_pBas->PlayCutCard(m_pBas->m_pHandCard->GetSendData(),m_pBas->m_pHandCard->GetDispatchCardPos(),ptTemp);
			else
				m_pBas->m_pHandCard->CutCardOver();
		}
	}
	else
	{
		m_pBas->m_pUserCard->SetCurrentCard(false);
	}

	ptTo.y-=10;
	tagMoveCardItem mci;
	mci.ptFrom = ptFrom;
	mci.ptTo = ptTo;
	mci.cbCardCount = 1;
	mci.cbCardData = cbOutCardData;
	mci.wViewChairId = wViewOutCardUser;
	m_pBas->OnMoveCardItem( mci );

	return true;
}

//ƶ
bool TL_Gwindow::BeginActionSendCard()
{
	SparrowCJDlg<<"BeginActionSendCard"<<endl;
	//Ч
	ASSERT( m_UserActionArray.GetCount() > 0 );
	if( m_UserActionArray.GetCount() == 0 ) return false;
	if( m_UserActionArray[0]->bHandleStatus ) return true;

	//
	tagActionSendCard *pSendCardItem = (tagActionSendCard *)m_UserActionArray[0];

	pSendCardItem->bHandleStatus = TRUE;

	WORD wSendUserViewId = SwitchViewChairID(pSendCardItem->wSendCardUser);
	SparrowCJDlg<<"pSendCardItem->wSendCardUser "<<pSendCardItem->wSendCardUser<<endl;
	SparrowCJDlg<<"wSendUserViewId "<<wSendUserViewId<<endl;
	//ʼ,
	CPoint ptFrom,ptTo;
	if( !pSendCardItem->bTail )
	{
		SparrowCJDlg<<"m_wHeapHead1 "<<m_wHeapHead<<endl;
		ASSERT( m_wHeapHead != INVALID_CHAIR );
		if(m_HeapCardInfo[m_wHeapHead].wStartIndex>0)
		{
			m_HeapCardInfo[m_wHeapHead].wStartIndex--;
			WORD wIndex=m_HeapCardInfo[m_wHeapHead].wStartIndex;

			if( wIndex%2 != 0 )
			{
				m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapHead)]->SetCardEmpty( wIndex-1,1 );
				ptFrom = m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapHead)]->GetDispatchCardPos(WORD(wIndex-1));
			}
			else 
			{
				m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapHead)]->SetCardEmpty( wIndex+1,1 );
				ptFrom = m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapHead)]->GetDispatchCardPos(WORD(wIndex+1));
			}
		}
		else
		{
			SparrowCJDlg<<"m_wHeapHead2 "<<m_wHeapHead<<endl;
			m_wHeapHead = (m_wHeapHead+1)%GAME_PLAYER;
			m_HeapCardInfo[m_wHeapHead].wStartIndex=HEAP_FULL_COUNT;

			SparrowCJDlg<<"m_wHeapHead3 "<<m_wHeapHead<<endl;
			m_HeapCardInfo[m_wHeapHead].wStartIndex--;
			WORD wIndex=m_HeapCardInfo[m_wHeapHead].wStartIndex;

			if( wIndex%2 != 0 )
			{
				m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapHead)]->SetCardEmpty( wIndex-1,1 );
				ptFrom = m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapHead)]->GetDispatchCardPos(WORD(wIndex-1));
			}
			else 
			{
				m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapHead)]->SetCardEmpty( wIndex+1,1 );
				ptFrom = m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapHead)]->GetDispatchCardPos(WORD(wIndex+1));
			}
		}
	}
	else
	{
		SparrowCJDlg<<"m_wHeapTail "<<m_wHeapTail<<endl;
		ASSERT( FALSE);
		ptFrom = m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapTail)]->GetDispatchCardPos(true);
		//ɾβ
		if( !m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapTail)]->DeductionHeapCard(true) )
		{
			m_wHeapTail = (m_wHeapTail+GAME_PLAYER-1)%GAME_PLAYER;
			ptFrom = m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapTail)]->GetDispatchCardPos(true);
			VERIFY( m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapTail)]->DeductionHeapCard(true) );
		}
	}

	if( wSendUserViewId == MYSELF_VIEW_ID )
		ptTo = m_pBas->m_pHandCard->GetDispatchCardPos();
	else
	{
		ptTo = m_pBas->m_pUserCard->GetDispatchCardPos();
	}

	//춯
	tagMoveCardItem mci;
	mci.ptFrom = ptFrom;
	mci.ptTo = ptTo;
	mci.cbCardCount = 1;
	mci.cbCardData = 0;
	mci.wViewChairId = SwitchViewChairID(pSendCardItem->wSendCardUser);
	mci.fScaleStart=m_pBas->m_pHeadCard[SwitchViewChairID(m_wHeapHead)]->GetScaleCard();
	if(wSendUserViewId==0)
	{
		mci.fScaleEnd=0.75f;
	}
	else
	{
		mci.fScaleEnd=1.4f;
	}
	m_pBas->OnMoveCardItem( mci,pSendCardItem->bOutCard );

	return true;
}

bool TL_Gwindow::BeginActionNotify()
{
	//Ч
	ASSERT( m_UserActionArray.GetCount() > 0 );
	if( m_UserActionArray.GetCount() == 0 ) return false;
	if( m_UserActionArray[0]->bHandleStatus ) return true;

	//
	tagActionActionNotify *pOperateNotify = (tagActionActionNotify *)m_UserActionArray[0];

	pOperateNotify->bHandleStatus = TRUE;

	SparrowCJDlg<<"BeginActionNotify cbCardData: "<<endl;
	for(BYTE j=0;j<MAX_INDEX;j++)
	{
		for(BYTE w=0;w<m_cbCardIndex[j];w++)
		{
			SparrowCJDlg<<(WORD)m_GameLogic.SwitchToCardData(j)<<" ";
		}
	}
	SparrowCJDlg<<endl;
	//û
	if ((IsLookonMode()==false)&&(pOperateNotify->cbActionMask!=WIK_NULL))
	{
		//ȡ
		WORD wMeChairID=GetMeChairID();
		m_cbActionMask = pOperateNotify->cbActionMask;
		m_cbActionCard = pOperateNotify->cbActionCard;

		//ڲģʽ,ȡ
		if( m_pBas->m_pHandCard->GetSelectMode() )
			m_pBas->m_pHandCard->SetSelectMode(false);

		m_pBas->SetControlInfo(m_cbActionMask,pOperateNotify->bShow);
		CMD_C_ShowThink ShowThink;
		ShowThink.bShowThink=true;
		SendSocketData(SUB_C_SHOW_THINK,&ShowThink,sizeof(ShowThink));

		//ʱ
		m_pBas->SetCurrentUser(INVALID_CHAIR);
	
		SetGameTimerN(GetMeChairID(),IDI_OPERATE_CARD,10);
	}

	return OnActionNotify();
}

//
bool TL_Gwindow::BeginActionResult()
{
	//Ч
	ASSERT( m_UserActionArray.GetCount() > 0 );
	if( m_UserActionArray.GetCount() == 0 ) return false;
	if( m_UserActionArray[0]->bHandleStatus ) return true;

	//
	tagActionActionResult *pOperateResult = (tagActionActionResult *)m_UserActionArray[0];

	pOperateResult->bHandleStatus = TRUE;

	//ɾʱ
	KillGameTimerN(IDI_OPERATE_CARD);

	//
	BYTE cbPublicCard=TRUE;
	WORD wOperateUser=pOperateResult->wOperateUser;
	BYTE cbOperateCard[3];
	CopyMemory( cbOperateCard,pOperateResult->cbOperateCard,sizeof(cbOperateCard) );
	WORD wOperateViewID=SwitchViewChairID(wOperateUser);
	WORD wProviderViewID = SwitchViewChairID(pOperateResult->wProvideUser);

	//ñ
	m_wCurrentUser=pOperateResult->wOperateUser;

	//
	if ((pOperateResult->cbOperateCode&WIK_GANG)!=0)
	{
		//ñ
		m_wCurrentUser=INVALID_CHAIR;

		//˿
		BYTE cbWeaveIndex=0xFF;
		for (BYTE i=0;i<m_cbWeaveCount[wOperateUser];i++)
		{
			DWORD cbWeaveKind=m_WeaveItemArray[wOperateUser][i].cbWeaveKind;
			BYTE cbCenterCard=m_WeaveItemArray[wOperateUser][i].cbCenterCard;
			if ((cbCenterCard==cbOperateCard[0])&&(cbWeaveKind==WIK_PENG))
			{
				cbWeaveIndex=i;
				m_WeaveItemArray[wOperateUser][cbWeaveIndex].cbPublicCard=TRUE;
				m_WeaveItemArray[wOperateUser][cbWeaveIndex].cbWeaveKind=pOperateResult->cbOperateCode;
				m_WeaveItemArray[wOperateUser][cbWeaveIndex].cbCardData[3] = cbCenterCard;
				break;
			}
		}

		//˿
		if (cbWeaveIndex==0xFF)
		{
			//ж
			cbPublicCard=(pOperateResult->wProvideUser==wOperateUser)?FALSE:TRUE;

			//˿
			cbWeaveIndex=m_cbWeaveCount[wOperateUser]++;
			m_WeaveItemArray[wOperateUser][cbWeaveIndex].cbPublicCard=cbPublicCard;
			m_WeaveItemArray[wOperateUser][cbWeaveIndex].cbCenterCard=cbOperateCard[0];
			m_WeaveItemArray[wOperateUser][cbWeaveIndex].cbWeaveKind=pOperateResult->cbOperateCode;
			m_WeaveItemArray[wOperateUser][cbWeaveIndex].wProvideUser=pOperateResult->wProvideUser;
			for( BYTE i = 0; i < 4; i++ ) m_WeaveItemArray[wOperateUser][cbWeaveIndex].cbCardData[i] = cbOperateCard[0];

			m_pBas->m_pWeaveCard[wOperateViewID][cbWeaveIndex]->SetDirectionCardPos((BYTE)wProviderViewID);
		}

		//Ͻ
		DWORD cbWeaveKind=pOperateResult->cbOperateCode;
		BYTE cbWeaveCardCount=4;
		m_pBas->m_pWeaveCard[wOperateViewID][cbWeaveIndex]->SetCardData(m_WeaveItemArray[wOperateUser][cbWeaveIndex].cbCardData,
			cbWeaveCardCount,cbWeaveIndex);
		m_pBas->m_pWeaveCard[wOperateViewID][cbWeaveIndex]->SetDisplayItem((cbPublicCard==TRUE)?true:false);

		//˿
		if (GetMeChairID()==wOperateUser)
		{
			m_cbCardIndex[m_GameLogic.SwitchToCardIndex(cbOperateCard[0])]=0;
		}

		//˿
		if (GetMeChairID()==wOperateUser)
		{
			SetHandCardControl( m_cbCardIndex,0x00 );
			m_cbSendCard=0x00;
		}
		else
		{
			BYTE cbCardCount=MAX_COUNT-m_cbWeaveCount[wOperateUser]*3;
			m_pBas->m_pUserCard->SetCardData(cbCardCount-1,false);
		}

		m_pBas->SetFanCount(0,false);
	}
	else if ((pOperateResult->cbOperateCode!=WIK_NULL&&pOperateResult->cbOperateCode!=WIK_LISTEN))
	{
		//
		BYTE cbWeaveIndex=m_cbWeaveCount[wOperateUser]++;
		m_WeaveItemArray[wOperateUser][cbWeaveIndex].cbPublicCard=TRUE;
		m_WeaveItemArray[wOperateUser][cbWeaveIndex].cbCenterCard=cbOperateCard[0];
		m_WeaveItemArray[wOperateUser][cbWeaveIndex].cbWeaveKind=pOperateResult->cbOperateCode;
		m_WeaveItemArray[wOperateUser][cbWeaveIndex].wProvideUser=pOperateResult->wProvideUser;
		CopyMemory( m_WeaveItemArray[wOperateUser][cbWeaveIndex].cbCardData,cbOperateCard,sizeof(cbOperateCard) );

		//Ͻ
		BYTE cbWeaveCard[3];
		DWORD cbWeaveKind=pOperateResult->cbOperateCode;
		BYTE cbWeaveCardCount=3;
		CopyMemory( cbWeaveCard,cbOperateCard,sizeof(cbWeaveCard) );
		m_GameLogic.SortCardList(cbWeaveCard,cbWeaveCardCount);
		m_pBas->m_pWeaveCard[wOperateViewID][cbWeaveIndex]->SetCardData(cbWeaveCard,cbWeaveCardCount,cbWeaveIndex);
		m_pBas->m_pWeaveCard[wOperateViewID][cbWeaveIndex]->SetDirectionCardPos((BYTE)wProviderViewID);

		//ɾ˿
		if (GetMeChairID()==wOperateUser)
		{
			VERIFY( m_GameLogic.RemoveCard(cbWeaveCard,cbWeaveCardCount,&cbOperateCard[0],1) );
			if( !m_GameLogic.RemoveCard(m_cbCardIndex,cbWeaveCard,cbWeaveCardCount-1) )
			{
				ASSERT( FALSE );
				return false;
			}
		}

		//˿
		if (GetMeChairID()==wOperateUser)
		{
			SetHandCardControl( m_cbCardIndex,0x00 );
			m_cbSendCard=0x00;
		}
		else
		{
			BYTE cbCardCount=MAX_COUNT-m_cbWeaveCount[wOperateUser]*3;
			m_pBas->m_pUserCard->SetCardData(cbCardCount-1,true);
		}
	}

	////
	//if( pOperateResult->wOperateUser == GetMeChairID() && 
	//	(pOperateResult->cbOperateCode&(WIK_LISTEN|WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN|WIK_PENG_LISTEN)) )
	//{
	//	m_bWillHearStatus = true;
	//}

	{
		//ṩҲԼ,ȥṩҵѳ
		if( pOperateResult->wProvideUser != wOperateUser )
		{
			if( m_pBas->m_pDiscardCard[wProviderViewID]->GetCardCount() > 0 )
				m_pBas->m_pDiscardCard[wProviderViewID]->RemoveCard(1);
		}
		m_pBas->SetOutCardInfo(INVALID_CHAIR,0); 
//		m_pBas->m_pControlWnd->SetShow(SW_HIDE);
		m_pBas->SetButtonShow(FALSE);
		OnHideRedouble();
		m_pBas->SetUserAction(wOperateViewID,pOperateResult->cbOperateCode,0);
		m_pBas->SetStatusFlag((IsLookonMode()==false)&&(m_wCurrentUser==GetMeChairID()),false);
		//ڲģʽ,ȡ
		if( m_pBas->m_pHandCard->GetSelectMode() )
			m_pBas->m_pHandCard->SetSelectMode(false);
		m_pBas->m_pHandCard->CutCardOver();
	}

	//
	PlayActionSound(wOperateUser,pOperateResult->cbOperateCode);


	SparrowCJDlg<<"BeginActionResult cbCardData: "<<endl;
	for(BYTE j=0;j<MAX_INDEX;j++)
	{
		for(BYTE w=0;w<m_cbCardIndex[j];w++)
		{
			SparrowCJDlg<<(WORD)m_GameLogic.SwitchToCardData(j)<<" ";
		}
	}
	SparrowCJDlg<<endl;

	//ʱ
	if (m_wCurrentUser!=INVALID_CHAIR)
	{
		//ж
		if ((IsLookonMode()==false)&&!m_bHearStatus&&!m_bWillHearStatus&&(m_wCurrentUser==GetMeChairID()))
		{
			//ж
			WORD wMeChairID=GetMeChairID();
			BYTE cbWeaveCount=m_cbWeaveCount[wMeChairID];
			WORD cbActionMask=m_GameLogic.AnalyseTingCard(m_cbCardIndex,m_WeaveItemArray[wMeChairID],cbWeaveCount);

			m_cbActionMask = cbActionMask;

			//ʾ
			if (cbActionMask!=NULL&&!(m_cbActionMask&WIK_CHI_HU))
			{
				//m_GameClientView.SetControlWnd(0,cbActionMask);
				//m_GameClientView.m_ControlWnd.SetControlInfo(0,cbActionMask);
				m_pBas->SetControlInfo(cbActionMask);
				m_pBas->SetFanCount(0,false);
				CMD_C_ShowThink ShowThink;
				ShowThink.bShowThink=true;
				SendSocketData(SUB_C_SHOW_THINK,&ShowThink,sizeof(ShowThink));
			}
		}
		//ʱ
		WORD wTimeCount=TIME_OPERATE_CARD;

		//ʱ
		m_pBas->SetCurrentUser(SwitchViewChairID(m_wCurrentUser));
		SetGameTimerN(m_wCurrentUser,IDI_OPERATE_CARD,wTimeCount);
	}

	return OnActionResult();
}

bool TL_Gwindow::BeginActionGameEnd()
{
	//Ч
	ASSERT( m_UserActionArray.GetCount() > 0 );
	if( m_UserActionArray.GetCount() == 0 ) return false;
	if( m_UserActionArray[0]->bHandleStatus ) return true;

	//
	tagActionGameEnd *pGameEnd = (tagActionGameEnd *)m_UserActionArray[0];

	pGameEnd->bHandleStatus = TRUE;

	//״̬
	m_pBas->SetStatusFlag(false,false);

	//ɾʱ
	KillGameTimerN(IDI_OPERATE_CARD);

	//ÿؼ
	m_pBas->SetStatusFlag(false,false);
	m_pBas->SetButtonShow(FALSE);
	OnHideRedouble();
	m_pBas->m_pHandCard->SetPositively(false);
	m_pBas->m_pHandCard->SetShowAnimate(false);
	m_pBas->m_pHandCard->SetDisplayItem(!IsLookonMode());
	m_pBas->m_btChiHuCue.SetState(false);
	m_pBas->SetCurrentUser(INVALID_CHAIR);
	m_pBas->SetFanCount(0,false);
	m_pBas->SetShowHead(false);
	m_pBas->ReleaseTingInfo();
	m_pBas->StopBGMusic();
	//m_pBas->m_pHeapCard->SetShow(FALSE);

	//˿
	for (WORD i=0;i<GAME_PLAYER;i++)
	{
		for( BYTE j = 0; j < CountArray(m_pBas->m_pWeaveCard[i]); j++ )
			m_pBas->m_pWeaveCard[i][j]->SetDisplayItem(true);
	}

	//
	tagScoreInfo ScoreInfo;
	tagWeaveInfo WeaveInfo;
	ZeroMemory(&ScoreInfo,sizeof(ScoreInfo));
	ZeroMemory(&WeaveInfo,sizeof(WeaveInfo));

	//ɼ
	ScoreInfo.wProvideUser=SwitchViewChairID(pGameEnd->wProvideUser);
	ScoreInfo.cbProvideCard=pGameEnd->cbProvideCard;
	ScoreInfo.wChengBaoUser=pGameEnd->wChengBaoUser;
	ScoreInfo.cbPaiMianCard=pGameEnd->cbPaiMianCard;
	ScoreInfo.cbHuaCardCount=pGameEnd->cbHuaCardCount;
	ScoreInfo.dwFanShu=pGameEnd->dwFanShu;

	CChiHuRight chr;
	chr.SetRightData( pGameEnd->dwChiHuRight,CountArray(pGameEnd->dwChiHuRight) );
	CChiHuRight chrhigh;
	chrhigh.SetRightData(pGameEnd->dwChiHuHigh,CountArray(pGameEnd->dwChiHuHigh));
	CChiHuRight	chrnew;
	chrnew.SetRightData(pGameEnd->dwChiHuNew,CountArray(pGameEnd->dwChiHuNew));
	if( pGameEnd->wProvideUser != INVALID_CHAIR )
	{
		for (WORD i=0;i<GAME_PLAYER;i++)
		{
			//
			ScoreInfo.dwChiHuKind[i]=pGameEnd->dwChiHuKind[i];

			//óɼ
			ScoreInfo.lGameScore[SwitchViewChairID(i)]=pGameEnd->lGameScore[i];
			ScoreInfo.lGameGold[SwitchViewChairID(i)]=pGameEnd->lGameGold[i];
			lstrcpyn(ScoreInfo.szUserName[i],m_szAccounts[i],CountArray(ScoreInfo.szUserName[i]));

			//˿
			if ((ScoreInfo.cbCardCount==0)&&(pGameEnd->dwChiHuKind[i]!=WIK_NULL))
			{
				ScoreInfo.wChiHuUser = SwitchViewChairID(i);
				//˿
				WeaveInfo.cbWeaveCount=m_cbWeaveCount[i];
				for (BYTE j=0;j<WeaveInfo.cbWeaveCount;j++)
				{
					DWORD cbWeaveKind=m_WeaveItemArray[i][j].cbWeaveKind;
					BYTE cbCenterCard=m_WeaveItemArray[i][j].cbCenterCard;
					WeaveInfo.cbPublicWeave[j]=m_WeaveItemArray[i][j].cbPublicCard;
					WeaveInfo.cbCardCount[j]=(cbWeaveKind&(WIK_LEFT|WIK_CENTER|WIK_RIGHT|WIK_PENG|
						WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN|WIK_PENG_LISTEN))?3:4;
					CopyMemory( WeaveInfo.cbCardData[j],m_WeaveItemArray[i][j].cbCardData,sizeof(m_WeaveItemArray[i][j].cbCardData) );
				}

				//˿
				ScoreInfo.cbCardCount=pGameEnd->cbCardCount[i];
				CopyMemory(ScoreInfo.cbCardData,&pGameEnd->cbCardData[i],ScoreInfo.cbCardCount*sizeof(BYTE));
			}
		}

		m_lUpScore=pGameEnd->lGameGold[GetMeChairID()];

		//ɼ
		m_pBas->SetScoreInfo(ScoreInfo,WeaveInfo,chr,chrhigh,chrnew,pGameEnd->cbMingGangCount,
			pGameEnd->cbAnGangCount,pGameEnd->lCellScore,GetMeChairID());

		m_pBas->ShowScore();
	}
	else
	{
		//m_pBas->m_pStartButton->SetShow(TRUE);
		m_pBas->SetHuangZhuang(true);
		m_pBas->m_bScoreShow=true;
		m_pBas->m_pGameScore->SetHuangZhuang(true);
		//˿
		ScoreInfo.cbCardCount=m_GameLogic.SwitchToCardData(m_cbCardIndex,ScoreInfo.cbCardData);
		ScoreInfo.cbProvideCard=0;
		WeaveInfo.cbWeaveCount=m_cbWeaveCount[GetMeChairID()];
		for(WORD i=0;i<GAME_PLAYER;i++)
		{
			//óɼ
			ScoreInfo.lGameScore[SwitchViewChairID(i)]=pGameEnd->lGameScore[i];
			ScoreInfo.lGameGold[SwitchViewChairID(i)]=pGameEnd->lGameGold[i];
		}
		for (BYTE j=0;j<WeaveInfo.cbWeaveCount;j++)
		{
			DWORD cbWeaveKind=m_WeaveItemArray[GetMeChairID()][j].cbWeaveKind;
			BYTE cbCenterCard=m_WeaveItemArray[GetMeChairID()][j].cbCenterCard;
			WeaveInfo.cbPublicWeave[j]=m_WeaveItemArray[GetMeChairID()][j].cbPublicCard;
			WeaveInfo.cbCardCount[j]=(cbWeaveKind&(WIK_LEFT|WIK_CENTER|WIK_RIGHT|WIK_PENG|WIK_LEFT_LISTEN|
				WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN|WIK_PENG_LISTEN))?3:4;
			CopyMemory( WeaveInfo.cbCardData[j],m_WeaveItemArray[GetMeChairID()][j].cbCardData,
				sizeof(m_WeaveItemArray[GetMeChairID()][j].cbCardData) );
		}

		m_lUpScore=0;

		//ɼ
		m_pBas->SetScoreInfo(ScoreInfo,WeaveInfo,chr,chrhigh,chrnew,0,0,pGameEnd->lCellScore,GetMeChairID());
	}

	//û˿
	for (WORD i=0;i<GAME_PLAYER;i++)
	{
		WORD wViewChairID=SwitchViewChairID(i);
		if (pGameEnd->dwChiHuKind[i]!=WIK_NULL)
		{
			m_pBas->SetUserAction(wViewChairID,WIK_CHI_HU,SwitchViewChairID(pGameEnd->wProvideUser),
				pGameEnd->wProvideUser==i);
			m_pBas->m_pTableCard[wViewChairID]->SetProvideCard(pGameEnd->cbProvideCard);
			PlayActionSound( i,WIK_CHI_HU,pGameEnd->wProvideUser==i);
		}
		m_pBas->m_pTableCard[wViewChairID]->SetCardData(pGameEnd->cbCardData[i],pGameEnd->cbCardCount[i]);
	}

	//˿
	m_pBas->m_pUserCard->SetCardData(0,false);
	m_pBas->m_pHandCard->SetCardData(NULL,0,0);

//	//û˿
//	for (WORD i=0;i<GAME_PLAYER;i++)
//	{
//		WORD wViewChairID=SwitchViewChairID(i);
//		if (pGameEnd->dwChiHuKind[i]!=WIK_NULL)
//		{
//			//m_pBas->SetUserAction(wViewChairID,WIK_CHI_HU,SwitchViewChairID(pGameEnd->wProvideUser),
//				//pGameEnd->wProvideUser==i);
////			m_pBas->SetChiHu(wViewChairID,SwitchViewChairID(pGameEnd->wProvideUser));
//			//m_pBas->m_pTableCard[wViewChairID]->SetProvideCard(pGameEnd->cbProvideCard);
//		}
//		//m_pBas->m_pTableCard[wViewChairID]->SetCardData(pGameEnd->cbCardData[i],pGameEnd->cbCardCount[i]);
//		//if(i==pGameEnd->)
//	}

	//
	/*if( !chr.IsEmpty() )
	{
		for( WORD i = 0; i < GAME_PLAYER; i++ )
		{
			if( pGameEnd->dwChiHuKind[i] != WIK_NULL )
			{
				PlayActionSound( i,WIK_CHI_HU,chr);
				break;
			}
		}
	}*/

	if(GetServerType()==GAME_GENRE_SCORE)
	{
		if(pGameEnd->lGameScore[GetMeChairID()]>0)
		{
			m_pBas->PlayGameSound("Common_Win");
		}
		else if(pGameEnd->lGameScore[GetMeChairID()]<0)
		{
			m_pBas->PlayGameSound("Common_Lost");
		}
		else
		{
			m_pBas->PlayGameSound("Common_End");
		}
	}
	else
	{
		if(pGameEnd->lGameGold[GetMeChairID()]>0)
		{
			m_pBas->PlayGameSound("Common_Win");
		}
		else if(pGameEnd->lGameGold[GetMeChairID()]<0)
		{
			m_pBas->PlayGameSound("Common_Lost");
		}
		else
		{
			m_pBas->PlayGameSound("Common_End");
		}
	}

	//ý
	if (IsLookonMode()==false)
	{
		//m_pBas->m_pStartButton->SetShow(TRUE);
		SetGameTimerN(GetMeChairID(),IDI_START_GAME,TIME_START_GAME);
	}

	SetGameStatus(GS_MJ_FREE);

	m_pBas->m_bGameEnd=true;

	//if(pGameEnd->lCellScore*88>GetUserData(GetMeChairID())->lGameGold)
	//{
	//	ShowMsgBox("ϵǮ趨޷Ϸ",MB_OK,"ܰʾ",10,
	//		st_warning,DLG_SHOWTYPE_QUITGAME);
	//}

	//ȡй
	if(m_bStustee)
		OnStusteeControl();

	m_pBas->m_btStartStustee.SetState(false);
	m_pBas->m_btStopStustee.SetState(false);

	return OnActionGameEnd();
}
BYTE TL_Gwindow::GetDiscardCount( BYTE cbCardData )
{
	BYTE cbCount = 0;
	//
	for( WORD i = 0; i < GAME_PLAYER; i++ )
	{
		for( BYTE j = 0; j < m_cbDiscardCount[i]; j++ )
		{
			if( m_cbDiscardCard[i][j] == cbCardData )
				if( ++cbCount == 4 ) break;
		}
	}
	if( cbCount < 4 )
	{
		//
		for( WORD i = 0; i < GAME_PLAYER; i++ )
		{
			for( BYTE j = 0; j < m_cbWeaveCount[i]; j++ )
			{
				//if( !m_WeaveItemArray[i][j].cbPublicCard ) continue;
				BYTE cbCardBuffer[4];
				BYTE cbCardCount = m_GameLogic.GetWeaveCard( m_WeaveItemArray[i][j].cbWeaveKind,
					m_WeaveItemArray[i][j].cbCenterCard,cbCardBuffer );
				for( BYTE k = 0; k < cbCardCount; k++ )
					if( cbCardBuffer[k] == cbCardData )
						if( ++cbCount == 4 ) break;
			}
		}

		cbCount+=m_cbCardIndex[m_GameLogic.SwitchToCardIndex(cbCardData)];

		if(cbCount>=4)
			cbCount=4;
	}

	return cbCount;
}
//
void TL_Gwindow::OnUserActionFinish()
{
	//У
	ASSERT( m_UserActionArray.GetCount() > 0 );		
	if( m_UserActionArray.GetCount() == 0 ) return ;

	//öٶ
	switch( m_UserActionArray[0]->enActionKind )
	{
	case AK_StartCard:				//
		OnActionStartCard();
		break;
	case AK_OutCard:
		OnActionOutCard();
		break;
	case AK_SendCard:
		OnActionSendCard();
		break;
	case AK_Sice:					//ɫ
		OnActionSice();
		break;
	default:
		ASSERT(FALSE);
		return ;
	}

	return ;
}
//Ϲܿ
void TL_Gwindow::OnStusteeControl()
{
	//ñ
	m_wTimeOutCount=0;

	//״̬
	if (m_bStustee==true)
	{
		m_bStustee=false;
		m_pBas->m_btStartStustee.SetShow(true);
		m_pBas->m_btStartStustee.SetState(true);
		m_pBas->m_btStopStustee.SetShow(false);
		m_pBas->PlayGameSound("CommonNoAuto");
		CMD_C_Trustee Trustee;
		Trustee.bTrustee = false;
		SendSocketData(SUB_C_TRUSTEE,&Trustee,sizeof(Trustee));
	}
	else
	{
		m_bStustee=true;
		m_pBas->m_btStopStustee.SetShow(true);
		m_pBas->m_btStartStustee.SetState(false);
		m_pBas->PlayGameSound("CommonAuto");
		CMD_C_Trustee Trustee;
		Trustee.bTrustee = true;
		m_pBas->m_cbRobotUpdata=0;
		m_pBas->m_cbRobotIndex=0;
		SendSocketData(SUB_C_TRUSTEE,&Trustee,sizeof(Trustee));
	}

	return ;
}
void TL_Gwindow::OnRedouble(int n)
{
	CMD_C_Redouble Redouble;
	Redouble.dwRedouble=m_pBas->GetFanCount();
	SendSocketData(SUB_C_REDOUBLE,&Redouble,sizeof(Redouble));
	m_pBas->SetFanCount(0,false);

	if(m_bHearStatus)
	{
		//زؼ
		m_pBas->SetButtonShow( SW_HIDE );
		OnHideRedouble();

		const tagUserInfo* pMeUserData= GetMeUserData();
		if(pMeUserData!=NULL)
		{
			bool bBoy = (pMeUserData->cbGender == 2 ? false : true);
			if(bBoy)
				m_pBas->PlayGameSound("BOY_RM");
			else
				m_pBas->PlayGameSound("Girl_RF");
		}
		KillGameTimerN( IDI_OPERATE_CARD );
		KillGameTimerN(IDI_CHI_HU);
	}
	else
	{
		m_cbActionMask&=~WIK_CHI_HU;

		if(m_cbActionMask==WIK_NULL)
		{
			m_bActionMask=true;
			//زؼ
			m_pBas->SetButtonShow( SW_HIDE );
			OnHideRedouble();

			const tagUserInfo* pMeUserData= GetMeUserData();
			if(pMeUserData!=NULL)
			{
				bool bBoy = (pMeUserData->cbGender == 2 ? false : true);
				if(bBoy)
					m_pBas->PlayGameSound("BOY_RM");
				else
					m_pBas->PlayGameSound("Girl_RF");
			}
			KillGameTimerN( IDI_OPERATE_CARD );
		}
		else
		{
			m_bActionMask=false;
			m_pBas->SetControlInfo(m_cbActionMask);
			const tagUserInfo* pMeUserData= GetMeUserData();
			if(pMeUserData!=NULL)
			{
				bool bBoy = (pMeUserData->cbGender == 2 ? false : true);
				if(bBoy)
					m_pBas->PlayGameSound("BOY_RM");
				else
					m_pBas->PlayGameSound("Girl_RF");
			}
		}
	}
}
void TL_Gwindow::OnMyFlashID()
{
	if(m_bHearStatus)
	{
		WORD wMeChairID=GetMeChairID();
		if (m_wCurrentUser==wMeChairID)
		{
			//ȡ˿
			BYTE cbCardData=m_pBas->m_pHandCard->GetCurrentCard();

			if( m_pBas->m_pHandCard->GetSelectMode() )
			{
				OnCardOperate();
				return;
			}
			//Ч
			if (VerdictOutCard(cbCardData)==false)
			{
				for (BYTE i=0;i<MAX_INDEX;i++)
				{
					//Ч
					if (m_cbCardIndex[i]==0) continue;
					if (VerdictOutCard(m_GameLogic.SwitchToCardData(i))==false) 
						continue;

					//ñ
					cbCardData=m_GameLogic.SwitchToCardData(i);
				}
			}

			//ƶ
			ASSERT( m_cbCardIndex[m_GameLogic.SwitchToCardIndex(cbCardData)] > 0 );
//			SparrowCJDlg<<"OnMyFlashID m_wCurrentUser==wMeChairID"<<endl;
			OnOutCard(cbCardData);
		}
		else 
		{
			OnUserAction(WIK_NULL);
		}
	}
	else
	{
		if(m_bActionMask)
			OnUserAction(WIK_NULL);
	}
}
void TL_Gwindow::OnHideRedouble()
{
	CMD_C_ShowThink ShowThink;
	ShowThink.bShowThink=false;
	SendSocketData(SUB_C_SHOW_THINK,&ShowThink,sizeof(ShowThink));
}
void TL_Gwindow::OnCardOperate()
{
	//
	DWORD cbOperateCode;
	BYTE cbOperateCard[3] = {0,0,0};

	//ɾʱ
	KillGameTimerN(IDI_OPERATE_CARD);

	//ȡѡϢ
	tagSelectCardInfo si;
	m_pBas->m_pHandCard->GetUserSelectResult( si );

	//Ϣ
	cbOperateCode = (DWORD)si.wActionMask;
	cbOperateCard[0] = si.cbActionCard;
	CopyMemory( &cbOperateCard[1],si.cbCardData,sizeof(BYTE)*2 );

	//ȡģʽ
	m_pBas->m_pHandCard->SetSelectMode( false );

	m_wCurrentUser = INVALID_CHAIR;
	m_cbActionMask = 0;
	m_cbActionCard = 0;

	//
	m_pBas->SetStatusFlag(false,true);

	//
	CMD_C_OperateCard OperateCard;
	OperateCard.cbOperateCode=cbOperateCode;
	CopyMemory( OperateCard.cbOperateCard,cbOperateCard,sizeof(cbOperateCard) );
	SendSocketData(SUB_C_OPERATE_CARD,&OperateCard,sizeof(OperateCard));

	return ;
}
bool TL_Gwindow::VerdictOutCard(BYTE cbCardData)
{
	//ж
	if ((m_bHearStatus==true)||(m_bWillHearStatus==true))
	{
		//
		CChiHuRight chr;
		CChiHuRight chrhigh;
		CChiHuRight chrnew;
		WORD wMeChairID=GetMeChairID();
		BYTE cbWeaveCount=m_cbWeaveCount[wMeChairID];

		//˿
		BYTE cbCardIndexTemp[MAX_INDEX];
		CopyMemory(cbCardIndexTemp,m_cbCardIndex,sizeof(cbCardIndexTemp));

		//ɾ˿
		if( !m_GameLogic.RemoveCard(cbCardIndexTemp,cbCardData) )
		{
			ASSERT( FALSE );
			//AfxMessageBox("VerdictOutCard");
			//AfxMessageBox("!m_GameLogic.RemoveCard(cbCardIndexTemp,cbCardData)");
			return false;
		}

		//ж
		BYTE i=0;
		for (;i<MAX_INDEX;i++)
		{
			//Ʒ
			BYTE cbCurrentCard=m_GameLogic.SwitchToCardData(i);
			BYTE cbHuCardKind=m_GameLogic.AnalyseChiHuCard(cbCardIndexTemp,m_WeaveItemArray[wMeChairID],
				cbWeaveCount,cbCurrentCard,chr,chrhigh,chrnew);

			//ж
			if (cbHuCardKind!=WIK_NULL)
			{
				//AfxMessageBox("cbHuCardKind");
				break;
			}
		}

		//ж
		//if(i==MAX_INDEX)
		//{
		//	AfxMessageBox("VerdictOutCard");
		//	AfxMessageBox("i==MAX_INDEX");
		//}
		return (i!=MAX_INDEX);
	}

	return true;
}
void TL_Gwindow::OnTingCard(int cbCardData)
{
	CWHArray<tagTingInfo> tempCard;
	tempCard.RemoveAll();
	if(GetTingCard(cbCardData,tempCard))
		m_pBas->SetTingInfo(tempCard);
}
void TL_Gwindow::OnOutCard(int cbCardData)
{
	//ж
	if ((IsLookonMode()==true)||(m_wCurrentUser!=GetMeChairID()))
		return ;

//	SparrowCJDlg<<"OnOutCard "<<cbCardData<<endl;

	//ж
	if (((m_bHearStatus==true)||(m_bWillHearStatus==true))&&(VerdictOutCard((BYTE)cbCardData)==false))
	{
		/*CString str;
		str.Format(TEXT("cbCardData %ld"),cbCardData);
		AfxMessageBox(str);
		AfxMessageBox("((m_cbListenStatus>0)||(m_bWillHearStatus==true))&&(VerdictOutCard((BYTE)cbCardData)==false)");*/
		return ;
	}

	//
	if (m_bWillHearStatus==true)
	{
		m_bHearStatus=true;
		m_bWillHearStatus=false;
		m_pBas->ReleaseTingInfo();
		m_pBas->m_pHandCard->SetListen(false);
		CMD_C_ListenSet ListenSet;
		ListenSet.bListen=true;
		SendSocketData(SUB_C_LISTEN_SET,&ListenSet,sizeof(ListenSet));
	}

	//˿
	BYTE cbCardIndexTemp[MAX_INDEX];
	CopyMemory(cbCardIndexTemp,m_cbCardIndex,sizeof(cbCardIndexTemp));

	//ɾ˿
	if( !m_GameLogic.RemoveCard(cbCardIndexTemp,(BYTE)cbCardData) )
	{
		/*CString str;
		str.Format(TEXT("cbCardData %ld"),cbCardData);
		AfxMessageBox(str);
		AfxMessageBox("!m_GameLogic.RemoveCard(cbCardIndexTemp,(BYTE)cbCardData)");*/
		return ;
	}

	KillGameTimerN(IDI_OPERATE_CARD);

	//ñ
	m_wCurrentUser=INVALID_CHAIR;
	BYTE cbOutCardData=(BYTE)cbCardData;

	//ý
	m_pBas->SetButtonShow(FALSE);
	OnHideRedouble();
	m_pBas->SetFanCount(0,false);

	//
	CMD_C_OutCard OutCard;
	OutCard.cbCardData=cbOutCardData;
	SendSocketData(SUB_C_OUT_CARD,&OutCard,sizeof(OutCard));

	//Ӷ
	tagActionOutCard *pActionOutCard = (tagActionOutCard *)ActiveUserAction(AK_OutCard);
	ASSERT( pActionOutCard );
	if( !pActionOutCard ) return ;

	pActionOutCard->cbOutCardData = cbOutCardData;
	pActionOutCard->wOutCardUser = GetMeChairID();

	m_UserActionArray.Add(pActionOutCard);

	BeginUserAction();

	return ;
}

bool TL_Gwindow::OnActionStartCard()
{
	//Ч
	ASSERT( m_UserActionArray.GetCount() > 0 );
	if( m_UserActionArray.GetCount() == 0 ) return false;
	//
	tagActionStartCard *pStartCardItem = (tagActionStartCard *)m_UserActionArray[0];

	//ñ
	WORD wMeChairId = GetMeChairID();
	WORD wChairId = pStartCardItem->wChairId;
	WORD wViewChairId = SwitchViewChairID(wChairId);

	//˿
	if( wViewChairId == MYSELF_VIEW_ID )
		m_pBas->m_pHandCard->AddCardData( pStartCardItem->cbCardData,pStartCardItem->cbCardCount );
	else
	{
		WORD wUserIndex = wViewChairId>2?2:wViewChairId;
		if( pStartCardItem->bLastItem )
			m_pBas->m_pUserCard->AddCardData(true);
		else
		{
			for( BYTE i = 0; i < pStartCardItem->cbCardCount; i++ )
				m_pBas->m_pUserCard->AddCardData(false);
		}
	}

	m_pBas->PlayGameSound("Common_Send_Card");

	//жǷһ
	if( pStartCardItem->bLastItem )
	{
////		//˿
//		for (WORD i=0;i<GAME_PLAYER;i++)
//		{
////			m_pBas->m_pHeadCard[SwitchViewChairID(i)]->SetHeapCardInfo(m_cbHeapCardInfo[i][0],m_cbHeapCardInfo[i][1]);
//			if(m_HeapCardInfo[i].wStartIndex%2!=0)
//			{
//				m_pBas->m_pHeadCard[SwitchViewChairID(i)]->SetCardEmpty(m_HeapCardInfo[i].wStartIndex-1,
//					m_HeapCardInfo[i].wRemoveCount);
//			}
//			else
//			{
//				m_pBas->m_pHeadCard[SwitchViewChairID(i)]->SetCardEmpty(m_HeapCardInfo[i].wStartIndex+1,
//					m_HeapCardInfo[i].wRemoveCount);
//			}
//		}

		SetHandCardControl(m_cbCardIndex,0x00);
		m_cbSendCard=0x00;

		m_pBas->m_pHandCard->SetPositively(!IsLookonMode());

		SendSocketData(SUB_C_START_OVER);
	}

	//ɾ
	RemoveCurrentAction();

	//¸
	BeginUserAction();


	return true;
}
//ɫ
bool TL_Gwindow::OnActionSice()
{
	//ش
	bool bPlayerMode=(IsLookonMode()==false);
	m_pBas->SetBankerUser(SwitchViewChairID(m_wBankerUser));
	m_pBas->m_pSiceContainer->SetShow(FALSE);

	m_pBas->SetShowHead(true);

	//÷
	ClacTurnoverCard();

	//ɾ
	RemoveCurrentAction();
	//¸
	BeginUserAction();

	return true;
}
//
bool TL_Gwindow::OnActionOutCard()
{
	//Ч
	ASSERT( m_UserActionArray.GetCount() > 0 );
	if( m_UserActionArray.GetCount() == 0 ) return false;

	//
	tagActionOutCard *pOutCardItem = (tagActionOutCard *)m_UserActionArray[0];

	WORD wOutUserViewId = SwitchViewChairID(pOutCardItem->wOutCardUser);
	BYTE cbOutCardData = pOutCardItem->cbOutCardData;
	//m_pBas->SetOutCardInfo(wOutUserViewId,cbOutCardData);
	//ӵѶ
	m_pBas->m_pDiscardCard[wOutUserViewId]->AddCardItem( cbOutCardData );
	m_pBas->SetStatusFlag(false,false);

	//óָʾ
	m_pBas->SetDiscUser( wOutUserViewId );

	m_pBas->PlayGameSound("Common_Out_Card");

	//ɾ
	RemoveCurrentAction();

	//¸
	BeginUserAction();

	return true;
}
bool TL_Gwindow::OnActionSendCard()
{
	SparrowCJDlg<<"OnActionSendCard"<<endl;
	//Ч
	ASSERT( m_UserActionArray.GetCount() > 0 );
	if( m_UserActionArray.GetCount() == 0 ) return false;

	//
	tagActionSendCard *pSendCardItem = (tagActionSendCard *)m_UserActionArray[0];

	//ñ
	WORD wMeChairID = GetMeChairID();
	WORD wViewChairID=SwitchViewChairID(pSendCardItem->wSendCardUser);
	WORD wChairId = pSendCardItem->wSendCardUser;
	BYTE cbSendCardData = pSendCardItem->cbCardData;
	m_wCurrentUser = pSendCardItem->wCurrentUser;
	m_wReplaceUser = pSendCardItem->wReplaceUser;
	m_bOutCard=pSendCardItem->bOutCard;

	SparrowCJDlg<<"pSendCardItem->wSendCardUser "<<pSendCardItem->wSendCardUser<<endl;
	SparrowCJDlg<<"pSendCardItem->cbCardData "<<(WORD)pSendCardItem->cbCardData<<endl;
	SparrowCJDlg<<"pSendCardItem->wCurrentUser "<<(WORD)pSendCardItem->wCurrentUser<<endl;
	SparrowCJDlg<<"pSendCardItem->wReplaceUser "<<(WORD)pSendCardItem->wReplaceUser<<endl;
	SparrowCJDlg<<"pSendCardItem->bOutCard "<<(WORD)pSendCardItem->bOutCard<<endl;

	//ȡƽ
	if (wViewChairID!=MYSELF_VIEW_ID)
	{
		if(!m_bDuiHuaStatus)
		{
			WORD wUserIndex=(wViewChairID>2)?2:wViewChairID;
			BYTE cbCardCount = m_pBas->m_pUserCard->GetCardCount()+m_cbWeaveCount[wChairId]*3;
			m_pBas->m_pUserCard->AddCardData(cbCardCount==MAX_COUNT-1?true:false);
		}
	}
	else
	{
		//˿
		m_cbCardIndex[m_GameLogic.SwitchToCardIndex(cbSendCardData)]++;

		//˿
		SetHandCardControl(m_cbCardIndex,cbSendCardData);
		m_cbSendCard=cbSendCardData;
		m_pBas->m_pHandCard->SetSendData(cbSendCardData);
		if(pSendCardItem->bReplace&&m_wCurrentUser!=GetMeChairID())
		{
			if(m_wReplaceUser==GetMeChairID())
				m_pBas->m_pHandCard->CutCardOver();
			if(m_pBas->m_pHandCard->GetCurrentCard()==0)
			{
				m_pBas->m_pHandCard->CutCardOver();
			}
		}
	}

	SparrowCJDlg<<"(IsLookonMode()==false)&&(m_wCurrentUser==wMeChairID)"<<endl;

	SparrowCJDlg<<"OnActionSendCard cbCardData: "<<endl;
	for(BYTE j=0;j<MAX_INDEX;j++)
	{
		for(BYTE w=0;w<m_cbCardIndex[j];w++)
		{
			SparrowCJDlg<<(WORD)m_GameLogic.SwitchToCardData(j)<<" ";
		}
	}
	SparrowCJDlg<<endl;

	//ǰû
	if ((IsLookonMode()==false)&&(m_wCurrentUser==wMeChairID))
	{
		//ж
		if (m_bHearStatus==false)
		{
			BYTE cbWeaveCount=m_cbWeaveCount[wMeChairID];
			pSendCardItem->cbActionMask|=m_GameLogic.AnalyseTingCard(m_cbCardIndex,m_WeaveItemArray[wMeChairID],cbWeaveCount);
		}
		else
		{
			{
				//ж
				WORD wMeChairID=GetMeChairID();
				BYTE cbWeaveCount=m_cbWeaveCount[wMeChairID];
				WORD cbActionMask=m_GameLogic.AnalyseTingCard(m_cbCardIndex,m_WeaveItemArray[wMeChairID],cbWeaveCount);
			}
		}
		m_cbActionMask = pSendCardItem->cbActionMask;

		m_cbActionCard = pSendCardItem->cbCardData;

		//
		if (m_cbActionMask!=WIK_NULL)
		{
			//ý
			//m_GameClientView.m_btStusteeControl.EnableWindow(FALSE);
			//if(m_cbActionMask&(WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN|WIK_PENG_LISTEN))
			m_pBas->SetControlInfo(m_cbActionMask);
			CMD_C_ShowThink ShowThink;
			ShowThink.bShowThink=true;
			SendSocketData(SUB_C_SHOW_THINK,&ShowThink,sizeof(ShowThink));
		}
	}

	SparrowCJDlg<<"ʾ"<<endl;
	//ʾ
	m_pBas->SetStatusFlag((IsLookonMode()==false)&&(m_wCurrentUser==wMeChairID),false);

	//Ʋ
	if ((IsLookonMode()==false)&&(pSendCardItem->wReplaceUser==wMeChairID))
	{
		if(m_bOutCard)
		{
			//ʱ
			m_bReplace=true;
		}
		else
		{
			m_bReplace=false;
			m_lReplaceCount=0;

			m_pBas->SetUserAction(INVALID_CHAIR,0,0);

			//Ѱ˿
			for(BYTE i=MAX_INDEX-MAX_HUA_CARD;i<MAX_INDEX;i++)
			{
				if(m_cbCardIndex[i]>0)
				{
					//
					BYTE cbReplaceCard=m_GameLogic.SwitchToCardData(i);
					if( !m_GameLogic.RemoveCard(m_cbCardIndex,cbReplaceCard) )
					{
						ASSERT( FALSE );
						return false;
					}

					//˿
					SetHandCardControl(m_cbCardIndex,0x00);

					//ý
					m_pBas->SetUserAction( MYSELF_VIEW_ID,WIK_REPLACE,0 );

					CMD_C_ReplaceCard ReplaceCard;
					ReplaceCard.cbCardData=cbReplaceCard;
					SendSocketData(SUB_C_REPLACE_CARD,&ReplaceCard,sizeof(ReplaceCard));

					break;
				}
			}
		}
	}

	SparrowCJDlg<<"(IsLookonMode()==false)&&(pSendCardItem->wReplaceUser==wMeChairID)"<<endl;
	if ((IsLookonMode()==false)&&(pSendCardItem->wReplaceUser==wMeChairID))
	{
		if(!m_bOutCard)
			m_pBas->PlayGameSound("Common_Send_Card");
	}
	SparrowCJDlg<<"ʱ"<<endl;

	//ʱ
	WORD wTimeCount=TIME_OPERATE_CARD;

	KillGameTimerN(IDI_OPERATE_CARD);
	SparrowCJDlg<<"KillGameTimerN"<<endl;
	//ʱ
	if( m_wCurrentUser != INVALID_CHAIR )
	{
		m_pBas->SetCurrentUser(SwitchViewChairID(m_wCurrentUser));
		SetGameTimerN(m_wCurrentUser,IDI_OPERATE_CARD,wTimeCount);
	}
	else m_pBas->SetCurrentUser( INVALID_CHAIR );

	SparrowCJDlg<<"RemoveCurrentAction"<<endl;

	//ɾ
	RemoveCurrentAction();

	SparrowCJDlg<<"BeginUserAction"<<endl;
	//¸
	BeginUserAction();

	SparrowCJDlg<<"¸"<<endl;
	return true;
}

//ʾ
bool TL_Gwindow::OnActionNotify()
{
	//ɾ
	RemoveCurrentAction();

	//¸
	BeginUserAction();

	return true;
}

//
bool TL_Gwindow::OnActionResult()
{
	//ɾ
	RemoveCurrentAction();

	//¸
	BeginUserAction();

	return true;
}

//Ϸ
bool TL_Gwindow::OnActionGameEnd()
{
	//ɾ
	RemoveCurrentAction();

	//¸
	BeginUserAction();

	return true;
}

void TL_Gwindow::ClacTurnoverCard()
{
   //㷭
   BYTE cbCardIndex;
   WORD wSice = WORD(m_lSiceCount&0xffff);

   {
	 cbCardIndex = (((BYTE)HIBYTE(wSice))+((BYTE)LOBYTE(wSice))-1)*2;
   }
}
//Ƴǰ
bool TL_Gwindow::RemoveCurrentAction()
{
	ASSERT( m_UserActionArray.GetCount() > 0 );
	if( m_UserActionArray.GetCount() == 0 ) return false;

	//ɾǰ
	tagUserAction *pUserAction = m_UserActionArray[0];
	m_UserActionArray.RemoveAt(0);
	pUserAction->ResetAction();
	delete pUserAction;

	return true;
}
void TL_Gwindow::OnUserAction(int nAction)
{
	//
	DWORD cbOperateCode=(DWORD)(nAction);
	BYTE cbOperateCard[3] = {0,0,0};

	//زؼ
	m_pBas->SetButtonShow( SW_HIDE );
	OnHideRedouble();

	//״̬ж
	if (cbOperateCode==WIK_NULL)
	{
		if(m_bHearStatus&&m_cbActionMask==WIK_GANG)
		{
			if(m_wCurrentUser==GetMeChairID())
			{
				//ȡ˿
				BYTE cbCardData=m_pBas->m_pHandCard->GetCurrentCard();

				//Ч
				if (VerdictOutCard(cbCardData)==false)
				{
					for (BYTE i=0;i<MAX_INDEX;i++)
					{
						//Ч
						if (m_cbCardIndex[i]==0) continue;
						if (VerdictOutCard(m_GameLogic.SwitchToCardData(i))==false) 
							continue;

						//ñ
						cbCardData=m_GameLogic.SwitchToCardData(i);
					}
				}

				//ƶ
				ASSERT( m_cbCardIndex[m_GameLogic.SwitchToCardIndex(cbCardData)] > 0 );
				OnOutCard(cbCardData);
			}
		}
		//ñ
		m_cbActionMask = WIK_NULL;
		m_cbActionCard = 0;
		m_pBas->SetFanCount(0,false);
		if( m_wCurrentUser == INVALID_CHAIR )
		{
			//ɾʱ
			KillGameTimerN( IDI_OPERATE_CARD );
			KillGameTimerN(IDI_CHI_HU);
			//Ϣ
			CMD_C_OperateCard OperateCard;
			OperateCard.cbOperateCode = WIK_NULL;
			ZeroMemory( OperateCard.cbOperateCard,sizeof(OperateCard.cbOperateCard) );
			SendSocketData( SUB_C_OPERATE_CARD,&OperateCard,sizeof(OperateCard) );
		}
		return ;
	}


	bool bDone = false;
	//  
	if( (cbOperateCode & WIK_CHI_HU))
	{
		bDone = true;
		m_pBas->SetFanCount(0,false);
	}
	else
	{
		//ȡѡ
		tagSelectCardInfo sci[MAX_WEAVE];
		BYTE cbInfoCount = GetSelectCardInfo( cbOperateCode,sci );

		//ò¼
		bDone = m_pBas->m_pHandCard->OnEventUserAction( sci,cbInfoCount );

		//ɲ
		if( bDone )
		{
			//ò
			tagSelectCardInfo si;
			m_pBas->m_pHandCard->GetUserSelectResult( si );
			cbOperateCode = (DWORD)si.wActionMask;
			cbOperateCard[0] = si.cbActionCard;
			CopyMemory( &cbOperateCard[1],si.cbCardData,2*sizeof(BYTE) );

			m_pBas->m_pHandCard->SetSelectMode( false );
		}
		//õȴѡ
		else m_pBas->SetStatusFlag( true,false );
	}

	//ɣֱӷͲ
	if( bDone )
	{
		//ɾʱ
		KillGameTimerN( IDI_OPERATE_CARD );
		KillGameTimerN(IDI_CHI_HU);

		//ñ
		m_wCurrentUser = INVALID_CHAIR;
		m_cbActionMask = WIK_NULL;
		m_cbActionCard = 0;

		CMD_C_OperateCard OperateCard;
		OperateCard.cbOperateCode = cbOperateCode;
		CopyMemory( OperateCard.cbOperateCard,cbOperateCard,sizeof(cbOperateCard) );
		SendSocketData( SUB_C_OPERATE_CARD,&OperateCard,sizeof(OperateCard) );
	}
}
void TL_Gwindow::OnListenCard(int nTemp)
{
	if( WIK_LISTEN != m_GameLogic.AnalyseTingCard(m_cbCardIndex,m_WeaveItemArray[GetMeChairID()],m_cbWeaveCount[GetMeChairID()]) ) 
		return ;

	//ñ
	m_bWillHearStatus=true;

	//زؼ
	m_pBas->SetButtonShow( SW_HIDE );
	m_pBas->SetFanCount(0,false);
	OnHideRedouble();

	//Ϣ
	SendSocketData(SUB_C_LISTEN);

	return ;
}
//ȡϢ
BYTE TL_Gwindow::GetSelectCardInfo( DWORD wOperateCode, tagSelectCardInfo SelectInfo[MAX_WEAVE] )
{
	//ʼ
	BYTE cbSelectCount = 0;

	if( wOperateCode == WIK_NULL ) return 0;

	//
	if( wOperateCode&(WIK_LEFT|WIK_CENTER|WIK_RIGHT) )
	{
		//Ч
		ASSERT( m_cbActionCard != 0 );
		if( m_cbActionCard == 0 ) return 0;
		if( m_cbActionMask & WIK_LEFT )
		{
			SelectInfo[cbSelectCount].cbActionCard = m_cbActionCard;
			SelectInfo[cbSelectCount].wActionMask = WIK_LEFT;
			SelectInfo[cbSelectCount].cbCardCount = 2;
			SelectInfo[cbSelectCount].cbCardData[0] = m_cbActionCard+1;
			SelectInfo[cbSelectCount++].cbCardData[1] = m_cbActionCard+2;
		}
		if( m_cbActionMask & WIK_CENTER )
		{
			SelectInfo[cbSelectCount].cbActionCard = m_cbActionCard;
			SelectInfo[cbSelectCount].wActionMask = WIK_CENTER;
			SelectInfo[cbSelectCount].cbCardCount = 2;
			SelectInfo[cbSelectCount].cbCardData[0] = m_cbActionCard-1;
			SelectInfo[cbSelectCount++].cbCardData[1] = m_cbActionCard+1;
		}
		if( m_cbActionMask & WIK_RIGHT )
		{
			SelectInfo[cbSelectCount].cbActionCard = m_cbActionCard;
			SelectInfo[cbSelectCount].wActionMask = WIK_RIGHT;
			SelectInfo[cbSelectCount].cbCardCount = 2;
			SelectInfo[cbSelectCount].cbCardData[0] = m_cbActionCard-2;
			SelectInfo[cbSelectCount++].cbCardData[1] = m_cbActionCard-1;
		}
	}
	//
	else if( wOperateCode&(WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN) )
	{
		//Ч
		ASSERT( m_cbActionCard != 0 );
		if( m_cbActionCard == 0 ) return 0;
		if( m_cbActionMask & WIK_LEFT_LISTEN )
		{
			SelectInfo[cbSelectCount].cbActionCard = m_cbActionCard;
			SelectInfo[cbSelectCount].wActionMask = WIK_LEFT_LISTEN;
			SelectInfo[cbSelectCount].cbCardCount = 2;
			SelectInfo[cbSelectCount].cbCardData[0] = m_cbActionCard+1;
			SelectInfo[cbSelectCount++].cbCardData[1] = m_cbActionCard+2;
		}
		if( m_cbActionMask & WIK_CENTER_LISTEN )
		{
			SelectInfo[cbSelectCount].cbActionCard = m_cbActionCard;
			SelectInfo[cbSelectCount].wActionMask = WIK_CENTER_LISTEN;
			SelectInfo[cbSelectCount].cbCardCount = 2;
			SelectInfo[cbSelectCount].cbCardData[0] = m_cbActionCard-1;
			SelectInfo[cbSelectCount++].cbCardData[1] = m_cbActionCard+1;
		}
		if( m_cbActionMask & WIK_RIGHT_LISTEN )
		{
			SelectInfo[cbSelectCount].cbActionCard = m_cbActionCard;
			SelectInfo[cbSelectCount].wActionMask = WIK_RIGHT_LISTEN;
			SelectInfo[cbSelectCount].cbCardCount = 2;
			SelectInfo[cbSelectCount].cbCardData[0] = m_cbActionCard-2;
			SelectInfo[cbSelectCount++].cbCardData[1] = m_cbActionCard-1;
		}
	}
	//
	else if( wOperateCode & (WIK_PENG) )
	{
		//Ч
		ASSERT( m_cbActionCard != 0 );
		if( m_cbActionCard == 0 ) return 0;
		if( m_cbActionMask & WIK_PENG )
		{
			SelectInfo[cbSelectCount].cbActionCard = m_cbActionCard;
			SelectInfo[cbSelectCount].wActionMask = WIK_PENG;
			SelectInfo[cbSelectCount].cbCardCount = 2;
			SelectInfo[cbSelectCount].cbCardData[0] = m_cbActionCard;
			SelectInfo[cbSelectCount++].cbCardData[1] = m_cbActionCard;
		}
	}
	//
	else if( wOperateCode & (WIK_PENG_LISTEN) )
	{
		//Ч
		ASSERT( m_cbActionCard != 0 );
		if( m_cbActionCard == 0 ) return 0;
		if( m_cbActionMask & WIK_PENG_LISTEN )
		{
			SelectInfo[cbSelectCount].cbActionCard = m_cbActionCard;
			SelectInfo[cbSelectCount].wActionMask = WIK_PENG_LISTEN;
			SelectInfo[cbSelectCount].cbCardCount = 2;
			SelectInfo[cbSelectCount].cbCardData[0] = m_cbActionCard;
			SelectInfo[cbSelectCount++].cbCardData[1] = m_cbActionCard;
		}
	}
	//
	else if( wOperateCode & WIK_GANG )
	{
		//Լ
		if( m_wCurrentUser == GetMeChairID() )
		{
			//ѰǷж
			WORD wMeChairId = GetMeChairID();
			tagGangCardResult gcr;
			ZeroMemory( &gcr,sizeof(gcr) );
			m_GameLogic.AnalyseGangCard( m_cbCardIndex,m_WeaveItemArray[wMeChairId],m_cbWeaveCount[wMeChairId],gcr );
			ASSERT( gcr.cbCardCount > 0 );
			for( BYTE i = 0; i < gcr.cbCardCount; i++ )
			{
				SelectInfo[cbSelectCount].cbActionCard = gcr.cbCardData[i];
				SelectInfo[cbSelectCount].wActionMask = WIK_GANG;				
				if( m_cbCardIndex[m_GameLogic.SwitchToCardIndex(gcr.cbCardData[i])] == 1 )
				{
					SelectInfo[cbSelectCount].cbCardCount = 1;
					SelectInfo[cbSelectCount].cbCardData[0] = gcr.cbCardData[i];
				}
				else
				{
					SelectInfo[cbSelectCount].cbCardCount = m_GameLogic.GetWeaveCard(WIK_GANG,gcr.cbCardData[i],
						SelectInfo[cbSelectCount].cbCardData);
				}
				cbSelectCount++;
			}
		}
		else
		{
			ASSERT( m_cbActionCard != 0 );
			if( m_cbActionCard == 0 ) return 0;
			SelectInfo[cbSelectCount].cbActionCard = m_cbActionCard;
			SelectInfo[cbSelectCount].wActionMask = WIK_GANG;
			SelectInfo[cbSelectCount].cbCardCount = 3;
			SelectInfo[cbSelectCount].cbCardData[0] = m_cbActionCard;
			SelectInfo[cbSelectCount].cbCardData[1] = m_cbActionCard;
			SelectInfo[cbSelectCount++].cbCardData[2] = m_cbActionCard;
		}
	}

	return cbSelectCount;
}

//ų
void TL_Gwindow::PlayCardSound(WORD wChairID, BYTE cbCardData)
{
	//return;
	if(m_GameLogic.IsValidCard(cbCardData) == false)
	{
		return;
	}
	if(wChairID < 0 || wChairID > 3)
	{
		return;
	}

	//жԱ
	const tagUserInfo* pUserData = GetUserData(wChairID);
	if(pUserData == 0)
	{
		assert(0 && "òϢ");
		return;
	}
	bool bBoy = (pUserData->cbGender == 2 ? false : true);
	BYTE cbType= (cbCardData & MASK_COLOR);
	BYTE cbValue= (cbCardData & MASK_VALUE);
	char szSoundName[32];
	std::string strSoundName;
	switch(cbType)
	{
	case 0X30:	//
		{
			//strSoundName.Format(TEXT("F%ld"),cbValue);
			sprintf(szSoundName, "F%ld", cbValue);
			break;
		}		
	case 0X20:	//Ͳ
		{
			//strSoundName.Format(TEXT("T%ld"),cbValue);
			sprintf(szSoundName, "T%ld", cbValue);
			break;
		}

	case 0X10:	//
		{
			//strSoundName.Format(TEXT("S%ld"),cbValue);
			sprintf(szSoundName, "S%ld", cbValue);
			break;
		}
	case 0X00:	//
		{
			//strSoundName.Format(TEXT("W%ld"),cbValue);
			sprintf(szSoundName, "W%ld", cbValue);
			break;
		}
	}	

	if(bBoy)
	{
		strSoundName = std::string("Boy_") + szSoundName;
	}
	else
	{
		strSoundName = std::string("Girl_") + szSoundName;
	}

	m_pBas->PlayGameSound(strSoundName.c_str());

}

//
void TL_Gwindow::PlayActionSound(WORD wChairID,DWORD cbAction,bool bZiMo)
{
	//return;
	//жԱ
	const tagUserInfo* pUserData = GetUserData(wChairID);
	if(pUserData == 0)
	{
		assert(0 && "òϢ");
		return;
	}
	if(wChairID < 0 || wChairID > 3)
	{
		return;
	}
	bool bBoy = (pUserData->cbGender == 2 ? false : true);

	switch (cbAction)
	{
	case WIK_LEFT:
	case WIK_CENTER:
	case WIK_RIGHT:		//
	case WIK_LEFT_LISTEN:
	case WIK_CENTER_LISTEN:
	case WIK_RIGHT_LISTEN:
		{
			if(bBoy)
			{
				m_pBas->PlayGameSound("BOY_C");
			}
			else
			{
				m_pBas->PlayGameSound("Girl_C");
			}
			break;
		}
	case WIK_PENG:		//
	case WIK_PENG_LISTEN:
		{
			if(bBoy)
			{
				m_pBas->PlayGameSound("BOY_P");
			}
			else
			{
				m_pBas->PlayGameSound("Girl_P");
			}
			break;
		}
	case WIK_GANG:		//
		{
			if(bBoy)
			{
				m_pBas->PlayGameSound("BOY_G");
			}
			else
			{	
				m_pBas->PlayGameSound("Girl_G");
			}
			break;
		}
	case WIK_CHI_HU:	//Ժ
		{
			if(bZiMo)
			{
				if(bBoy)
				{
					m_pBas->PlayGameSound("BOY_Z");
				}
				else
				{
					m_pBas->PlayGameSound("Girl_Z");
				}
			}
			else
			{
				if(bBoy)
				{
					m_pBas->PlayGameSound("BOY_H");
				}
				else
				{
					m_pBas->PlayGameSound("Girl_H");
				}
			}
			break;
		}
	case WIK_REPLACE:
		{
			if(bBoy)
			{
				m_pBas->PlayGameSound("BOY_B");
			}
			else
			{	
				m_pBas->PlayGameSound("Girl_B");
			}
			break;
		}
	case WIK_LISTEN:
		{
			if(bBoy)
			{
				m_pBas->PlayGameSound("BOY_T");
			}
			else
			{	
				m_pBas->PlayGameSound("Girl_T");
			}
			break;
		}
	}

	return;
}
void TL_Gwindow::OnSort(hgeItemBase *p)
{
	//Ŀ
	WORD wMeChairID=GetMeChairID();
	if(wMeChairID==INVALID_CHAIR) return;
	BYTE cbWeaveCardCount=m_cbWeaveCount[wMeChairID]*3;

	//ת˿
	BYTE cbHandCardData[MAX_COUNT];
	BYTE cbCardCount=m_GameLogic.SwitchToCardData(m_cbCardIndex,cbHandCardData);

	//˿
	if ( (cbWeaveCardCount+cbCardCount)==MAX_COUNT )
	{
		if( m_cbSendCard != 0x00 )
		{
			//ɾ˿
			BYTE cbRemoveCard[]={m_cbSendCard};
			VERIFY( m_GameLogic.RemoveCard(cbHandCardData,cbCardCount,cbRemoveCard,1) );

			//˿
			cbHandCardData[cbCardCount-1]=m_cbSendCard;
		}
		m_GameLogic.SortCardList(cbHandCardData,cbCardCount-1,m_bSort);
		m_pBas->m_pHandCard->SetCardData(cbHandCardData,cbCardCount-1,cbHandCardData[cbCardCount-1]);
	}
	else
	{
		m_GameLogic.SortCardList(cbHandCardData,cbCardCount,m_bSort);
		m_pBas->m_pHandCard->SetCardData(cbHandCardData,cbCardCount,0x00);
	}

	m_bSort=(!m_bSort);
}
void TL_Gwindow::OnOKButton(int nCellPos)
{
	if(nCellPos==255)
	{
		OnStart(NULL);
	}
	else
	{
		//Ϣ
		CMD_C_CellScore CellScore;
		CellScore.lCellScore=nCellPos;
		SendSocketData( SUB_C_SENDCELL,&CellScore,sizeof(CellScore) );
	}
	m_pBas->m_bShowSetCell=false;
}
void TL_Gwindow::OnShowCard(int Card)
{
	if(m_pBas->m_pEndPlay->GetState())
	{
		CMD_C_DuiHuaCard DuiHuaCard;
		DuiHuaCard.cbCardData=Card;
		SendSocketData(SUB_C_DUIHUA_CARD,&DuiHuaCard,sizeof(DuiHuaCard));
	}
	else
	{
		CMD_C_HaiDiCard HaiDiCard;
		HaiDiCard.cbCardData=Card;
		SendSocketData(SUB_C_HAIDI_CARD,&HaiDiCard,sizeof(HaiDiCard));
	}

	KillGameTimerN(IDI_DUI_HUA);
}
void TL_Gwindow::OnRightButtonDown()
{
	if(m_bWillHearStatus)
	{
		//ڲģʽ
		if( m_pBas->m_pHandCard->GetSelectMode() )
		{
			m_pBas->m_pHandCard->SetSelectMode(false);
			m_pBas->m_pHandCard->ReleaseInfo();
		}
		m_bWillHearStatus=false;
		m_pBas->ReleaseTingInfo();
		m_pBas->m_pHandCard->SetListen(false);
		m_pBas->m_pHandCard->SetAllCardGray(false);
		CMD_C_ListenSet ListenSet;
		ListenSet.bListen=false;
		SendSocketData(SUB_C_LISTEN_SET,&ListenSet,sizeof(ListenSet));
	}

	//ڲģʽ
	if( m_pBas->m_pHandCard->GetSelectMode() )
	{
		//
		DWORD cbOperateCode;
		BYTE cbOperateCard[3] = {0,0,0};

		//ɾʱ
		//KillGameTimerN(IDI_OPERATE_CARD);

		//ȡѡϢ
		tagSelectCardInfo si;
		m_pBas->m_pHandCard->GetUserSelectResult( si );

		//Ϣ
		cbOperateCode = (DWORD)si.wActionMask;
		cbOperateCard[0] = si.cbActionCard;
		CopyMemory( &cbOperateCard[1],si.cbCardData,sizeof(BYTE)*2 );

		//ȡģʽ
		m_pBas->m_pHandCard->SetSelectMode( false );

		if(cbOperateCode==WIK_GANG)
		{
			m_cbActionMask = 0;
			m_cbActionCard = 0;
		}
		else
		{
			m_wCurrentUser = INVALID_CHAIR;
			m_cbActionMask = 0;
			m_cbActionCard = 0;
			//
			m_pBas->SetStatusFlag(false,true);
			OnUserAction(WIK_NULL);
		}
	}
}
//Ȩλ
void TL_Gwindow::FiltrateRight( WORD wWinner, BYTE cbProvideCard,BYTE cbRemoveCard, CChiHuRight &chr ,CChiHuRight &chrhigh,CChiHuRight &chrnew)
{
	/*	Ȩλ	*/

	CWHArray<BYTE> tempCard;

	bool bKan=false;

	//
	CChiHuRight chrc;
	CChiHuRight chrhighc;
	CChiHuRight	chrnewc;
	//˿
	BYTE cbCardIndexTemp[MAX_INDEX];
	CopyMemory(cbCardIndexTemp,m_cbCardIndex,sizeof(cbCardIndexTemp));
	//ɾ˿
	if( !m_GameLogic.RemoveCard(cbCardIndexTemp,cbRemoveCard) )
	{
		ASSERT( FALSE );
		return;
	}
	//ж
	BYTE i=0;
	for (;i<MAX_INDEX;i++)
	{
		//Ʒ
		BYTE cbCurrentCard=m_GameLogic.SwitchToCardData(i);               
		BYTE cbHuCardKind=m_GameLogic.AnalyseChiHuCard(cbCardIndexTemp,m_WeaveItemArray[wWinner],
			m_cbWeaveCount[wWinner],cbCurrentCard,chrc,chrhighc,chrnewc);

		//ж
		if (cbHuCardKind!=WIK_NULL)
		{
			tempCard.Add(m_GameLogic.SwitchToCardData(i));
		}
	}

	if(tempCard.GetCount()==1)
	{
		if(tempCard[0]>0x01&&tempCard[0]<0x09)
			bKan=true;
	}

	if(bKan)
	{
		chrnew|=CHR_KAN_ZHANG;
	}

	if(!(chrnew&CHR_BIAN_ZHANG).IsEmpty())
	{
		chrnew&=~CHR_KAN_ZHANG;
	}

	if(!(chr&CHR_DAN_DIAO).IsEmpty())
	{
		chrnew&=~CHR_KAN_ZHANG;
	}

	if(!(chrnew&CHR_BIAN_ZHANG).IsEmpty()&&!(chr&CHR_DAN_DIAO).IsEmpty())
	{
		chrnew&=~CHR_BIAN_ZHANG;
	}

	if(m_pBas->GetHuaCount(wWinner)>0)
	{
		chrnew|=CHR_HUA_CARD;
	}

	if(!(chrhigh&CHR_QI_DUI).IsEmpty())
	{
		chrnew&=~CHR_KAN_ZHANG;
	}

	BYTE tempcount=0;
	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		for(BYTE j=0;j<m_cbDiscardCount[i];j++)
		{
			if(m_cbDiscardCard[i][j]==cbProvideCard)
			{
				tempcount++;
			}
		}

		for(BYTE j=0;j<m_cbWeaveCount[i];j++)
		{
			for(BYTE z=0;z<4;z++)
			{
				if(m_WeaveItemArray[i][j].cbCardData[z]==cbProvideCard)
				{
					tempcount++;
				}
			}
		}
	}

	//for(BYTE i=0;i<MAX_INDEX;i++)
	//{
	//	if(m_cbCardIndex[m_GameLogic.SwitchToCardIndex(cbProvideCard)]>0)
	//	{
	//		tempcount+=m_cbCardIndex[m_GameLogic.SwitchToCardIndex(cbProvideCard)];
	//	}
	//}

	if(tempcount==4)
		chr |= CHR_JUE_ZHANG;

	if(!(chr&CHR_MEN_QI_QING).IsEmpty())
		chr|=CHR_LI_ZHI;
	else
		chr|=CHR_TING_CARD;

	if((!(chr&CHR_ZI_MO).IsEmpty())&&(!(chr&CHR_MEN_QI_QING).IsEmpty()))
	{
		chr |= CHR_MENQING_ZIMO;
		chr&=~CHR_ZI_MO;
		chr&=~CHR_MEN_QI_QING;
	}
	if((!(chrhigh&CHR_QING_LONG).IsEmpty()))
	{
		chr&=~CHR_LIAN_6;
		chr&=~CHR_LAO_SHAO_F;
	}
	if((!(chrhigh&CHR_YISE_SIBU).IsEmpty()))
	{
		chr&=~CHR_DOUBLE_ANKE;
	}
	if((!(chrhigh&CHR_QING_LAOTOU).IsEmpty()))
	{
		chr&=~CHR_PENG_PENG;
		chr&=~CHR_YAO_JIU_KE;
		chr&=~CHR_QUAN_DAI_YAO;
	}
	if((!(chrhigh&CHR_LONG_QI_DUI).IsEmpty()))
	{
		chrhigh&=~CHR_QI_DUI;
		chr&=~CHR_SI_GUI_YI;
	}
	if((!(chrhigh&CHR_YISE_SANTONG).IsEmpty()))
	{
		chrhigh&=~CHR_THREE_ANKE;
	}
	if((!(chrhigh&CHR_YISE_SITONG).IsEmpty()))
	{
		chrhigh&=~CHR_LONG_QI_DUI;
	}
	if((!(chrhigh&CHR_YISE_SIJIE).IsEmpty()))
	{
		chrhigh&=~CHR_YISE_SANTONG;
		chr&=~CHR_PENG_PENG;
	}

	if((!(chrhigh&CHR_YISE_SHUANG_LONG).IsEmpty()))
	{
		chrhigh&=~CHR_QI_DUI;
	}

	if((!(chrhigh&CHR_CHUN_QUAN_DAI_YI).IsEmpty()))
	{
		chr&=~CHR_QUAN_DAI_YAO;
	}

	CChiHuRight tempRight,tempDa;
	tempRight.SetEmpty();
	tempDa.SetEmpty();
	if((!(chrhigh&CHR_XIAO_SI_XI).IsEmpty()))
	{
		tempRight|=CHR_XIAO_SI_XI;
	}
	if((!(chrhigh&CHR_XIAO_SAN_YUAN).IsEmpty()))
	{
		tempRight|=CHR_XIAO_SAN_YUAN;
	}
	if((!(chrhigh&CHR_ZI_YI_SE).IsEmpty()))
	{
		tempRight|=CHR_ZI_YI_SE;
	}
	if((!(chrhigh&CHR_SI_AN_KE).IsEmpty()))
	{
		tempRight|=CHR_SI_AN_KE;
	}
	if((!(chrhigh&CHR_YISE_SHUANG_LONG).IsEmpty()))
	{
		tempRight|=CHR_YISE_SHUANG_LONG;
	}
	if((!(chrhigh&CHR_TIAN_HU).IsEmpty()))
	{
		tempRight|=CHR_TIAN_HU;
	}
	if((!(chrhigh&CHR_DI_HU).IsEmpty()))
	{
		tempRight|=CHR_DI_HU;
	}

	if((!(chrhigh&CHR_DA_SI_XI).IsEmpty()))
	{
		tempDa|=CHR_DA_SI_XI;
	}
	if((!(chrhigh&CHR_DA_SAN_YUAN).IsEmpty()))
	{
		tempDa|=CHR_DA_SAN_YUAN;
	}
	if((!(chrhigh&CHR_JIU_LIAN).IsEmpty()))
	{
		tempDa|=CHR_JIU_LIAN;
	}
	if((!(chrhigh&CHR_SHI_BA).IsEmpty()))
	{
		tempDa|=CHR_SHI_BA;
	}
	if((!(chrhigh&CHR_LIAN_QI_DUI).IsEmpty()))
	{
		tempDa|=CHR_LIAN_QI_DUI;
	}
	if((!(chrhigh&CHR_DA_5).IsEmpty()))
	{
		tempDa|=CHR_DA_5;
	}
	if((!(chrhigh&CHR_XIAO_5).IsEmpty()))
	{
		tempDa|=CHR_XIAO_5;
	}

	if(!(tempDa.IsEmpty()))
	{
		chrhigh.SetEmpty();
		chr.SetEmpty();
		chrnew.SetEmpty();
		chrhigh=tempDa;
	}
	else if(!(tempRight.IsEmpty()))
	{
		if((!(chrhigh&CHR_LONG_QI_DUI).IsEmpty()))
		{
			tempRight|=CHR_LONG_QI_DUI;
		}
		if((!(chrhigh&CHR_QI_DUI).IsEmpty()))
		{
			tempRight|=CHR_QI_DUI;
		}
		chrhigh.SetEmpty();
		chr.SetEmpty();
		chrnew.SetEmpty();
		chrhigh=tempRight;
	}
}


bool TL_Gwindow::OnResetGameEngine()
{
	return true;
}

bool TL_Gwindow::OnInitGameEngine( )
{
	HICON hIcon=LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDR_MAINFRAME));
	SetGameAttribute(KIND_ID,GAME_PLAYER,VERSION_CLIENT,hIcon,GAME_NAME);
	if (IsSingleMode() == false)
	{
		CreateConnect();
	}
	return true;
}
