
#include "UserActionItem.h"
#include "GUIHallComm.h"

#define WINDOW_DRAWWIDTH		1024
#define WINDOW_DRAWHEIGHT		740

struct tagHeapCardInfo
{
	WORD			wStartIndex;
	WORD			wRemoveCount;
};

typedef CWHArray<tagUserAction *> CUserActionArray;				//Ŀ

class  TL_Gwindow: public TL_FrameWindow/*,public TL_GameComm*/
{
public:
	TL_Gwindow();
	~TL_Gwindow();
	virtual bool  InitWnd();
	virtual void  InitRes();
	virtual void  LoadXML();
	virtual void  DrawWnd();
	virtual void  RectifyControl(int nWidth, int nHeight);
	virtual bool  ProcMessage(UINT msg, WPARAM wparam, LPARAM lparam);
	virtual bool  Update();
	virtual void  ReleaseRes();
	virtual bool  InsertUserChat(LPCTSTR pszSendName, LPCTSTR pszString, COLORREF crColor, UINT uSize);
	virtual bool  InsertUserChat(LPCTSTR pszSendName, LPCTSTR pszRecvName, LPCTSTR pszString, COLORREF crColor, UINT uSize);	
	virtual void  ResetGameFrame();

public:
	void  CloseGAME(hgeItemBase *p);
protected:
	
	void  MinGAME(hgeItemBase  *p);
	void  HomePage(hgeItemBase *p);
	void  GetMoney(hgeItemBase *p);
	void  GameShop(hgeItemBase *p);
	void  GameSnap(hgeItemBase *p);
private:
	TL_GUIHallComm              *m_pGUIHanllComm;
private:
	TL_GBaseContainer			*m_pBas;
	CGameLogic					m_GameLogic;							//Ϸ߼
private:
	WORD						m_wTimerChair;
	//û
protected:
	WORD						m_wBankerUser;
	WORD						m_wCurrentUser;							//ǰû
	WORD						m_wReplaceUser;							//û
	BYTE						m_cbActionCard;							//
	bool						m_bGameStart;
	bool						m_bSort;
	bool						m_bGameEnd;
	BYTE						m_cbSendCard;
	BYTE						m_cbHaiDiIndex;
	bool						m_bHaiDiUpdata;
	bool						m_bHaiDiHu;
	bool						m_bOutCard;
protected:
	BYTE						m_cbCardIndex[MAX_INDEX];				//˿
	BYTE						m_cbLeftCardCount;						//ʣĿ
	DWORD						m_cbActionMask;							//Ҷ
	bool						m_bActionMask;
	LONG						m_lSiceCount;							//ӵ
	WORD						m_wHeapHead;							//ƶͷ
	WORD						m_wHeapTail;							//ƶβ
	//BYTE						m_cbHeapCardInfo[GAME_PLAYER][2];		//Ϣ
	tagHeapCardInfo				m_HeapCardInfo[GAME_PLAYER];


	//
	TCHAR						m_szAccounts[GAME_PLAYER][LEN_ACCOUNTS];	//
protected:
	bool						m_bStustee;							//йܱ־
	BYTE						m_cbListenStatus;					//״̬,0ָδ,1ָֻ,2ָֻ,3ָƺ
	bool						m_bWillHearStatus;					//
	WORD						m_wTimeOutCount;					//ʱ
	LONG						m_lReplaceCount;
	bool						m_bReplace;
	LONGLONG					m_lUpScore;

	//״̬
protected:
	bool						m_bHearStatus;							//״̬
	WORD						m_wListenUser;
	bool						m_bDuiHuaStatus;
//	bool							m_bWillHearStatus;					//
	//
protected:
	CUserActionArray				m_UserActionArray;					//Ŀ
	ofstream						SparrowCJDlg;
	//CUserActionArray				m_UserActionStorage;				//Ŀ
	//˿
protected:
	BYTE							m_cbWeaveCount[GAME_PLAYER];	        	//Ŀ
	tagWeaveItem					m_WeaveItemArray[GAME_PLAYER][MAX_WEAVE];	//˿
	BYTE							m_cbDiscardCount[GAME_PLAYER];				//Ŀ
	BYTE							m_cbDiscardCard[GAME_PLAYER][60];			//¼
protected:
	void OnStart(hgeItemBase  *p);
	void KillGameTimerN(UINT nTimerID);
	void SetGameTimerN(WORD wChairID, UINT nTimerID, UINT nElapse);
	//㷭
	void ClacTurnoverCard();
	//ָ
	void ReleaseGame();
	//Ϣ
protected:
	//Ϸʼ
	bool OnSubGameStart(const void * pBuffer, WORD wDataSize);
	//û
	bool OnSubListenCard(const void * pBuffer, WORD wDataSize);
	//
	bool OnSubListenSet(const void * pBuffer,WORD wDataSize);
	//û
	bool OnSubOutCard(const void * pBuffer, WORD wDataSize);
	//Ϣ
	bool OnSubSendCard(const void * pBuffer, WORD wDataSize);
	//ʾ
	bool OnSubOperateNotify(const void * pBuffer, WORD wDataSize);
	//
	bool OnSubOperateResult(const void * pBuffer, WORD wDataSize);
	//Ϸ
	bool OnSubGameEnd(const void * pBuffer, WORD wDataSize);
	//ûй
	bool OnSubTrustee(const void * pBuffer,WORD wDataSize);
	//Ϣ
	bool OnSubReplaceCard(const void * pBuffer, WORD wDataSize);
	//õ׷
	bool OnSubSetCell(const void * pBuffer, WORD wDataSize);
	//ʾ
	bool OnSubShowSet(const void * pBuffer, WORD wDataSize);
	//Ի
	bool OnSubDuiHua(const void * pBuffer, WORD wDataSize);
	//
	bool OnSubHaiDi(const void * pBuffer, WORD wDataSize);
	//ս
	bool OnSubRedouble(const void * pBuffer, WORD wDataSize);
	bool OnSubShowRedouble(const void * pBuffer, WORD wDataSize);
	//˿
	void SetHandCardControl(BYTE cbCardIndex[MAX_INDEX], BYTE cbAdvanceCard);
	//ȡϢ
	BYTE GetSelectCardInfo( DWORD wOperateCode, tagSelectCardInfo SelectInfo[MAX_WEAVE] );
	//ȡϢ
	bool GetTingCard(BYTE cbCardData,CWHArray<tagTingInfo> &tCard);
	//Ի
	bool OnSubDuiHuaResult(const void * pBuffer, WORD wDataSize);
	//׽
	bool OnSubHaiDiResult(const void * pBuffer, WORD wDataSize);
	//ʾ˼
	bool OnSubShowThink(const void * pBuffer, WORD wDataSize);
	bool OnSubTingInfo(const void * pBuffer,WORD wDataSize);
	bool OnSubStartOver(const void * pBuffer, WORD wDataSize);
	//
	void ResetTable();
public:
	virtual bool RequestQuit();
	virtual BYTE InitGameFrame();
	virtual void OnGameOptionSet(hgeItemBase *p);

	virtual bool OnInitGameEngine();
	virtual bool OnResetGameEngine();

	//ʱϢ
	virtual bool OnEventGameClockInfo(WORD wChairID, UINT nElapse, WORD wClockID);

	virtual bool OnEventGameClockKill(WORD wChairID){return true;};
	//Թ״̬
	virtual bool OnEventLookonMode(VOID * pData, WORD wDataSize);
	//Ϣ
	virtual bool OnEventGameMessage(WORD wSubCmdID, VOID * pData, WORD wDataSize);
	//Ϸ
	virtual bool OnEventSceneMessage(BYTE cbGameStatus, bool bLookonUser, VOID * pData, WORD wDataSize);
	//
protected:
	//ʼҶ
	bool BeginUserAction();
	//ֹͣҶ
	bool StopUserAction();
	//Ƴǰ
	bool RemoveCurrentAction();
	//
	tagUserAction *ActiveUserAction(enmActionKind enActionKind);
	//ƶ
	bool BeginActionStartCard();
	//ɫ
	bool BeginActionSice();
	//ƶ
	bool BeginActionOutCard();
	//ƶ
	bool BeginActionSendCard();
	//ʾ
	bool BeginActionNotify();
	//
	bool BeginActionResult();
	//Ϸ
	bool BeginActionGameEnd();
protected:
	//
	void OnUserActionFinish();
	//
	bool OnActionStartCard();
	//ɫ
	bool OnActionSice();
	//
	bool OnActionOutCard();
	//ץ
	bool OnActionSendCard();
	//ʾ
	bool OnActionNotify();
	//
	bool OnActionResult();
protected:
	//Ҳ
	void OnUserAction(int nAction);
	//Ʋ
	void OnListenCard(int nTemp);
	//Ϲܿ
	void OnStusteeControl();
	//˿˲
	void OnCardOperate();
	//ж
	bool VerdictOutCard(BYTE cbCardData);
	//Ʋ
	void OnOutCard(int cbCardData);
	//Ϣ
	void OnTingCard(int cbCardData);
	//Ϸ
	bool OnActionGameEnd();
	void OnContinue();
	void OnEsc();
	void OnRedouble(int n);
	//ť
	void OnSort(hgeItemBase *p);
	//
	void PlayCardSound(WORD wChairID,BYTE cbCardData);
	//
	void PlayActionSound(WORD wChairID,DWORD cbAction,bool bZiMo=false);
	void OnOKButton(int nCellPos);
	//ѡ
	void OnShowCard(int Card);
	void OnMyFlashID();
	void OnHideRedouble();
	//ȡ
	BYTE GetDiscardCount( BYTE cbCardData );
	//
	void OnRightButtonDown();
	//Ȩλ
	void FiltrateRight( WORD wWinner, BYTE cbProvideCard,BYTE cbRemoveCard, CChiHuRight &chr ,CChiHuRight &chrhigh,CChiHuRight &chrnew);
};