#ifndef GROUP_ANIMATE
#define GROUP_ANIMATE

#pragma once
#include "stdafx.h"

class CGroupAnimate :
	public hgeItemContainer
{
protected:
	CWHArray<MySprite*>	m_ArraySprite;
	CWHArray<HTEXTURE>	m_ArrayTexture;
private:
	float		m_fSpriteWidth;
	float		m_fSpriteHeight;
	DWORD		m_dwFrame;
	DWORD		m_dwSpeed;
	CString		m_PathName;
protected:
	hgePoint	m_hgePoint;
	bool		m_bStart;
	bool		m_bRun;
	BYTE		m_cbFrom;
	HGE			*m_phge;				//hge
public:
	CGroupAnimate(const tstring& strName);
public:
	~CGroupAnimate(void);
public:
	void InitAnimate(CString pathname,float nWidth,float nHeight,DWORD dwFrame,BYTE cbFrom=0);
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	void SetPoint(hgePoint point);
	void UpData();
	void Stop();
	void Start();
	void LondData();
	bool IsStart(){return m_bStart;}
	void SetRun(bool bRun){m_bRun=bRun;}
};

#endif