#ifndef SET_CELL_SCORE
#define SET_CELL_SCORE

#pragma once
#include "Stdafx.h"
#include "GfxFont.h"

class CSetCellScore :
	public hgeItemContainer
{
protected:
	MySprite			*m_pBack;
	GfxFont				*m_pFont;
	MySprite			*m_pCheckBox[9];
public:
	hgeItemButton		*m_pOk;
	hgeItemButton		*m_pCancel;
	hgeItemButton		*m_pClose;
	FEvent_PInt			m_FPOk;
	FEvent_PItemV2		m_FPClose;
private:
	hgePoint			m_ptPoint;
	hgePoint			m_ptOk;
	hgeRect				m_rcOk;
	hgePoint			m_ptClose;
	hgeRect				m_rcClose;
	hgePoint			m_ptCancel;
	hgeRect				m_rcCancel;
protected:
	LONGLONG			m_lCellScore[9];
	BYTE				m_cbCheckEstate[9];
	hgePoint			m_ptCheck[9];
	hgeRect				m_rcCheck[9];
	BYTE				m_cbCheckPos;
private:
	bool				m_bWait;
	bool				m_bSetOk;
	bool				m_bLeave;
	LONGLONG				m_lSetScore;
public:
	CSetCellScore(const tstring &strname);
public:
	~CSetCellScore(void);
public:
	void Init();
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	void SetPoint(hgePoint Point);
	void DrawNumberString(LONGLONG dwNumber,COLORREF crText,float nXPos,float nYPos);
public:
	void OnLButtonDown(UINT nFlags, const hgePoint& point);
	void OnLButtonUp(UINT nFlags, const hgePoint& point);
	void OnMouseMove(UINT nFlags, const hgePoint& point);
public:
	void SetUserScore(LONGLONG uUserScore);
	void SetWait();
	void SetCellScore(LONGLONG uCellScore,bool bLeave);
	void ReleaseData();
};
#endif