#ifndef ANDROID_USER_ITEM_SINK_HEAD_FILE
#define ANDROID_USER_ITEM_SINK_HEAD_FILE

#pragma once

#include "Stdafx.h"
#include "GameLogic.h"
#include <fstream>
using namespace std;

//////////////////////////////////////////////////////////////////////////

//
class CAndroidUserItemSink : public IAndroidUserItemSink
{
	//û
protected:
	WORD							m_wBankerUser;							//ׯû
	WORD							m_wCurrentUser;							//ǰû
	WORD							m_wReplaceUser;

	//״̬
protected:
	bool							m_bHearStatus;							//״̬
	bool							m_bWillHearStatus;						//
	DWORD							m_bActionMask;							//
	BYTE							m_cbActionCard;							//˿	

	bool                            m_bFenZhangStatus;

	WORD							m_wHunPiSiceCount;							//ӵ
	WORD							m_wQiePaiSiceCount;							//ӵ
	BYTE                            m_cbHunPiPositon; 

	//˿˱
protected:
	BYTE							m_cbLeftCardCount;						//ʣĿ
	BYTE							m_cbCardIndex[GAME_PLAYER][MAX_INDEX];	//˿
	BYTE							m_cbRepertoryCard[MAX_REPERTORY];		//˿

	//˿
protected:
	BYTE							m_cbWeaveCount[GAME_PLAYER];			//Ŀ
	tagWeaveItem					m_WeaveItemArray[GAME_PLAYER][4];		//˿

	//Ϣ
protected:
	WORD							m_wOutCardUser;							//û
	BYTE							m_cbOutCardData;						//˿
	BYTE							m_cbDiscardCount[GAME_PLAYER];			//Ŀ
	BYTE							m_cbDiscardCard[GAME_PLAYER][60];		//¼
	BYTE							m_cbSendCardData;						//˿
	BYTE							m_cbSendQingCardData;						//˿
	LONGLONG						m_lCellScore[9];
	CWHArray<BYTE>					m_ArrayCard;
	CWHArray<bool>					m_ArrayBool;
	bool							m_bReplace;
	bool							m_bOutCard;
	bool							m_bAllAndroidUser;


	//ؼ
protected:
	CGameLogic						m_GameLogic;							//Ϸ߼
	IAndroidUserItem *				m_pIAndroidUserItem;					//ûӿ
	//ofstream						Androiout;


	//
public:
	//캯
	CAndroidUserItemSink();
	//
	virtual ~CAndroidUserItemSink();

	//ӿ
public:
	//ͷŶ
	virtual void  Release() {}
	//ǷЧ
	virtual bool  IsValid() { return AfxIsValidAddress(this,sizeof(CAndroidUserItemSink))?true:false; }
	//ӿڲѯ
	virtual void *  QueryInterface(const IID & Guid, DWORD dwQueryVer);

	//ƽӿ
public:
	//ʼӿ
	virtual bool  Initialization(IUnknownEx * pIUnknownEx);
	//ýӿ
	virtual bool  RepositionSink();

	//Ϸ¼
public:
	//ʱϢ
	virtual bool  OnEventTimer(UINT nTimerID);
	//ϷϢ
	virtual bool  OnEventGameMessage(WORD wSubCmdID, void * pData, WORD wDataSize);
	//ϷϢ
	virtual bool  OnEventFrameMessage(WORD wSubCmdID, void * pData, WORD wDataSize);
	//Ϣ
	virtual bool  OnEventSceneMessage(BYTE cbGameStatus, bool bLookonOther, VOID * pData, WORD wDataSize);

	//û¼
public:
	//û
	virtual void  OnEventUserEnter(IAndroidUserItem * pIAndroidUserItem, bool bLookonUser);
	//û뿪
	virtual void  OnEventUserLeave(IAndroidUserItem * pIAndroidUserItem, bool bLookonUser);
	//û
	virtual void  OnEventUserScore(IAndroidUserItem * pIAndroidUserItem, bool bLookonUser);
	//û״̬
	virtual void  OnEventUserStatus(IAndroidUserItem * pIAndroidUserItem, bool bLookonUser);


	//Ϣ
protected:
	//ׯϢ
	bool OnSubGameStart(void * pData, WORD wDataSize);
	//Ϸ
	bool OnSubGameEnd(void * pData, WORD wDataSize);
	//õ׷
	//bool OnSetCell(void *pData,WORD wDataSize);
	//û
	bool OnSubOutCard(const void * pBuffer, WORD wDataSize);
	//Ϣ
	bool OnSubSendCard(const void * pBuffer, WORD wDataSize);
	//ʾ
	bool OnSubOperateNotify(const void * pBuffer, WORD wDataSize);
	//
	bool OnSubOperateResult(const void * pBuffer, WORD wDataSize);
	//û
	bool OnSubListenCard(const void * pBuffer, WORD wDataSize);
	//õ׷
	bool OnSubSetCell(const void * pBuffer, WORD wDataSize);
	//ʾ
	bool OnSubShowSet(const void * pBuffer, WORD wDataSize);
	//Ի
	bool OnSubDuiHua(const void * pBuffer, WORD wDataSize);
	//Ի
	bool OnSubDuiHuaResult(const void * pBuffer, WORD wDataSize);
	//
	bool OnSubHaiDi(const void * pBuffer, WORD wDataSize);
	//׽
	bool OnSubHaiDiResult(const void * pBuffer, WORD wDataSize);
	//У
	bool VerdictOutCard(BYTE cbPreCardData);
	bool OnSubStartOver(const void * pBuffer, WORD wDataSize);

	bool GoOnSendCard(bool bGoOn);
	//
protected:
	//Ʋ
	void OnOutCard( BYTE cbOutCard );
	//
	void OnReplaceCard();
	//˿˲
	void OnOperateCard( DWORD cbOperateCode,BYTE cbOperateCard );
	//ܳ
	BYTE GetIsolatedCard();
	//ȡϢ
	bool GetTingCard(BYTE cbCardData,CWHArray<BYTE> &tCard);
	//
	void OnListenCard();
	//Ŀ
	BYTE GetIsolatedCardCount(BYTE cbCardIndex[MAX_INDEX]);
	//Ų
	BYTE GetTheBestOperate(DWORD cbOperateCode,BYTE cbOperateCard);
	//ȡ
	LONGLONG GetCellScore(LONGLONG lCellScore);
	void OnHideRedouble();

};

//////////////////////////////////////////////////////////////////////////

#endif