#include "StdAfx.h"
#include "TableFrameSink.h"
#include "math.h"

//////////////////////////////////////////////////////////////////////////

//̬
const WORD			CTableFrameSink::m_wPlayerCount=GAME_PLAYER;			//Ϸ
const BYTE			CTableFrameSink::m_GameStartMode=START_MODE_ALL_READY;	//ʼģʽ

//////////////////////////////////////////////////////////////////////////
ofstream SparrowTowPlayerTable("SparrowTowPlayTable.log");
ofstream SparrowTwoPeopleError("SparrowTwoPeopleGameMessage.txt");
//캯
CTableFrameSink::CTableFrameSink()
{
	//Ϸ
	m_bDelete=false;
	m_lSiceCount=0;
	m_wBankerUser=INVALID_CHAIR;
	m_wChengBaoChairID=INVALID_CHAIR;
	m_lCellScore=0;
	m_cbPlayerSitDown=0;
	m_bSetCell=false;
	m_cbPaiMianCard=0;
	m_wSetCellChairID=INVALID_CHAIR;
	ZeroMemory(m_cbCardIndex,sizeof(m_cbCardIndex));
	ZeroMemory(m_bTrustee,sizeof(m_bTrustee));
	ZeroMemory(m_cbListenStatus,sizeof(m_cbListenStatus));
	ZeroMemory( m_lGameScore,sizeof(m_lGameScore) );
	ZeroMemory(m_bHearStatus,sizeof(m_bHearStatus));
	ZeroMemory(m_bWillHearStatus,sizeof(m_bWillHearStatus));
	ZeroMemory(m_bSitDown,sizeof(m_bSitDown));
	m_wHearUser=INVALID_CHAIR;
	m_cbLaoYueCount=0;
	m_bHaiDiTrue=false;
	m_bPlaySet=false;
	ZeroMemory(m_bKan,sizeof(m_bKan));
	m_bDuiHuaStatus=false;
	m_bHaiDiStatus=false;
	m_bEndGameStatus=false;
	m_wEndChairID=INVALID_CHAIR;
	ZeroMemory(m_dwRedoubleCount,sizeof(m_dwRedoubleCount));
	ZeroMemory(m_cbEndPlayData,sizeof(m_cbEndPlayData));
	ZeroMemory(m_cbShowCardData,sizeof(m_cbShowCardData));

	//Ϣ
	m_cbOutCardData=0;
	m_cbOutCardCount=0;
	m_cbGameStartOver=0;
	ZeroMemory(m_cbTempOutData,sizeof(m_cbTempOutData));
	m_wOutCardUser=INVALID_CHAIR;
	ZeroMemory(m_cbDiscardCard,sizeof(m_cbDiscardCard));
	ZeroMemory(m_cbDiscardCount,sizeof(m_cbDiscardCount));

	//Ϣ
	m_wHeapHead = INVALID_CHAIR;
	m_wHeapTail = INVALID_CHAIR;
//	ZeroMemory(m_cbHeapCardInfo,sizeof(m_cbHeapCardInfo));
	ZeroMemory(m_HeapCardInfo,sizeof(m_HeapCardInfo));

	//Ϣ
	m_cbSendCardData=0;
	m_cbSendCardCount=0;
	m_cbLeftCardCount=0;
	ZeroMemory(m_cbRepertoryCard,sizeof(m_cbRepertoryCard));
	m_cbEndLeftCount = 0;
	m_cbGoodCardIndex=0;

	//б
	m_cbProvideCard=0;
	m_cbGangOutCard=0;
	m_wResumeUser=INVALID_CHAIR;
	m_wCurrentUser=INVALID_CHAIR;
	m_wProvideUser=INVALID_CHAIR;
	m_wMyChairID=INVALID_CHAIR;
	m_wHaveGoodCardAndroidUser=INVALID_CHAIR;

	ZeroMemory( m_cbHuaCardCount,sizeof(m_cbHuaCardCount) );
	ZeroMemory( m_cbHuaCardData,sizeof(m_cbHuaCardData) );
	ZeroMemory( m_cbHuaCardInfo,sizeof(m_cbHuaCardInfo) );
	m_wReplaceUser = INVALID_CHAIR;

	//״̬
	m_bSendStatus=false;
	m_bGangStatus = false;
	m_bQiangGang=false;
	m_bOutCardData=false;
	m_bShow=false;
	m_bManGuan=false;
	ZeroMemory(m_bEnjoinChiPeng,sizeof(m_bEnjoinChiPeng));
	ZeroMemory(m_bEnjoinPeng,sizeof(m_bEnjoinPeng));

	//û״̬
	ZeroMemory(m_bResponse,sizeof(m_bResponse));
	ZeroMemory(m_cbUserAction,sizeof(m_cbUserAction));
	ZeroMemory(m_cbOperateCard,sizeof(m_cbOperateCard));
	ZeroMemory(m_cbPerformAction,sizeof(m_cbPerformAction));
	ZeroMemory(m_dwFanShu,sizeof(m_dwFanShu));

	//˿
	ZeroMemory(m_WeaveItemArray,sizeof(m_WeaveItemArray));
	ZeroMemory(m_cbWeaveItemCount,sizeof(m_cbWeaveItemCount));

	//Ϣ
	ZeroMemory(m_cbMingGangCount,sizeof(m_cbMingGangCount));
	ZeroMemory(m_cbAnGangCount,sizeof(m_cbAnGangCount));

	//Ϣ
	m_cbChiHuCard=0;
	ZeroMemory( m_dwChiHuKind,sizeof(m_dwChiHuKind) );
	ZeroMemory(m_ChiHuNew,sizeof(m_ChiHuNew));

	//
	m_pITableFrame=NULL;
	m_pGameServiceOption=NULL;
	m_GameState= gs_Free;
	return;
}

//
CTableFrameSink::~CTableFrameSink(void)
{
}

//ӿڲѯ
void *  CTableFrameSink::QueryInterface(const IID & Guid, DWORD dwQueryVer)
{
	QUERYINTERFACE(ITableFrameSink,Guid,dwQueryVer);
	QUERYINTERFACE(ITableUserAction,Guid,dwQueryVer);
	QUERYINTERFACE_IUNKNOWNEX(ITableFrameSink,Guid,dwQueryVer);
	return NULL;
}

//ʼ
bool  CTableFrameSink::Initialization(IUnknownEx * pIUnknownEx)
{
	//ѯӿ
	ASSERT(pIUnknownEx!=NULL);
	m_pITableFrame=QUERY_OBJECT_PTR_INTERFACE(pIUnknownEx,ITableFrame);
	if (m_pITableFrame==NULL)
		return false;

	//ȡ
	m_pGameServiceOption=m_pITableFrame->GetGameServiceOption();
	ASSERT(m_pGameServiceOption!=NULL);

	//ʼģʽ
	m_pITableFrame->SetStartMode(START_MODE_FULL_READY);
	return true;
}

//λ
void  CTableFrameSink::RepositionSink()
{
	//Ϸ
	//m_lSiceCount=0;
	m_bDelete=false;
	m_cbPaiMianCard=0;
	ZeroMemory(m_cbCardIndex,sizeof(m_cbCardIndex));
	ZeroMemory(m_bTrustee,sizeof(m_bTrustee));
	ZeroMemory(m_cbListenStatus,sizeof(m_cbListenStatus));
	ZeroMemory( m_lGameScore,sizeof(m_lGameScore) );
	ZeroMemory(m_bHearStatus,sizeof(m_bHearStatus));
	ZeroMemory(m_bWillHearStatus,sizeof(m_bWillHearStatus));
	m_wHearUser=INVALID_CHAIR;

	//Ϣ
	m_cbOutCardData=0;
	m_cbOutCardCount=0;
	m_cbOutCardData=0;
	m_wOutCardUser=INVALID_CHAIR;
	m_wChengBaoChairID=INVALID_CHAIR;
	ZeroMemory(m_cbDiscardCard,sizeof(m_cbDiscardCard));
	ZeroMemory(m_cbDiscardCount,sizeof(m_cbDiscardCount));
	ZeroMemory(m_cbTempOutData,sizeof(m_cbTempOutData));

	//Ϣ
	m_wHeapHead = INVALID_CHAIR;
	m_wHeapTail = INVALID_CHAIR;
//	ZeroMemory(m_cbHeapCardInfo,sizeof(m_cbHeapCardInfo));
	ZeroMemory(m_HeapCardInfo,sizeof(m_HeapCardInfo));

	//Ϣ
	m_cbSendCardData=0;
	m_cbSendCardCount=0;
	m_cbLeftCardCount=0;
	ZeroMemory(m_cbRepertoryCard,sizeof(m_cbRepertoryCard));
	m_cbEndLeftCount = 0;
	m_cbGoodCardIndex=0;
	m_cbLaoYueCount=0;
	m_bHaiDiTrue=false;
	m_bDuiHuaStatus=false;
	m_bHaiDiStatus=false;
	m_bEndGameStatus=false;
	m_bOutCardData=false;
	m_wEndChairID=INVALID_CHAIR;
	ZeroMemory(m_dwRedoubleCount,sizeof(m_dwRedoubleCount));
	ZeroMemory(m_cbEndPlayData,sizeof(m_cbEndPlayData));
	ZeroMemory(m_cbShowCardData,sizeof(m_cbShowCardData));

	m_cbGameStartOver=0;
	//б
	m_cbProvideCard=0;
	m_cbGangOutCard=0;
	m_wResumeUser=INVALID_CHAIR;
	m_wCurrentUser=INVALID_CHAIR;
	m_wProvideUser=INVALID_CHAIR;
	m_wMyChairID=INVALID_CHAIR;
	m_wHaveGoodCardAndroidUser=INVALID_CHAIR;

	ZeroMemory( m_cbHuaCardCount,sizeof(m_cbHuaCardCount) );
	ZeroMemory( m_cbHuaCardData,sizeof(m_cbHuaCardData) );
	ZeroMemory( m_cbHuaCardInfo,sizeof(m_cbHuaCardInfo) );
	m_wReplaceUser = INVALID_CHAIR;

	//״̬
	m_bSendStatus=false;
	m_bGangStatus = false;
	m_bQiangGang=false;
	m_bShow=false;
	m_bManGuan=false;
	ZeroMemory(m_bKan,sizeof(m_bKan));
	ZeroMemory(m_bEnjoinChiPeng,sizeof(m_bEnjoinChiPeng));
	ZeroMemory(m_bEnjoinPeng,sizeof(m_bEnjoinPeng));
	ZeroMemory(m_cbPengCard,sizeof(m_cbPengCard));

	//û״̬
	ZeroMemory(m_bResponse,sizeof(m_bResponse));
	ZeroMemory(m_cbUserAction,sizeof(m_cbUserAction));
	ZeroMemory(m_cbOperateCard,sizeof(m_cbOperateCard));
	ZeroMemory(m_cbPerformAction,sizeof(m_cbPerformAction));
	ZeroMemory(m_dwFanShu,sizeof(m_dwFanShu));

	//˿
	ZeroMemory(m_WeaveItemArray,sizeof(m_WeaveItemArray));
	ZeroMemory(m_cbWeaveItemCount,sizeof(m_cbWeaveItemCount));

	//Ϣ
    ZeroMemory(m_cbMingGangCount,sizeof(m_cbMingGangCount));
	ZeroMemory(m_cbAnGangCount,sizeof(m_cbAnGangCount));

	//Ϣ
	m_cbChiHuCard=0;
	ZeroMemory(m_dwChiHuKind,sizeof(m_dwChiHuKind));
	ZeroMemory(m_ChiHuNew,sizeof(m_ChiHuNew));

	return;
}

//ʼģʽ
BYTE  CTableFrameSink::GetGameStartMode()
{
	return m_GameStartMode;
}

//Ϸ״̬
bool  CTableFrameSink::IsUserPlaying(WORD wChairID)
{
	return true;
}
bool CTableFrameSink::OnSetCellScore(WORD wChairID,LONGLONG lCellScore)
{
	IServerUserItem *pIServerUserItem=m_pITableFrame->GetTableUserItem(wChairID);
	if (pIServerUserItem!=NULL)
	{
		if (lCellScore*88>pIServerUserItem->GetUserScore()) 
		{
			m_pITableFrame->SendGameMessage(pIServerUserItem,TEXT("ϵǮ趨޷Ϸ"),SMT_CHAT|SMT_EJECT|SMT_CLOSE_GAME);
			return false;
		}
	}
	m_lCellScore=lCellScore;
	m_pITableFrame->SetCellScore(m_lCellScore*100);
	m_bSetCell=true;

	//
	CMD_S_SendCell SendCell;
	SendCell.lCellScore=(m_lCellScore);
	SendCell.wChairID=wChairID;
	//Ϣ
	m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_SEND_CELL,&SendCell,sizeof(SendCell));
	m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_SEND_CELL,&SendCell,sizeof(SendCell));

	return true;
}
//Ϸʼ
bool  CTableFrameSink::OnEventGameStart()
{
	for (int i=0;i<GAME_PLAYER;i++)
	{
		IServerUserItem *pIServerUserItem=m_pITableFrame->GetTableUserItem(i);
		if (pIServerUserItem!=NULL)
		{
			if (m_lCellScore*88>pIServerUserItem->GetUserScore()) 
			{
				OnEventGameConclude(INVALID_CHAIR,NULL,GER_DISMISS);
				return true;
			}
		}
	}


	m_GameState=gs_Playing;
	//״̬
	m_pITableFrame->SetGameStatus(GS_MJ_PLAY);
	m_cbPaiMianCard=0;

	//tagUserInfo * pUserData=pIServerUserItem->GetUserInfo();

	//˿
	/*if( m_wBankerUser == INVALID_CHAIR )
		m_lSiceCount = MAKELONG(MAKEWORD(rand()%6+1,rand()%6+1),MAKEWORD(rand()%6+1,rand()%6+1));
	else*/
	m_lSiceCount = MAKELONG(MAKEWORD(rand()%6+1,rand()%6+1),0);
	//m_lSiceCount = MAKELONG(MAKEWORD(6,6),0);

	m_cbLeftCardCount=CountArray(m_cbRepertoryCard);
	for(BYTE i=0;i<5;i++)
		m_GameLogic.RandCardData(m_cbRepertoryCard,CountArray(m_cbRepertoryCard));

	////test
	//BYTE byTest[] = {
	//	0x05,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,						
	//	0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,						
	//	0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,
	//	0x07,0x02,0x07,0x08,0x08,0x08, 
	//	0x01,0x02,0x03,0x04,0x05,0x03,0x03,0x31,

	//	0x34,0x32,0x08,0x31,0x35,

	//	0x01,0x02,0x02,0x32,
	//	0x03,0x38,0x34,0x38,0x37,0x34,0x09,0x36,0x35,

	//	0x01,0x02,0x02,0x03,
	//	0x03,0x38,0x04,0x37,0x09,0x09,0x04,0x07,0x35
	//};
	//CopyMemory( m_cbRepertoryCard,byTest,sizeof(byTest) );
	//m_wBankerUser = 1; 
	////end test

	//ַ˿
	for (WORD i=0;i<m_wPlayerCount;i++)
	{
		m_cbLeftCardCount-=(MAX_COUNT-1);
		m_GameLogic.SwitchToCardIndex(&m_cbRepertoryCard[m_cbLeftCardCount],MAX_COUNT-1,m_cbCardIndex[i]);
	}

	//ׯҵķλ
	if( m_wBankerUser == INVALID_CHAIR )
	{
		//WORD wSice = (WORD)(m_lSiceCount>>16);
		m_wBankerUser =rand()%GAME_PLAYER;
	}

	//˿
	m_cbSendCardCount++;
	m_cbSendCardData=m_cbRepertoryCard[--m_cbLeftCardCount];
	m_cbCardIndex[m_wBankerUser][m_GameLogic.SwitchToCardIndex(m_cbSendCardData)]++;

	//ñ
	m_cbProvideCard=m_cbSendCardData;
	m_wProvideUser=m_wBankerUser;
	m_wCurrentUser=m_wBankerUser;

	//Ϣ
	WORD wSice = WORD(m_lSiceCount&0xffff);
	BYTE cbSiceTakeCount=HIBYTE(wSice)+LOBYTE(wSice);
	WORD wTakeChairID=m_wBankerUser;
	while( cbSiceTakeCount*2 > HEAP_FULL_COUNT )
	{
		wTakeChairID = (wTakeChairID+1)%GAME_PLAYER;
		cbSiceTakeCount -= HEAP_FULL_COUNT/2;
	}
	m_wHeapTail = wTakeChairID;

	BYTE cbTakeCount=MAX_REPERTORY-m_cbLeftCardCount;
	bool bTake=false;
	for (WORD i=0;i<GAME_PLAYER;i++)
	{
		//Ŀ
		BYTE cbValidCount=HEAP_FULL_COUNT-((i==0)?(cbSiceTakeCount)*2:0);
		BYTE cbRemoveCount=__min(cbValidCount,cbTakeCount);

		m_HeapCardInfo[wTakeChairID].wStartIndex=cbValidCount;
		//ȡ˿
		cbTakeCount-=cbRemoveCount;
		m_HeapCardInfo[wTakeChairID].wRemoveCount=cbRemoveCount;

		//ж
		if (cbTakeCount==0)
		{
			m_wHeapHead=wTakeChairID;
			if(!bTake)
				m_HeapCardInfo[(wTakeChairID+1)%GAME_PLAYER].wStartIndex=HEAP_FULL_COUNT;
			break;
		}
		//л
		wTakeChairID=(wTakeChairID+1)%GAME_PLAYER;
		bTake=true;
	}

	bool bAroseAction=false;
	for (WORD i=0;i<m_wPlayerCount;i++)
	{
		//û
		WORD wUserIndex=(m_wCurrentUser+GAME_PLAYER-i)%GAME_PLAYER;

		for( BYTE j = MAX_INDEX-MAX_HUA_CARD; j < MAX_INDEX; j++ )
		{
			if( m_cbCardIndex[wUserIndex][j] > 0)
			{
				m_wReplaceUser = wUserIndex;
				break;
			}
		}

		if( m_wReplaceUser != INVALID_CHAIR ) break;
	}
	if ( m_wReplaceUser==INVALID_CHAIR )
	{
		//ж
		tagGangCardResult GangCardResult;
		m_cbUserAction[m_wBankerUser]|=m_GameLogic.AnalyseGangCard(m_cbCardIndex[m_wBankerUser],NULL,0,m_wProvideUser,
			m_wBankerUser,m_bHearStatus[m_wBankerUser],GangCardResult);

		//ж
		CChiHuRight chr;
		CChiHuRight chrhigh;
		CChiHuRight chrnew;
		m_cbCardIndex[m_wBankerUser][m_GameLogic.SwitchToCardIndex(m_cbSendCardData)]--;
		CString str;
		str.Format(TEXT("m_wBankerUser %ld"),m_wBankerUser);
		m_cbUserAction[m_wBankerUser]|=m_GameLogic.AnalyseChiHuCard(m_cbCardIndex[m_wBankerUser],NULL,0,
			m_wProvideUser,m_wCurrentUser,m_cbSendCardData,chr,chrhigh,chrnew);
		m_cbCardIndex[m_wBankerUser][m_GameLogic.SwitchToCardIndex(m_cbSendCardData)]++;
		//ж
		m_cbUserAction[m_wBankerUser]|=m_GameLogic.AnalyseTingCard(m_cbCardIndex[m_wBankerUser],NULL,0);
	}

	//
	CMD_S_GameStart GameStart;
	ZeroMemory(&GameStart,sizeof(GameStart));
	GameStart.lSiceCount=m_lSiceCount;
	GameStart.wBankerUser=m_wBankerUser;
	GameStart.wReplaceUser=m_wReplaceUser;
	GameStart.wCurrentUser= m_wReplaceUser==INVALID_CHAIR?m_wCurrentUser:INVALID_CHAIR;
	GameStart.wHeapHead = m_wHeapHead;
	GameStart.wHeapTail = m_wHeapTail;
	GameStart.bOutCardData=m_bOutCardData;
	GameStart.bAllAndroidUser=true;
	for(WORD i=0;i<m_wPlayerCount;i++)
	{
		if(m_pITableFrame->GetTableUserItem(i)->IsAndroidUser()==false)
			GameStart.bAllAndroidUser=false;
	}
	ZeroMemory(GameStart.HeapCardInfo,sizeof(GameStart.HeapCardInfo));
	CopyMemory(GameStart.HeapCardInfo,m_HeapCardInfo,sizeof(m_HeapCardInfo));
//	ZeroMemory(GameStart.cbHeapCardInfo,sizeof(GameStart.cbHeapCardInfo));
//	CopyMemory(GameStart.cbHeapCardInfo,m_cbHeapCardInfo,sizeof(m_cbHeapCardInfo));

	//
	for (WORD i=0;i<m_wPlayerCount;i++)
	{
		//ñ
		GameStart.cbUserAction=m_cbUserAction[i];

		ZeroMemory(GameStart.cbCardData,sizeof(GameStart.cbCardData));
		m_GameLogic.SwitchToCardData(m_cbCardIndex[i],GameStart.cbCardData);

		/*if( m_pITableFrame->GetTableUserItem(i)->IsAndroidUser() )             //delete by lv  
		{
			BYTE bIndex = 1;
			for( WORD j=0; j<GAME_PLAYER; j++ )
			{
				if( j == i ) continue;
				m_GameLogic.SwitchToCardData(m_cbCardIndex[j],&GameStart.cbCardData[MAX_COUNT*bIndex++]);
			}
		}*/

		//
		m_pITableFrame->SendTableData(i,SUB_S_GAME_START,&GameStart,sizeof(GameStart));
		m_pITableFrame->SendLookonData(i,SUB_S_GAME_START,&GameStart,sizeof(GameStart));
	}


	ZeroMemory(GameStart.cbCardData,sizeof(GameStart.cbCardData));
	return true;
}

//Ϸ
bool CTableFrameSink::OnGameEndPlay(bool bLiuJu)
{
	m_pITableFrame->SetGameStatus(GS_MJ_END);
	m_bEndGameStatus=true;
	if(!bLiuJu)
	{
		CMD_S_DuiHua DuiHua;
		ZeroMemory(&DuiHua,sizeof(DuiHua));
		//Ϣ
		WORD wWinner = INVALID_CHAIR;
		for (WORD i=0;i<GAME_PLAYER;i++)
		{
			DuiHua.dwChiHuKind[i]=m_dwChiHuKind[i];
			if( m_dwChiHuKind[i] == WIK_CHI_HU )
				wWinner = i;
			DuiHua.cbCardCount[i]=m_GameLogic.SwitchToCardData(m_cbCardIndex[i],DuiHua.cbCardData[i]);
		}

		m_bDuiHuaStatus=true;
		m_bHaiDiStatus=false;

		//BYTE cbCardData[10];
		ZeroMemory(m_cbEndPlayData,sizeof(m_cbEndPlayData));
		ZeroMemory(m_cbShowCardData,sizeof(m_cbShowCardData));
		GetDuiHuaCard(wWinner,m_cbEndPlayData);
		DuiHua.wProvideUser=m_wProvideUser;
		DuiHua.wChairID=wWinner;
		m_cbCardIndex[wWinner][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)]--;
		DuiHua.cbCardCount[wWinner]=m_GameLogic.SwitchToCardData(m_cbCardIndex[wWinner],DuiHua.cbCardData[wWinner]);
		m_cbCardIndex[wWinner][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)]++;
		DuiHua.cbProvideCard=m_cbProvideCard;
		m_wEndChairID=wWinner;

		m_GameLogic.RandCardData(m_cbEndPlayData,CountArray(m_cbEndPlayData),DuiHua.cbDuiHuaCard);

		//Ϣ
		m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_DUI_HUA,&DuiHua,sizeof(DuiHua));
		m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_DUI_HUA,&DuiHua,sizeof(DuiHua));
	}
	else
	{
		if(m_wHearUser!=INVALID_CHAIR)
		{
			CMD_S_HaiDi HaiDi;
			ZeroMemory(&HaiDi,sizeof(HaiDi));

			//BYTE cbCardData[10];
			m_bHaiDiStatus=true;
			m_bDuiHuaStatus=false;
			ZeroMemory(m_cbEndPlayData,sizeof(m_cbEndPlayData));
			ZeroMemory(m_cbShowCardData,sizeof(m_cbShowCardData));
			GetHaiDiCard(m_wHearUser,m_cbEndPlayData);
			HaiDi.wChairID=m_wHearUser;

			m_wEndChairID=m_wHearUser;

			m_GameLogic.RandCardData(m_cbEndPlayData,CountArray(m_cbEndPlayData),HaiDi.cbHaiDiCard);
			//CopyMemory(HaiDi.cbHaiDiCard,m_cbEndPlayData,sizeof(m_cbEndPlayData));

			//Ϣ
			m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_HAI_DI,&HaiDi,sizeof(HaiDi));
			m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_HAI_DI,&HaiDi,sizeof(HaiDi));
		}
		else
		{
			m_cbChiHuCard=0;
			m_wProvideUser=INVALID_CHAIR;
			OnEventGameConclude(m_wProvideUser,NULL,GER_NORMAL);
		}
	}
	return true;
}
void CTableFrameSink::GetDuiHuaCard(WORD wChairID,BYTE cbCardData[10])
{
	BYTE cbTempIndex[MAX_COUNT],cbTempCount=0;
	ZeroMemory(cbTempIndex,sizeof(cbTempIndex));

	//˿
	BYTE cbCardIndexTemp[MAX_INDEX];
	CopyMemory(cbCardIndexTemp,m_cbCardIndex[wChairID],sizeof(cbCardIndexTemp));
	for(BYTE i=0;i<m_cbWeaveItemCount[wChairID];i++)
	{
		if(m_WeaveItemArray[wChairID][i].cbWeaveKind==WIK_GANG)
		{
			BYTE index=m_GameLogic.SwitchToCardIndex(m_WeaveItemArray[wChairID][i].cbCenterCard);
			cbCardIndexTemp[index]+=4;
		}
		else if(m_WeaveItemArray[wChairID][i].cbWeaveKind&(WIK_PENG|WIK_PENG_LISTEN))
		{
			BYTE index=m_GameLogic.SwitchToCardIndex(m_WeaveItemArray[wChairID][i].cbCenterCard);
			cbCardIndexTemp[index]+=3;
		}
		else
		{
			for(BYTE j=0;j<3;j++)
			{
				BYTE index=m_GameLogic.SwitchToCardIndex(m_WeaveItemArray[wChairID][i].cbCardData[j]);
				cbCardIndexTemp[index]++;
			}
		}
	}

	for(BYTE i=0;i<MAX_INDEX;i++)
	{
		if(cbCardIndexTemp[i]>0)
		{
			cbTempIndex[cbTempCount++]=i;
		}
	}
	//for(BYTE i=0;i<(cbTempCount>5?5:cbTempCount);i++)
	//{
	//	cbCardData[i]=m_GameLogic.SwitchToCardData(cbTempIndex[i]);
	//}
	if(cbTempCount<=5)
	{
		for(BYTE i=0;i<cbTempCount;i++)
		{
			cbCardData[i]=m_GameLogic.SwitchToCardData(cbTempIndex[i]);
		}
	}
	else
	{
		for(BYTE i=0;i<5;i++)
		{
			BYTE tempIndex=rand()%cbTempCount;
			while(cbTempIndex[tempIndex]==0)
			{
				tempIndex=rand()%cbTempCount;
			}

			cbCardData[i]=m_GameLogic.SwitchToCardData(cbTempIndex[tempIndex]);
			cbTempIndex[tempIndex]=0;
		}
	}
	for(BYTE i=0;i<10;i++)
	{
		if(cbCardData[i]==0)
		{
			BYTE tempIndex=rand()%34;
			while (cbCardIndexTemp[tempIndex]!=0||(tempIndex>8&&tempIndex<27))
			{
				tempIndex=rand()%34;
			}

			cbCardData[i]=m_GameLogic.SwitchToCardData(tempIndex);
			cbCardIndexTemp[tempIndex]=255;
		}
	}
}
bool CTableFrameSink::OnUserDuiHuaCard(WORD wChairID,BYTE cbCardData)
{
	//˿
	BYTE cbCardIndexTemp[MAX_INDEX];
	CopyMemory(cbCardIndexTemp,m_cbCardIndex[wChairID],sizeof(cbCardIndexTemp));
	for(BYTE i=0;i<m_cbWeaveItemCount[wChairID];i++)
	{
		if(m_WeaveItemArray[wChairID][i].cbWeaveKind==WIK_GANG)
		{
			BYTE index=m_GameLogic.SwitchToCardIndex(m_WeaveItemArray[wChairID][i].cbCenterCard);
			cbCardIndexTemp[index]+=4;
		}
		else if(m_WeaveItemArray[wChairID][i].cbWeaveKind&(WIK_PENG|WIK_PENG_LISTEN))
		{
			BYTE index=m_GameLogic.SwitchToCardIndex(m_WeaveItemArray[wChairID][i].cbCenterCard);
			cbCardIndexTemp[index]+=3;
		}
		else
		{
			for(BYTE j=0;j<3;j++)
			{
				BYTE index=m_GameLogic.SwitchToCardIndex(m_WeaveItemArray[wChairID][i].cbCardData[j]);
				cbCardIndexTemp[index]++;
			}
		}
	}

	for(BYTE i=0;i<10;i++)
	{
		if(m_cbShowCardData[i]==0)
			m_cbShowCardData[i]=cbCardData;
	}
	CMD_S_ContinueDH ContinueDH;
	ZeroMemory(&ContinueDH,sizeof(ContinueDH));
	if(cbCardIndexTemp[m_GameLogic.SwitchToCardIndex(cbCardData)]>0)
	{
		ContinueDH.bContinue=true;
		m_cbPaiMianCard+=cbCardIndexTemp[m_GameLogic.SwitchToCardIndex(cbCardData)];
	}
	else
	{
		ContinueDH.bContinue=false;
		OnEventGameConclude(m_wProvideUser,NULL,GER_NORMAL);
	}

	ContinueDH.wChairID=wChairID;
	ContinueDH.cbCardData=cbCardData;

	m_wEndChairID=wChairID;
	//Ϣ
	m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_CONTINUE_DH,&ContinueDH,sizeof(ContinueDH));
	m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_CONTINUE_DH,&ContinueDH,sizeof(ContinueDH));

	return true;
}
void CTableFrameSink::GetHaiDiCard(WORD wChairID,BYTE cbCardData[10])
{
	CWHArray<BYTE> tempCard;

	//
	CChiHuRight chr;
	CChiHuRight chrhigh;
	CChiHuRight chrnew;
	//˿
	BYTE cbCardIndexTemp[MAX_INDEX];
	CopyMemory(cbCardIndexTemp,m_cbCardIndex[wChairID],sizeof(cbCardIndexTemp));
	//ж
	BYTE i=0;
	for (;i<MAX_INDEX;i++)
	{
		//Ʒ
		BYTE cbCurrentCard=m_GameLogic.SwitchToCardData(i);
		BYTE cbHuCardKind=m_GameLogic.AnalyseChiHuCard(cbCardIndexTemp,m_WeaveItemArray[wChairID],
			m_cbWeaveItemCount[wChairID],m_wProvideUser,wChairID,cbCurrentCard,chr,chrhigh,chrnew);

		//ж
		if (cbHuCardKind!=WIK_NULL)
		{
			tempCard.Add(m_GameLogic.SwitchToCardData(i));
		}
	}

	ZeroMemory(cbCardIndexTemp,sizeof(cbCardIndexTemp));

	if(tempCard.GetCount()>0)
	{
		for(BYTE i=0;i<(rand()%3+1);i++)
		{
			cbCardData[i]=tempCard[rand()%(tempCard.GetCount())];
		}
		for(BYTE i=0;i<tempCard.GetCount();i++)
		{
			cbCardIndexTemp[m_GameLogic.SwitchToCardIndex(tempCard[i])]=255;
		}
	}

	for(BYTE i=0;i<10;i++)
	{
		if(cbCardData[i]==0)
		{
			BYTE tempIndex=rand()%34;
			while (cbCardIndexTemp[tempIndex]!=0||(tempIndex>8&&tempIndex<27))
			{
				tempIndex=rand()%34;
			}

			cbCardData[i]=m_GameLogic.SwitchToCardData(tempIndex);
			cbCardIndexTemp[tempIndex]=255;
		}
	}
}
bool CTableFrameSink::OnUserHaiDiCard(WORD wChairID,BYTE cbCardData)
{
	//Ч״̬
	ASSERT(m_pITableFrame->GetGameStatus()==GS_MJ_END);
	if (m_pITableFrame->GetGameStatus()!=GS_MJ_END) 
	{
		return true;
	}

	if(wChairID!=m_wCurrentUser)
	{
		m_wCurrentUser=wChairID;
	}

	//
	ASSERT(wChairID==m_wCurrentUser);
	ASSERT(m_GameLogic.IsValidCard(cbCardData)==true);

	//Ч
	if (wChairID!=m_wCurrentUser) 
	{
		return false;
	}
	if (m_GameLogic.IsValidCard(cbCardData)==false)
	{
		return false;
	}

	for(BYTE i=0;i<10;i++)
	{
		if(m_cbShowCardData[i]==0)
			m_cbShowCardData[i]=cbCardData;
	}
	
	bool bAroseAction=false;
	bool bOver=false;
	if(m_cbLaoYueCount<2)
	{
		bOver=false;
		//ñ
		m_bSendStatus=true;
		m_bGangStatus = false;
		m_bQiangGang=false;
		m_cbUserAction[wChairID]=WIK_NULL;
		m_cbPerformAction[wChairID]=WIK_NULL;

		m_bDelete=false;
		m_wProvideUser=wChairID;
		m_cbProvideCard=cbCardData;
		m_cbLaoYueCount++;

		//û״̬
		ZeroMemory(m_bResponse,sizeof(m_bResponse));
		ZeroMemory(m_cbUserAction,sizeof(m_cbUserAction));
		ZeroMemory(m_cbPerformAction,sizeof(m_cbPerformAction));

			//ж
			CChiHuRight chr;
			CChiHuRight chrhigh;
			CChiHuRight chrnew;
			BYTE cbWeaveCount=m_cbWeaveItemCount[wChairID];
			BYTE cbAction = m_GameLogic.AnalyseChiHuCard(m_cbCardIndex[wChairID],m_WeaveItemArray[wChairID],cbWeaveCount,wChairID,
				m_wPlayerCount,cbCardData,chr,chrhigh,chrnew);

			m_cbUserAction[wChairID] |= cbAction;

			//ж
			if (m_cbUserAction[wChairID]!=WIK_NULL) 
				bAroseAction=true;

		//
		if (bAroseAction==true) 
		{
			//ñ
			m_cbCardIndex[wChairID][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)]++;
			m_wProvideUser=wChairID;
			m_cbProvideCard=cbCardData;
			m_wResumeUser=m_wCurrentUser;
		}
	}
	else
	{
		bOver=true;
	}

	CMD_S_ContinueHD ContinueHD;
	ContinueHD.wChiarID=wChairID;
	ContinueHD.bContinue=!bAroseAction;
	ContinueHD.bHaiDiOver=bOver;

	m_wEndChairID=wChairID;

	//Ϣ
	m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_CONTINUE_HD,&ContinueHD,sizeof(ContinueHD));
	m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_CONTINUE_HD,&ContinueHD,sizeof(ContinueHD));

	return true;
}
bool CTableFrameSink::OnHaiDiContinue()
{
	m_wHearUser = (m_wHearUser+1)%GAME_PLAYER;
	if(m_bHearStatus[m_wHearUser]&&!m_bHaiDiTrue)
	{
		m_cbLaoYueCount=0;
		m_bHaiDiTrue=true;
		OnGameEndPlay(true);
	}
	else
	{
		m_cbChiHuCard=0;
		m_wProvideUser=INVALID_CHAIR;
		OnEventGameConclude(m_wProvideUser,NULL,GER_NORMAL);
	}

	return true;
}
//Ϸ
bool  CTableFrameSink::OnEventGameConclude(WORD wChairID, IServerUserItem * pIServerUserItem, BYTE cbReason)
{
	m_bEndGameStatus=false;
	switch (cbReason)
	{
	case GER_NORMAL:		//
		{
			//
			CMD_S_GameEnd GameEnd;
			ZeroMemory(&GameEnd,sizeof(GameEnd));

			//Ϣ
			WORD wWinner = INVALID_CHAIR;
			for (WORD i=0;i<GAME_PLAYER;i++)
			{
				GameEnd.dwChiHuKind[i]=m_dwChiHuKind[i];
				if( m_dwChiHuKind[i] == WIK_CHI_HU )
					wWinner = i;
				GameEnd.cbCardCount[i]=m_GameLogic.SwitchToCardData(m_cbCardIndex[i],GameEnd.cbCardData[i]);
			}

			//
			if( wWinner != INVALID_CHAIR )
			{
				//Ȩλ
				FiltrateRight( wWinner,m_ChiHuRight[wWinner],m_ChiHuHigh[wWinner],m_ChiHuNew[wWinner] );
			}

			//ͳƻ
			if (m_wProvideUser!=INVALID_CHAIR)
			{
				//Ϣ
				GameEnd.wProvideUser=m_wProvideUser;
				GameEnd.wChengBaoUser=m_wChengBaoChairID;
				GameEnd.cbProvideCard=m_cbProvideCard;
				GameEnd.lCellScore=(m_lCellScore);
				GameEnd.cbHuaCardCount=m_cbHuaCardCount[wWinner];
				GameEnd.cbPaiMianCard=m_cbPaiMianCard;

				m_cbCardIndex[wWinner][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)]--;
				GameEnd.cbCardCount[wWinner]=m_GameLogic.SwitchToCardData(m_cbCardIndex[wWinner],GameEnd.cbCardData[wWinner]);

				m_ChiHuRight[wWinner].GetRightData( GameEnd.dwChiHuRight,MAX_RIGHT_COUNT );
				m_ChiHuHigh[wWinner].GetRightData(GameEnd.dwChiHuHigh,MAX_RIGHT_COUNT);
				m_ChiHuNew[wWinner].GetRightData(GameEnd.dwChiHuNew,MAX_RIGHT_COUNT);

				if(m_pGameServiceOption->wServerType==GAME_GENRE_GOLD)
					CalScore( wWinner,GameEnd.lGameGold );
				else
					CalScore(wWinner,GameEnd.lGameScore);
			}
			else
			{
				//ֽ
				GameEnd.wProvideUser=m_wProvideUser;
				GameEnd.wChengBaoUser=m_wChengBaoChairID;
				GameEnd.cbProvideCard=m_cbProvideCard;
				GameEnd.lCellScore=(m_lCellScore);
			}
			//ͳƻ
			LONG lGameTax[GAME_PLAYER];
			ZeroMemory(lGameTax,sizeof(lGameTax));
			//for (WORD i=0;i<GAME_PLAYER;i++)
			//{
			//	//øƸ
   //   			CopyMemory(GameEnd.cbMingGangCount,m_cbMingGangCount,sizeof(m_cbMingGangCount));
			//	CopyMemory(GameEnd.cbAnGangCount,m_cbAnGangCount,sizeof(m_cbAnGangCount));
			//}
			if(wWinner!=INVALID_CHAIR)
			{
				GameEnd.cbMingGangCount=m_cbMingGangCount[wWinner];
				GameEnd.cbAnGangCount=m_cbAnGangCount[wWinner];
				GameEnd.dwFanShu=m_dwFanShu[wWinner];
			}

			LONGLONG llUserScore[GAME_PLAYER];
			for ( int i=0;i < GAME_PLAYER; i++)
			{
				IServerUserItem * pIServerUserItem=m_pITableFrame->GetTableUserItem(i);
				if(pIServerUserItem==NULL)
					continue;
				llUserScore[i] = pIServerUserItem->GetUserScore();
			}
			//ƽ
			if ( m_pGameServiceOption->wServerType==GAME_GENRE_GOLD )
			{
				LONGLONG llResultScore[GAME_PLAYER];
				BOOL bNeedBalance = FALSE;
				LONGLONG lRelative = 0;
				LONGLONG lWinTotalScore = 0;
				LONGLONG lLossTotalScore = 0;
				for ( int i=0; i<GAME_PLAYER; i++)
				{

					if ( llUserScore[i] + GameEnd.lGameGold[i] <0)
					{
						bNeedBalance  = TRUE;
						llResultScore[i] = -llUserScore[i];

					}
					else
					{
						llResultScore[i] = GameEnd.lGameGold[i];
					}
					lRelative += llResultScore[i];
					if (llResultScore[i]>0)
						lWinTotalScore += llResultScore[i];
					else 
						lLossTotalScore += -llResultScore[i];
				}

				if ( bNeedBalance)
				{
					for ( int i=0;i< GAME_PLAYER; i++)
					{
						if (GameEnd.lGameGold[i]>0&&lWinTotalScore)
						{
							GameEnd.lGameGold[i] = lLossTotalScore*llResultScore[i]/lWinTotalScore;
						}
						else
						{
							GameEnd.lGameGold[i] = llResultScore[i];
						}
					}
				}
				else
				{
					if (lWinTotalScore > lLossTotalScore) 
					{
						ASSERT(0);
						//memset(GameEnd.lGameScore,0,sizeof(GameEnd.lGameScore));
					}
					
				}

			}

			if(m_pGameServiceOption->wServerType==GAME_GENRE_GOLD)
			{
				//ͳƻ
				for (WORD i=0;i<GAME_PLAYER;i++)
				{
					tagScoreInfo ScoreInfo={0};

					ScoreInfo.cbType   = (GameEnd.lGameGold[i]>0L)?SCORE_TYPE_WIN:SCORE_TYPE_LOSE;
					ScoreInfo.lRevenue = lGameTax[i];
					ScoreInfo.lScore   = GameEnd.lGameGold[i];

					/*TCHAR szBuffer[256];
					wsprintf(szBuffer, TEXT("cbTyp = %d, lRevenue = %d, lScore = %d"), ScoreInfo.cbType, ScoreInfo.lRevenue, ScoreInfo.lScore);
					MessageBox(NULL, szBuffer, TEXT("ʾ"), MB_OK);*/
					//д
					m_pITableFrame->WriteUserScore(i,ScoreInfo);
					//Ϣ
					m_pITableFrame->SendTableData(i,SUB_S_GAME_END,&GameEnd,sizeof(GameEnd));
					m_pITableFrame->SendLookonData(i,SUB_S_GAME_END,&GameEnd,sizeof(GameEnd));
				}
			}
			else
			{
				//ͳƻ
				for (WORD i=0;i<GAME_PLAYER;i++)
				{
					//GameEnd.lGameScore[i]=(m_lHitSocre[i]-100)*m_pGameServiceOption->lCellScore;

					tagScoreInfo ScoreInfo={0};

					ScoreInfo.cbType   = (GameEnd.lGameScore[i]>0L)?SCORE_TYPE_WIN:SCORE_TYPE_LOSE;
					ScoreInfo.lRevenue = lGameTax[i];
					ScoreInfo.lScore   = GameEnd.lGameScore[i];
					//д
					m_pITableFrame->WriteUserScore(i,ScoreInfo);
					//Ϣ
					m_pITableFrame->SendTableData(i,SUB_S_GAME_END,&GameEnd,sizeof(GameEnd));
					m_pITableFrame->SendLookonData(i,SUB_S_GAME_END,&GameEnd,sizeof(GameEnd));
				}
			}

			if(m_wBankerUser!=wWinner)
			{
				//ñ
				m_wBankerUser = (m_wBankerUser+1)%GAME_PLAYER;
			}

			//Ϸ
			m_pITableFrame->ConcludeGame(GAME_STATUS_FREE);

			for ( int i=0;i < GAME_PLAYER; i++)
			{
				IServerUserItem * pIServerUserItem=m_pITableFrame->GetTableUserItem(i);
				if(pIServerUserItem==NULL)
					continue;
				LONGLONG lScore = pIServerUserItem->GetUserScore();
				if(m_lCellScore*88>lScore)
				{
					m_pITableFrame->SendGameMessage(pIServerUserItem,TEXT("ϵǮ趨޷Ϸ"),SMT_CHAT|SMT_EJECT|SMT_CLOSE_GAME);
				}
			}

			return true;
		}
	case GER_DISMISS:		//Ϸɢ
		{
			//
			CMD_S_GameEnd GameEnd;
			ZeroMemory(&GameEnd,sizeof(GameEnd));

			//ñ
			GameEnd.wProvideUser=INVALID_CHAIR;
			//GameEnd.bUserOut=true;

			GameEnd.bUserOut=true;


			for (int i=0;i<GAME_PLAYER;i++)
			{
				IServerUserItem *pIServerUserItem1=m_pITableFrame->GetTableUserItem(i);
				if (pIServerUserItem1!=NULL)
				{
					if (m_lCellScore*88>pIServerUserItem1->GetUserScore()) 
					{
						m_pITableFrame->SendGameMessage(pIServerUserItem1,TEXT("ϵǮ趨޷Ϸ"),SMT_CHAT|SMT_EJECT|SMT_CLOSE_GAME);					
					}
				}
			}



			//˿
			for (WORD i=0;i<GAME_PLAYER;i++)
			{
				GameEnd.cbCardCount[i]=m_GameLogic.SwitchToCardData(m_cbCardIndex[i],GameEnd.cbCardData[i]);
			}

			//Ϣ
			m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_GAME_END,&GameEnd,sizeof(GameEnd));
			m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_GAME_END,&GameEnd,sizeof(GameEnd));

			//Ϸ
			m_pITableFrame->ConcludeGame(GAME_STATUS_FREE);

			/*for(BYTE i=0;i<GAME_PLAYER;i++)
			{
				IServerUserItem * pIServerUserItem=m_pITableFrame->GetTableUserItem(i);
				if(pIServerUserItem!=NULL&&pIServerUserItem->IsAndroidUser())
					m_pITableFrame->DismissGame();
			}*/

			return true;
		}
	case GER_USER_LEAVE:		//ûǿ
		{
			//
			CMD_S_GameEnd GameEnd;
			ZeroMemory(&GameEnd,sizeof(GameEnd));

			//ñ
			GameEnd.wProvideUser=INVALID_CHAIR;

			//˿
			for (WORD i=0;i<GAME_PLAYER;i++)
			{
				GameEnd.cbCardCount[i]=m_GameLogic.SwitchToCardData(m_cbCardIndex[i],GameEnd.cbCardData[i]);
			}

			LONGLONG lTempScore=m_lCellScore*100;

			if(m_pGameServiceOption->wServerType==GAME_GENRE_GOLD)
			{
				//
				GameEnd.lGameGold[wChairID] = -m_lCellScore*100;
			}
			else
			{
				//
				GameEnd.lGameScore[wChairID] = -m_lCellScore*100;
			}

			for(BYTE i=0;i<GAME_PLAYER;i++)
			{
				if(i==wChairID) continue;
				if(m_pGameServiceOption->wServerType==GAME_GENRE_GOLD)
				{
					//
					GameEnd.lGameGold[i] = (lTempScore/2);
				}
				else
				{
					//
					GameEnd.lGameScore[i] = (lTempScore/2);
				}
			}
			
			//֪ͨϢ
			TCHAR szMessage[128]=TEXT("");
			if(m_pITableFrame->GetTableUserItem( wChairID )->GetUserInfo()->szNickName[0]!=NULL)
			{
				_sntprintf(szMessage,CountArray(szMessage),TEXT(" [ %s ] 뿪ϷϷ"),pIServerUserItem->GetUserInfo()->szNickName);
			}
			else
			{
				_sntprintf(szMessage,CountArray(szMessage),TEXT(" [ %s ] 뿪ϷϷ"),pIServerUserItem->GetNickName());
			}
			for (WORD i=0;i<m_wPlayerCount;i++)
			{
				IServerUserItem * pISendUserItem=m_pITableFrame->GetTableUserItem(i);
				if (pISendUserItem!=NULL) 
					m_pITableFrame->SendGameMessage(pISendUserItem,szMessage,SMT_CHAT);
			}

			WORD wIndex=0;
			do
			{
				IServerUserItem * pISendUserItem=m_pITableFrame->EnumLookonUserItem(wIndex++);
				if (pISendUserItem==NULL)
					break;
				m_pITableFrame->SendGameMessage(pISendUserItem,szMessage,SMT_CHAT);
			} while (true);

			//Ϣ
			m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_GAME_END,&GameEnd,sizeof(GameEnd));
			m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_GAME_END,&GameEnd,sizeof(GameEnd));

			if ( m_pGameServiceOption->wServerType==GAME_GENRE_GOLD )
			{
				LONGLONG lUserGold= pIServerUserItem->GetUserScore();
				if (lUserGold + GameEnd.lGameGold[wChairID]< 0)
				{
					GameEnd.lGameGold[wChairID] = -lUserGold;
				}
			}

			if ( m_pGameServiceOption->wServerType==GAME_GENRE_GOLD )
			{
				for(WORD i=0;i<GAME_PLAYER;i++)
				{
					tagScoreInfo ScoreInfo={0};

					ScoreInfo.cbType   = (GameEnd.lGameGold[i]>0L)?SCORE_TYPE_WIN:SCORE_TYPE_LOSE;
					ScoreInfo.lRevenue = 0;
					ScoreInfo.lScore   = GameEnd.lGameGold[i];
					//д
					m_pITableFrame->WriteUserScore(i,ScoreInfo);
				}
			}
			else
			{
				for(WORD i=0;i<GAME_PLAYER;i++)
				{
					tagScoreInfo ScoreInfo={0};

					ScoreInfo.cbType   = (GameEnd.lGameScore[i]>0L)?SCORE_TYPE_WIN:SCORE_TYPE_LOSE;
					ScoreInfo.lRevenue =0;
					ScoreInfo.lScore   = GameEnd.lGameScore[i];
					//д
					m_pITableFrame->WriteUserScore(i,ScoreInfo);
				}
			}
			
			//Ϸ
			m_pITableFrame->ConcludeGame(GAME_STATUS_FREE);

			/*for(BYTE i=0;i<GAME_PLAYER;i++)
			{
				IServerUserItem * pIServerUserItem=m_pITableFrame->GetTableUserItem(i);
				if(pIServerUserItem!=NULL&&pIServerUserItem->IsAndroidUser())
					m_pITableFrame->DismissGame();
			}*/

			return true;
		}
	}

	//
	ASSERT(FALSE);
	return false;
}

//ͳ
bool  CTableFrameSink::OnEventSendGameScene(WORD wChiarID, IServerUserItem * pIServerUserItem, BYTE cbGameStatus, bool bSendSecret)
{
	switch (cbGameStatus)
	{
	case GS_MJ_FREE:	//״̬
		{
			//
			CMD_S_StatusFree StatusFree;
			//memset(&StatusFree,0,sizeof(StatusFree));
			ZeroMemory(&StatusFree,sizeof(StatusFree));

			//
			StatusFree.wBankerUser=m_wBankerUser;
			StatusFree.lCellScore=(m_lCellScore);
			StatusFree.bPlayerSitDown=(wChiarID==m_wSetCellChairID&&!m_bPlaySet);
			CopyMemory(StatusFree.bTrustee,m_bTrustee,sizeof(m_bTrustee));
			if(wChiarID==m_wSetCellChairID)
				m_bPlaySet=true;

			//ͳ
			return m_pITableFrame->SendGameScene(pIServerUserItem,&StatusFree,sizeof(StatusFree));
		}
	case GS_MJ_PLAY:	//Ϸ״̬
		{
			//
			CMD_S_StatusPlay StatusPlay;
			//memset(&StatusPlay,0,sizeof(StatusPlay));
			ZeroMemory(&StatusPlay,sizeof(StatusPlay));

			//Ϸ
			StatusPlay.wReplaceUser=INVALID_CHAIR;
			StatusPlay.wBankerUser=m_wBankerUser;
			StatusPlay.wReplaceUser=m_wReplaceUser;
			StatusPlay.wCurrentUser=(m_wReplaceUser==INVALID_CHAIR?m_wCurrentUser:INVALID_CHAIR);
			StatusPlay.lCellScore=(m_lCellScore);
			CopyMemory(StatusPlay.bTrustee,m_bTrustee,sizeof(m_bTrustee));
			CopyMemory(StatusPlay.cbHuaCardCount,m_cbHuaCardCount,sizeof(m_cbHuaCardCount));
			CopyMemory(StatusPlay.dwFanShu,m_dwFanShu,sizeof(m_dwFanShu));

			//״̬
			CopyMemory(StatusPlay.bHearStatus,m_bHearStatus,sizeof(m_bHearStatus));
			StatusPlay.bWillHearStatus = m_bWillHearStatus[wChiarID];
			StatusPlay.bOutCardData=m_bOutCardData;

			//״̬
			StatusPlay.cbActionCard=m_cbProvideCard;
			StatusPlay.cbLeftCardCount=m_cbLeftCardCount;
			StatusPlay.cbActionMask=(m_bResponse[wChiarID]==false)?m_cbUserAction[wChiarID]:WIK_NULL;

			//״̬
			CopyMemory( StatusPlay.cbHearStatus,m_cbListenStatus,sizeof(m_cbListenStatus) );
			StatusPlay.lSiceCount=m_lSiceCount;

			//ʷ¼
			StatusPlay.wOutCardUser=m_wOutCardUser;
			StatusPlay.cbOutCardData=m_cbOutCardData;
			CopyMemory(StatusPlay.cbDiscardCard,m_cbDiscardCard,sizeof(StatusPlay.cbDiscardCard));
			CopyMemory(StatusPlay.cbDiscardCount,m_cbDiscardCount,sizeof(StatusPlay.cbDiscardCount));

			//˿
			CopyMemory(StatusPlay.WeaveItemArray,m_WeaveItemArray,sizeof(m_WeaveItemArray));
			CopyMemory(StatusPlay.cbWeaveCount,m_cbWeaveItemCount,sizeof(m_cbWeaveItemCount));

			//Ϣ
			StatusPlay.wHeapHead = m_wHeapHead;
			StatusPlay.wHeapTail = m_wHeapTail;
			CopyMemory(StatusPlay.HeapCardInfo,m_HeapCardInfo,sizeof(m_HeapCardInfo));
//			CopyMemory(StatusPlay.cbHeapCardInfo,m_cbHeapCardInfo,sizeof(m_cbHeapCardInfo));

			//˿
			StatusPlay.cbCardCount=m_GameLogic.SwitchToCardData(m_cbCardIndex[wChiarID],StatusPlay.cbCardData);
			if(m_wReplaceUser==wChiarID) StatusPlay.cbSendCardData=m_cbSendCardData;
			else StatusPlay.cbSendCardData=(m_wProvideUser==wChiarID)?m_cbProvideCard:0x00;

			if(m_wReplaceUser==INVALID_CHAIR)
			{
				if(m_cbUserAction[wChiarID]&WIK_CHI_HU&&m_dwRedoubleCount[wChiarID]<8)
				{
					DWORD dwFanShu=m_dwFanShu[wChiarID]+GetFanShu(wChiarID,m_cbProvideCard,(StatusPlay.cbCardCount-2)%3);
					LONGLONG lUserScore=m_pITableFrame->GetTableUserItem((wChiarID+1)%GAME_PLAYER)->GetUserScore();
					if(dwFanShu*m_lCellScore<lUserScore)
					{
						CMD_S_ShowRedouble ShowRedouble;
						ShowRedouble.dwFanCount=GetFanShu(wChiarID,m_cbProvideCard,m_wCurrentUser==wChiarID?0:1);
						ShowRedouble.wChairID=wChiarID;
						m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_SHOW_REDOUBLE,&ShowRedouble,sizeof(ShowRedouble));
						m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_SHOW_REDOUBLE,&ShowRedouble,sizeof(ShowRedouble));
					}
				}
			}

			//ͳ
			return m_pITableFrame->SendGameScene(pIServerUserItem,&StatusPlay,sizeof(StatusPlay));
		}
	case GS_MJ_END:
		{
			//
			CMD_S_StatusEnd StatusEnd;
			ZeroMemory(&StatusEnd,sizeof(StatusEnd));

			//Ϸ
			StatusEnd.wReplaceUser=INVALID_CHAIR;
			StatusEnd.wBankerUser=m_wBankerUser;
			StatusEnd.wReplaceUser=m_wReplaceUser;
			StatusEnd.wCurrentUser=m_wCurrentUser;
			StatusEnd.lCellScore=(m_lCellScore);
			CopyMemory(StatusEnd.bTrustee,m_bTrustee,sizeof(m_bTrustee));
			CopyMemory(StatusEnd.cbHuaCardCount,m_cbHuaCardCount,sizeof(m_cbHuaCardCount));

			//״̬
			CopyMemory(StatusEnd.bHearStatus,m_bHearStatus,sizeof(m_bHearStatus));
			StatusEnd.bWillHearStatus = m_bWillHearStatus[wChiarID];

			//״̬
			StatusEnd.cbActionCard=m_cbProvideCard;
			StatusEnd.cbLeftCardCount=m_cbLeftCardCount;
			StatusEnd.cbActionMask=(m_bResponse[wChiarID]==false)?m_cbUserAction[wChiarID]:WIK_NULL;

			//״̬
			CopyMemory( StatusEnd.cbHearStatus,m_cbListenStatus,sizeof(m_cbListenStatus) );
			StatusEnd.lSiceCount=m_lSiceCount;

			//ʷ¼
			StatusEnd.wOutCardUser=m_wOutCardUser;
			StatusEnd.cbOutCardData=m_cbOutCardData;
			CopyMemory(StatusEnd.cbDiscardCard,m_cbDiscardCard,sizeof(StatusEnd.cbDiscardCard));
			CopyMemory(StatusEnd.cbDiscardCount,m_cbDiscardCount,sizeof(StatusEnd.cbDiscardCount));

			//˿
			CopyMemory(StatusEnd.WeaveItemArray,m_WeaveItemArray,sizeof(m_WeaveItemArray));
			CopyMemory(StatusEnd.cbWeaveCount,m_cbWeaveItemCount,sizeof(m_cbWeaveItemCount));

			for (WORD i=0;i<GAME_PLAYER;i++)
			{
				StatusEnd.cbCardCount[i]=m_GameLogic.SwitchToCardData(m_cbCardIndex[i],StatusEnd.cbCardData[i]);
			}

			if(m_bDuiHuaStatus)
			{
				m_cbCardIndex[m_wEndChairID][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)]--;
				StatusEnd.cbCardCount[m_wEndChairID]=m_GameLogic.SwitchToCardData(m_cbCardIndex[m_wEndChairID],
					StatusEnd.cbCardData[m_wEndChairID]);
				m_cbCardIndex[m_wEndChairID][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)]++;
				StatusEnd.cbProvideCard=m_cbProvideCard;
			}

			StatusEnd.bDuiHuaStatus=m_bDuiHuaStatus;
			StatusEnd.bHaiDiStatus=m_bHaiDiStatus;
			StatusEnd.wEndChairID=m_wEndChairID;
			m_GameLogic.RandCardData(m_cbEndPlayData,CountArray(m_cbEndPlayData),StatusEnd.cbEndPlayData);
			CopyMemory(StatusEnd.cbShowPlayCard,m_cbShowCardData,sizeof(m_cbShowCardData));

			//ͳ
			return m_pITableFrame->SendGameScene(pIServerUserItem,&StatusEnd,sizeof(StatusEnd));
		}
	}

	return false;
}

//ʱ¼
bool  CTableFrameSink::OnTimerMessage(DWORD wTimerID, WPARAM wBindParam)
{
	return false;
}

//ϷϢ
bool  CTableFrameSink::OnGameMessage(WORD wSubCmdID, VOID * pDataBuffer, WORD wDataSize, IServerUserItem * pIServerUserItem)
{
	SparrowTwoPeopleError<<"wSubCmdID="<<wSubCmdID<<","<<pIServerUserItem->GetUserInfo()->szNickName;
	if (pIServerUserItem->IsAndroidUser())
	{
		SparrowTwoPeopleError<<",ˣ"<<endl;
	}
	else
		SparrowTwoPeopleError<<endl;
	if( pIServerUserItem->GetUserStatus() == US_LOOKON) return true;
	switch (wSubCmdID)
	{
	case SUB_C_OUT_CARD:		//Ϣ
		{
			//ЧϢ
			ASSERT(wDataSize==sizeof(CMD_C_OutCard));
			if (wDataSize!=sizeof(CMD_C_OutCard))
			{
				return false;
			}

			//ûЧ
			tagUserInfo * pUserData=pIServerUserItem->GetUserInfo();
			if (pUserData->cbUserStatus!=US_PLAYING) 
			{
				return true;
			}

			//Ϣ
			CMD_C_OutCard * pOutCard=(CMD_C_OutCard *)pDataBuffer;
			return OnUserOutCard(pUserData->wChairID,pOutCard->cbCardData);
		}
	case SUB_C_SENDCELL:
		{
			//ЧϢ
			ASSERT(wDataSize==sizeof(CMD_C_CellScore));
			if (wDataSize!=sizeof(CMD_C_CellScore))
			{
				return false;
			}

			//ûЧ
			tagUserInfo * pUserData=pIServerUserItem->GetUserInfo();
			//Ϣ
			CMD_C_CellScore *pCellScore=(CMD_C_CellScore *)pDataBuffer;
			return OnSetCellScore(pUserData->wChairID,pCellScore->lCellScore);
		}
	case SUB_C_OPERATE_CARD:	//Ϣ
		{
			//ЧϢ
			ASSERT(wDataSize==sizeof(CMD_C_OperateCard));
			if (wDataSize!=sizeof(CMD_C_OperateCard)) 
			{
				return false;
			}

			//ûЧ
			tagUserInfo * pUserData=pIServerUserItem->GetUserInfo();
			if (pUserData->cbUserStatus!=US_PLAYING)
			{
				return true;
			}

			//Ϣ
			CMD_C_OperateCard * pOperateCard=(CMD_C_OperateCard *)pDataBuffer;
			return OnUserOperateCard(pUserData->wChairID,pOperateCard->cbOperateCode,pOperateCard->cbOperateCard);
		}
	case SUB_C_START_OVER:
		{
			//ûЧ
			ASSERT(pIServerUserItem->GetUserStatus()==US_PLAYING);
			if (pIServerUserItem->GetUserStatus()!=US_PLAYING) return true;

			return OnUserStartOver();
		}
	case SUB_C_REPLACE_CARD:	//û
		{
			//Ч
			ASSERT(wDataSize==sizeof(CMD_C_ReplaceCard));
			if (wDataSize!=sizeof(CMD_C_ReplaceCard)) return false;

			//ûЧ
			ASSERT(pIServerUserItem->GetUserStatus()==US_PLAYING);
			if (pIServerUserItem->GetUserStatus()!=US_PLAYING) return true;

			//
			CMD_C_ReplaceCard * pReplaceCard=(CMD_C_ReplaceCard *)pDataBuffer;

			//Ϣ
			WORD wChairID=pIServerUserItem->GetChairID();
			return OnUserReplaceCard(pIServerUserItem->GetChairID(),pReplaceCard->cbCardData);
		}
	case SUB_C_SHOW_THINK:
		{
			//
			CMD_C_ShowThink * pShowThink=(CMD_C_ShowThink *)pDataBuffer;

			//Ϣ
			WORD wChairID=pIServerUserItem->GetChairID();
			return OnUserShowThink(wChairID,pShowThink->bShowThink);
		}
	case SUB_C_REDOUBLE:
		{
			//Ч
			ASSERT(wDataSize==sizeof(CMD_C_Redouble));
			if(wDataSize!=sizeof(CMD_C_Redouble)) return false;

			//ûЧ
			ASSERT(pIServerUserItem->GetUserStatus()==US_PLAYING);
			if(pIServerUserItem->GetUserStatus()!=US_PLAYING) return true;

			//
			CMD_C_Redouble * pRedouble=(CMD_C_Redouble *)pDataBuffer;

			//Ϣ
			WORD wChairID=pIServerUserItem->GetChairID();
			return OnUserRedouble(wChairID,pRedouble->dwRedouble);
		}
	case SUB_C_TRUSTEE:
		{
			CMD_C_Trustee *pTrustee =(CMD_C_Trustee *)pDataBuffer;
			if(wDataSize != sizeof(CMD_C_Trustee))
			{
				return false;
			}
			

			//ûЧ
			tagUserInfo * pUserData=pIServerUserItem->GetUserInfo();
			//Ϣ
			if (pUserData->cbUserStatus!=US_PLAYING&&pTrustee->bTrustee) 
			{
				m_pITableFrame->SendGameMessage(pIServerUserItem,TEXT("Ǹ,Ϸδʼй!!!"),SMT_CHAT|SMT_EJECT|SMT_CLOSE_GAME);
				return true;
			}

			m_bTrustee[pUserData->wChairID]=pTrustee->bTrustee;
			CMD_S_Trustee Trustee;
			Trustee.bTrustee=pTrustee->bTrustee;
			Trustee.wChairID = pUserData->wChairID;
			m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_TRUSTEE,&Trustee,sizeof(Trustee));
			m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_TRUSTEE,&Trustee,sizeof(Trustee));

			return true;
		}
	case SUB_C_LISTEN:
		{
			//ûЧ
			tagUserInfo * pUserData=pIServerUserItem->GetUserInfo();
			if (pUserData->cbUserStatus!=US_PLAYING) return true;

			return OnUserListenCard(pUserData->wChairID);
		}
	case SUB_C_LISTEN_SET:
		{
			//Ч
			ASSERT(wDataSize==sizeof(CMD_C_ListenSet));
			if (wDataSize!=sizeof(CMD_C_ListenSet)) return false;

			//ûЧ
			ASSERT(pIServerUserItem->GetUserStatus()==US_PLAYING);
			if (pIServerUserItem->GetUserStatus()!=US_PLAYING) return true;

			CMD_C_ListenSet	* pListenSet=(CMD_C_ListenSet *)pDataBuffer;

			//ûЧ
			tagUserInfo * pUserData=pIServerUserItem->GetUserInfo();

			return OnUserListenSet(pUserData->wChairID,pListenSet->bListen);
		}
	case SUB_C_DUIHUA_CARD:
		{
			//Ч
			ASSERT(wDataSize==sizeof(CMD_C_DuiHuaCard));
			if (wDataSize!=sizeof(CMD_C_DuiHuaCard)) return false;

			//ûЧ
			ASSERT(pIServerUserItem->GetUserStatus()==US_PLAYING);
			if (pIServerUserItem->GetUserStatus()!=US_PLAYING) return true;

			//
			CMD_C_DuiHuaCard * pDuiHuaCard=(CMD_C_DuiHuaCard *)pDataBuffer;

			//ûЧ
			tagUserInfo * pUserData=pIServerUserItem->GetUserInfo();
			if (pUserData->cbUserStatus!=US_PLAYING)
			{
				return true;
			}
			return OnUserDuiHuaCard(pUserData->wChairID,pDuiHuaCard->cbCardData);
		}
	case SUB_C_HAIDI_CARD:
		{
			//Ч
			ASSERT(wDataSize==sizeof(CMD_C_HaiDiCard));
			if (wDataSize!=sizeof(CMD_C_HaiDiCard)) return false;

			//ûЧ
			ASSERT(pIServerUserItem->GetUserStatus()==US_PLAYING);
			if (pIServerUserItem->GetUserStatus()!=US_PLAYING) return true;

			//
			CMD_C_HaiDiCard * pHaiDiCard=(CMD_C_HaiDiCard *)pDataBuffer;

			//ûЧ
			tagUserInfo * pUserData=pIServerUserItem->GetUserInfo();
			if (pUserData->cbUserStatus!=US_PLAYING)
			{
				return true;
			}
			return OnUserHaiDiCard(pUserData->wChairID,pHaiDiCard->cbCardData);
		}
	case SUB_C_HAIDI_CONTINUE:
		{
			//ûЧ
			ASSERT(pIServerUserItem->GetUserStatus()==US_PLAYING);
			if (pIServerUserItem->GetUserStatus()!=US_PLAYING) return true;

			return OnHaiDiContinue();
		}
	case SUB_C_LEAVE:
		{
			m_pITableFrame->DismissGame();
			return true;
		}
	}

	return false;
}

//Ϣ
bool  CTableFrameSink::OnFrameMessage(WORD wSubCmdID, VOID * pData, WORD wDataSize, IServerUserItem * pIServerUserItem)
{
	return false;
}

bool CTableFrameSink::OnGameDataBase( WORD wRequestID, VOID * pData, WORD wDataSize )
{
	return true;
}


//û
bool  CTableFrameSink::OnActionUserSitDown(WORD wChairID, IServerUserItem * pIServerUserItem, bool bLookonUser)
{
	TCHAR szBuffer[32];
	if(bLookonUser==false)
	{
		
		m_cbPlayerSitDown=0;

		for(BYTE i=0;i<GAME_PLAYER;i++)
		{
			if(m_bSitDown[i])
			{
				m_cbPlayerSitDown++;
			}
		}

		if(m_cbPlayerSitDown==0)
		{
			m_wSetCellChairID=pIServerUserItem->GetChairID();
			m_bSetCell=false;
			m_lCellScore=0;
			m_bPlaySet=false;
			m_pITableFrame->SetCellScore(m_lCellScore);
		}

		m_bSitDown[wChairID]=true;
	}
	return true;
}

//û
bool  CTableFrameSink::OnActionUserStandUp(WORD wChairID, IServerUserItem * pIServerUserItem, bool bLookonUser)
{
	//ׯ
	if (bLookonUser==false)
	{
		
		m_wBankerUser = INVALID_CHAIR;
		m_bSitDown[wChairID]=false;

		BYTE player=0;
		for(BYTE i=0;i<GAME_PLAYER;i++)
		{
			if(m_bSitDown[i]==true)
			{
				player++;
			}
		}
		if(player==0)
		{
			m_pITableFrame->SetCellScore(0);
			m_bPlaySet=false;
		}

		if(pIServerUserItem->GetUserStatus()==US_PLAYING)
		{
			m_bTrustee[wChairID]=false;
			CMD_S_Trustee Trustee;
			Trustee.bTrustee=false;
			Trustee.wChairID = wChairID;
			m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_TRUSTEE,&Trustee,sizeof(Trustee));
			m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_TRUSTEE,&Trustee,sizeof(Trustee));
		}

		if(!m_bSetCell&&wChairID==m_wSetCellChairID)
		{
			for(BYTE i=0;i<GAME_PLAYER;i++)
			{
				IServerUserItem * pIServerUserItemT=m_pITableFrame->GetTableUserItem(i);
				if(pIServerUserItemT!=NULL)
				{
					CMD_S_SendSet SendSet;
					SendSet.wChairID=pIServerUserItemT->GetChairID();
					m_wSetCellChairID=pIServerUserItemT->GetChairID();
					m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_SEND_SET,&SendSet,sizeof(SendSet));
					m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_SEND_SET,&SendSet,sizeof(SendSet));
					break;
				}
			}
		}                                   
	}

	return true;
}

//û
bool CTableFrameSink::OnUserListenCard(WORD wChairID)
{
	//Ч״̬
	ASSERT(m_pITableFrame->GetGameStatus()==GS_MJ_PLAY);
	if (m_pITableFrame->GetGameStatus()!=GS_MJ_PLAY) return true;

	//Ч
	//Ч
	ASSERT((wChairID==m_wCurrentUser)&&(m_bEnjoinChiPeng[wChairID]==false));
	if ((wChairID!=m_wCurrentUser)||(m_bEnjoinChiPeng[wChairID]==true)) 
	{
		return false;
	}

	//ñ
	m_bWillHearStatus[wChairID] = true;

	//
	CMD_S_Listen ListenCard;
	ZeroMemory(&ListenCard,sizeof(ListenCard));
	ListenCard.wChairId=wChairID;
	CopyMemory(ListenCard.cbDiscardCount,m_cbDiscardCount,sizeof(m_cbDiscardCount));
	CopyMemory(ListenCard.cbDiscardCard,m_cbDiscardCard,sizeof(m_cbDiscardCard));

	//Ϣ
	m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_LISTEN,&ListenCard,sizeof(ListenCard));
	m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_LISTEN,&ListenCard,sizeof(ListenCard));

	return true;
}
//
bool CTableFrameSink::OnUserListenSet(WORD wChairID,bool bListen)
{
	//Ч״̬
	ASSERT(m_pITableFrame->GetGameStatus()==GS_MJ_PLAY);
	if (m_pITableFrame->GetGameStatus()!=GS_MJ_PLAY) return true;

	////Ч
	////Ч
	//ASSERT((wChairID==m_wCurrentUser)&&(m_bEnjoinChiPeng[wChairID]==false));
	//if ((wChairID!=m_wCurrentUser)||(m_bEnjoinChiPeng[wChairID]==true)) 
	//{
	//	return false;
	//}

	if(!bListen)
	{
		m_bWillHearStatus[wChairID] = false;
		m_bHearStatus[wChairID] = false;
		m_bEnjoinChiPeng[wChairID]=false;
		m_bKan[wChairID]=false;
	}
	CMD_S_ListenSet ListenSet;
	ListenSet.bListen=bListen;
	ListenSet.wChairID=wChairID;

	//Ϣ
	m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_LISTEN_SET,&ListenSet,sizeof(ListenSet));
	m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_LISTEN_SET,&ListenSet,sizeof(ListenSet));

	return true;
}
//û
bool CTableFrameSink::OnUserOutCard(WORD wChairID, BYTE cbCardData)
{
	//Ч״̬
	ASSERT(m_pITableFrame->GetGameStatus()==GS_MJ_PLAY);
	if (m_pITableFrame->GetGameStatus()!=GS_MJ_PLAY) 
	{
		return true;
	}

	if(wChairID!=m_wCurrentUser)
	{
		m_wCurrentUser=wChairID;
	}
		
	//
	ASSERT(wChairID==m_wCurrentUser);
	ASSERT(m_GameLogic.IsValidCard(cbCardData)==true);

	//Ч
	if (wChairID!=m_wCurrentUser) 
	{
		return false;
	}
	if (m_GameLogic.IsValidCard(cbCardData)==false)
	{
		return false;
	}

	//ɾ˿
	if (m_GameLogic.RemoveCard(m_cbCardIndex[wChairID],cbCardData)==false)
	{
		ASSERT(FALSE);
		return false;
	}

	m_bOutCardData=true;

	if(m_bGangStatus)
	{
		m_cbGangOutCard=cbCardData;
	}
	else
	{
		m_cbGangOutCard=0;
	}

	SparrowTowPlayerTable<<"OnUserOutCard"<<endl;
	SparrowTowPlayerTable<<m_pITableFrame->GetTableUserItem(wChairID)->GetUserInfo()->szNickName<<" cbCardData "<<(WORD)cbCardData<<endl;

	//ñ
	m_bSendStatus=true;
	m_bGangStatus = false;
	m_bQiangGang=false;
	m_cbUserAction[wChairID]=WIK_NULL;
	m_cbPerformAction[wChairID]=WIK_NULL;

	if( m_bWillHearStatus[wChairID] )
	{
		m_bWillHearStatus[wChairID] = false;
		m_bHearStatus[wChairID] = true;
		m_bEnjoinChiPeng[wChairID]=true;
		if(m_wHearUser==INVALID_CHAIR)
			m_wHearUser=wChairID;

		CWHArray<BYTE> tempCard;

		//
		CChiHuRight chr;
		CChiHuRight chrhigh;
		CChiHuRight	chrnew;
		//˿
		BYTE cbCardIndexTemp[MAX_INDEX];
		CopyMemory(cbCardIndexTemp,m_cbCardIndex[wChairID],sizeof(cbCardIndexTemp));
		//ж
		BYTE i=0;
		for (;i<MAX_INDEX;i++)
		{
			//Ʒ
			BYTE cbCurrentCard=m_GameLogic.SwitchToCardData(i);
			BYTE cbHuCardKind=m_GameLogic.AnalyseChiHuCard(cbCardIndexTemp,m_WeaveItemArray[wChairID],
				m_cbWeaveItemCount[wChairID],m_wProvideUser,wChairID,cbCurrentCard,chr,chrhigh,chrnew);

			//ж
			if (cbHuCardKind!=WIK_NULL)
			{
				tempCard.Add(m_GameLogic.SwitchToCardData(i));
			}
		}

		if(tempCard.GetCount()==1)
		{
			if(tempCard[0]>0x01&&tempCard[0]<0x09)
				m_bKan[wChairID]=true;
		}
	}

	//Ƽ¼
	m_cbOutCardCount++;
	m_wOutCardUser=wChairID;
	m_cbOutCardData=cbCardData;

	//
	CMD_S_OutCard OutCard;
	ZeroMemory(&OutCard,sizeof(OutCard));
	OutCard.wOutCardUser=wChairID;
	OutCard.cbOutCardData=cbCardData;
	OutCard.bCurrentTing=m_bHearStatus[m_wCurrentUser];
	OutCard.bDelte=m_bDelete;

	//Ϣ
	m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_OUT_CARD,&OutCard,sizeof(OutCard));
	m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_OUT_CARD,&OutCard,sizeof(OutCard));

	m_bDelete=false;
	m_wProvideUser=wChairID;
	m_cbProvideCard=cbCardData;

	//ûл
	m_wCurrentUser=(wChairID+m_wPlayerCount-1)%m_wPlayerCount;

	//Ӧж
	bool bAroseAction=EstimateUserRespond(wChairID,cbCardData,EstimatKind_OutCard,true);

	if(bAroseAction)
	{
		SparrowTowPlayerTable<<"bAroseAction"<<endl;
		UpdataTingInfo(wChairID,0);
	}

	//ɷ˿
	if (bAroseAction==false) DispatchCardData(m_wCurrentUser);

	return true;
}

//û
bool CTableFrameSink::OnUserOperateCard(WORD wChairID, DWORD cbOperateCode, BYTE cbOperateCard[3])
{
	//Ч״̬
	ASSERT(m_pITableFrame->GetGameStatus()==GS_MJ_PLAY||m_pITableFrame->GetGameStatus()==GS_MJ_END);
	if (m_pITableFrame->GetGameStatus()!=GS_MJ_PLAY&&m_pITableFrame->GetGameStatus()!=GS_MJ_END)
	{
		return true;
	}

	//Чû ע⣺лʱпܻᷢ˶
	//ASSERT((wChairID==m_wCurrentUser)||(m_wCurrentUser==INVALID_CHAIR));
	if ((wChairID!=m_wCurrentUser)&&(m_wCurrentUser!=INVALID_CHAIR)) 
	{
		return true;
	}

	//
	if (m_wCurrentUser==INVALID_CHAIR|| ((cbOperateCode&WIK_LISTEN)&&!m_bWillHearStatus[m_wCurrentUser]))
	{
		//Ч״̬
		//ASSERT(m_bResponse[wChairID]==false);
		//ASSERT( m_cbUserAction[wChairID] != WIK_NULL );
	//	ASSERT((cbOperateCode==WIK_NULL)||((m_cbUserAction[wChairID]&cbOperateCode)!=0));

		//Ч״̬
		if (m_bResponse[wChairID]==true) 
		{
			return true;
		}
		if( m_cbUserAction[wChairID] == WIK_NULL &&(!(cbOperateCode&WIK_LISTEN))  )
		{
			return true;
		}
		if ((cbOperateCode!=WIK_NULL)&&((m_cbUserAction[wChairID]&cbOperateCode)==0)&&(!(cbOperateCode&WIK_LISTEN)))
		{
			return true;
		}

		//
		WORD wTargetUser=wChairID;
		DWORD cbTargetAction=cbOperateCode;

		//ñ
		m_bResponse[wChairID]=true;
		m_cbPerformAction[wChairID]=cbOperateCode;
		if(cbOperateCard[0]==0)
			m_cbOperateCard[wChairID][0] = m_cbProvideCard;
		else CopyMemory( m_cbOperateCard[wChairID],cbOperateCard,sizeof(m_cbOperateCard[wChairID]) );

		//ִж
		for (WORD i=0;i<m_wPlayerCount;i++)
		{
			//ȡ
			DWORD cbUserAction=(m_bResponse[i]==false)?m_cbUserAction[i]:m_cbPerformAction[i];

			//ȼ
			DWORD cbUserActionRank=m_GameLogic.GetUserActionRank(cbUserAction);
			DWORD cbTargetActionRank=m_GameLogic.GetUserActionRank(cbTargetAction);

			//ж
			if (cbUserActionRank>cbTargetActionRank)
			{
				wTargetUser=i;
				cbTargetAction=cbUserAction;
			}
		}
		if (m_bResponse[wTargetUser]==false) 
		{
			return true;
		}

		//Ժȴ
		if (cbTargetAction==WIK_CHI_HU)
		{
			for (WORD i=0;i<m_wPlayerCount;i++)
			{
				if ((m_bResponse[i]==false)&&(m_cbUserAction[i]&WIK_CHI_HU))
				{
					return true;
				}
			}
		}

		//
		if (cbTargetAction==WIK_NULL)
		{
			//û״̬
			ZeroMemory(m_bResponse,sizeof(m_bResponse));
			ZeroMemory(m_cbUserAction,sizeof(m_cbUserAction));
			ZeroMemory(m_cbOperateCard,sizeof(m_cbOperateCard));
			ZeroMemory(m_cbPerformAction,sizeof(m_cbPerformAction));

			//˿
			DispatchCardData(m_wResumeUser);

			return true;
		}

		//
		BYTE cbTargetCard=m_cbOperateCard[wTargetUser][0];

		//Ʊ
		m_cbOutCardData=0;
		m_bSendStatus=true;
		m_wOutCardUser=INVALID_CHAIR;

		//Ʋ
		if (cbTargetAction==WIK_CHI_HU)
		{
			//Ϣ
			m_cbChiHuCard=cbTargetCard;

			for (WORD i=(m_wProvideUser+m_wPlayerCount-1)%GAME_PLAYER;i!=m_wProvideUser;i = (i+m_wPlayerCount-1)%GAME_PLAYER)
			{
				//ж
				if ((m_cbPerformAction[i]&WIK_CHI_HU)==0)
					continue;

				//ж
				BYTE cbWeaveItemCount=m_cbWeaveItemCount[i];
				tagWeaveItem * pWeaveItem=m_WeaveItemArray[i];
				m_dwChiHuKind[i] = m_GameLogic.AnalyseChiHuCard(m_cbCardIndex[i],pWeaveItem,cbWeaveItemCount,
					m_wProvideUser,wTargetUser,m_cbChiHuCard,m_ChiHuRight[i],m_ChiHuHigh[i],m_ChiHuNew[i]);

				//˿
				if (m_dwChiHuKind[i]!=WIK_NULL) 
				{
					m_cbCardIndex[i][m_GameLogic.SwitchToCardIndex(m_cbChiHuCard)]++;
					wTargetUser = i;
					break;
				}
			}

			//Ϸ
			ASSERT(m_dwChiHuKind[wTargetUser]!=WIK_NULL);
			OnEventGameConclude(m_wProvideUser,NULL,GER_NORMAL);
			//OnGameEndPlay(false);

			return true;
		}

		if(cbTargetAction!=WIK_LISTEN)
		{
			//˿
			ASSERT(m_cbWeaveItemCount[wTargetUser]<MAX_WEAVE);
			WORD wIndex=m_cbWeaveItemCount[wTargetUser]++;
			m_WeaveItemArray[wTargetUser][wIndex].cbPublicCard=TRUE;
			m_WeaveItemArray[wTargetUser][wIndex].cbCenterCard=cbTargetCard;
			m_WeaveItemArray[wTargetUser][wIndex].cbWeaveKind=cbTargetAction;
			m_WeaveItemArray[wTargetUser][wIndex].wProvideUser=(m_wProvideUser==INVALID_CHAIR)?wTargetUser:m_wProvideUser;
			m_WeaveItemArray[wTargetUser][wIndex].cbCardData[0] = cbTargetCard;
			if( cbTargetAction&(WIK_LEFT|WIK_LEFT_LISTEN|WIK_CENTER|WIK_CENTER_LISTEN|WIK_RIGHT|WIK_RIGHT_LISTEN) )
			{
				m_WeaveItemArray[wTargetUser][wIndex].cbCardData[1] = m_cbOperateCard[wTargetUser][1];
				m_WeaveItemArray[wTargetUser][wIndex].cbCardData[2] = m_cbOperateCard[wTargetUser][2];
			}
			else
			{
				m_WeaveItemArray[wTargetUser][wIndex].cbCardData[1] = cbTargetCard;
				m_WeaveItemArray[wTargetUser][wIndex].cbCardData[2] = cbTargetCard;
				if( cbTargetAction & WIK_GANG )
				{
					m_WeaveItemArray[wTargetUser][wIndex].cbCardData[3] = cbTargetCard;
					//ܸ
					m_cbMingGangCount[wTargetUser]++;
				}
			}
		}

		//ɾ˿
		switch (cbTargetAction)
		{
		case WIK_LEFT:		//Ʋ
		case WIK_LEFT_LISTEN:
			{
				//ɾ˿
				if( !m_GameLogic.RemoveCard(m_cbCardIndex[wTargetUser],&m_cbOperateCard[wTargetUser][1],2) )
				{
					ASSERT( FALSE );
					return false;
				}

				break;
			}
		case WIK_RIGHT:		//Ʋ
		case WIK_RIGHT_LISTEN:
			{
				//ɾ˿
				if( !m_GameLogic.RemoveCard(m_cbCardIndex[wTargetUser],&m_cbOperateCard[wTargetUser][1],2) )
				{
					ASSERT( FALSE );
					return false;
				}

				break;
			}
		case WIK_CENTER:	//Ʋ
		case WIK_CENTER_LISTEN:
			{
				//ɾ˿
				if( !m_GameLogic.RemoveCard(m_cbCardIndex[wTargetUser],&m_cbOperateCard[wTargetUser][1],2) )
				{
					ASSERT( FALSE );
					return false;
				}

				break;
			}
		case WIK_PENG:		//Ʋ
		case WIK_PENG_LISTEN:	
			{
				//ɾ˿
				BYTE cbRemoveCard[]={cbTargetCard,cbTargetCard};
				if( !m_GameLogic.RemoveCard(m_cbCardIndex[wTargetUser],cbRemoveCard,2) )
				{
					ASSERT( FALSE );
					return false;
				}

				break;
			}
		case WIK_GANG:		//Ʋ
			{
				//ɾ˿,ֻڷŸ
				BYTE cbRemoveCard[]={cbTargetCard,cbTargetCard,cbTargetCard};
				if( !m_GameLogic.RemoveCard(m_cbCardIndex[wTargetUser],cbRemoveCard,CountArray(cbRemoveCard)) )
				{
					ASSERT( FALSE );
					return false;
				}

				break;
			}
		default:
			ASSERT( FALSE );
			return false;
		}

		//
		CMD_S_OperateResult OperateResult;
		ZeroMemory( &OperateResult,sizeof(OperateResult) );
		OperateResult.wOperateUser=wTargetUser;
		OperateResult.cbOperateCode=cbTargetAction;
		OperateResult.wProvideUser=(m_wProvideUser==INVALID_CHAIR)?wTargetUser:m_wProvideUser;
		OperateResult.cbOperateCard[0] = cbTargetCard;
		if( cbTargetAction&(WIK_LEFT|WIK_LEFT_LISTEN|WIK_CENTER|WIK_CENTER_LISTEN|WIK_RIGHT|WIK_RIGHT_LISTEN) )
			CopyMemory( &OperateResult.cbOperateCard[1],&m_cbOperateCard[wTargetUser][1],2*sizeof(BYTE) );
		else if( cbTargetAction&(WIK_PENG|WIK_PENG_LISTEN) )
		{
			OperateResult.cbOperateCard[1] = cbTargetCard;
			OperateResult.cbOperateCard[2] = cbTargetCard;
		}

		//Ϣ
		m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_OPERATE_RESULT,&OperateResult,sizeof(OperateResult));
		m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_OPERATE_RESULT,&OperateResult,sizeof(OperateResult));

		//û״̬
		ZeroMemory(m_bResponse,sizeof(m_bResponse));
		ZeroMemory(m_cbUserAction,sizeof(m_cbUserAction));
		ZeroMemory(m_cbOperateCard,sizeof(m_cbOperateCard));
		ZeroMemory(m_cbPerformAction,sizeof(m_cbPerformAction));

		//û
		m_wCurrentUser=wTargetUser;

		//ƴ
		if (cbTargetAction==WIK_GANG)
		{
			m_bGangStatus = true;
			DispatchCardData(wTargetUser);
		}

		return true;
	}

	//
	if (m_wCurrentUser==wChairID)
	{
		//
		if (cbOperateCode==WIK_NULL)
		{
			//û״̬
			ZeroMemory(m_bResponse,sizeof(m_bResponse));
			ZeroMemory(m_cbUserAction,sizeof(m_cbUserAction));
			ZeroMemory(m_cbOperateCard,sizeof(m_cbOperateCard));
			ZeroMemory(m_cbPerformAction,sizeof(m_cbPerformAction));

			//˿
			BYTE cbCardData=0;
			for(byte i=0;i<34;i++)
			{
				if(m_cbCardIndex[wChairID][i]!=0)
				{
					cbCardData=m_GameLogic.SwitchToCardData(i);
					break;
				}
			}
			m_bDelete=true;
			OnUserOutCard(wChairID, cbCardData);
			return true;
		}

		if( m_cbUserAction[wChairID] == WIK_NULL )
		{
			//SendGameScene(wChairID,m_pITableFrame->GetTableUserItem( wChairID ),GS_MJ_PLAY,false);
			//
			return true;
		}

		//OutputDebugString("");
		
		////
		//if (cbOperateCode==WIK_NULL)
		//{
		//	OutputDebugString("");
		//	//û״̬
		//	ZeroMemory(m_bResponse,sizeof(m_bResponse));
		//	ZeroMemory(m_cbUserAction,sizeof(m_cbUserAction));
		//	ZeroMemory(m_cbOperateCard,sizeof(m_cbOperateCard));
		//	ZeroMemory(m_cbPerformAction,sizeof(m_cbPerformAction));

		//	//˿
		//	BYTE cbCardData=0;
		//	for(byte i=0;i<34;i++)
		//	{
		//		if(m_cbCardIndex[wChairID][i]!=0)
		//		{
		//			cbCardData=m_GameLogic.SwitchToCardData(i);
		//		    break;
		//		}
		//	}
		//	m_bDelete=true;
		//	OnUserOutCard(wChairID, cbCardData);
		//	return true;
		//}

		//Ч
		ASSERT((cbOperateCode!=WIK_NULL)&&((m_cbUserAction[wChairID]&cbOperateCode)!=0));
		if ((cbOperateCode==WIK_NULL)||((m_cbUserAction[wChairID]&cbOperateCode)==0))
		{
			return false;
		}

		//˿Ч
		ASSERT((cbOperateCode==WIK_NULL)||(cbOperateCode==WIK_CHI_HU) ||(m_GameLogic.IsValidCard(cbOperateCard[0])==true));
		if ((cbOperateCode!=WIK_NULL)&&(cbOperateCode!=WIK_CHI_HU)&&(m_GameLogic.IsValidCard(cbOperateCard[0])==false)) 
		{
			return false;
		}

		//ñ
		m_bSendStatus=true;
		m_cbUserAction[m_wCurrentUser]=WIK_NULL;
		m_cbPerformAction[m_wCurrentUser]=WIK_NULL;

		bool bPublic=false;

		//ִж
		switch (cbOperateCode)
		{
		case WIK_GANG:			//Ʋ
			{
				//
				BYTE cbWeaveIndex=0xFF;
				BYTE cbCardIndex=m_GameLogic.SwitchToCardIndex(cbOperateCard[0]);

				//ƴ
				if (m_cbCardIndex[wChairID][cbCardIndex]==1)
				{
					//Ѱ
					for (BYTE i=0;i<m_cbWeaveItemCount[wChairID];i++)
					{
						BYTE cbWeaveKind=m_WeaveItemArray[wChairID][i].cbWeaveKind;
						BYTE cbCenterCard=m_WeaveItemArray[wChairID][i].cbCenterCard;
						if ((cbCenterCard==cbOperateCard[0])&&(cbWeaveKind==WIK_PENG))
						{
							bPublic=true;
							cbWeaveIndex=i;
							break;
						}
					}

					//Ч鶯
					ASSERT(cbWeaveIndex!=0xFF);
					if (cbWeaveIndex==0xFF) return false;

					//˿
					m_WeaveItemArray[wChairID][cbWeaveIndex].cbPublicCard=TRUE;
					m_WeaveItemArray[wChairID][cbWeaveIndex].cbWeaveKind=cbOperateCode;
					m_WeaveItemArray[wChairID][cbWeaveIndex].cbCenterCard=cbOperateCard[0];
					m_WeaveItemArray[wChairID][cbWeaveIndex].cbCardData[3]=cbOperateCard[0];
                    //ܸ
			    	m_cbMingGangCount[wChairID]++;                  
					
				}
				else
				{
					//˿Ч
					ASSERT(m_cbCardIndex[wChairID][cbCardIndex]==4);
					if (m_cbCardIndex[wChairID][cbCardIndex]!=4) 
						return false;

					//ñ
					bPublic=false;
					cbWeaveIndex=m_cbWeaveItemCount[wChairID]++;
					m_WeaveItemArray[wChairID][cbWeaveIndex].cbPublicCard=FALSE;
					m_WeaveItemArray[wChairID][cbWeaveIndex].wProvideUser=wChairID;
					m_WeaveItemArray[wChairID][cbWeaveIndex].cbWeaveKind=cbOperateCode;
					m_WeaveItemArray[wChairID][cbWeaveIndex].cbCenterCard=cbOperateCard[0];
					for( BYTE j = 0; j < 4; j++ )
						m_WeaveItemArray[wChairID][cbWeaveIndex].cbCardData[j] = cbOperateCard[0];
					//ܸ
					m_cbAnGangCount[wChairID]++;
				}

				//m_wCurrentUser=wChairID;

				//ɾ˿
				m_cbCardIndex[wChairID][cbCardIndex]=0;

				m_bGangStatus = true;
				m_bQiangGang=true;

				//
				CMD_S_OperateResult OperateResult;
				ZeroMemory( &OperateResult,sizeof(OperateResult) );
				OperateResult.wOperateUser=wChairID;
				OperateResult.wProvideUser=wChairID;
				OperateResult.cbOperateCode=cbOperateCode;
				OperateResult.cbOperateCard[0]=cbOperateCard[0];

				//Ϣ
				m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_OPERATE_RESULT,&OperateResult,sizeof(OperateResult));
				m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_OPERATE_RESULT,&OperateResult,sizeof(OperateResult));

				//Ч鶯
				bool bAroseAction=false;
				if (bPublic==true) 
				{
					bAroseAction=EstimateUserRespond(wChairID,cbOperateCard[0],EstimatKind_GangCard,false);
				}

				//˿
				if (bAroseAction==false)
				{
					DispatchCardData(wChairID);
				}

				return true;
			}
		case WIK_CHI_HU:		//Ժ
			{
				//ͨ
				BYTE cbWeaveItemCount=m_cbWeaveItemCount[wChairID];
				tagWeaveItem * pWeaveItem=m_WeaveItemArray[wChairID];
				if( !m_GameLogic.RemoveCard(m_cbCardIndex[wChairID],&m_cbProvideCard,1) )
				{
					ASSERT( FALSE );
					return false;
				}
				m_dwChiHuKind[wChairID] = m_GameLogic.AnalyseChiHuCard(m_cbCardIndex[wChairID],pWeaveItem,cbWeaveItemCount,
					m_wProvideUser,m_wCurrentUser,m_cbProvideCard,m_ChiHuRight[wChairID],m_ChiHuHigh[wChairID],
					m_ChiHuNew[wChairID]);
				m_cbCardIndex[wChairID][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)]++;

				//Ϣ
				m_cbChiHuCard=m_cbProvideCard;

				//Ϸ
				OnEventGameConclude(m_wProvideUser,NULL,GER_NORMAL);
				//OnGameEndPlay(false);

				return true;
			}
		}

		return true;
	}

	return false;
}
bool CTableFrameSink::OnUserRedouble(WORD wChairID, DWORD dwRedouble)
{
	m_dwFanShu[wChairID]+=(dwRedouble);
	m_dwRedoubleCount[wChairID]++;

	CMD_S_Redouble Redouble;
	ZeroMemory(&Redouble,sizeof(Redouble));
	Redouble.wChairID=wChairID;
	CopyMemory(Redouble.dwFanShu,m_dwFanShu,sizeof(m_dwFanShu));
	//Ϣ
	m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_REDOUBLE,&Redouble,sizeof(Redouble));
	m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_REDOUBLE,&Redouble,sizeof(Redouble));
	return true;
}
BYTE CTableFrameSink::GetResidualCount(BYTE cbTingCard)
{
	BYTE cbGetCount=GetDiscardCount(cbTingCard);

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		if(m_bHearStatus[i])
		{
			cbGetCount+=m_cbCardIndex[i][m_GameLogic.SwitchToCardIndex(cbTingCard)];
		}
	}

	if(cbTingCard==m_cbOutCardData)
		cbGetCount++;

	if(cbGetCount>=4)
		cbGetCount=4;

	return 4-cbGetCount;
}
void CTableFrameSink::UpdataTingInfo(WORD wChairID,BYTE cbProvideCard)
{
	if(m_bHearStatus[wChairID])
	{
		m_ArrayTingCard[wChairID].RemoveAll();
		//
		CChiHuRight ChiHuResult;
		CChiHuRight ChiHuHigh;
		CChiHuRight ChiHuNew;
		ZeroMemory(&ChiHuResult,sizeof(ChiHuResult));
		ZeroMemory(&ChiHuHigh,sizeof(ChiHuHigh));
		ZeroMemory(&ChiHuNew,sizeof(ChiHuNew));

		//˿
		BYTE cbCardIndexTemp[MAX_INDEX];
		CopyMemory(cbCardIndexTemp,m_cbCardIndex[wChairID],sizeof(cbCardIndexTemp));
		if(cbProvideCard!=0)
		{
			ASSERT(cbCardIndexTemp[m_GameLogic.SwitchToCardIndex(cbProvideCard)]!=0);
			cbCardIndexTemp[m_GameLogic.SwitchToCardIndex(cbProvideCard)]--;
		}

		tagTingInfo TingInfo;
		//ж
		for (BYTE j=0;j<MAX_INDEX;j++)
		{
			//Ʒ
			BYTE cbCurrentCard=m_GameLogic.SwitchToCardData(j);
			WORD cbHuCardKind=m_GameLogic.AnalyseChiHuCard(cbCardIndexTemp,m_WeaveItemArray[wChairID],
				m_cbWeaveItemCount[wChairID],0,0,cbCurrentCard,ChiHuResult,ChiHuHigh,ChiHuNew);

			//ж
			if (cbHuCardKind!=WIK_NULL) 
			{
				WORD wFanShuo=GetFanShu(wChairID,cbCardIndexTemp,cbCurrentCard);
				TingInfo.cbCardData=m_GameLogic.SwitchToCardData(j);
				TingInfo.cbFan=wFanShuo;
				TingInfo.cbCardCount=GetResidualCount(m_GameLogic.SwitchToCardData(j));
				m_ArrayTingCard[wChairID].Add(TingInfo);
			}
		}

		CMD_S_UpDataTInfo UpdataTInfo;
		ZeroMemory(&UpdataTInfo,sizeof(UpdataTInfo));
		UpdataTInfo.cbInfoCount=m_ArrayTingCard[wChairID].GetCount();
		for(BYTE i=0;i<m_ArrayTingCard[wChairID].GetCount();i++)
		{
			UpdataTInfo.cbCardData[i]=m_ArrayTingCard[wChairID][i].cbCardData;
			UpdataTInfo.cbCount[i]=m_ArrayTingCard[wChairID][i].cbCardCount;
			UpdataTInfo.dwFanShu[i]=m_ArrayTingCard[wChairID][i].cbFan;
		}

		//Ϣ
		m_pITableFrame->SendTableData(wChairID,SUB_S_UPDATA_TINFO,&UpdataTInfo,sizeof(UpdataTInfo));
		m_pITableFrame->SendLookonData(wChairID,SUB_S_UPDATA_TINFO,&UpdataTInfo,sizeof(UpdataTInfo));
	}

	if(m_bHearStatus[(wChairID+1)%GAME_PLAYER])
	{
		WORD wNextChairID=(wChairID+1)%GAME_PLAYER;

		m_ArrayTingCard[wNextChairID].RemoveAll();
		//
		CChiHuRight ChiHuResult;
		CChiHuRight ChiHuHigh;
		CChiHuRight ChiHuNew;
		ZeroMemory(&ChiHuResult,sizeof(ChiHuResult));
		ZeroMemory(&ChiHuHigh,sizeof(ChiHuHigh));
		ZeroMemory(&ChiHuNew,sizeof(ChiHuNew));

		//˿
		BYTE cbCardIndexTemp[MAX_INDEX];
		CopyMemory(cbCardIndexTemp,m_cbCardIndex[wNextChairID],sizeof(cbCardIndexTemp));

		tagTingInfo TingInfo;
		//ж
		for (BYTE j=0;j<MAX_INDEX;j++)
		{
			//Ʒ
			BYTE cbCurrentCard=m_GameLogic.SwitchToCardData(j);
			WORD cbHuCardKind=m_GameLogic.AnalyseChiHuCard(cbCardIndexTemp,m_WeaveItemArray[wNextChairID],
				m_cbWeaveItemCount[wNextChairID],0,0,cbCurrentCard,ChiHuResult,ChiHuHigh,ChiHuNew);

			//ж
			if (cbHuCardKind!=WIK_NULL) 
			{
				WORD wFanShuo=GetFanShu(wNextChairID,cbCardIndexTemp,cbCurrentCard);
				TingInfo.cbCardData=m_GameLogic.SwitchToCardData(j);
				TingInfo.cbFan=wFanShuo;
				TingInfo.cbCardCount=GetResidualCount(m_GameLogic.SwitchToCardData(j));
				m_ArrayTingCard[wNextChairID].Add(TingInfo);
			}
		}

		CMD_S_UpDataTInfo UpdataTInfo;
		ZeroMemory(&UpdataTInfo,sizeof(UpdataTInfo));
		UpdataTInfo.cbInfoCount=m_ArrayTingCard[wNextChairID].GetCount();
		for(BYTE i=0;i<m_ArrayTingCard[wNextChairID].GetCount();i++)
		{
			UpdataTInfo.cbCardData[i]=m_ArrayTingCard[wNextChairID][i].cbCardData;
			UpdataTInfo.cbCount[i]=m_ArrayTingCard[wNextChairID][i].cbCardCount;
			UpdataTInfo.dwFanShu[i]=m_ArrayTingCard[wNextChairID][i].cbFan;
		}

		//Ϣ
		m_pITableFrame->SendTableData(wNextChairID,SUB_S_UPDATA_TINFO,&UpdataTInfo,sizeof(UpdataTInfo));
		m_pITableFrame->SendLookonData(wNextChairID,SUB_S_UPDATA_TINFO,&UpdataTInfo,sizeof(UpdataTInfo));
	}
}
//û
bool CTableFrameSink::OnUserReplaceCard(WORD wChairID, BYTE cbCardData)
{
	//
	ASSERT(wChairID==m_wReplaceUser);
	ASSERT(m_GameLogic.IsHuaCard(cbCardData)==true);
	ASSERT(m_GameLogic.IsValidCard(cbCardData)==true);

	//Ч
	if (wChairID!=m_wReplaceUser) return false;
	if (m_GameLogic.IsHuaCard(cbCardData)==false) return false;
	if (m_GameLogic.IsValidCard(cbCardData)==false)  return false;

	//ɾ˿
	if (m_GameLogic.RemoveCard(m_cbCardIndex[wChairID],cbCardData)==false)
	{
		ASSERT(FALSE);
		return false;
	}

	//״̬
	m_bSendStatus=true;
	m_cbSendCardData=0x00;

	//ͳ
	m_cbHuaCardData[wChairID][m_cbHuaCardCount[wChairID]] = cbCardData;
	m_cbHuaCardCount[wChairID]++;


	//˿
	//m_cbDiscardCount[wChairID]++;
	//m_cbDiscardCard[wChairID][m_cbDiscardCount[wChairID]-1]=cbCardData;

	//
	CMD_S_ReplaceCard ReplaceCard;
	ZeroMemory(&ReplaceCard,sizeof(ReplaceCard));
	ReplaceCard.wReplaceUser=wChairID;
	ReplaceCard.cbReplaceCard=cbCardData;
	ReplaceCard.bOutCardData=m_bOutCardData;
	CopyMemory(ReplaceCard.cbHuaCardCount,m_cbHuaCardCount,sizeof(m_cbHuaCardCount));

	//Ϣ
	m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_REPLACE_CARD,&ReplaceCard,sizeof(ReplaceCard));
	m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_REPLACE_CARD,&ReplaceCard,sizeof(ReplaceCard));

	//ɷ˿
	DispatchCardData(wChairID,false,true);

	return true;
}

//Ͳ
bool CTableFrameSink::SendOperateNotify(bool bShow)
{
	//ʾ
	for (WORD i=0;i<m_wPlayerCount;i++)
	{
		if (m_cbUserAction[i]!=WIK_NULL)
		{
			//
			CMD_S_OperateNotify OperateNotify;
			ZeroMemory(&OperateNotify,sizeof(OperateNotify));
			OperateNotify.wResumeUser=m_wResumeUser;
			OperateNotify.cbActionCard=m_cbProvideCard;
			OperateNotify.cbActionMask=m_cbUserAction[i];
			OperateNotify.bShow=bShow;

			if(m_cbUserAction[i]&WIK_CHI_HU&&m_dwRedoubleCount[i]<8)
			{
				DWORD dwFanShu=m_dwFanShu[i]+GetFanShu(i,m_cbProvideCard,1);
				LONGLONG lUserScore=m_pITableFrame->GetTableUserItem((i+1)%GAME_PLAYER)->GetUserScore();
				if(dwFanShu*m_lCellScore<lUserScore)
				{
					CMD_S_ShowRedouble ShowRedouble;
					ShowRedouble.dwFanCount=GetFanShu(i,m_cbProvideCard,1);
					ShowRedouble.wChairID=i;
					m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_SHOW_REDOUBLE,&ShowRedouble,sizeof(ShowRedouble));
					m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_SHOW_REDOUBLE,&ShowRedouble,sizeof(ShowRedouble));
				}
			}

			//
			m_pITableFrame->SendTableData(i,SUB_S_OPERATE_NOTIFY,&OperateNotify,sizeof(OperateNotify));
			m_pITableFrame->SendLookonData(i,SUB_S_OPERATE_NOTIFY,&OperateNotify,sizeof(OperateNotify));
		}
	}

	return true;
}
bool CTableFrameSink::OnUserShowThink(WORD wChairID,bool bShowThink)
{
	CMD_S_ShowThink ShowThink;
	ShowThink.wChairID=wChairID;
	ShowThink.bShowThink=bShowThink;

	//
	m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_SHOW_THINK,&ShowThink,sizeof(ShowThink));
	m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_SHOW_THINK,&ShowThink,sizeof(ShowThink));
	return true;
}
bool CTableFrameSink::OnUserStartOver()
{
	//for(WORD i=0;i<m_wPlayerCount;i++)
	//{
	//	if(m_pITableFrame->GetTableUserItem(i)->IsAndroidUser())
	//	{
	//		SparrowTowPlayerTable<<"i "<<i<<"SUB_S_START_OVER"<<endl;
	//		m_pITableFrame->SendTableData(i,SUB_S_START_OVER);
	//		m_pITableFrame->SendLookonData(i,SUB_S_START_OVER);
	//	}
	//}
	m_cbGameStartOver++;
	if(m_cbGameStartOver==m_wPlayerCount)
	{
		m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_START_OVER);
		m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_START_OVER);
	}
	return true;
}
//ɷ˿
bool CTableFrameSink::DispatchCardData(WORD wCurrentUser,bool bTail,bool bReplace)
{
	//״̬Ч
	ASSERT(wCurrentUser!=INVALID_CHAIR);
	if (wCurrentUser==INVALID_CHAIR)
	{
		return false;
	}
	ASSERT( m_bSendStatus );
	if( m_bSendStatus == false ) 
	{
		return false;
	}

	//˿
	if ((m_wReplaceUser==INVALID_CHAIR)&&(m_wOutCardUser!=INVALID_CHAIR)&&(m_cbOutCardData!=0))
	{
		m_cbDiscardCount[m_wOutCardUser]++;
		m_cbDiscardCard[m_wOutCardUser][m_cbDiscardCount[m_wOutCardUser]-1]=m_cbOutCardData;
	}

	//ׯ
	if (m_cbLeftCardCount==m_cbEndLeftCount)
	{
		m_cbChiHuCard=0;
		m_wProvideUser=INVALID_CHAIR;
		OnEventGameConclude(m_wProvideUser,NULL,GER_NORMAL);
		//OnGameEndPlay(true);

		return true;
	}

	//ñ
	if ((m_wOutCardUser!=INVALID_CHAIR)&&(m_cbOutCardData!=0))
		m_cbTempOutData[m_wOutCardUser]=m_cbOutCardData;

	//ñ
	if( m_wReplaceUser == INVALID_CHAIR )
	{
		SparrowTowPlayerTable<<"m_wReplaceUser == INVALID_CHAIR "<<endl;
		m_cbOutCardData=0;
		m_wCurrentUser=wCurrentUser;
		m_wOutCardUser=INVALID_CHAIR;
	}

	//˿
	m_cbSendCardCount++;
	--m_cbLeftCardCount;
	m_cbSendCardData=m_cbRepertoryCard[max(m_cbLeftCardCount,0)];

	//
	m_cbCardIndex[wCurrentUser][m_GameLogic.SwitchToCardIndex(m_cbSendCardData)]++;

	//ͳƻ
	if (m_GameLogic.IsHuaCard(m_cbSendCardData))
		m_cbHuaCardInfo[wCurrentUser][m_cbSendCardData-0x38]++;

	//ж
	if ((m_wReplaceUser!=INVALID_CHAIR)||(m_GameLogic.IsHuaCard(m_cbSendCardData)))
	{
		m_wReplaceUser=INVALID_CHAIR;

		//ûж
		for (WORD i=0;i<GAME_PLAYER;i++)
		{
			//û
			WORD wUserIndex=(wCurrentUser+GAME_PLAYER-i)%GAME_PLAYER;

			//˿ж
			for (BYTE j=MAX_INDEX-MAX_HUA_CARD;j<MAX_INDEX;j++)
			{	//091231JJ
				if (m_cbCardIndex[wUserIndex][j] > 0 )
				{
					m_wReplaceUser=wUserIndex;
					break;
				}
			}

			if( m_wReplaceUser != INVALID_CHAIR ) break;
		}
	}
	
	if( m_wCurrentUser == wCurrentUser )
	{
		SparrowTowPlayerTable<<"m_wCurrentUser == wCurrentUser "<<endl;
		//ñ
		m_wProvideUser=wCurrentUser;
		m_cbProvideCard=m_cbSendCardData;
	}

	if(m_wReplaceUser==INVALID_CHAIR)
	{
		if(!m_GameLogic.IsHuaCard(m_cbProvideCard))
		{
			m_bEnjoinPeng[wCurrentUser]=false;
			m_cbPengCard[wCurrentUser]=0;
			//ж
			CChiHuRight chr;
			CChiHuRight chrhigh;
			CChiHuRight chrnew;
			SparrowTowPlayerTable<<m_wCurrentUser<<","<<wCurrentUser<<endl;
			if (m_wCurrentUser==INVALID_CHAIR)
			{
				m_wCurrentUser=wCurrentUser;
				SparrowTowPlayerTable<<"ţ"<<m_pITableFrame->GetTableID()<<endl;
			}
			m_cbCardIndex[m_wCurrentUser][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)]--;
			BYTE cbAction= m_GameLogic.AnalyseChiHuCard(m_cbCardIndex[m_wCurrentUser],m_WeaveItemArray[m_wCurrentUser],
				m_cbWeaveItemCount[m_wCurrentUser],m_wProvideUser,m_wCurrentUser,m_cbProvideCard,chr,chrhigh,chrnew);
			m_cbCardIndex[m_wCurrentUser][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)]++;

			m_cbUserAction[m_wCurrentUser] |= cbAction;

			SparrowTowPlayerTable<<m_wCurrentUser<<","<<wCurrentUser<<"Ƿƽ"<<endl;

			//ж
			if (/*(m_bEnjoinChiPeng[m_wCurrentUser]==false)&&*/(m_cbLeftCardCount>m_cbEndLeftCount))
			{
				tagGangCardResult GangCardResult;
				m_cbUserAction[m_wCurrentUser]|=m_GameLogic.AnalyseGangCard(m_cbCardIndex[m_wCurrentUser],
					m_WeaveItemArray[m_wCurrentUser],m_cbWeaveItemCount[m_wCurrentUser],m_wProvideUser,m_wCurrentUser,
					m_bHearStatus[m_wCurrentUser],GangCardResult);
			}

			UpdataTingInfo(m_wCurrentUser,m_cbProvideCard);
		}
	}

//	//Ϣ
//	ASSERT( m_wHeapHead != INVALID_CHAIR && m_wHeapTail != INVALID_CHAIR );
//	if( !bTail )
//	{
//		//л
////		BYTE cbHeapCount=m_cbHeapCardInfo[m_wHeapHead][0]+m_cbHeapCardInfo[m_wHeapHead][1];
////		if (cbHeapCount==HEAP_FULL_COUNT) 
////			m_wHeapHead=(m_wHeapHead+1)%CountArray(m_cbHeapCardInfo);
//		m_cbHeapCardInfo[m_wHeapHead][0]++;
//	}
//	else
//	{
//		//л
//		BYTE cbHeapCount=m_cbHeapCardInfo[m_wHeapTail][0]+m_cbHeapCardInfo[m_wHeapTail][1];
//		if (cbHeapCount==HEAP_FULL_COUNT) 
//			m_wHeapTail=(m_wHeapTail+3)%CountArray(m_cbHeapCardInfo);
//		m_cbHeapCardInfo[m_wHeapTail][1]++;
//	}

	//Ϣ
	ASSERT( m_wHeapHead != INVALID_CHAIR && m_wHeapTail != INVALID_CHAIR );
	BYTE cbHeapCount=m_HeapCardInfo[m_wHeapHead].wRemoveCount+(HEAP_FULL_COUNT-m_HeapCardInfo[m_wHeapHead].wStartIndex);
	if(cbHeapCount==HEAP_FULL_COUNT)
	{
		m_wHeapHead=(m_wHeapHead+1)%GAME_PLAYER;
		m_HeapCardInfo[m_wHeapHead].wStartIndex=HEAP_FULL_COUNT;
	}
	m_HeapCardInfo[m_wHeapHead].wRemoveCount++;

	//
	CMD_S_SendCard SendCard;
	ZeroMemory(&SendCard,sizeof(SendCard));
	SendCard.wSendCardUser = wCurrentUser;
	SendCard.wReplaceUser=m_wReplaceUser;
	SendCard.wCurrentUser= m_wReplaceUser==INVALID_CHAIR?m_wCurrentUser:INVALID_CHAIR;
	SendCard.bTail = bTail;
	SendCard.cbCardCount=m_cbLeftCardCount;
	SendCard.bReplaceCard=bReplace;
	SendCard.bOutCardData=m_bOutCardData;
	SendCard.cbCardData=(m_wCurrentUser==wCurrentUser)?m_cbProvideCard:m_cbSendCardData;
    SendCard.cbActionMask=m_wReplaceUser==INVALID_CHAIR?m_cbUserAction[m_wCurrentUser]:WIK_NULL;
	SendCard.bCurrentTing=m_bHearStatus[m_wCurrentUser];
	if(m_cbUserAction[m_wCurrentUser]&WIK_CHI_HU&&m_dwRedoubleCount[m_wCurrentUser]<8)
	{
		DWORD dwFanShu=m_dwFanShu[m_wCurrentUser]+GetFanShu(m_wCurrentUser,m_cbProvideCard,0);
		LONGLONG lUserScore=m_pITableFrame->GetTableUserItem((m_wCurrentUser+1)%GAME_PLAYER)->GetUserScore();
		if(dwFanShu*m_lCellScore<lUserScore)
		{
			CMD_S_ShowRedouble ShowRedouble;
			ShowRedouble.dwFanCount=GetFanShu(m_wCurrentUser,m_cbProvideCard,0);
			ShowRedouble.wChairID=m_wCurrentUser;
			m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_SHOW_REDOUBLE,&ShowRedouble,sizeof(ShowRedouble));
			m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_SHOW_REDOUBLE,&ShowRedouble,sizeof(ShowRedouble));
		}
	}

	//
	m_pITableFrame->SendTableData(INVALID_CHAIR,SUB_S_SEND_CARD,&SendCard,sizeof(SendCard));
	m_pITableFrame->SendLookonData(INVALID_CHAIR,SUB_S_SEND_CARD,&SendCard,sizeof(SendCard));

	return true;
}

//Ӧж
bool CTableFrameSink::EstimateUserRespond(WORD wCenterUser, BYTE cbCenterCard, enEstimatKind EstimatKind,bool bShow)
{
	//
	bool bAroseAction=false;

	//û״̬
	ZeroMemory(m_bResponse,sizeof(m_bResponse));
	ZeroMemory(m_cbUserAction,sizeof(m_cbUserAction));
	ZeroMemory(m_cbPerformAction,sizeof(m_cbPerformAction));

	//ж
	for (WORD i=0;i<m_wPlayerCount;i++)
	{
		//û
		if (wCenterUser==i) continue;

		//
		if (EstimatKind==EstimatKind_OutCard)
		{
			//ж
			if (m_bEnjoinChiPeng[i]==false)
			{
				if(!m_bEnjoinPeng[i]||m_cbPengCard[i]!=cbCenterCard)
				{
					//ж
					m_cbUserAction[i]|=m_GameLogic.EstimatePengCard(m_cbCardIndex[i],cbCenterCard,m_WeaveItemArray[i],m_cbWeaveItemCount[i],wCenterUser);
					if(m_cbUserAction[i]&WIK_PENG)
					{
						m_bEnjoinPeng[i]=true;
						m_cbPengCard[i]=cbCenterCard;
					}
				}
				
				//ж
				WORD wEatUser=(wCenterUser+m_wPlayerCount-1)%m_wPlayerCount;
				if (wEatUser==i)
					m_cbUserAction[i]|=m_GameLogic.EstimateEatCard(m_cbCardIndex[i],cbCenterCard,m_WeaveItemArray[i],m_cbWeaveItemCount[i],wCenterUser);
			}
			//ж
			if (m_cbLeftCardCount>m_cbEndLeftCount) 
			{
				m_cbUserAction[i]|=m_GameLogic.EstimateGangCard(m_cbCardIndex[i],cbCenterCard,m_WeaveItemArray[i],m_cbWeaveItemCount[i],wCenterUser,m_bHearStatus[i]);
			}
		}

		//ж
		CChiHuRight chr;
		CChiHuRight chrhigh;
		CChiHuRight chrnew;
		BYTE cbWeaveCount=m_cbWeaveItemCount[i];
		BYTE cbAction = m_GameLogic.AnalyseChiHuCard(m_cbCardIndex[i],m_WeaveItemArray[i],cbWeaveCount,wCenterUser,
			m_wPlayerCount,cbCenterCard,chr,chrhigh,chrnew);
		
		m_cbUserAction[i] |= cbAction;

		//ж
		if (m_cbUserAction[i]!=WIK_NULL) 
			bAroseAction=true;
	}

	//
	if (bAroseAction==true) 
	{
		//ñ
		m_wProvideUser=wCenterUser;
		m_cbProvideCard=cbCenterCard;
		m_wResumeUser=m_wCurrentUser;
		m_wCurrentUser=INVALID_CHAIR;

		//ʾ
		//SendOperateTime();
		SendOperateNotify(bShow);
		return true;
	}

	return false;
}

//
BYTE CTableFrameSink::CalScore( WORD wWinner, LONGLONG lScore[GAME_PLAYER] )
{
	//ʼ
	ZeroMemory( lScore,sizeof(LONGLONG)*GAME_PLAYER );

	IServerUserItem * pIServerUserItem=m_pITableFrame->GetTableUserItem(wWinner);
	tagUserInfo * pUserData=pIServerUserItem->GetUserInfo();

	//Ʒ
	WORD wFanShuo= m_GameLogic.GetChiHuActionRank( m_ChiHuRight[wWinner],m_ChiHuHigh[wWinner],m_ChiHuNew[wWinner],
		pUserData);

	if(!m_bManGuan)
	{
		wFanShuo+=m_cbPaiMianCard;
		wFanShuo+=m_cbHuaCardCount[wWinner];
	}

	if(wFanShuo>=88)
		wFanShuo=88;

	wFanShuo+=m_dwFanShu[wWinner];

	ASSERT( wFanShuo > 0 );
	if( wFanShuo == 0 ) return 0;

	for( WORD i = 0; i < GAME_PLAYER; i++)
	{
		if(i==wWinner) continue;

		LONGLONG wPerFanshu=wFanShuo;  
		{
			LONGLONG lGameScore=wPerFanshu;
			lGameScore=wPerFanshu*m_lCellScore;
			lScore[i]=-lGameScore;
			lScore[wWinner]+=lGameScore;
		}
	}
	   
	return BYTE(wFanShuo);
}
DWORD CTableFrameSink::GetFanShu(WORD wChairID,BYTE cbCardData,BYTE cbType,bool bRedouble)
{
	CChiHuRight chr;
	CChiHuRight chrhigh;
	CChiHuRight chrnew;
	if(cbType==0)
	{
		m_cbCardIndex[wChairID][m_GameLogic.SwitchToCardIndex(cbCardData)]--;
		BYTE cbAction= m_GameLogic.AnalyseChiHuCard(m_cbCardIndex[wChairID],m_WeaveItemArray[wChairID],
			m_cbWeaveItemCount[wChairID],m_wProvideUser,wChairID,cbCardData,chr,chrhigh,chrnew);
		m_cbCardIndex[wChairID][m_GameLogic.SwitchToCardIndex(cbCardData)]++;
		if(cbAction!=WIK_CHI_HU)
			return 0;
	}
	else
	{
		BYTE cbAction= m_GameLogic.AnalyseChiHuCard(m_cbCardIndex[wChairID],m_WeaveItemArray[wChairID],
			m_cbWeaveItemCount[wChairID],m_wProvideUser,wChairID,cbCardData,chr,chrhigh,chrnew);
		if(cbAction!=WIK_CHI_HU)
			return 0;
	}

	FiltrateRight(wChairID,chr,chrhigh,chrnew);

	IServerUserItem * pIServerUserItem=m_pITableFrame->GetTableUserItem(wChairID);
	tagUserInfo * pUserData=pIServerUserItem->GetUserInfo();

	//Ʒ
	DWORD dwFanShu= m_GameLogic.GetChiHuActionRank(chr,chrhigh,chrnew,pUserData);

	if(dwFanShu>=88)
		dwFanShu=88;

	if(bRedouble)
		return dwFanShu;
	else
		return dwFanShu*2;
}
DWORD CTableFrameSink::GetFanShu(WORD wChairID,BYTE cbCardIndex[MAX_INDEX],BYTE cbCardData)
{
	CChiHuRight chr;
	CChiHuRight chrhigh;
	CChiHuRight chrnew;
	BYTE cbAction= m_GameLogic.AnalyseChiHuCard(cbCardIndex,m_WeaveItemArray[wChairID],
		m_cbWeaveItemCount[wChairID],m_wProvideUser,wChairID,cbCardData,chr,chrhigh,chrnew);
	if(cbAction!=WIK_CHI_HU)
		ASSERT(FALSE);

	FiltrateRight(wChairID,chr,chrhigh,chrnew,m_cbProvideCard==cbCardData);

	IServerUserItem * pIServerUserItem=m_pITableFrame->GetTableUserItem(wChairID);
	tagUserInfo * pUserData=pIServerUserItem->GetUserInfo();

	//Ʒ
	DWORD dwFanShu= m_GameLogic.GetChiHuActionRank(chr,chrhigh,chrnew,pUserData);

	if(dwFanShu>=88)
		dwFanShu=88;

	return dwFanShu;
}
//ϵͳƻȡ
BYTE CTableFrameSink::GetMagicIndex( BYTE cbFanCard )
{
	BYTE cbZPaiIndex = m_GameLogic.SwitchToCardIndex(cbFanCard);
	if( cbZPaiIndex < 27 )
	{
		if( (cbZPaiIndex+1)%9 == 0 )
			cbZPaiIndex -= 8;
		else
			cbZPaiIndex++;
	}
	else
	{
		if( cbZPaiIndex + 1 == MAX_INDEX )
			cbZPaiIndex = 27;
		else
			cbZPaiIndex++;
	}
	return cbZPaiIndex;
}

//ȡ
BYTE CTableFrameSink::GetDiscardCount( BYTE cbCardData )
{
	BYTE cbCount = 0;
	//
	for( WORD i = 0; i < GAME_PLAYER; i++ )
	{
		for( BYTE j = 0; j < m_cbDiscardCount[i]; j++ )
		{
			if( m_cbDiscardCard[i][j] == cbCardData )
				if( ++cbCount == 4 ) break;
		}
	}
	if( cbCount < 4 )
	{
		//
		for( WORD i = 0; i < GAME_PLAYER; i++ )
		{
			for( BYTE j = 0; j < m_cbWeaveItemCount[i]; j++ )
			{
				//if( !m_WeaveItemArray[i][j].cbPublicCard ) continue;
				BYTE cbCardBuffer[4];
				BYTE cbCardCount = m_GameLogic.GetWeaveCard( m_WeaveItemArray[i][j].cbWeaveKind,
					m_WeaveItemArray[i][j].cbCenterCard,cbCardBuffer );
				for( BYTE k = 0; k < cbCardCount; k++ )
					if( cbCardBuffer[k] == cbCardData )
						if( ++cbCount == 4 ) break;
			}
		}
	}

	return cbCount;
}

//Ȩλ
void CTableFrameSink::FiltrateRight( WORD wWinner, CChiHuRight &chr ,CChiHuRight &chrhigh,CChiHuRight &chrnew)
{
	/*	Ȩλ	*/

	m_bManGuan=false;
	//
	if( wWinner == m_wProvideUser )
	{
		chr |= CHR_ZI_MO;
	}

	if(m_cbLeftCardCount==0&&m_cbLaoYueCount==0)
	{
		if(wWinner==m_wProvideUser)
		{
			chr|=CHR_MIAO_SHOU;
			chr&=~CHR_ZI_MO;
		}
	}

	if(m_cbLaoYueCount!=0)
	{
		chr|=CHR_HAI_DI;
	}

	if( m_bGangStatus )
	{
		//
		if( wWinner == m_wProvideUser )
		{
			chr |= CHR_ZI_MO;
		}
		//Ͽ
		if( !(chr&CHR_ZI_MO).IsEmpty() )
		{
			chr |= CHR_GANG_KAI;
			chr&=~CHR_ZI_MO;
			m_bQiangGang=false;
			
		}
	}

	if(m_bQiangGang)
	{
		chr|=CHR_QIANG_GANG;
		chr&=~CHR_JUE_ZHANG;
	}

	if(m_cbPaiMianCard>0)
	{
		chrnew|=CHR_PAI_MIAN;
	}

	if(m_bKan[wWinner])
	{
		chrnew|=CHR_KAN_ZHANG;
	}

	if(!(chrnew&CHR_BIAN_ZHANG).IsEmpty())
	{
		chrnew&=~CHR_KAN_ZHANG;
	}

	if(!(chr&CHR_DAN_DIAO).IsEmpty())
	{
		chrnew&=~CHR_KAN_ZHANG;
	}

	if(!(chrnew&CHR_BIAN_ZHANG).IsEmpty()&&!(chr&CHR_DAN_DIAO).IsEmpty())
	{
		chrnew&=~CHR_BIAN_ZHANG;
	}

	if(m_cbHuaCardCount[wWinner]>0)
	{
		chrnew|=CHR_HUA_CARD;
	}

	if(!(chrhigh&CHR_QI_DUI).IsEmpty())
	{
		chrnew&=~CHR_KAN_ZHANG;
	}

	BYTE tempcount=0;
	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		for(BYTE j=0;j<m_cbDiscardCount[i];j++)
		{
			if(m_cbDiscardCard[i][j]==m_cbProvideCard)
			{
				tempcount++;
			}
		}

		for(BYTE j=0;j<m_cbWeaveItemCount[i];j++)
		{
			for(BYTE z=0;z<4;z++)
			{
				if(m_WeaveItemArray[i][j].cbCardData[z]==m_cbProvideCard)
				{
					tempcount++;
				}
			}
		}
	}

	if(m_cbOutCardData==m_cbProvideCard)
		tempcount++;

	//if(m_cbCardIndex[wWinner][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)]>0)
	//{
	//	tempcount+=m_cbCardIndex[wWinner][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)];
	//}

	if(tempcount==4)
		chr |= CHR_JUE_ZHANG;

	if(m_bHearStatus[wWinner])
	{
		if(!(chr&CHR_MEN_QI_QING).IsEmpty())
			chr|=CHR_LI_ZHI;
		else
			chr|=CHR_TING_CARD;
	}

	if((!(chr&CHR_ZI_MO).IsEmpty())&&(!(chr&CHR_MEN_QI_QING).IsEmpty()))
	{
		chr |= CHR_MENQING_ZIMO;
		chr&=~CHR_ZI_MO;
		chr&=~CHR_MEN_QI_QING;
	}
	if((!(chrhigh&CHR_QING_LONG).IsEmpty()))
	{
		chr&=~CHR_LIAN_6;
		chr&=~CHR_LAO_SHAO_F;
	}
	if((!(chrhigh&CHR_YISE_SIBU).IsEmpty()))
	{
		chr&=~CHR_DOUBLE_ANKE;
	}
	if((!(chrhigh&CHR_QING_LAOTOU).IsEmpty()))
	{
		chr&=~CHR_PENG_PENG;
		chr&=~CHR_YAO_JIU_KE;
		chr&=~CHR_QUAN_DAI_YAO;
	}
	if((!(chrhigh&CHR_LONG_QI_DUI).IsEmpty()))
	{
		chrhigh&=~CHR_QI_DUI;
		chr&=~CHR_SI_GUI_YI;
	}
	if((!(chrhigh&CHR_YISE_SANTONG).IsEmpty()))
	{
		chrhigh&=~CHR_THREE_ANKE;
	}
	if((!(chrhigh&CHR_YISE_SITONG).IsEmpty()))
	{
		chrhigh&=~CHR_LONG_QI_DUI;
	}
	if((!(chrhigh&CHR_YISE_SIJIE).IsEmpty()))
	{
		chrhigh&=~CHR_YISE_SANTONG;
		chr&=~CHR_PENG_PENG;
	}
	if(m_cbSendCardCount==1&&m_cbOutCardCount==0)
	{
		chrhigh|=CHR_TIAN_HU;
	}

	if(m_cbSendCardCount==1&&m_cbOutCardCount==1)
	{
		chrhigh|=CHR_DI_HU;
	}

	if((!(chrhigh&CHR_CHUN_QUAN_DAI_YI).IsEmpty()))
	{
		chr&=~CHR_QUAN_DAI_YAO;
	}

	if((!(chrhigh&CHR_YISE_SHUANG_LONG).IsEmpty()))
	{
		chrhigh&=~CHR_QI_DUI;
	}

	CChiHuRight tempRight,tempDa;
	tempRight.SetEmpty();
	tempDa.SetEmpty();
	if((!(chrhigh&CHR_XIAO_SI_XI).IsEmpty()))
	{
		tempRight|=CHR_XIAO_SI_XI;
	}
	if((!(chrhigh&CHR_XIAO_SAN_YUAN).IsEmpty()))
	{
		tempRight|=CHR_XIAO_SAN_YUAN;
	}
	if((!(chrhigh&CHR_ZI_YI_SE).IsEmpty()))
	{
		tempRight|=CHR_ZI_YI_SE;
	}
	if((!(chrhigh&CHR_SI_AN_KE).IsEmpty()))
	{
		tempRight|=CHR_SI_AN_KE;
	}
	if((!(chrhigh&CHR_YISE_SHUANG_LONG).IsEmpty()))
	{
		tempRight|=CHR_YISE_SHUANG_LONG;
	}
	if((!(chrhigh&CHR_TIAN_HU).IsEmpty()))
	{
		tempRight|=CHR_TIAN_HU;
	}
	if((!(chrhigh&CHR_DI_HU).IsEmpty()))
	{
		tempRight|=CHR_DI_HU;
	}

	if((!(chrhigh&CHR_DA_SI_XI).IsEmpty()))
	{
		tempDa|=CHR_DA_SI_XI;
	}
	if((!(chrhigh&CHR_DA_SAN_YUAN).IsEmpty()))
	{
		tempDa|=CHR_DA_SAN_YUAN;
	}
	if((!(chrhigh&CHR_JIU_LIAN).IsEmpty()))
	{
		tempDa|=CHR_JIU_LIAN;
	}
	if((!(chrhigh&CHR_SHI_BA).IsEmpty()))
	{
		tempDa|=CHR_SHI_BA;
	}
	if((!(chrhigh&CHR_LIAN_QI_DUI).IsEmpty()))
	{
		tempDa|=CHR_LIAN_QI_DUI;
	}
	if((!(chrhigh&CHR_DA_5).IsEmpty()))
	{
		tempDa|=CHR_DA_5;
	}
	if((!(chrhigh&CHR_XIAO_5).IsEmpty()))
	{
		tempDa|=CHR_XIAO_5;
	}

	if(!(tempDa.IsEmpty()))
	{
		chrhigh.SetEmpty();
		chr.SetEmpty();
		chrnew.SetEmpty();
		chrhigh=tempDa;
		m_bManGuan=true;
	}
	else if(!(tempRight.IsEmpty()))
	{
		if((!(chrhigh&CHR_LONG_QI_DUI).IsEmpty()))
		{
			tempRight|=CHR_LONG_QI_DUI;
		}
		if((!(chrhigh&CHR_QI_DUI).IsEmpty()))
		{
			tempRight|=CHR_QI_DUI;
		}
		chrhigh.SetEmpty();
		chr.SetEmpty();
		chrnew.SetEmpty();
		chrhigh=tempRight;
		m_bManGuan=true;
	}
}
void CTableFrameSink::FiltrateRight(WORD wWinner, CChiHuRight &chr ,CChiHuRight &chrhigh,CChiHuRight &chrnew,bool bChiHu)
{
	m_bManGuan=false;

	if(bChiHu)
	{
		//
		if( wWinner == m_wProvideUser )
		{
			chr |= CHR_ZI_MO;
		}
	}

	if(m_cbLeftCardCount==0&&m_cbLaoYueCount==0)
	{
		if(wWinner==m_wProvideUser)
		{
			chr|=CHR_MIAO_SHOU;
			chr&=~CHR_ZI_MO;
		}
	}

	if(m_cbLaoYueCount!=0)
	{
		chr|=CHR_HAI_DI;
	}

	if(bChiHu)
	{
		if( m_bGangStatus )
		{
			//
			if( wWinner == m_wProvideUser )
			{
				chr |= CHR_ZI_MO;
			}
			//Ͽ
			if( !(chr&CHR_ZI_MO).IsEmpty() )
			{
				chr |= CHR_GANG_KAI;
				chr&=~CHR_ZI_MO;
				m_bQiangGang=false;
			}
		}
	}

	if(m_bQiangGang)
	{
		chr|=CHR_QIANG_GANG;
		chr&=~CHR_JUE_ZHANG;
	}

	if(m_cbPaiMianCard>0)
	{
		chrnew|=CHR_PAI_MIAN;
	}

	if(m_bKan[wWinner])
	{
		chrnew|=CHR_KAN_ZHANG;
	}

	if(!(chrnew&CHR_BIAN_ZHANG).IsEmpty())
	{
		chrnew&=~CHR_KAN_ZHANG;
	}

	if(!(chr&CHR_DAN_DIAO).IsEmpty())
	{
		chrnew&=~CHR_KAN_ZHANG;
	}

	if(!(chrnew&CHR_BIAN_ZHANG).IsEmpty()&&!(chr&CHR_DAN_DIAO).IsEmpty())
	{
		chrnew&=~CHR_BIAN_ZHANG;
	}

	if(m_cbHuaCardCount[wWinner]>0)
	{
		chrnew|=CHR_HUA_CARD;
	}

	if(!(chrhigh&CHR_QI_DUI).IsEmpty())
	{
		chrnew&=~CHR_KAN_ZHANG;
	}

	BYTE tempcount=0;
	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		for(BYTE j=0;j<m_cbDiscardCount[i];j++)
		{
			if(m_cbDiscardCard[i][j]==m_cbProvideCard)
			{
				tempcount++;
			}
		}

		for(BYTE j=0;j<m_cbWeaveItemCount[i];j++)
		{
			for(BYTE z=0;z<4;z++)
			{
				if(m_WeaveItemArray[i][j].cbCardData[z]==m_cbProvideCard)
				{
					tempcount++;
				}
			}
		}
	}

	//if(m_cbCardIndex[wWinner][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)]>0)
	//{
	//	tempcount+=m_cbCardIndex[wWinner][m_GameLogic.SwitchToCardIndex(m_cbProvideCard)];
	//}

	if(tempcount==4)
		chr |= CHR_JUE_ZHANG;

	if(m_bHearStatus[wWinner])
	{
		if(!(chr&CHR_MEN_QI_QING).IsEmpty())
			chr|=CHR_LI_ZHI;
		else
			chr|=CHR_TING_CARD;
	}

	if((!(chr&CHR_ZI_MO).IsEmpty())&&(!(chr&CHR_MEN_QI_QING).IsEmpty()))
	{
		chr |= CHR_MENQING_ZIMO;
		chr&=~CHR_ZI_MO;
		chr&=~CHR_MEN_QI_QING;
	}
	if((!(chrhigh&CHR_QING_LONG).IsEmpty()))
	{
		chr&=~CHR_LIAN_6;
		chr&=~CHR_LAO_SHAO_F;
	}
	if((!(chrhigh&CHR_YISE_SIBU).IsEmpty()))
	{
		chr&=~CHR_DOUBLE_ANKE;
	}
	if((!(chrhigh&CHR_QING_LAOTOU).IsEmpty()))
	{
		chr&=~CHR_PENG_PENG;
		chr&=~CHR_YAO_JIU_KE;
		chr&=~CHR_QUAN_DAI_YAO;
	}
	if((!(chrhigh&CHR_LONG_QI_DUI).IsEmpty()))
	{
		chrhigh&=~CHR_QI_DUI;
		chr&=~CHR_SI_GUI_YI;
	}
	if((!(chrhigh&CHR_YISE_SANTONG).IsEmpty()))
	{
		chrhigh&=~CHR_THREE_ANKE;
	}
	if((!(chrhigh&CHR_YISE_SITONG).IsEmpty()))
	{
		chrhigh&=~CHR_LONG_QI_DUI;
	}
	if((!(chrhigh&CHR_YISE_SIJIE).IsEmpty()))
	{
		chrhigh&=~CHR_YISE_SANTONG;
		chr&=~CHR_PENG_PENG;
	}
	if(m_cbSendCardCount==1&&m_cbOutCardCount==0)
	{
		chrhigh|=CHR_TIAN_HU;
	}

	if(m_cbSendCardCount==1&&m_cbOutCardCount==1)
	{
		chrhigh|=CHR_DI_HU;
	}

	if((!(chrhigh&CHR_YISE_SHUANG_LONG).IsEmpty()))
	{
		chrhigh&=~CHR_QI_DUI;
	}

	if((!(chrhigh&CHR_CHUN_QUAN_DAI_YI).IsEmpty()))
	{
		chr&=~CHR_QUAN_DAI_YAO;
	}

	CChiHuRight tempRight,tempDa;
	tempRight.SetEmpty();
	tempDa.SetEmpty();
	if((!(chrhigh&CHR_XIAO_SI_XI).IsEmpty()))
	{
		tempRight|=CHR_XIAO_SI_XI;
	}
	if((!(chrhigh&CHR_XIAO_SAN_YUAN).IsEmpty()))
	{
		tempRight|=CHR_XIAO_SAN_YUAN;
	}
	if((!(chrhigh&CHR_ZI_YI_SE).IsEmpty()))
	{
		tempRight|=CHR_ZI_YI_SE;
	}
	if((!(chrhigh&CHR_SI_AN_KE).IsEmpty()))
	{
		tempRight|=CHR_SI_AN_KE;
	}
	if((!(chrhigh&CHR_YISE_SHUANG_LONG).IsEmpty()))
	{
		tempRight|=CHR_YISE_SHUANG_LONG;
	}
	if((!(chrhigh&CHR_TIAN_HU).IsEmpty()))
	{
		tempRight|=CHR_TIAN_HU;
	}
	if((!(chrhigh&CHR_DI_HU).IsEmpty()))
	{
		tempRight|=CHR_DI_HU;
	}

	if((!(chrhigh&CHR_DA_SI_XI).IsEmpty()))
	{
		tempDa|=CHR_DA_SI_XI;
	}
	if((!(chrhigh&CHR_DA_SAN_YUAN).IsEmpty()))
	{
		tempDa|=CHR_DA_SAN_YUAN;
	}
	if((!(chrhigh&CHR_JIU_LIAN).IsEmpty()))
	{
		tempDa|=CHR_JIU_LIAN;
	}
	if((!(chrhigh&CHR_SHI_BA).IsEmpty()))
	{
		tempDa|=CHR_SHI_BA;
	}
	if((!(chrhigh&CHR_LIAN_QI_DUI).IsEmpty()))
	{
		tempDa|=CHR_LIAN_QI_DUI;
	}
	if((!(chrhigh&CHR_DA_5).IsEmpty()))
	{
		tempDa|=CHR_DA_5;
	}
	if((!(chrhigh&CHR_XIAO_5).IsEmpty()))
	{
		tempDa|=CHR_XIAO_5;
	}

	if(!(tempDa.IsEmpty()))
	{
		chrhigh.SetEmpty();
		chr.SetEmpty();
		chrnew.SetEmpty();
		chrhigh=tempDa;
		m_bManGuan=true;
	}
	else if(!(tempRight.IsEmpty()))
	{
		if((!(chrhigh&CHR_LONG_QI_DUI).IsEmpty()))
		{
			tempRight|=CHR_LONG_QI_DUI;
		}
		if((!(chrhigh&CHR_QI_DUI).IsEmpty()))
		{
			tempRight|=CHR_QI_DUI;
		}
		chrhigh.SetEmpty();
		chr.SetEmpty();
		chrnew.SetEmpty();
		chrhigh=tempRight;
		m_bManGuan=true;
	}
}
//////////////////////////////////////////////////////////////////////////
