#ifndef CMD_SPARROW_HEAD_FILE
#define CMD_SPARROW_HEAD_FILE
#pragma pack(1)
//////////////////////////////////////////////////////////////////////////
//궨
//#ifdef _DEBUG
#define KIND_ID						901									//Ϸ I D
//#else
  // #define KIND_ID						322									//Ϸ I D
//#endif
   
#define GAME_PLAYER					2									//Ϸ
#define GAME_NAME					TEXT("ȸ")					//Ϸ
#define GAME_GENRE					(GAME_GENRE_SCORE|GAME_GENRE_MATCH|GAME_GENRE_GOLD)	//Ϸ

#define VERSION_SERVER				 100728832       // PROCESS_VERSION(1,0,0)
#define VERSION_CLIENT				 100728832       // PROCESS_VERSION(1,0,0)


//Ϸ״̬
#define GS_MJ_FREE					GAME_STATUS_FREE							//״̬
#define GS_MJ_PLAY					(GAME_STATUS_PLAY+1)						//Ϸ״̬
#define GS_MJ_END					(GAME_STATUS_PLAY+2)

//
#define MAX_WEAVE					4									//
#define MAX_INDEX					42									//
#define MAX_COUNT					14									//Ŀ
#define MAX_REPERTORY				72									//
#define MAX_HUA_CARD				8									//Ƹ

//˿˶
#define HEAP_FULL_COUNT				36									//ȫ

#define MAX_RIGHT_COUNT				3									//ȨλDWORD			

//////////////////////////////////////////////////////////////////////////

//
struct CMD_WeaveItem
{
	DWORD							cbWeaveKind;						//
	BYTE							cbCenterCard;						//˿
	BYTE							cbPublicCard;						//־
	WORD							wProvideUser;						//Ӧû
	BYTE							cbCardData[4];						//
};
struct CMD_HeapCardInfo
{
	WORD			wStartIndex;
	WORD			wRemoveCount;
};
//////////////////////////////////////////////////////////////////////////
//ṹ

#define SUB_S_GAME_START			100									//Ϸʼ
#define SUB_S_OUT_CARD				101									//
#define SUB_S_SEND_CARD				102									//˿
#define SUB_S_OPERATE_NOTIFY		103									//ʾ
#define SUB_S_OPERATE_RESULT		104									//
#define SUB_S_GAME_END				105									//Ϸ
#define SUB_S_TRUSTEE				106									//ûй
#define SUB_S_LISTEN				107									//û
#define SUB_S_REPLACE_CARD			108									//û
#define SUB_S_SEND_CELL				109
#define SUB_S_SEND_SET				110
#define SUB_S_DUI_HUA				111
#define SUB_S_CONTINUE_DH			112
#define SUB_S_HAI_DI				113
#define SUB_S_CONTINUE_HD			114
#define SUB_S_LISTEN_SET			115
#define SUB_S_SHOW_REDOUBLE			116
#define SUB_S_REDOUBLE				117
#define SUB_S_SHOW_THINK			118
#define SUB_S_UPDATA_TINFO			119
#define SUB_S_START_OVER			120

//Ϸ״̬
struct CMD_S_StatusFree
{
	LONGLONG						lCellScore;							//
	WORD							wBankerUser;						//ׯû
	bool							bTrustee[GAME_PLAYER];				//Ƿй
	bool							bPlayerSitDown;
};
struct CMD_S_SendCell
{
	LONGLONG						lCellScore;							//
	WORD							wChairID;
};
struct CMD_S_SendSet
{
	WORD							wChairID;
};
//û
struct CMD_S_ContinueGame
{
	WORD							wChairID;							//û
};
//Ϸ״̬
struct CMD_S_StatusPlay
{
	//Ϸ
	LONGLONG						lCellScore;									//Ԫ
	WORD							wBankerUser;								//ׯû
	WORD							wCurrentUser;								//ǰû
	WORD							wReplaceUser;								//滻û
	LONG							lSiceCount;									//ӵ
	BYTE							cbHuaCardCount[GAME_PLAYER];				//Ŀ

	//״̬
	BYTE							cbActionCard;								//˿
	DWORD							cbActionMask;								//
	BYTE							cbHearStatus[GAME_PLAYER];					//״̬
	BYTE							cbLeftCardCount;							//ʣĿ
	bool							bTrustee[GAME_PLAYER];						//Ƿй
	bool							bHearStatus[GAME_PLAYER];					//״̬
	bool							bWillHearStatus;
	bool							bOutCardData;//
	DWORD							dwFanShu[GAME_PLAYER];

	//Ϣ
	WORD							wOutCardUser;								//û
	BYTE							cbOutCardData;								//˿
	BYTE							cbDiscardCount[GAME_PLAYER];				//Ŀ
	BYTE							cbDiscardCard[GAME_PLAYER][60];				//¼

	//˿
	BYTE							cbCardCount;								//˿Ŀ
	BYTE							cbCardData[MAX_COUNT];						//˿б
	BYTE							cbSendCardData;								//˿ 

	//˿
	BYTE							cbWeaveCount[GAME_PLAYER];					//Ŀ
	CMD_WeaveItem					WeaveItemArray[GAME_PLAYER][MAX_WEAVE];		//˿

	//Ϣ
	WORD							wHeapHead;									//ͷ
	WORD							wHeapTail;									//β
	CMD_HeapCardInfo				HeapCardInfo[GAME_PLAYER];
	//BYTE							cbHeapCardInfo[GAME_PLAYER][2];				//Ϣ
};

struct CMD_S_StatusEnd
{

	//Ϸ
	LONGLONG						lCellScore;									//Ԫ
	WORD							wBankerUser;								//ׯû
	WORD							wCurrentUser;								//ǰû
	WORD							wReplaceUser;								//滻û
	LONG							lSiceCount;									//ӵ
	BYTE							cbHuaCardCount[GAME_PLAYER];				//Ŀ

	//״̬
	BYTE							cbActionCard;								//˿
	DWORD							cbActionMask;								//
	BYTE							cbHearStatus[GAME_PLAYER];					//״̬
	BYTE							cbLeftCardCount;							//ʣĿ
	bool							bTrustee[GAME_PLAYER];						//Ƿй
	bool							bHearStatus[GAME_PLAYER];					//״̬
	bool							bWillHearStatus;							//

	//Ϣ
	WORD							wOutCardUser;								//û
	BYTE							cbOutCardData;								//˿
	BYTE							cbDiscardCount[GAME_PLAYER];				//Ŀ
	BYTE							cbDiscardCard[GAME_PLAYER][60];				//¼

	//˿
	BYTE							cbCardCount[GAME_PLAYER];					//˿Ŀ
	BYTE							cbCardData[GAME_PLAYER][MAX_COUNT];			//˿б
	BYTE							cbProvideCard;								//˿

	bool							bDuiHuaStatus;
	bool							bHaiDiStatus;
	WORD							wEndChairID;
	BYTE							cbEndPlayData[10];
	BYTE							cbShowPlayCard[10];

	//˿
	BYTE							cbWeaveCount[GAME_PLAYER];					//Ŀ
	CMD_WeaveItem					WeaveItemArray[GAME_PLAYER][MAX_WEAVE];		//˿
};

//Ϸʼ
struct CMD_S_GameStart
{ 
   	LONG							lSiceCount;									//ӵ
	WORD							wBankerUser;								//ׯû
	WORD							wCurrentUser;								//ǰû
	WORD							wReplaceUser;								//û
	DWORD							cbUserAction;					 			//û
	BYTE							cbCardData[MAX_COUNT];		            	//˿б
	bool							bOutCardData;
	WORD							wHeapHead;									//ͷ
	WORD							wHeapTail;									//β
	bool							bAllAndroidUser;
	//BYTE							cbHeapCardInfo[GAME_PLAYER][2];				//Ϣ
	CMD_HeapCardInfo				HeapCardInfo[GAME_PLAYER];
};
//ս
struct CMD_S_ShowRedouble
{
	WORD							wChairID;
	DWORD							dwFanCount;
};
//
struct CMD_S_OutCard
{
	WORD							wOutCardUser;						//û
	BYTE							cbOutCardData;						//˿
	bool							bCurrentTing;
	bool                            bDelte;
};
struct CMD_S_Redouble
{
	WORD							wChairID;
	DWORD							dwFanShu[GAME_PLAYER];
};
//˿
struct CMD_S_SendCard
{
	BYTE							cbCardData;							//˿
	DWORD							cbActionMask;						//
	WORD							wCurrentUser;						//ǰû
	WORD							wReplaceUser;						//û
	WORD							wSendCardUser;						//û
	bool							bTail;								//ĩβ
	bool							bOutCardData;
	BYTE				            cbCardCount;
	bool							bReplaceCard;
	bool							bCurrentTing;
};

//ʾ
struct CMD_S_OperateNotify
{
	WORD							wResumeUser;						//ԭû
	DWORD							cbActionMask;						//
	BYTE							cbActionCard;						//˿
	bool							bShow;
};
struct CMD_S_ShowThink
{
	WORD							wChairID;
	bool							bShowThink;
};
//
struct CMD_S_OperateResult
{
	WORD							wOperateUser;						//û
	WORD							wProvideUser;						//Ӧû
	DWORD							cbOperateCode;						//
	BYTE							cbOperateCard[3];					//˿
};
//Ի
struct CMD_S_DuiHua
{
	WORD							wChairID;							//Իû
	BYTE							cbDuiHuaCard[10];					//Ի˿
	WORD							wProvideUser;						//Ӧû
	BYTE							cbProvideCard;						//Ӧ˿
	DWORD							dwChiHuKind[GAME_PLAYER];			//
	//˿Ϣ
	BYTE							cbCardCount[GAME_PLAYER];			//˿Ŀ
	BYTE							cbCardData[GAME_PLAYER][MAX_COUNT];	//˿
};
//
struct CMD_S_HaiDi
{
	WORD							wChairID;
	BYTE							cbHaiDiCard[10];
};
//Ϸ
struct CMD_S_GameEnd
{
	LONG                            lCellScore;                          //Ԫ
	LONG							lGameTax;							//Ϸ˰
	//Ϣ
	WORD							wChengBaoUser;						//аû
	WORD							wProvideUser;						//Ӧû
	BYTE							cbProvideCard;						//Ӧ˿
	bool							bUserOut;
	BYTE							cbHuaCardCount;						//Ƹ
	BYTE							cbPaiMianCard;
	DWORD							dwChiHuKind[GAME_PLAYER];			//
	DWORD							dwChiHuRight[MAX_RIGHT_COUNT];		//
	DWORD							dwChiHuHigh[MAX_RIGHT_COUNT];
	DWORD							dwChiHuNew[MAX_RIGHT_COUNT];
	DWORD							dwFanShu;

	//Ϣ
    BYTE                            cbMingGangCount;					//ܸ    
	BYTE                            cbAnGangCount;						//ܸ

	//Ϣ
	LONGLONG						lGameScore[GAME_PLAYER];			//Ϸ
	LONGLONG						lGameGold[GAME_PLAYER];				//Ϸ

	//˿Ϣ
	BYTE							cbCardCount[GAME_PLAYER];			//˿Ŀ
	BYTE							cbCardData[GAME_PLAYER][MAX_COUNT];	//˿
};

//ûй
struct CMD_S_Trustee
{
	bool							bTrustee;							//Ƿй
	WORD							wChairID;							//йû
};

//û
struct CMD_S_Listen
{
	WORD							wChairId;							//û
	BYTE							cbDiscardCount[GAME_PLAYER];				//Ŀ
	BYTE							cbDiscardCard[GAME_PLAYER][60];				//¼
};
struct CMD_S_ListenSet
{
	WORD							wChairID;
	bool							bListen;
};

//
struct CMD_S_ReplaceCard
{
	WORD							wReplaceUser;						//û
	BYTE							cbReplaceCard;						//˿
	bool							bOutCardData;
	BYTE							cbHuaCardCount[GAME_PLAYER];		//Ŀ
};
struct CMD_S_ContinueDH
{
	WORD							wChairID;
	bool							bContinue;
	BYTE							cbCardData;
};
struct CMD_S_ContinueHD
{
	WORD							wChiarID;
	bool							bHaiDiOver;
	bool							bContinue;
};
struct CMD_S_UpDataTInfo
{
	BYTE							cbInfoCount;
	BYTE							cbCardData[MAX_COUNT];
	BYTE							cbCount[MAX_COUNT];
	DWORD							dwFanShu[MAX_COUNT];
};
//////////////////////////////////////////////////////////////////////////
//ͻṹ

#define SUB_C_OUT_CARD				1									//
#define SUB_C_OPERATE_CARD			3									//˿
#define SUB_C_TRUSTEE				4									//ûй
#define SUB_C_LISTEN				2									//û
#define SUB_C_SENDCELL				7
#define SUB_C_REPLACE_CARD			8									//û
#define SUB_C_DUIHUA_CARD			9		
#define SUB_C_HAIDI_CARD			10
#define SUB_C_HAIDI_CONTINUE		11
#define SUB_C_LISTEN_SET			12
#define SUB_C_LEAVE					13
#define SUB_C_REDOUBLE				14
#define SUB_C_SHOW_THINK			15
#define SUB_C_START_OVER			16

//
struct CMD_C_OutCard
{
	BYTE							cbCardData;							//˿
};

//
struct CMD_C_OperateCard
{
	DWORD							cbOperateCode;						//
	BYTE							cbOperateCard[3];					//˿
};

//ûй
struct CMD_C_Trustee
{
	bool							bTrustee;							//Ƿй	
};

//
struct CMD_C_ReplaceCard
{
	BYTE							cbCardData;							//˿
};
struct CMD_C_PlayerOut
{
	WORD							wOutChairID;
};
struct CMD_C_CellScore
{
	LONGLONG						lCellScore;
};
//Իѡ
struct CMD_C_DuiHuaCard
{
	BYTE							cbCardData;
};
//ѡ
struct CMD_C_HaiDiCard
{
	BYTE							cbCardData;
};
//
struct CMD_C_ListenSet
{
	bool							bListen;
};
struct CMD_C_Redouble
{
	DWORD							dwRedouble;
};
struct CMD_C_ShowThink
{
	bool							bShowThink;
};
//////////////////////////////////////////////////////////////////////////

#pragma pack()
#endif
