#ifndef DRAW_BELL
#define DRAW_BELL

#pragma once
#include "Stdafx.h"
#include "Resource.h"
#include "cassert"

class CBellFlash
{
	//λñ
protected:
	int								m_nItemWidth;						//߶
	int								m_nItemHeight;						//
	//Դ
protected:
	MySprite						*m_pBellImage;
	//
public:
	//캯
	CBellFlash();
	//
	virtual ~CBellFlash();
	//Ϣ
public:
	//ȡ
	int GetViewWidth() { return m_nItemWidth; }
	//ȡ߶
	int GetViewHeight() { return m_nItemHeight; }

	//Դ
public:
	//Դ
	bool LoadResource(HTEXTURE tex,float cbWidth,float cbHeight);
	//ͷԴ
	bool DestroyResource();

	//ܺ
public:
	//滭˿
	inline bool DrawCardItem(BYTE cbIndex, float xDest, float yDest);
};

//˿Դ
class CBellResource
{
public:
	CBellFlash		m_BellFlash;
	//
public:
	//캯
	CBellResource();
	//
	virtual ~CBellResource();

	//ܺ
public:
	//Դ
	bool LoadResource();
	//Դ
	bool DestroyResource();
};

class CDrawBell :
	public hgeItemContainer
{
private:
	DWORD		m_dwFrame;
	DWORD		m_dwSpeed;
protected:
	hgePoint	m_hgePoint;
	bool		m_bStart;
	bool		m_bStop;
public:
	CDrawBell(const tstring& strName);
public:
	~CDrawBell(void);
public:
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	void SetPoint(hgePoint point);
	void UpData();
	void Stop();
	void Start();
	bool IsStart(){return m_bStart;}
};

//////////////////////////////////////////////////////////////////////////

//
extern CBellResource				g_BellResource;						//˿Դ

//////////////////////////////////////////////////////////////////////////
#endif