#ifndef DRAW_MESSAGE
#define DRAW_MESSAGE

#pragma once

#include "Stdafx.h"
#include "GfxFont.h"

//
struct tagSystemItem 
{
	tstring				SystemString;
	hgePoint			ptExcusion;										//Ի׼λ
};

//ģ
typedef	CWHArray<tagSystemItem>	CSystemItemArray;

class CDrawMessage :
	public hgeItemContainer
{
protected:
	tstring				m_SystemString;
	float				m_fSysXpos;
	float				m_fSysYpos;
	hgePoint			m_ptBack;
private:
	CSystemItemArray	m_ItemArray;
private:
	GfxFont				*m_pSysFont;
	GfxFont				*m_pSayFont;
	MySprite			*m_pSprite;
private:
	MySprite			*m_pLeftSay;
	MySprite			*m_pRightSay;
	MySprite			*m_pMySay;
	hgePoint			m_ptSay[GAME_PLAYER];
protected:
	tstring				m_UserSay[GAME_PLAYER];
	bool				m_bUserSay[GAME_PLAYER];
	BYTE				m_cbSayIndex[GAME_PLAYER];
public:
	CDrawMessage(const tstring &strname);
public:
	~CDrawMessage(void);
public:
	void Init();
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	void DrawTextString(const tstring &str,COLORREF crText,float nXPos,float nYPos);
	void DrawTextSay(const tstring &str,COLORREF crText,float nXPos,float nYPos);
	long GetTestLong(const tstring &str);
	void SetSystem(const tstring &strmessage);
	void SetUserSay(const tstring &strsay,WORD wChairID);
	void Update(DWORD dwDelTick);
	void SetPoint(hgePoint point);
};
#endif