#ifndef END_PLAY_HEAD_FILE
#define END_PLAY_HEAD_FILE

#pragma once

#include "Stdafx.h"

struct tagCardInfo
{
	BYTE		cbCardData;
	hgeRect		rcCard;
	bool		bShow;
	bool		bGrayed;
};

typedef CWHArray<tagCardInfo> CArrayCard;

class CEndPlay :
	public hgeItemContainer
{
protected:
	MySprite		*m_pBack;
	MySprite		*m_pDuiHua;
	MySprite		*m_pHaiDi;
	MySprite		*m_pDownBack;
	MySprite		*m_pShowDonw;
	MySprite		*m_pDuiHuaWait;
	MySprite		*m_pHaiDiWait;
protected:
	//BYTE			m_cbCardData[10];
	CArrayCard		m_cbCardData;
	hgePoint		m_ptPlayCard;
	bool			m_bUpdata;
	bool			m_bCanDown;
	bool			m_bShowCard;
	bool			m_bDuiHua;
public:
	FEvent_PInt		m_ShowCard;
public:
	CEndPlay(const tstring &strname);
public:
	~CEndPlay(void);
public:
	void Init();
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	void Update(DWORD dwDelTick );
public:
	void SetPlayCard(bool bShowCard,bool bDuiHua,BYTE cbCardData[10]);
	void SetCardPoint();
	void SetStart();
	void SetCanDown(bool bCanDown);
	void Stustee();
	void SetAllShow();
	bool GetState(){return m_bDuiHua;}
	void ResealeInfo();
	void SetShowCard(BYTE cbCardData[10]);
public:
	void OnLButtonUp(UINT nFlags, const hgePoint& point);
};
#endif