

#include "stdafx.h"
#include "GUIBaseContainer.h"
#include "GameWindow.h"

#define NOR_FACE_WIDTH						100							//ͷ32
#define NOR_FACE_HEIGHT						100							//ͷ߶32

#define MOVE_STEP_COUNT					6								//ƶ
#define TIME_MOVE_CARD					25								//ƶʱʱ

//Ŀ
#define BOMB_EFFECT_COUNT				11								//Ŀ
#define DISC_EFFECT_COUNT				8								//Ч	

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern TL_Gwindow* g_pGWindow;
extern char g_szCurPath[MAX_PATH];
extern char g_szFacePath[MAX_PATH];

REGISTER_WIDGET_EX(TL_GBaseContainer)

TL_GBaseContainer::TL_GBaseContainer(const tstring &strname, const std::string & group )
:hgeItemContainerEx(strname)
{
	m_phge=NULL;
	m_phge = hgeCreate(HGE_VERSION);
	m_nTestTimerID =-1;
	m_nTrusteeID=-1;
//	m_nMoveCardID=-1;
	//m_nDiscID=-1;
	m_nCutCardID=-1;
	m_nUpDataID=-1;
	m_nFlashID=-1;
	m_nMyFlashID=-1;
	m_nActionBackID=-1;
	m_nCardActionID=-1;
	m_nActionID=-1;
	m_nTingID[0]=-1;
	m_nTingID[1]=-1;
	m_nChiHuID=-1;
	m_nZiMoID=-1;
	//m_nBGM1ID=-1;
	//m_nBGM2ID=-1;
	//m_nBGM3ID=-1;
	m_nSystemID=-1;
	m_nShowSystemID=-1;
	m_nUserFlashID=-1;
	m_nUserActionID=-1;
	m_pViewFront=NULL;
	m_pUserReady=NULL;
	m_fXChi=0;
	m_fYChi=0;

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		m_pHeadCard[i]=NULL;
		m_pTableCard[i]=NULL;
		m_pDiscardCard[i]=NULL;
		m_pUserInfo[i]=NULL;
	}

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		for(BYTE j=0;j<CountArray(m_pWeaveCard[i]);j++)
		{
			m_pWeaveCard[i][j]=NULL;
		}
	}
	
	//ÿؼ
	m_pUserCard=NULL;
	m_pHandCard=NULL;
	m_pSiceContainer=NULL;
	m_pOutCard=NULL;
	m_pWaitOther=NULL;
	m_pHuangZhuang=NULL;
	m_pGfxFont=NULL;
	m_pGfxNameFont=NULL;
	m_pNumberFont=NULL;
	m_pGameOption=NULL;
	m_pCellBack=NULL;
	m_pCellInfo=NULL;
	m_pTingInfo=NULL;
	m_pCellNumber=NULL;
	m_pWhiteNumber=NULL;
	m_pYellowNumber=NULL;
	m_pReplaceCard=NULL;
	m_pReplaceNum=NULL;
	ZeroMemory(m_bTingCard,sizeof(m_bTingCard));

	m_pUserTimer=NULL;
	m_pDrawMessage=NULL;
	m_pEndPlay=NULL;
//	m_pButtonChi=NULL;
	m_lCellScore=0L;
	m_cbRobotUpdata=0;
	m_cbRobotIndex=0;
	m_wDiscUser=INVALID_CHAIR;
	ZeroMemory(m_bTrustee,sizeof(m_bTrustee));
	m_cbCutCardData=0;
	m_wBankerUser=INVALID_CHAIR;
	m_wCurrentUser=INVALID_CHAIR;
//	m_wChiHuUser=INVALID_CHAIR;
//	m_wProvideUser=INVALID_CHAIR;
	m_bCardMoving = false;
	m_bEnableAnimate=true;
	m_bPlaySound=true;
	m_bBackSound=true;
	m_bShowCutCard=false;
	m_nCutCardCount=0;
	m_cbCutType=0;
	m_nCutStep=0;
	//־
	m_bOutCard=false;
	m_bWaitOther=false;
	m_bTimerShow=false;
	m_bHuangZhuang=false;
	m_bGameEnd=false;
	m_bShowWnd=false;
	m_bScoreShow=false;
	m_bStart=false;
	m_bShowOption=false;
	m_bShowSetCell=false;
	m_bShowPlay=false;
	m_bGameStart=false;
	m_bMoveCardID=false;
	m_bZiMo=false;
	m_bGameChiHu=false;
	m_bShowHead=false;
	ZeroMemory(m_bShowTing,sizeof(m_bShowTing));
	ZeroMemory(m_cbTingIndex,sizeof(m_cbTingIndex));
	//û״̬
	m_cbCardData=0;
	m_cbUserFlash=0;
	m_cbUserIndex=0;
	m_cbUserType=rand()%10+20;
	m_wOutCardUser=INVALID_CHAIR;
	ZeroMemory(m_cbUserAction,sizeof(m_cbUserAction));
	m_cbDiscFrameIndex=0;
	m_bPlusDisc=true;
	m_lpUserLevel[0]=("");
	m_lpUserLevel[1]=("");
	m_bShowBelle=false;
	m_bDrawTingCard=false;
	m_ArrayTingCard.RemoveAll();
	m_lUpScore=0;
	ZeroMemory(m_cbHuaCardCount,sizeof(m_cbHuaCardCount));
	m_wDrawUserType=0;
	m_bShowRedouble=false;
	m_dwMyFanShu=0;
	m_dwOtherFanShu=0;
	m_dwFanCount=0;
	m_cbSysIndex=0;
	ZeroMemory(m_dwFanShu,sizeof(m_dwFanShu));

	//@@Դ
	BIND_DEFINED_GROUP_WIDGETS(this, "TL_GBaseContainer")
	TYPE_CHILD_WIDGET(m_pViewFront,"FrontView");
	TYPE_CHILD_WIDGET(m_pStartButton,"StartButton");

	m_pViewFront->SetShow(TRUE);
	m_pStartButton->SetShow(FALSE);

	InitBaseContainer();
}

TL_GBaseContainer::~TL_GBaseContainer()
{
	if(m_pUserReady)
		delete m_pUserReady;
	if(m_pUserFlag)
		delete m_pUserFlag;
	if(m_pOutCard)
		delete m_pOutCard;
	if(m_pWaitOther)
		delete m_pWaitOther;
	if(m_pHuangZhuang)
		delete m_pHuangZhuang;
	if(m_pGfxFont)
		delete m_pGfxFont;
	if(m_pGfxNameFont)
		delete m_pGfxNameFont;
	if(m_pNumberFont)
		delete m_pNumberFont;
	if(m_pControlWnd)
		delete m_pControlWnd;
	if(m_pUserTimer)
		delete m_pUserTimer;
	if(m_pCellBack)
		delete m_pCellBack;
	if(m_pCellInfo)
		delete m_pCellInfo;
	if(m_pGameOption)
		delete m_pGameOption;
	if(m_pframebtnEmotion)
		delete m_pframebtnEmotion;
	if(m_pframebtnBugle)
		delete m_pframebtnBugle;
	if(m_pDrawMessage)
		delete m_pDrawMessage;
	if(m_pSetCellScore)
		delete m_pSetCellScore;
	if(m_pGameScore)
		delete m_pGameScore;
	if(m_pTingInfo)
		delete m_pTingInfo;
	if(m_pCellNumber)
		delete m_pCellNumber;
	if(m_pWhiteNumber)
		delete m_pWhiteNumber;
	if(m_pYellowNumber)
		delete m_pYellowNumber;
	if(m_pEndPlay)
		delete m_pEndPlay;
	if(m_pReplaceCard)
		delete m_pReplaceCard;
	if(m_pReplaceNum)
		delete m_pReplaceNum;
	if(m_pNameBack)
		delete m_pNameBack;
	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		for(BYTE j=0;j<CountArray(m_pWeaveCard[i]);j++)
		{
			if(m_pWeaveCard[i][j])
				delete m_pWeaveCard[i][j];
		}
		if(m_pTableCard[i])
			delete m_pTableCard[i];
		if(m_pHeadCard[i])
			delete m_pHeadCard[i];
	}
	KillTimer(m_nTestTimerID);
	KillTimer(m_nTrusteeID);
//	KillTimer(m_nMoveCardID);
	//KillTimer(m_nDiscID);
	KillTimer(m_nCutCardID);
	KillTimer(m_nUpDataID);
	KillTimer(m_nFlashID);
	KillTimer(m_nMyFlashID);
	KillTimer(m_nActionBackID);
	KillTimer(m_nCardActionID);
	KillTimer(m_nActionID);
	KillTimer(m_nTingID[0]);
	KillTimer(m_nTingID[1]);
	KillTimer(m_nChiHuID);
	KillTimer(m_nZiMoID);
	//KillTimer(m_nBGM1ID);
	//KillTimer(m_nBGM2ID);
	//KillTimer(m_nBGM3ID);
	KillTimer(m_nUserFlashID);
	KillTimer(m_nUserActionID);
	KillTimer(m_nSystemID);
	KillTimer(m_nShowSystemID);

	if (m_phge)
	{
		m_phge->Release();
	}
}

void TL_GBaseContainer::ReleaseGame()
{
	m_wDiscUser=INVALID_CHAIR;
	m_wBankerUser=INVALID_CHAIR;
	m_wCurrentUser=INVALID_CHAIR;
//	m_wChiHuUser=INVALID_CHAIR;
//	m_wProvideUser=INVALID_CHAIR;
	m_bCardMoving = false;
	//־
	m_bOutCard=false;
	m_bWaitOther=false;
	m_bTimerShow=false;
	m_bHuangZhuang=false;
	m_bGameEnd=false;
	m_bShowCutCard=false;
	m_bShowWnd=false;
	m_bScoreShow=false;
	m_bShowSetCell=false;
	m_bShowPlay=false;
	m_bDrawTingCard=false;
	m_bZiMo=false;
	m_bGameChiHu=false;
	m_bShowHead=false;
	m_ArrayTingCard.RemoveAll();
	m_nCutCardCount=0;
	m_cbCutType=0;
	m_nCutStep=0;
	//û״̬
	m_cbCardData=0;
	m_cbCutCardData=0;
	m_wDrawUserType=0;
	m_cbUserFlash=0;
	m_cbUserIndex=0;
	m_cbUserType=rand()%10+20;
	m_wOutCardUser=INVALID_CHAIR;
	ZeroMemory(m_cbUserAction,sizeof(m_cbUserAction));
	ZeroMemory(m_bTingCard,sizeof(m_bTingCard));
	ZeroMemory(m_bShowTing,sizeof(m_bShowTing));
	m_cbDiscFrameIndex=0;
	m_bPlusDisc=true;
	m_bShowRedouble=false;
	m_dwMyFanShu=0;
	m_dwOtherFanShu=0;
	m_dwFanCount=0;
	SetButtonShow(FALSE);
	ZeroMemory(m_pUserInfo,sizeof(m_pUserInfo));
	ZeroMemory(m_cbHuaCardCount,sizeof(m_cbHuaCardCount));
	ZeroMemory(m_dwFanShu,sizeof(m_dwFanShu));
}
//@@ ʼ
void TL_GBaseContainer::InitBaseContainer()
{
	InitInfo();
	InitCard();
	InitButton();
	InitAnimate();
	InitImage();
	SetButtonShow(FALSE);
	RectifyGameView(1024,740);

	//srand( (unsigned)time( NULL ) );
	//PlayBGMusic(rand()%3);

	//m_bShowSetCell=true;
	//m_pSetCellScore->SetCellScore(1000,false);
	//m_pSetCellScore->SetWait();
	//m_bShowOption=true;
	//SetGameTimer(0,8);
	//m_bTimerShow=true;
	//m_bShowWnd=true;
	//m_pControlWnd->SetControlInfo(WIK_LEFT,false);

  	//for(BYTE i=0;i<GAME_PLAYER;i++)
  	//{
  	//	////test
  	//	tagUserInfo *pUsertempData = new tagUserInfo;
  	//	lstrcpy(pUsertempData->szName,TEXT("SSSSS"));
  	//	lstrcpy(pUsertempData->szNickName,TEXT("绰ͤ"));
  	//	pUsertempData->cbUserStatus = US_READY;
  	//	pUsertempData->cbGender=2;
  	//	pUsertempData->wFaceID=5;
  	//	pUsertempData->lGameGold=622222002;
  	//	pUsertempData->lLoveliness=2000;
  	//	m_pUserInfo[i]=pUsertempData;
  	//	//m_pUserTimer->UpDataTimer(5,i,INVALID_CHAIR);
  	//	//m_pHeapCard[i]->SetShow(TRUE);
  	////	m_bTrustee[i]=true;
  	//	//m_pHeapCard[i]->SetZOrder(10);
  	//	////end test
  	//}

	//m_wDrawUserType=1;

	//m_bTingCard[0]=true;
	//m_bTingCard[1]=true;

	//m_lCellScore=100000;
	//m_lUpScore=-320000;

	//m_lpUserLevel[0]="ȸ";
	//m_lpUserLevel[1]="ȸ";

	//m_cbHuaCardCount[0]=4;
	//m_cbHuaCardCount[1]=3;

	//

	//m_pSiceContainer->SetSiceInfo((WORD)(258));
	//m_pSiceContainer->SetShow(TRUE);

	//////////m_wChiHuUser=0;

	//m_dwFanShu[0]=10;
	//m_dwFanShu[1]=23;

	//SetFanCount(10,true);

 	//m_bGameStart=true;
 	//m_bShowHead=true;
 
 	//test
 	//BYTE byCard[] = {
 	//	0x07,0x13,0x21,0x31,0x37,0x02,0x12,0x23,0x33,					
 	//	0x39,0x01,0x01,0x01,0x01,0x06,0x07,0x08,0x09,
 	//	0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,
 	//	0x31,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,
 	//	0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09
 	//};
	//////m_pEndPlay->SetPlayCard(true,false,byCard);
	//////m_bShowPlay=true;
	//////m_pEndPlay->SetStart();
	//tagTingInfo TingInfo;
	//m_bDrawTingCard=true;
	//for(BYTE i=0;i<6;i++)
	//{
	//	TingInfo.cbCardData=byCard[i];
	//	TingInfo.cbFan=(i+1)*2;
	//	TingInfo.cbCardCount=5;
	//	m_ArrayTingCard.Add(TingInfo);
	//}
	///////*BYTE byCardCount = 14;
	//////static int n = 0;
	//////if( ++n==1 )
	//////{*/
		//m_bStart=true;
		//m_pHandCard->SetDisplayItem(true);
		//m_pHandCard->SetPositively(true);
		//m_pHandCard->SetCardData(byCard,MAX_COUNT-1-3,byCard[MAX_COUNT-1]);
		//m_pHandCard->SetShowAnimate(true);
		//////m_pHandCard->SetCardData(NULL,0,0);
		//////m_pHandCard->SetAllCardGray(true);
		//////m_pHandCard->SetCaiShenData(byCard[0]);
		//////m_pHandCard->SetShowCaiShen(true);
		//m_pHeapCard->SetCardCount(16);
		//////m_pHeapCard->SetScaleCard(0.8f);
		//m_pUserCard->SetCardData(MAX_COUNT-1-3,true);
		//m_pUserCard->SetScaleCard(0.8f);
	//	/*m_pHeapCard[2]->SetHeapCardInfo(0,0);
 //		m_pHeapCard[2]->SetCardData(12,0x05);
 //		m_pHeapCard[2]->SetHeapCardInfo(0,0);
 //		m_pHeapCard[2]->SetShow(TRUE);*/
  		//for( BYTE i = 0; i < GAME_PLAYER; i++ )
  		//{
  		//	//m_pHeadCard[i]->SetHeapCardInfo(1,26);
  		//	//m_pHeapCard[i]->SetCardData( 22,0x19 );
  		//	//m_pHeapCard[i]->SetCardData( 14,0x26 );
  		//	//m_pHeapCard[i]->SetShow(TRUE);
  		//	//m_pHeadCard[i]->SetCardEmpty(34,1);
  		//	m_pTableCard[i]->SetCardData(byCard,9);
  		//	//m_pTableCard[i]->SetDuiHuaCard(0x09);
  		//	//m_pTableCard[i]->SetProvideCard(0x09);
  		//	//m_pDiscardCard[i]->SetCardData(byCard,12);
  		//	//m_pWeaveCard[i][0]->SetCardData(byCard,3,0);
  		//	//m_pWeaveCard[i][0]->SetDuiHuaCard(byCard[i]);
  		//	//m_pWeaveCard[i][0]->SetDuiHuaCard(byCard[0]);
  		//	//m_pWeaveCard[i][0]->SetDuiHuaCard(byCard[1]);
  		//	//m_pWeaveCard[i][0]->SetDuiHuaCard(byCard[2]);
  		//	//m_pWeaveCard[i][0]->SetDuiHuaCard(byCard[3]);
  		//	//m_pWeaveCard[i][0]->SetDisplayItem(true);
  		//	//m_pWeaveCard[i][1]->SetCardData( byCard,3,1);
  		//	//m_pWeaveCard[i][1]->SetDisplayItem(true);
  		//	//m_pWeaveCard[i][2]->SetCardData( byCard,3,2 );
  		//	//m_pWeaveCard[i][2]->SetDisplayItem(true);
  		//	//m_pWeaveCard[i][3]->SetCardData( byCard,3,3);
  		//	//m_pWeaveCard[i][3]->SetDisplayItem(true);
  		//	//m_pWeaveCard[i][0]->SetDirectionCardPos( (i+1)%4 );
  		//	//m_pWeaveCard[i][1]->SetDirectionCardPos( (i+1)%4 );
  		//	//m_pWeaveCard[i][2]->SetDirectionCardPos( (i+1)%4 );
  		//	////m_pWeaveCard[i][3]->SetDirectionCardPos( (i+1)%4 );
  		//	//m_bTrustee[i] = true;
  		//	//m_cbUserAction[i] = WIK_RIGHT;
  		//	//m_bListenStatus[i] = true;
  		//}
		//for(BYTE j=0;j<8;j++)
		//{
		//	m_pTableCard[0]->SetDuiHuaCard(byCard[j]);
		//	m_pTableCard[1]->SetDuiHuaCard(byCard[j+1]);
		//}
//////////////////////		m_bWaitOther = true;
//////////////////		m_bHuangZhuang = true;
//////////////////		m_bOutCard = true;
//////////////////		m_wOutCardUser = 3;
//////////////////		m_cbCardData = 0x01;
//////////////////		m_cbUserAction[3] = WIK_NULL;
//////////////////		SetDiscUser( 1 );
////////////////////		SetBombEffect(true);
		//tagScoreInfo ScoreInfo;
		//ZeroMemory(&ScoreInfo,sizeof(ScoreInfo));
		//tagWeaveInfo WeaveInfo;
		//ZeroMemory(&WeaveInfo,sizeof(WeaveInfo));
		//WeaveInfo.cbWeaveCount=2;
		//for(BYTE i=0;i<WeaveInfo.cbWeaveCount;i++)
		//{
		//	WeaveInfo.cbCardCount[i]=3;
		//	for(BYTE j=0;j<WeaveInfo.cbCardCount[i];j++)
		//		WeaveInfo.cbCardData[i][j]=byCard[i];
		//}
		//ScoreInfo.wChiHuUser = 0;
		//ScoreInfo.wProvideUser = 1;
		//ScoreInfo.wLianBankerCount=3;
		//ScoreInfo.cbProvideCard=byCard[5];
		//ScoreInfo.cbFanCount = 88;
		//ScoreInfo.cbCardCount = 13-6;
		//ScoreInfo.wChengBaoUser=1;
		//ScoreInfo.lGameGold[0]=0;
		//ScoreInfo.lGameGold[1]=0;
		//CopyMemory( ScoreInfo.cbCardData,byCard,sizeof(BYTE)*ScoreInfo.cbCardCount );
		////ScoreInfo.cbProvideCard=0x06;
		//for( WORD i = 0; i < GAME_PLAYER; i++ )
		//{
		//	lstrcpy( ScoreInfo.szUserName[i],TEXT("SSSSdsfs"));
		//	ScoreInfo.lGameScore[i] = 123000L*((i%2)?-1:1);
		//	//ScoreInfo.lGameGold[i] = 123000L*((i%2)?-1:1);
		//	ScoreInfo.lHitScore[i]=100+i*10;
		//}
		//CChiHuRight chr;
		//CChiHuRight chrhigh;
		//CChiHuRight chrnew;
		//chr |= CHR_ZI_MO;
		//chr |= CHR_GANG_KAI;
		//chr |= CHR_PENG_PENG;
		//chr |= CHR_QUAN_QIU;
		//chr |= CHR_DOUBLE_JIAN_KE;
		//chr |= CHR_HUN_YI_SE;
		//chr |= CHR_LIAN_6;
		//chr |= CHR_YI_BAN_GAO;
		////chrhigh |= CHR_DA_SAN_YUAN;
		////chr |= CHR_MENQING_ZIMO;												//
		////chr |= CHR_YAO_JIU_KE;													//۾ſ
		////chrhigh |= CHR_YISE_SANBU;
		////chrhigh |= CHR_SAN_FENG_KE;
		//chrhigh |= CHR_YISE_SIBU;
		//chrhigh |= CHR_QING_LAOTOU;													//ͷ
		//chrhigh |= CHR_CHUN_QUAN_DAI_YI;											//ȫ
		//chrhigh |= CHR_LONG_QI_DUI;												//߶
		////chrhigh|=CHR_XIAO_SI_XI;
		////chrhigh|=CHR_XIAO_SAN_YUAN;
		////chrhigh|=CHR_YISE_SHUANG_LONG;
		////chrhigh|=CHR_ZI_YI_SE;
		////chrhigh|=CHR_TIAN_HU;
		////chrhigh|=CHR_DI_HU;
		////chrhigh|=CHR_SI_AN_KE;
		////chrhigh |=CHR_DA_SI_XI;
		////chrhigh |=CHR_DA_SAN_YUAN;
		////chrhigh |=CHR_JIU_LIAN;
		////chrhigh |=CHR_SHI_BA;
		////chrhigh |=CHR_LIAN_QI_DUI;
		////chrhigh |=CHR_DA_5;
		////chrhigh |=CHR_XIAO_5;
		////chr |= CHR_GANG_HOU_PAO;
		////chr |= CHR_QUAN_FENG_XIANG;
		////chr	|= CHR_GUAN_FENG;
		////chr |= CHR_QIANG_LZ;
		////chr |= CHR_MEN_QI_QING;
		////chr |= CHR_QUAN_QIU_REN;
		////chr |= CHR_HUN_YI_SE;
		//for(BYTE i=0;i<2;i++)
		//	m_pGameScore->SetDuiHuaCard(byCard[i]);
		//ScoreInfo.cbHuaCardCount = 3;
		//ScoreInfo.cbFanCount = 23;
		//m_pGameScore->SetScoreInfo(ScoreInfo,WeaveInfo,0,0,chr,chrhigh,chrnew,10,1);
		//m_pGameScore->SetShow();
		////m_pGameScore->SetHuangZhuang(true);
		//m_bScoreShow=true;
//////		SetHuangZhuang(true);
////		m_cbFengQuan = 0;
////		m_btStart.ShowWindow( SW_SHOW );
////
////		tagSelectCardInfo sci[MAX_WEAVE];
////		ZeroMemory( sci,sizeof(sci) );
////		sci[0].cbActionCard = 0x03;
////		sci[0].wActionMask = WIK_LEFT;
////		sci[0].cbCardCount = 2;
////		sci[0].cbCardData[0] = 0x04;
////		sci[0].cbCardData[1] = 0x05;
////		sci[1].cbActionCard = 0x03;
////		sci[1].wActionMask = WIK_CENTER;
////		sci[1].cbCardCount = 2;
////		sci[1].cbCardData[0] = 0x02;
////		sci[1].cbCardData[1] = 0x04;
////		sci[2].cbActionCard = 0x03;
////		sci[2].wActionMask = WIK_RIGHT;
////		sci[2].cbCardCount = 2;
////		sci[2].cbCardData[0] = 0x01;
////		sci[2].cbCardData[1] = 0x02;
////		m_HandCardControl.OnEventUserAction( sci,3 );
////		m_ControlWnd.SetControlInfo( WIK_PENG|WIK_CHI_HU|WIK_LEFT|WIK_GANG );
////
		//m_DrawSiceWnd.SetSiceInfo( GetDC(),50,MAKEWORD(4,5),0 );
		//m_DrawSiceWnd.ShowWindow( SW_SHOW );
//	//}
//	/*else
//	{
		//tagMoveCardItem mci;
		//mci.cbCardCount = 1;
		//mci.cbCardData = 0x26;
		//mci.wViewChairId = 0;
		//mci.ptFrom = m_pUserCard->GetDispatchCardPos();
		//mci.ptTo = m_pDiscardCard[0]->GetDispatchCardPos();
		//OnMoveCardItem( mci );
	//	m_bCardMoving=true;
		//m_enMoveDirection=Direction_North;
		//m_MoveCardItem.cbCardData=0x26;
//	}*/
		//m_btStart.ShowWindow(SW_SHOW);
////	end test

	//m_bScoreShow=true;
}
void TL_GBaseContainer::InitCard()
{
	//
	enDirection Direction[]={Direction_North,Direction_South};
	tstring strDiscardName[]={"DiscardCardN","DiscardCardS"};
	tstring strTableName[]={"TableCardN","TableCardS"};
	tstring strHeadName[]={"HeadCardN","HeadCardS"};

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		if(i==1||i==2)
		{
			m_pDiscardCard[i]=new CDiscardCard(strDiscardName[i]);
			AddItem(m_pDiscardCard[i]);
			m_pDiscardCard[i]->SetDirection(Direction[i]);
		}
		else
		{
			m_pDiscardCard[i]=new CDiscardCard(strDiscardName[i]);
			AddItem(m_pDiscardCard[i]);
			m_pDiscardCard[i]->SetDirection(Direction[i]);
		}
		
		m_pTableCard[i]=new CTableCard(strTableName[i]);
		//AddItem(m_pTableCard[i]);
		m_pTableCard[i]->SetDirection(Direction[i]);
		if(i==0)
		{
			m_pTableCard[i]->SetCardSize(true);
			m_pTableCard[i]->SetScaleCard(0.79f);
		}

		m_pHeadCard[i]=new CHeapCard(strHeadName[i]);
		m_pHeadCard[i]->SetDirection(Direction[i]);
		if(i==0)
		{
			m_pHeadCard[i]->SetScaleCard(0.79f);
		}
	}


	tstring strWeaveName[GAME_PLAYER][MAX_WEAVE]={"WeaveCardN1","WeaveCardN2","WeaveCardN3","WeaveCardN4",
		"WeaveCardS1","WeaveCardS2","WeaveCardS3","WeaveCardS4"};

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		for(BYTE j=0;j<CountArray(m_pWeaveCard[i]);j++)
		{
			m_pWeaveCard[i][j]=new CWeaveCard(strWeaveName[i][j]);
			//AddItem(m_pWeaveCard[i][j]);
			m_pWeaveCard[i][j]->SetDisplayItem(true);
			m_pWeaveCard[i][j]->SetDirection(Direction[i]);
			if(i==0)
			{
				m_pWeaveCard[i][j]->SetCardSize(true);
				m_pWeaveCard[i][j]->SetScaleCard(0.79f);
			}
		}
	}

	m_pHandCard=new CCardControl("HandCard");
	AddItem(m_pHandCard);
	m_pHandCard->InitCardAnimate();

	m_pUserCard=new CUserCard("UserCardN");
	AddItem(m_pUserCard);
	m_pUserCard->SetDirection(Direction_North);
	m_pUserCard->SetScaleCard(0.5f);

	m_pControlWnd=new CControlWnd("ControlWnd","wnd");
	m_pControlWnd->Init();

	char szFile[MAX_PATH];
	sprintf(szFile, "%s\\gameend\\", g_szCurPath);
	/*CString strFile;
	strFile.Format(TEXT("%s\\gameend\\"),g_szCurPath);*/
	m_pGameScore=new CGameScore("GameScore");
	m_pGameScore->InitData(szFile);
}
void TL_GBaseContainer::InitAnimate()
{
	m_ActionBack.InitAnimate("\\Animate\\ActionBack.png",5,2);
	m_ActionChiHu.InitAnimate("\\Animate\\ActionChiHu.png",4,2);
	m_ImageChi.LoadImage("\\Animate\\actionchi.png");
	m_ImagePeng.LoadImage("\\Animate\\actionpeng.png");
	m_ImageGang.LoadImage("\\Animate\\actiongang.png");
	m_ImageZiMo.LoadImage("\\Animate\\actionzimo.png");
	m_MyRedFlash.InitAnimate("\\Animate\\MyRedouble.png",4,4);
	m_OtherRedFlash.InitAnimate("\\Animate\\OtherRedouble.png",4,3);
	m_DrawThinking.InitAnimate("\\Animate\\Thinking.png",7,1);
	m_TingSign.InitAnimate("\\Animate\\TingSign.png",7,1);
	m_TingSign.ShowAnimate();
	m_TingPoint.InitAnimate("\\Animate\\TingPoint.png",3,1);
	m_TingPoint.ShowAnimate();
}
void TL_GBaseContainer::InitInfo()
{
	HTEXTURE tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexUserReady");
	m_pUserReady=new MySprite(tex,0,0,105,32);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexUserFlag");
	m_pUserFlag=new MySprite(tex,0,0,140,35);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("texOutCard");
	m_pOutCard=new MySprite(tex,0,0,224,24);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("texWaitOther");
	m_pWaitOther=new MySprite(tex,0,0,117,23);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexFrame_NameBack");
	m_pNameBack=new MySprite(tex,0,0,1018,42);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexHuangZhuang");
	m_pHuangZhuang=new MySprite(tex,0,0,322,237);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexWhiteNumber");
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexCellBack");
	m_pCellBack=new MySprite(tex,0,0,145,85);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexCellInfo");
	m_pCellInfo=new MySprite(tex,0,0,40,22);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexTingInfo");
	m_pTingInfo=new MySprite(tex,0,0,266,34);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexCellNumber");
	m_pCellNumber=new MySprite(tex,0,0,120,20);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexWhiteNumber");
	m_pWhiteNumber=new MySprite(tex,0,0,88,11);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexYellowNumber");
	m_pYellowNumber=new MySprite(tex,0,0,88,11);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexReplaceCard");
	m_pReplaceCard=new MySprite(tex,0,0,49,43);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexReplaceNum");
	m_pReplaceNum=new MySprite(tex,0,0,190,26);

	m_pUserTimer=new CDrawTimer("UserTimer");
	//AddItem(m_pUserTimer);
	m_pUserTimer->InitTime();

	m_pSiceContainer=new CSiceContainer("Sice");
	AddItem(m_pSiceContainer);
	m_pSiceContainer->Init();

	m_pGfxFont=new GfxFont("",15);
	m_pNumberFont=new GfxFont("",16,FALSE,FALSE,FALSE);

	m_pGfxNameFont=new GfxFont("",12);

	m_pGameOption=new CGameOption("GameOption");
	m_pGameOption->Init();

	m_pDrawMessage=new CDrawMessage("Message");
	m_pDrawMessage->Init();

	m_pSetCellScore=new CSetCellScore("SetCellScore");
	m_pSetCellScore->Init();

	m_pEndPlay=new CEndPlay("EndPlay");
	m_pEndPlay->Init();

	m_pSiceContainer->EventTest = BIND_THIS_METHOD(TL_GBaseContainer::OnActionFinish);

	m_nTestTimerID = SetTimer(130,true);
	m_nTrusteeID = SetTimer(500,true);
//	m_nMoveCardID = SetTimer(TIME_MOVE_CARD,true);
//	SetStoped(m_nMoveCardID,true);
	//m_nDiscID=SetTimer(250,true);
	//SetStoped(m_nDiscID,true);
	m_nCutCardID=SetTimer(15,true);
	SetStoped(m_nCutCardID,true);
	m_nUpDataID=SetTimer(500,true);
	//SetStoped(m_nUpDataID,true);
	m_nActionID=SetTimer(100,true);
	m_nTingID[0]=SetTimer(1500,true);
	SetStoped(m_nTingID[0],true);
	m_nTingID[1]=SetTimer(1600,true);
	SetStoped(m_nTingID[1],true);
	m_nChiHuID=SetTimer(125,true);
	SetStoped(m_nChiHuID,true);
	m_nZiMoID=SetTimer(100,true);
	SetStoped(m_nZiMoID,true);
	m_nUserFlashID=SetTimer(200,true);
	m_nActionBackID=SetTimer(130,true);
	SetStoped(m_nActionBackID,true);
	m_nCardActionID=SetTimer(150,true);
	m_nUserActionID=SetTimer(100,true);
	SetStoped(m_nUserActionID,true);
	//m_nBGM1ID=SetTimer(32000,true);
	//SetStoped(m_nBGM1ID,true);
	//m_nBGM2ID=SetTimer(33000,true);
	//SetStoped(m_nBGM2ID,true);
	//m_nBGM3ID=SetTimer(33000,true);
	//SetStoped(m_nBGM3ID,true);
	m_nFlashID=SetTimer(150,true);
	m_nMyFlashID=SetTimer(80,true);
	m_nSystemID=SetTimer(35000,true);
	SetStoped(m_nSystemID,true);
	m_nShowSystemID=SetTimer(100,true);
}
void TL_GBaseContainer::InitImage()
{
	m_ImageManOneS.LoadImage("\\UserImage\\Man11.png");
	m_ImageManOneT.LoadImage("\\UserImage\\Man12.png");
	m_ImageManTwoS.LoadImage("\\UserImage\\Man21.png");
	m_ImageManTwoT.LoadImage("\\UserImage\\Man22.png");
	m_ImageWomanOneS.LoadImage("\\UserImage\\Woman11.png");
	m_ImageWomanOneT.LoadImage("\\UserImage\\Woman12.png");
	m_ImageWomanTwoS.LoadImage("\\UserImage\\Woman21.png");
	m_ImageWomanTwoT.LoadImage("\\UserImage\\Woman22.png");
	m_ImageStartCue.LoadImage("\\data\\StartCue.png");
	m_ImageNameBack.LoadImage("\\data\\NameBack.png");
	m_ImageHintLeft.LoadImage("\\data\\HintBackLeft.png");
	m_ImageHintMiddle.LoadImage("\\data\\HintBackMiddle.png");
	m_ImageHintRight.LoadImage("\\data\\HintBackRight.png");
	m_ImageHintNumber.LoadImage("\\data\\FanNumber.png");
	m_ImageHintFan.LoadImage("\\data\\Fan.png");
	m_RedoubleBack.LoadImage("\\data\\RedoubleBack.png");
	m_RedoubleNum.LoadImage("\\data\\ReNum.png");
	m_MyRedouble.LoadImage("\\data\\MyRedouble.png");
	m_MyRedoubleNum.LoadImage("\\data\\MyRedoubleNum.png");
//	m_MyRedAnimate.InitAnimate("\\data\\MyRedAnimate.png",4,1);
//	m_MyRedAnimate.ShowAnimate();
	m_RedLight.InitAnimate("\\data\\RedLight.png",5,1);
	m_ImageDisc.LoadImage("\\data\\DISC.png");
	m_RedLight.ShowAnimate();
}
void TL_GBaseContainer::InitButton()
{
	m_pGameScore->m_pButtonContinue->_OnPress=FEvent_PItemV2(this,&TL_GBaseContainer::OnContinue);
	m_pGameOption->m_pOk->_OnPress=FEvent_PItemV2(this,&TL_GBaseContainer::OnOkButton);
	m_pGameOption->m_pCancel->_OnPress=FEvent_PItemV2(this,&TL_GBaseContainer::OnCancelButton);
	m_pGameOption->m_pClose->_OnPress=FEvent_PItemV2(this,&TL_GBaseContainer::OnCancelButton);

	HTEXTURE tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexFrame_emotion");
	m_pframebtnEmotion=new hgeItemButton("Emotion",tex,hgePoint(0,0),hgePoint(72,32),TRUE,4,TRUE);
	m_pframebtnEmotion->_OnPress=FEvent_PItemV2(this,&TL_GBaseContainer::OnBtnPressed);
	m_pframebtnEmotion->SetDoHitTest(TRUE);

	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexFrame_bugle");
	m_pframebtnBugle=new hgeItemButton("Bugle",tex,hgePoint(0,0),hgePoint(72,32),TRUE,4,TRUE);
	m_pframebtnBugle->_OnPress=FEvent_PItemV2(this,&TL_GBaseContainer::OnBtnPressed);
	m_pframebtnBugle->SetDoHitTest(TRUE);

	m_btStartStustee.LoadButtonImage("\\frame\\StartStustee.png",100);
	m_btStartStustee.m_ButtonMessage=FEvent_PInt(this,&TL_GBaseContainer::OnStartTrustee);
	m_btStartStustee.SetState(false);
	m_btStopStustee.LoadButtonImage("\\frame\\StopStustee.png",110);
	m_btStopStustee.m_ButtonMessage=FEvent_PInt(this,&TL_GBaseContainer::OnStopTrustee);
	m_btStopStustee.SetShow(false);
	m_btRedouble.LoadButtonImage("\\data\\RedoubleButton.png",120);
	m_btRedouble.m_ButtonMessage=FEvent_PInt(this,&TL_GBaseContainer::OnRedouble);
	m_btRedouble.SetShow(false);
	m_btChiHuCue.LoadButtonImage("\\frame\\ChiHuCue.png",130);
	m_btChiHuCue.m_ButtonMessage=FEvent_PInt(this,&TL_GBaseContainer::OnChiHuCue);
	m_btChiHuCue.SetState(false);
}
void TL_GBaseContainer::RectifyGameView(int nWidth, int nHeight)
{
	m_fWidth=(float)nWidth;
	m_fHeight=(float)nHeight;
	m_ptFace[0].x=(float)(nWidth/2)-58;
	m_ptFace[0].y=53.0f;
	m_ptReady[0].x=(float)(nWidth/2)-52;
	m_ptReady[0].y=270.0f;
	m_ptName[0].x=352;
	m_ptName[0].y=208.0f;
	m_ptTimer[0].x=(float)(nWidth/2+220);
	m_ptTimer[0].y=180.0f;
	m_ptTrustee[0].x=m_ptFace[0].x+8;
	m_ptTrustee[0].y=m_ptFace[0].y+9;
	m_ptUserFlag[0].x=m_ptFace[0].x-31;
	m_ptUserFlag[0].y=m_ptFace[0].y+5;
	m_ptActionAni[0].x=337.0f;
	m_ptActionAni[0].y=150.0f;
	m_ptActionBack[0].x=470.0f;
	m_ptActionBack[0].y=255.0f;
	m_ptTing[0].x=m_fWidth/2+25;
	m_ptTing[0].y=145.0f;

	m_ptFace[1].x=(float)28;
	m_ptFace[1].y=(float)(nHeight-177);
	m_ptReady[1].x=(float)(nWidth/2-52);
	m_ptReady[1].y=(float)(nHeight-110);
	m_ptName[1].x=92;
	m_ptName[1].y=710;
	m_ptTimer[1].x=(float)nWidth-95;
	m_ptTimer[1].y=(float)nHeight-132;
	m_ptTrustee[1].x=m_ptFace[1].x+8;
	m_ptTrustee[1].y=m_ptFace[1].y+9;
	m_ptUserFlag[1].x=m_ptFace[1].x+119;
	m_ptUserFlag[1].y=m_ptFace[1].y+112;
	m_ptActionAni[1].x=337.0f;
	m_ptActionAni[1].y=350.0f;
	m_ptActionBack[1].x=470.0f;
	m_ptActionBack[1].y=410.0f;
	m_ptTing[1].x=85.0f;
	m_ptTing[1].y=496.0f;

	m_ptUserPoint.x=400;
	m_ptUserPoint.y=32;

	m_pTableCard[0]->SetControlPoint(315,256);
	m_pTableCard[1]->SetControlPoint(191,nHeight-126);

	m_pHeadCard[0]->SetControlPoint(nWidth/2-235,nHeight/2-68);
	m_pHeadCard[1]->SetControlPoint(nWidth/2+295,nHeight/2+135);

	int nXCenter=nWidth/2;
	int nYCenter=nHeight/2;
	//˿
	m_pDiscardCard[0]->SetControlPoint(nXCenter-261,nYCenter-18);
	m_pDiscardCard[1]->SetControlPoint(nXCenter-228,nYCenter+88);

	//˿
	int nXControl = 358;
	int nYControl = 256;
	for( BYTE i = 0; i < CountArray(m_pWeaveCard[0]); i++ )
	{
		m_pWeaveCard[0][i]->SetControlPoint(nXControl,nYControl);
		nXControl += 92;
	}

	//˿
	nXControl = 98;
	nYControl = nHeight-126;
	for( BYTE i = 0; i < CountArray(m_pWeaveCard[1]); i++ )
	{
		m_pWeaveCard[1][i]->SetControlPoint(nXControl,nYControl);
		nXControl += 168;
	}

	m_pUserCard->SetControlPoint(nWidth/2+140,242);
	m_pHandCard->SetBenchmarkPos(nWidth/2+5,nHeight-51,enXCenter,enYBottom);

	m_ptMagicCard.x=2.0f;
	m_ptMagicCard.y=30.0f;
	m_pSiceContainer->SetSicePoint(hgePoint(450,150));

	m_ptControl=hgePoint((float)nWidth/2+295,485);
	m_pControlWnd->SetScorePoint(m_ptControl);
	m_pGameOption->SetPoint(hgePoint(360,230));
	m_rcOption=hgeRect(395,240,395+325,240+270);
	m_pGameScore->SetScorePoint(hgePoint(0,0));
	m_ptEmotion=hgePoint(506,700);
	m_rcEmotion=hgeRect(m_ptEmotion.x,m_ptEmotion.y,m_ptEmotion.x+72,m_ptEmotion.y+32);
	m_ptBugle=hgePoint(584,700);
	m_rcBugle=hgeRect(m_ptBugle.x,m_ptBugle.y,m_ptBugle.x+72,m_ptBugle.y+32);
	m_btStartStustee.SetPoint(CPoint(428,700));
	m_btStopStustee.SetPoint(CPoint(432,620));
	m_btRedouble.SetPoint(CPoint((int)m_fWidth-180,(int)m_fHeight/2+19));
	m_btChiHuCue.SetPoint(CPoint(662,700));
	m_rcChiHuCue.left=662;
	m_rcChiHuCue.top=700;
	m_rcChiHuCue.right=662+96;
	m_rcChiHuCue.bottom=700+32;
	m_pDrawMessage->SetPoint(hgePoint(0,740-45));
	m_pSetCellScore->SetPoint(hgePoint(360,250));
	m_rcSetCell.x1=360;
	m_rcSetCell.y1=250;
	m_rcSetCell.x2=m_rcSetCell.x1+319;
	m_rcSetCell.y2=m_rcSetCell.y1+212;
}
void TL_GBaseContainer::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	__super::Render(ptParentOffset,bClip,clipRect);

	DrawUser(m_ptUserPoint.x,m_ptUserPoint.y);
	for(WORD i=0;i<GAME_PLAYER;i++)
	{
		m_pTableCard[i]->Render(ptParentOffset,bClip,clipRect);
		if(m_bShowHead)
			m_pHeadCard[i]->Render(ptParentOffset,bClip,clipRect);
	}

	for(WORD i=0;i<GAME_PLAYER;i++)
	{
		for(WORD j=0;j<MAX_WEAVE;j++)
			m_pWeaveCard[i][j]->Render(ptParentOffset,bClip,clipRect);
	}

	m_pNameBack->Render(3,m_fHeight-m_pNameBack->GetHeight()-3);

	m_pDrawMessage->Render(ptParentOffset,bClip,clipRect);

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		const tagUserInfo *pUserData=m_pUserInfo[i];
		if(pUserData!=NULL)
		{
			if(i!=1)
			{
				m_ImageNameBack.DrawImage(280,203);
				if(pUserData->szNickName[0]!=NULL)
					DrawTextString( pUserData->szNickName,m_pGfxNameFont,0xFFFFDF7B,m_ptName[i].x,m_ptName[i].y );
				else
					DrawTextString( pUserData->szNickName,m_pGfxNameFont, 0xFFFFDF7B, m_ptName[i].x,m_ptName[i].y );
				DrawNumberString(pUserData->lScore,m_pGfxNameFont,0xFFFFDF7B,m_ptName[i].x,m_ptName[i].y+17,true);
				//DrawTextString(m_lpUserLevel[i],0xFFFFFFFF,495,38);
				if(m_bTingCard[i])
				{
					m_TingSign.DrawAnimate(m_ptTing[i].x,m_ptTing[i].y);
					m_TingPoint.DrawAnimate(m_ptTing[i].x+125,m_ptTing[i].y+75);
				}
				if(m_cbHuaCardCount[i]>0)
				{
					m_pReplaceCard->Render(m_fWidth-300,257);
					DrawNumberString(m_cbHuaCardCount[i],m_fWidth-247,265,m_pReplaceNum,190,26,false,false);
				}
			}
			else
			{
				if(pUserData->szNickName[0]!=NULL)
					DrawTextString( pUserData->szNickName,m_pGfxFont,0xFF9CC37B,m_ptName[i].x,m_ptName[i].y);
				else
					DrawTextString( pUserData->szNickName,m_pGfxFont, 0xFF9CC37B, m_ptName[i].x,m_ptName[i].y );
				DrawNumberString(pUserData->lScore,m_pNumberFont,0xFF9CC37B,m_ptName[i].x+106,m_ptName[i].y,false);
				DrawNumberString(m_lUpScore,m_pNumberFont,0xFF9CC37B,m_ptName[i].x+251,m_ptName[i].y,false);
				//if(m_lUpScore>=0)
				//	DrawNumberString(m_lUpScore,680,713,m_pWhiteNumber,88,11,true,false);
				//else
				if(m_bTingCard[i])
				{
					m_TingSign.DrawAnimate(m_ptTing[i].x,m_ptTing[i].y);
					m_TingPoint.DrawAnimate(m_ptTing[i].x+125,m_ptTing[i].y+75);
				}
				if(m_cbHuaCardCount[i]>0)
				{
					m_pReplaceCard->Render(20,627);
					DrawNumberString(m_cbHuaCardCount[i],74,635,m_pReplaceNum,190,26,false,false);
				}
			}
			if(pUserData->cbUserStatus==US_READY)
				m_pUserReady->Render(m_ptReady[i].x,m_ptReady[i].y);

			//if(m_bTrustee[i])
			//{
			//	m_pUserTrustee->SetTextureRect((m_cbRobotUpdata%6)*100.0f,0,100,100);
			//	m_pUserTrustee->Render(m_ptTrustee[i].x,m_ptTrustee[i].y);
			//	m_pUserTrusteeS->SetTextureRect((m_cbRobotIndex%6)*100.0f,0,100,100);
			//	m_pUserTrusteeS->Render(m_ptTrustee[i].x,m_ptTrustee[i].y);
			//}
		}
	}

	if(m_lCellScore!=0)
	{
		DrawCellInfo(5,38);
	}

	if(!m_bGameStart)
		m_ImageStartCue.DrawImage(70,290);
	if(m_bShowSetCell)
		m_pSetCellScore->Render(ptParentOffset,bClip,clipRect);

	//m_bShowRedouble=true;
	//m_dwFanCount=8;
	if(m_bShowRedouble)
	{
		m_RedoubleBack.DrawImage(m_fWidth-250,m_fHeight/2-m_RedoubleBack.GetHeight()/2-7);
		DrawNumberString(m_dwFanCount,(int)m_fWidth-91,int(m_fHeight/2-m_RedoubleBack.GetHeight()/2+60),m_RedoubleNum,false,true);
	}

	//m_dwMyFanShu=10;
	if(m_dwMyFanShu>0)
	{
		m_MyRedouble.DrawImage(m_fWidth-135,m_fHeight/2+70);
		DrawNumberString(m_dwMyFanShu,int(m_fWidth-73),int(m_fHeight/2+74),m_MyRedoubleNum,false,true);
//		m_MyRedAnimate.DrawAnimate(m_fWidth-135,m_fHeight/2+60);
	}

	//m_dwOtherFanShu=10;
	if(m_dwOtherFanShu>0)
	{
		m_MyRedouble.DrawImage(135+32,m_fHeight/2-74);
		DrawNumberString(m_dwOtherFanShu,197+32,int(m_fHeight/2-70),m_MyRedoubleNum,false,true);
	}

	m_MyRedFlash.DrawAnimate(0,265);
	m_OtherRedFlash.DrawAnimate(0,300);
	m_DrawThinking.DrawAnimate(m_fWidth/2+60,120);

	////m_lCellScore=10000;
	//if(m_lCellScore>0)
	//{
	//	DrawNumberString(m_lCellScore,0xFFFF0000,88,141);
	//}

	////m_wBankerUser=3;
	//if(m_wBankerUser!=INVALID_CHAIR)
	//{
	//	//λͼ
	//	float nImageWidth=35;
	//	float nImageHeight=35;
	//	float nNumberWidth=11;
	//	float nNumberHeight=13;

	//	//滭־
	//	for (WORD i=0;i<GAME_PLAYER;i++)
	//	{
	//		WORD wIndex=(m_wBankerUser+GAME_PLAYER-i)%GAME_PLAYER;
	//		m_pUserFlag->SetTextureRect(nImageWidth*i,0,nImageWidth,nImageHeight);
	//		m_pUserFlag->Render(m_ptUserFlag[wIndex].x,m_ptUserFlag[wIndex].y);
	//	}
	//}

	//ʾ
	//m_bOutCard=true;
	//m_bOutCard=true;
	if (m_bOutCard==true)
	{
		m_pOutCard->Render(400,570);
	}

	//ȴʾ
	//m_bWaitOther=true;
	if (m_bWaitOther==true)
	{
		m_pWaitOther->Render(450,562);
	}

	//ׯ־
	//m_bHuangZhuang=true;
	if (m_bHuangZhuang==true)
	{
		m_pHuangZhuang->Render(350.0f,290.0f);
	}

	//m_wDiscUser=1;
	if(m_wDiscUser!=INVALID_CHAIR)
	{
		CPoint pt=m_pDiscardCard[m_wDiscUser]->GetLastCardPosition();
		m_ImageDisc.DrawImage((float)pt.x-m_ImageDisc.GetWidth()/2,(float)(pt.y-m_ImageDisc.GetHeight()/2-10)-m_cbDiscFrameIndex);
	}

	//û״̬
	for(WORD i=0;i<GAME_PLAYER;i++)
	{
		//滭
		if(m_cbUserAction[i]!=WIK_NULL&&m_cbUserAction[i]!=WIK_LISTEN)
		{
			if((m_cbUserAction[i]&WIK_CHI_HU)&&!m_bZiMo)
			{
				m_ActionChiHu.DrawAnimate(310,250);
			}
			else
			{
				float nXPos=287,nYPos=290;
				float fBackWidth=m_ActionBack.GetItemWidth(),fBackHeight=m_ActionBack.GetItemHeight();
				float fActionWidth=0,fActionHeight=0;
				m_ActionBack.DrawAnimate(nXPos,nXPos);
				if(m_ActionBack.GetShow())
				{
					if(m_cbUserAction[i]&(WIK_PENG|WIK_PENG_LISTEN))
					{
						fActionWidth=m_ImagePeng.GetWidth();
						fActionHeight=m_ImagePeng.GetHeight();
						m_ImagePeng.DrawImage(nXPos+fBackWidth/2-fActionWidth/2,nYPos+fBackHeight/2-fActionHeight/2);
					}
					else if(m_cbUserAction[i]&(WIK_GANG))
					{
						fActionWidth=m_ImageGang.GetWidth();
						fActionHeight=m_ImageGang.GetHeight();
						m_ImageGang.DrawImage(nXPos+fBackWidth/2-fActionWidth/2,nYPos+fBackHeight/2-fActionHeight/2);
					}
					else if(m_cbUserAction[i]&(WIK_CHI_HU))
					{
						fActionWidth=m_ImageZiMo.GetWidth();
						fActionHeight=m_ImageZiMo.GetHeight();
						m_ImageZiMo.DrawImage(nXPos+fBackWidth/2-fActionWidth/2,nYPos+fBackHeight/2-fActionHeight/2);
					}
					else
					{
						fActionWidth=m_ImageChi.GetWidth();
						fActionHeight=m_ImageChi.GetHeight();
						m_ImageChi.DrawImage(nXPos+fBackWidth/2-fActionWidth/2,nYPos+fBackHeight/2-fActionHeight/2);
					}
				}
			}
		}
	}

	//for(BYTE i=0;i<GAME_PLAYER;i++)
	//{
	//	if(m_bShowTing[i])
	//		m_pActionTing[i]->Render(ptParentOffset,bClip,clipRect);
	//}

	if(m_bShowWnd)
		m_pControlWnd->Render(ptParentOffset,bClip,clipRect);

	DrawMoveCardItem();

	//m_bShowCutCard=true;
	//m_cbCutFromPoint.x=100;
	//m_cbCutFromPoint.y=100;
	//m_cbCutCardData=0x33;
	if(m_bShowCutCard)
	{
		g_CardResource.m_HandCardWhite.DrawCardItem(m_cbCutCardData,m_cbCutFromPoint.x+7,m_cbCutFromPoint.y+8);
	}

	if(m_bDrawTingCard)
	{
		//m_pTingBack->Render(0,460);
		m_pTingInfo->Render(m_fWidth/2-m_pTingInfo->GetWidth()/2,450);

		float fWidth=(float)g_CardResource.m_HandCardWhite.GetViewWidth();
		if(m_ArrayTingCard.GetCount()<=3)
		{
			float fDrawWidth=(fWidth+18)*3;
			float j=0;
			for(;j<fDrawWidth;j++)
				m_ImageHintMiddle.DrawImage((m_fWidth-fDrawWidth)/2+m_ImageHintMiddle.GetWidth()*j,473);
			m_ImageHintLeft.DrawImage((m_fWidth-fDrawWidth)/2-m_ImageHintLeft.GetWidth(),473);
			m_ImageHintRight.DrawImage((m_fWidth-fDrawWidth)/2+m_ImageHintMiddle.GetWidth()*j,473);
		}
		else
		{
			float fDrawWidth=(fWidth+18)*m_ArrayTingCard.GetCount();
			float j=0;
			for(;j<fDrawWidth;j++)
				m_ImageHintMiddle.DrawImage((m_fWidth-fDrawWidth)/2+m_ImageHintMiddle.GetWidth()*j,473);
			m_ImageHintLeft.DrawImage((m_fWidth-fDrawWidth)/2-m_ImageHintLeft.GetWidth(),473);
			m_ImageHintRight.DrawImage((m_fWidth-fDrawWidth)/2+m_ImageHintMiddle.GetWidth()*j,473);
		}

		BYTE cbCardCount=m_ArrayTingCard.GetCount();
		float fXCardPos=(m_fWidth-fWidth*cbCardCount-18*(cbCardCount-1))/2;
		for(BYTE i=0;i<m_ArrayTingCard.GetCount();i++)
		{
			BYTE cbCount=m_ArrayTingCard[i].cbCardCount;
			CString str;
			str.Format(TEXT("ʣ%ld"),cbCount);
			DrawTextString(str,m_pGfxNameFont,0xFFFFDF7B,fXCardPos+26+(fWidth+18)*i,492);
			g_CardResource.m_HandCardWhite.DrawCardItem(m_ArrayTingCard[i].cbCardData,fXCardPos+(fWidth+18)*i,505);
			DrawNumberString(m_ArrayTingCard[i].cbFan,int(fXCardPos+(fWidth+18)*i-m_ImageHintFan.GetWidth()/2+fWidth/2),595,
				m_ImageHintNumber,false,true,true);
		}
	}

	if(m_bShowPlay)
		m_pEndPlay->Render(ptParentOffset,bClip,clipRect);

	if(m_bTimerShow&&!m_bScoreShow)
		m_pUserTimer->Render(ptParentOffset,bClip,clipRect);

	if(m_bScoreShow)
	{
		m_pGameScore->Render(ptParentOffset,bClip,clipRect);
	}

	if(m_bShowOption)
		m_pGameOption->Render(ptParentOffset,bClip,clipRect);

	m_pframebtnEmotion->Render(m_ptEmotion,bClip,clipRect);
	m_pframebtnBugle->Render(m_ptBugle,bClip,clipRect);
	m_btStartStustee.DrawButton();
	m_btStopStustee.DrawButton();
	m_btChiHuCue.DrawButton();
	m_btRedouble.DrawButton();
	if(m_btRedouble.GetShow())
	{
//		m_MyRedAnimate.DrawAnimate(m_fWidth-181,m_fHeight/2+14);
		m_RedLight.DrawAnimate(m_fWidth-185,m_fHeight/2+13);
	}

}
void TL_GBaseContainer::SetControlInfo(DWORD cbAcitonMask,bool bShow)
{
	////ưť
	//m_pButtonPeng->SetState(((cbAcitonMask&WIK_PENG)!=0)?eItemStateNormal:eItemStateDisable);
	//m_pButtonGang->SetState(((cbAcitonMask&WIK_GANG)!=0)?eItemStateNormal:eItemStateDisable);
	//m_pButtonChiHu->SetState(((cbAcitonMask&WIK_CHI_HU)!=0)?eItemStateNormal:eItemStateDisable);
	//m_pButtonChi->SetState((cbAcitonMask&(WIK_LEFT|WIK_CENTER|WIK_RIGHT))?eItemStateNormal:eItemStateDisable);

	//ƴ
	//SetButtonShow((cbAcitonMask!=WIK_NULL)?SW_SHOW:SW_HIDE);
	m_bShowWnd=(cbAcitonMask!=WIK_NULL?true:false);
	if(m_bShowWnd)
	{
		m_pControlWnd->SetControlInfo(cbAcitonMask,bShow);
	}
}
//
void TL_GBaseContainer::SetScoreInfo(const tagScoreInfo & ScoreInfo, const tagWeaveInfo & WeaveInfo,
									 const CChiHuRight &ChiHuRight,const CChiHuRight &ChiHuHigh,const CChiHuRight &ChiHuNew,
								   const BYTE cbMingGangCount,const BYTE cbAnGangCount,LONG lCellScore,WORD wMeChairID)
{
	m_pGameScore->SetScoreInfo(ScoreInfo,WeaveInfo,cbMingGangCount,cbAnGangCount,
		ChiHuRight,ChiHuHigh,ChiHuNew,lCellScore,wMeChairID);
	return;
}
void TL_GBaseContainer::SetUserLevel(WORD wChairID,const char* lpUserLevel)
{
	m_lpUserLevel[wChairID]=lpUserLevel;
}
void TL_GBaseContainer::DrawUser(float fXPos,float fYPos)
{
	const tagUserInfo *pUserData=m_pUserInfo[0];
	if(pUserData==NULL)
		return ;
	bool bBoy = (pUserData->cbGender == 2 ? false : true);
	if(bBoy)
	{
		if(m_wDrawUserType==0)
		{
			if(m_cbUserFlash==0)
				m_ImageManOneS.DrawImage(fXPos,fYPos);
			else
				m_ImageManOneT.DrawImage(fXPos,fYPos);
		}
		else
		{
			if(m_cbUserFlash==0)
				m_ImageManTwoS.DrawImage(fXPos,fYPos);
			else
				m_ImageManTwoT.DrawImage(fXPos,fYPos);
		}
	}
	else
	{
		if(m_wDrawUserType==0)
		{
			if(m_cbUserFlash==0)
				m_ImageWomanOneS.DrawImage(fXPos,fYPos);
			else
				m_ImageWomanOneT.DrawImage(fXPos,fYPos);
		}
		else
		{
			if(m_cbUserFlash==0)
				m_ImageWomanTwoS.DrawImage(fXPos,fYPos);
			else
				m_ImageWomanTwoT.DrawImage(fXPos,fYPos);
		}
	}
}
void TL_GBaseContainer::ChangeDrawType()
{
	m_wDrawUserType=rand()%2;
	m_cbUserFlash=0;
	m_cbUserIndex=0;
}
VOID TL_GBaseContainer::DrawGoldString( LONGLONG lNumber, float nXPos, float nYPos, MySprite *pSprite,float nWidth,
								  float nHeight,bool bGlod)
{
	//Դ
	float nNumberHeight=nHeight;
	float nNumberWidth=nWidth/10;

	//Ŀ
	INT nNumberCount=0;
	LONGLONG lNumberTemp=lNumber;
	do
	{
		nNumberCount++;
		lNumberTemp/=10;
	} while (lNumberTemp!=0);

	//λö
	float nYDrawPos=nYPos;
	float nXDrawPos= 0;
		nXDrawPos = (nXPos+nNumberCount*(nNumberWidth+1));

	//滭
	if( lNumber < 0L ) lNumberTemp = -lNumber;
	else lNumberTemp = lNumber;
	for (INT i=0;i<nNumberCount;i++)
	{
		//滭
		INT lCellNumber=INT(lNumberTemp%10);
		pSprite->SetTextureRect((float)lCellNumber*nNumberWidth,0,nNumberWidth,nNumberHeight);
		pSprite->Render(nXDrawPos,nYDrawPos);

		//ñ
		lNumberTemp/=10;
		nXDrawPos-=(INT)(nNumberWidth+1);
	}

	return;
}
VOID TL_GBaseContainer::DrawCellString(LONGLONG lNumber, float nXPos, float nYPos, MySprite *pSprite, float nWidth,
									   float nHeight)
{
	//Դ
	float nNumberHeight=nHeight;
	float nNumberWidth=nWidth/10;

	//Ŀ
	INT nNumberCount=0;
	LONGLONG lNumberTemp=lNumber;
	do
	{
		nNumberCount++;
		lNumberTemp/=10;
	} while (lNumberTemp!=0);

	//λö
	float nYDrawPos=nYPos;
	float nXDrawPos= 0;
	nXDrawPos = (nXPos);

	//滭
	if( lNumber < 0L ) lNumberTemp = -lNumber;
	else lNumberTemp = lNumber;
	for (INT i=0;i<nNumberCount;i++)
	{
		//滭
		INT lCellNumber=INT(lNumberTemp%10);
		pSprite->SetTextureRect((float)lCellNumber*nNumberWidth,0,nNumberWidth,nNumberHeight);
		pSprite->Render(nXDrawPos,nYDrawPos);

		//ñ
		lNumberTemp/=10;
		nXDrawPos-=(INT)(nNumberWidth+1);
	}
}
VOID TL_GBaseContainer::DrawCellString( LONGLONG lNumber, float nXPos, float nYPos, MySprite *pSprite, float nWidth,
									   float nHeight,bool bDrawCenter )
{
	//Դ
	float nNumberHeight=nHeight;
	float nNumberWidth=nWidth/10;

	//Ŀ
	INT nNumberCount=0;
	LONGLONG lNumberTemp=lNumber;
	do
	{
		nNumberCount++;
		lNumberTemp/=10;
	} while (lNumberTemp!=0);

	//λö
	float nYDrawPos=nYPos;
	float nXDrawPos= 0;
	if( !bDrawCenter )
		nXDrawPos = (nXPos+(nNumberCount)*nNumberWidth);
	else 
		nXDrawPos = ((nXPos-nNumberWidth)+(nNumberCount*nNumberWidth)/2);

	//滭
	if( lNumber < 0L ) lNumberTemp = -lNumber;
	else lNumberTemp = lNumber;
	for (INT i=0;i<nNumberCount;i++)
	{
		//滭
		INT lCellNumber=INT(lNumberTemp%10);
		pSprite->SetTextureRect((float)(lCellNumber)*nNumberWidth,0,nNumberWidth,nNumberHeight);
		pSprite->Render(nXDrawPos,nYDrawPos);

		//ñ
		lNumberTemp/=10;
		nXDrawPos-=(INT)nNumberWidth;
	}

	m_pCellInfo->SetTextureRect(20.0f,0.0f,20.0f,22.0f);
	m_pCellInfo->Render(nXPos+5+(nNumberCount*nNumberWidth)/2,nYPos);

	return ;
}
VOID TL_GBaseContainer::DrawNumberString( LONGLONG lNumber, float nXPos, float nYPos, MySprite *pSprite,float nWidth,
								  float nHeight, bool bHasSign, bool bDrawCenter)
{
	//Դ
	float nNumberHeight=nHeight;
	float nNumberWidth=nWidth/(10+(bHasSign?1:0));

	//Ŀ
	INT nNumberCount=0;
	LONGLONG lNumberTemp=lNumber;
	do
	{
		nNumberCount++;
		lNumberTemp/=10;
	} while (lNumberTemp!=0);

	//λö
	float nYDrawPos=nYPos;
	float nXDrawPos= 0;
	if( !bDrawCenter )
		nXDrawPos = (nXPos+(nNumberCount+(bHasSign?0:-1))*nNumberWidth);
	else 
		nXDrawPos = (nXPos+(nNumberCount+(bHasSign?1:0))*nNumberWidth/2-nNumberWidth/2);

	BYTE bySignCount = bHasSign?1:0;
	//滭
	if( lNumber < 0L ) lNumberTemp = -lNumber;
	else lNumberTemp = lNumber;
	for (INT i=0;i<nNumberCount;i++)
	{
		//滭
		INT lCellNumber=INT(lNumberTemp%10);
		pSprite->SetTextureRect((float)(lCellNumber+bySignCount)*nNumberWidth,0,nNumberWidth,nNumberHeight);
		pSprite->Render(nXDrawPos,nYDrawPos);

		//ñ
		lNumberTemp/=10;
		nXDrawPos-=(INT)nNumberWidth;
	}
	//滭
	if( bHasSign )
	{
		pSprite->SetTextureRect(0,0,nNumberWidth,nNumberHeight);
		pSprite->Render(nXDrawPos,nYDrawPos);
	}

	return;
}
void  TL_GBaseContainer::DrawNumberString(LONGLONG lNumber,INT nXPos,INT nYPos,CHgeImage &HgeNumber,bool bHasSign,
										  bool bDrawCenter,bool bDrawTael)
{
	//Դ
	INT nNumberHeight=(int)HgeNumber.GetHeight();
	INT nNumberWidth=(int)HgeNumber.GetWidth()/(10+(bHasSign?2:0));

	//Ŀ
	INT nNumberCount=0;
	LONGLONG lNumberTemp=lNumber;
	do
	{
		nNumberCount++;
		lNumberTemp/=10;
	} while (lNumberTemp!=0);

	//λö
	INT nYDrawPos=nYPos;
	INT nXDrawPos= 0;
	if( !bDrawCenter )
		nXDrawPos = INT(nXPos+(nNumberCount+(bHasSign?0:-1))*nNumberWidth);
	else 
		nXDrawPos = INT(nXPos+(nNumberCount+(bHasSign?1:0))*nNumberWidth/2-nNumberWidth);

	BYTE bySignCount = bHasSign?2:0;
	//滭
	if( lNumber < 0L ) lNumberTemp = -lNumber;
	else lNumberTemp = lNumber;
	for (INT i=0;i<nNumberCount;i++)
	{
		//滭
		INT lCellNumber=INT(lNumberTemp%10);
		HgeNumber.DrawImage((float)nXDrawPos,(float)nYDrawPos,(float)nNumberWidth,(float)nNumberHeight,
			(float)((lCellNumber)*nNumberWidth),0);

		//ñ
		lNumberTemp/=10;
		nXDrawPos-=nNumberWidth;
	}
	//滭
	if( bHasSign )
	{
		HgeNumber.DrawImage((float)nXDrawPos,(float)nYDrawPos,(float)nNumberWidth,(float)nNumberHeight,
			(float)((lNumber>=0?10:11)*nNumberWidth),0);
	}

	if(bDrawTael)
	{
		m_ImageHintFan.DrawImage((float)(nXPos+(nNumberCount+(bHasSign?0:-1))*nNumberWidth+(nNumberCount==1?4:0)),
			(float)nYPos-1);
	}
}
float TL_GBaseContainer::DrawNumber(LONGLONG lNumber, float fXPos, float fYPos, MySprite* pNumSprite,
								  int nCellWidth, int nCellHeight)
{
	//	0,1,2..9,-
	//Դ
	
	bool bNegative=lNumber<0;
	LONGLONG lNumberTemp=lNumber>=0?lNumber:-lNumber;
	
	//Ŀ
	INT nNumberCount=0;
	do
	{
		nNumberCount++;
		lNumberTemp/=10;
	} while (lNumberTemp!=0);
	
	lNumberTemp=lNumber>=0?lNumber:-lNumber;
	//λö
	float nYDrawPos=fYPos;
	float nXDrawPos= (fXPos+nNumberCount*(nCellWidth+1));
	if(bNegative) nXDrawPos+=nCellWidth+1;
	for (INT i=0;i<nNumberCount;i++)
	{
		//滭
		INT lCellNumber=INT(lNumberTemp%10);
		pNumSprite->SetTextureRect((float)lCellNumber*nCellWidth,0,(float)nCellWidth,(float)nCellHeight);
		pNumSprite->Render(nXDrawPos,nYDrawPos);
		//ñ
		lNumberTemp/=10;
		nXDrawPos-=(INT)(nCellWidth+1);
	}
	if( bNegative )
	{
		bNegative =false;
		pNumSprite->SetTextureRect(10.0f*nCellWidth,0,(float)nCellWidth,(float)nCellHeight);	
		pNumSprite->Render(nXDrawPos,nYDrawPos);
		
	}
	
	return 0;
}
//˿
void TL_GBaseContainer::SetHuangZhuang(bool bHuangZhuang)
{
	//˿
	if (bHuangZhuang!=m_bHuangZhuang)
	{
		//ñ
		m_bHuangZhuang=bHuangZhuang;
		ZeroMemory(m_bTingCard,sizeof(m_bTingCard));
		ZeroMemory(m_bShowTing,sizeof(m_bShowTing));
	}

	return;
}

void TL_GBaseContainer::DrawTextString(LPCTSTR pszString,GfxFont *pFont,COLORREF crText,float nXPos,float nYPos)
{
	std::string strString;
#ifdef _UNICODE
	strString = ST2A(pszString);
#else
	strString = pszString;
#endif
	SIZE size=pFont->GetPrintSize(strString.c_str());
	float fXPos=nXPos-size.cx/2;
	pFont->SetColor(crText);

	pFont->Print(fXPos,nYPos,strString.c_str());
}

void TL_GBaseContainer::DrawNumberString(LONGLONG lNumber,GfxFont *pFont,COLORREF crText,float nXPos,float nYPos,bool bCenter)
{
	/*CString String;
	String.Format(TEXT("%I64d"),lNumber);*/
	char szBuffer[32];
	sprintf(szBuffer,"%I64d", lNumber );
	if(bCenter)
	{
		SIZE size=pFont->GetPrintSize(szBuffer);
		float fXPos=nXPos-size.cx/2;
		pFont->SetColor(crText);
		pFont->Print(fXPos,nYPos,szBuffer);
	}
	else
	{
		pFont->SetColor(crText);
		pFont->Print(nXPos,nYPos,szBuffer);
	}
}
void TL_GBaseContainer::DrawCellInfo(float fXPos,float fYPos)
{
	m_pCellBack->Render(fXPos,fYPos);
	DrawCellString(1,fXPos+57,fYPos+25,m_pCellNumber,120,20);
	m_pCellInfo->SetTextureRect(0.0f,0.0f,20.0f,22.0f);
	m_pCellInfo->Render(fXPos+72,fYPos+24);
	DrawCellString(m_lCellScore,fXPos+62,fYPos+48,m_pCellNumber,120,20,true);
}
void TL_GBaseContainer::SetButtonShow(BOOL bShow)
{
	//m_pButtonChi->SetShow(bShow);
	//m_pButtonPeng->SetShow(bShow);
	//m_pButtonGang->SetShow(bShow);
	//m_pButtonChiHu->SetShow(bShow);
	//m_pButtonGiveUp->SetShow(bShow);

	
	m_bShowWnd=false;
}
void TL_GBaseContainer::PlayGameSound(const tstring &strname)
{
	if(m_bPlaySound)
		TL_SoundManager::Instance().PlaySound(strname);
}
void TL_GBaseContainer::PlayBGMusic(BYTE cbIndex)
{
	if(m_bBackSound)
	{
		switch(cbIndex)
		{
		case 0:
			TL_SoundManager::Instance().PlaySound("CommonBGM1");
			//ResetTimer(m_nBGM1ID);
			//SetStoped(m_nBGM1ID,false);
			break;
		case 1:
			TL_SoundManager::Instance().PlaySound("CommonBGM2");
			//ResetTimer(m_nBGM2ID);
			//SetStoped(m_nBGM2ID,false);
			break;
		case 2:
			TL_SoundManager::Instance().PlaySound("CommonBGM3");
			//ResetTimer(m_nBGM3ID);
			//SetStoped(m_nBGM3ID,false);
			break;
		}
	}
}
void TL_GBaseContainer::StopBGMusic()
{
	TL_SoundManager::Instance().StopSound("CommonBGMT");
	TL_SoundManager::Instance().StopSound("CommonBGM1");
	//ResetTimer(m_nBGM1ID);
	//SetStoped(m_nBGM1ID,true);
	TL_SoundManager::Instance().StopSound("CommonBGM2");
	//ResetTimer(m_nBGM2ID);
	//SetStoped(m_nBGM2ID,true);
	TL_SoundManager::Instance().StopSound("CommonBGM3");
	//ResetTimer(m_nBGM3ID);
	//SetStoped(m_nBGM3ID,true);
}
//滭˿˶
void TL_GBaseContainer::DrawMoveCardItem()
{
	//m_bCardMoving=true;
	//m_enMoveDirection=Direction_East;
	//m_MoveCardItem.cbCardData=0x26;
	if( m_bCardMoving )
	{
		float nXDraw =(float)m_MoveCardItem.ptFrom.x, nYDraw = (float)m_MoveCardItem.ptFrom.y;
		switch( m_enMoveDirection )
		{
		case Direction_West:
		case Direction_North:
			{
				//
				if( m_MoveCardItem.cbCardData != 0 )
				{
					g_CardResource.m_SmallSpecialCard.DrawCardItem( m_MoveCardItem.cbCardData,nXDraw,nYDraw);
				}
				else
				{
					if(m_MoveCardItem.cbCardCount==1)
					{
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXDraw,nYDraw,true,m_MoveCardItem.fScaleStart);
					}
					else
					{
						ASSERT( m_MoveCardItem.cbCardCount == 4 );
						DWORD dwWidth=g_CardResource.m_SmallSpecialCard.GetViewWidth();
						float fScale=m_MoveCardItem.fScaleStart;
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXDraw,nYDraw,
							true,fScale);
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXDraw+dwWidth*fScale,nYDraw,
							true,fScale);
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXDraw,nYDraw-14*fScale,
							true,fScale);
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXDraw+dwWidth*fScale,nYDraw-14*fScale,
							true,fScale);
					}
				}
			}
			break;
		case Direction_East:
		case Direction_South:
			{
				//
				if( m_MoveCardItem.cbCardData != 0 )
				{
					g_CardResource.m_SpecialCard.DrawCardItem( m_MoveCardItem.cbCardData,nXDraw,nYDraw);
				}
				else
				{
					if(m_MoveCardItem.cbCardCount==1)
					{
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXDraw,nYDraw,true,m_MoveCardItem.fScaleStart);
					}
					else
					{
						ASSERT( m_MoveCardItem.cbCardCount == 4 );
						DWORD dwWidth=g_CardResource.m_SmallSpecialCard.GetViewWidth();
						float fScale=m_MoveCardItem.fScaleStart;
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXDraw,nYDraw,
							true,fScale);
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXDraw+dwWidth*fScale,nYDraw,
							true,fScale);
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXDraw,nYDraw-14*fScale,
							true,fScale);
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXDraw+dwWidth*fScale,nYDraw-14*fScale,
							true,fScale);
					}
				}
			}
			break;
		default:
			ASSERT(FALSE);
		}
	}
}
//@@¼Ӧ
void TL_GBaseContainer::ClickTest( hgeItemBase *p )
{
	this->SetShow(FALSE);
}
void TL_GBaseContainer::UpdateUserInfo(const tagUserInfo * pUserData,WORD wChairID)
{
	m_pUserInfo[wChairID]=pUserData;
}
void TL_GBaseContainer::SetGameTimer(WORD wChairID,WORD nElapse,bool bEndPlay)
{
	if(m_bScoreShow)
	{
		m_pGameScore->SetEndTime(nElapse);
	}
	else
	{
		if(bEndPlay)
			m_pUserTimer->SetTimePoint(hgePoint(510,260));
		else
			m_pUserTimer->SetTimePoint(m_ptTimer[wChairID]);
		m_pUserTimer->UpDataTimer(nElapse,wChairID,bEndPlay);
	}
}
//@@ʱ¼Ӧ
void TL_GBaseContainer::OnTimer( unsigned long iID )
{
	if (m_nTestTimerID==iID)
	{
		m_cbRobotUpdata++;
		if(m_cbRobotUpdata==100)
			m_cbRobotUpdata=0;
	}

	if(m_nTrusteeID==iID)
	{
		m_cbRobotIndex++;
		if(m_cbRobotIndex==100)
			m_cbRobotIndex=0;
	}

	//if(m_nDiscID==iID)
	//{
	//	//ñ
	//	if ((m_cbDiscFrameIndex+1)>=DISC_EFFECT_COUNT)
	//	{
	//		m_cbDiscFrameIndex=0;
	//	}
	//	else m_cbDiscFrameIndex++;

	//	return;
	//}
	if(m_nCutCardID==iID)
	{
		switch(m_cbCutType)
		{
		case 0:
			{
				m_cbCutFromPoint.y-=15;
				m_nCutCardCount+=15;
				if(m_nCutCardCount>=g_CardResource.m_HandCardWhite.GetViewHeight()-10)
				{
					m_nCutCardCount=0;
					m_cbCutType=1;
				}
				break;
			}
		case 1:
			{
				m_cbCutFromPoint.x+=m_nCutStep;
				if(m_cbCutFromPoint.x<=m_cbCutToPoint.x+30)
				{
					m_cbCutFromPoint.x=m_cbCutToPoint.x;
					m_cbCutType=2;
				}
				break;
			}
		case 2:
			{
				m_cbCutFromPoint.y+=15;
				if(m_cbCutFromPoint.y>=m_cbCutToPoint.y)
				{
					m_cbCutFromPoint.y=m_cbCutToPoint.y;
					SetStoped(m_nCutCardID,true);
					m_pHandCard->CutCardOver();
					m_bShowCutCard=false;
				}
				break;
			}
		}
		
	}
	if(m_nUpDataID==iID)
	{
		//m_bScoreShow=true;
		//m_pGameScore->SetShow();
		//for(BYTE i=0;i<GAME_PLAYER;i++)
		//{
		//	for(BYTE j=0;j<MAX_WEAVE;j++)
		//		m_pWeaveCard[i][j]->ResealeInfo();
		//	m_pTableCard[i]->ResealeInfo();
		//}
		//m_pHandCard->ReleaseInfo();
		//SetStoped(m_nUpDataID,true);
		m_TingPoint.UpData(true);
	}

	if(m_nFlashID==iID)
	{
//		m_MyRedAnimate.UpData(true);
		m_RedLight.UpData(true);
		if(m_OtherRedFlash.UpData())
			m_dwOtherFanShu=m_dwFanShu[0];
		m_DrawThinking.UpData(true);
		m_TingSign.UpData(true);
	}
	if(m_nMyFlashID==iID)
	{
		if(m_MyRedFlash.UpData())
		{
			m_dwMyFanShu=m_dwFanShu[1];
			m_MyRedOver();
		}
	}
	if(m_nUserFlashID==iID)
	{
		m_cbUserIndex++;
		if(m_cbUserIndex==m_cbUserType)
		{
			m_cbUserIndex=0;
			m_cbUserFlash=1;
			m_cbUserType=rand()%10+5;
			SetStoped(m_nUserFlashID,true);
			SetStoped(m_nUserActionID,false);
		}
	}
	if(m_nUserActionID==iID)
	{
		m_cbUserIndex++;
		if(m_cbUserIndex==m_cbUserType)
		{
			m_cbUserIndex=0;
			m_cbUserFlash=0;
			m_cbUserType=rand()%30+20;
			SetStoped(m_nUserFlashID,false);
			SetStoped(m_nUserActionID,true);
		}
	}
	if(m_nActionBackID==iID)
	{
		if(m_ActionBack.UpData())
		{
			SetStoped(m_nActionBackID,true);
			if(m_bGameChiHu)
			{
				m_bScoreShow=true;
				m_pGameScore->SetShow();
				ZeroMemory(m_bTingCard,sizeof(m_bTingCard));
				ZeroMemory(m_bShowTing,sizeof(m_bShowTing));
			}
		}
		if(m_ActionChiHu.UpData())
		{
			SetStoped(m_nActionBackID,true);
			if(m_bGameChiHu)
			{
				m_bScoreShow=true;
				m_pGameScore->SetShow();
				ZeroMemory(m_bTingCard,sizeof(m_bTingCard));
				ZeroMemory(m_bShowTing,sizeof(m_bShowTing));
			}
		}
	}
	if(m_nCardActionID==iID)
	{
		m_pHandCard->UpData();
	}
	if(m_nActionID==iID)
	{
		m_pUserTimer->UpData();
	}

	if(m_nTingID[0]==iID)
	{
		if(m_bTingCard[0])
		{
			m_bShowTing[0]=true;
			SetStoped(m_nTingID[0],true);
		}
		else
		{
			SetStoped(m_nTingID[0],true);
		}
	}
	
	if(m_nTingID[1]==iID)
	{
		if(m_bTingCard[1])
		{
			m_bShowTing[1]=true;
			SetStoped(m_nTingID[1],true);
		}
		else
		{
			SetStoped(m_nTingID[1],true);
		}
	}

	if(m_nChiHuID==iID)
	{
		SetStoped(m_nChiHuID,true);
		m_bShowPlay=true;
		m_pEndPlay->SetStart();
		ZeroMemory(m_bTingCard,sizeof(m_bTingCard));
		ZeroMemory(m_bShowTing,sizeof(m_bShowTing));
	}
	if(m_nZiMoID==iID)
	{
		SetStoped(m_nZiMoID,true);
		m_bShowPlay=true;
		m_pEndPlay->SetStart();
		ZeroMemory(m_bTingCard,sizeof(m_bTingCard));
		ZeroMemory(m_bShowTing,sizeof(m_bShowTing));
	}
	//if(m_nBGM1ID==iID)
	//{
	//	srand( (unsigned)time( NULL ) );
	//	TL_SoundManager::Instance().StopSound("CommonBGM1");
	//	SetStoped(m_nBGM1ID,true);
	//	BYTE temp=rand()%3;
	//	while(temp==0)
	//	{
	//		temp=rand()%3;
	//	}
	//	PlayBGMusic(temp);
	//}
	//if(m_nBGM2ID==iID)
	//{
	//	srand( (unsigned)time( NULL ) );
	//	TL_SoundManager::Instance().StopSound("CommonBGM2");
	//	SetStoped(m_nBGM2ID,true);
	//	BYTE temp=rand()%3;
	//	while(temp==1)
	//	{
	//		temp=rand()%3;
	//	}
	//	PlayBGMusic(temp);
	//}
	//if(m_nBGM3ID==iID)
	//{
	//	srand( (unsigned)time( NULL ) );
	//	TL_SoundManager::Instance().StopSound("CommonBGM3");
	//	SetStoped(m_nBGM3ID,true);
	//	BYTE temp=rand()%3;
	//	while(temp==2)
	//	{
	//		temp=rand()%3;
	//	}
	//	PlayBGMusic(temp);
	//}

	if(m_nSystemID==iID)
	{
		//char  temp[MAX_PATH];
		//sprintf_s(temp,MAX_PATH,"%s\\urge\\System.ini",g_szCurPath);
		//if(m_SystemMessage.SetSource(temp))
		//{
		//	tstring System=_T("");
		//	CString strInxe;
		//	strInxe.Format(TEXT("%ld"),m_cbSysIndex);
		//	m_SystemMessage.GetString("SystemMessage",strInxe,System);
		//	m_pDrawMessage->SetSystem(System);
		//	m_cbSysIndex++;
		//	if(m_cbSysIndex>6)
		//	{
		//		m_cbSysIndex=0;
		//	}
		//}
		SetStoped(m_nSystemID,true);
		SetStoped(m_nShowSystemID,false);
	}
	if(m_nShowSystemID==iID)
	{
		char  temp[MAX_PATH];
		sprintf_s(temp,MAX_PATH,"%s\\urge\\System.ini",g_szCurPath);
		if(m_SystemMessage.SetSource(temp))
		{
			tstring System=("");
			char szBuffer[32];
			sprintf(szBuffer, "%ld", 0);

			m_SystemMessage.GetString(("SystemMessage"),szBuffer,System);
			m_pDrawMessage->SetSystem(System);
			m_cbSysIndex++;
			SetStoped(m_nShowSystemID,true);
			SetStoped(m_nSystemID,false);
		}
	}
}

//@@º
void TL_GBaseContainer::Update(DWORD dwDelTick)
{
	hgeItemContainer::Update(dwDelTick);

	if(m_bMoveCardID)
	{
		//жϵǰǷ
		if( m_nStepCount == 0 )
		{
			//ɾʱ
			m_bMoveCardID=false;

			//FALSE
			m_bCardMoving = false;

			//ͶϢ
			OnActionFinish();
		}
		//û
		else
		{
			//ٲ
			m_nStepCount--;

			//ƶ
			m_MoveCardItem.ptFrom.x += m_nXStep;
			m_MoveCardItem.ptFrom.y += m_nYStep;
			m_MoveCardItem.fScaleStart+=m_fScaleStep;
		}
	}

	if(m_wDiscUser!=INVALID_CHAIR)
	{
		if(m_bPlusDisc)
			m_cbDiscFrameIndex++;
		else
			m_cbDiscFrameIndex--;
		if(m_cbDiscFrameIndex==10)
		{
			m_bPlusDisc=false;
		}
		if(m_cbDiscFrameIndex==0)
		{
			m_bPlusDisc=true;
		}
	}

	if(m_btChiHuCue.GetState())
	{
		//ȡ
		CPoint MousePoint;
		hgePoint point;
		m_phge->Input_GetMousePos(&point.x,&point.y);
		MousePoint.x=(int)point.x;
		MousePoint.y=(int)point.y;

		if(m_pHandCard->OnInCardRect(MousePoint)||
			m_rcChiHuCue.PtInRect(MousePoint))
		{
			m_bDrawTingCard=true;
		}
		else
		{
			m_bDrawTingCard=false;
		}
	}

	m_pGameScore->Update(dwDelTick);
	m_pDrawMessage->Update(dwDelTick);
	if(m_bShowPlay)
		m_pEndPlay->Update(dwDelTick);
}

void TL_GBaseContainer::OnLButtonDown(UINT nFlags, const hgePoint& point)
{
	__super::OnLButtonDown(nFlags, point);
	ReleaseCapture();

	m_pHandCard->OnEventLeftHitCard();

	//m_MyRedFlash.ShowAnimate();
	//m_OtherRedFlash.ShowAnimate();
	//m_DrawThinking.ShowAnimate();

	if(m_bStart)
	{
		if(m_rcEmotion.TestPoint(point.x,point.y))
			m_pframebtnEmotion->OnLButtonDown(nFlags,point);
		if(m_rcBugle.TestPoint(point.x,point.y))
			m_pframebtnBugle->OnLButtonDown(nFlags,point);
		m_btStartStustee.OnLButtonDown(nFlags,CPoint((int)point.x,(int)point.y));
		m_btStopStustee.OnLButtonDown(nFlags,CPoint((int)point.x,(int)point.y));
		m_btRedouble.OnLButtonDown(nFlags,CPoint((int)point.x,(int)point.y));
	}

	if(m_bShowWnd)
		m_pControlWnd->OnLButtonDown(nFlags,point);
	if(m_bScoreShow)
		m_pGameScore->OnLButtonDown(nFlags,point);
	if(m_bShowOption)
	{
		m_rcOption.x1=m_pGameOption->GetPoint().x;
		m_rcOption.y1=m_pGameOption->GetPoint().y;
		m_rcOption.x2=m_pGameOption->GetPoint().x+325;
		m_rcOption.y2=m_pGameOption->GetPoint().y+270;
		if(m_rcOption.TestPoint(point.x,point.y))
			m_pGameOption->OnLButtonDown(nFlags,point);
	}
	if(m_bShowSetCell)
		m_pSetCellScore->OnLButtonDown(nFlags,point);
	return;
}

void TL_GBaseContainer::OnLButtonUp( UINT nFlags, const hgePoint & point )
{
	//if(m_rcPack.TestPoint(point.x,point.y))
	//	m_pframebtnPack->OnLButtonUp(nFlags,point);
	__super::OnLButtonUp(nFlags, point);

	if(m_rcEmotion.TestPoint(point.x,point.y))
		m_pframebtnEmotion->OnLButtonUp(nFlags,point);
	if(m_rcBugle.TestPoint(point.x,point.y))
		m_pframebtnBugle->OnLButtonUp(nFlags,point);
	m_btStartStustee.OnLButtonUp(nFlags,CPoint((int)point.x,(int)point.y));
	m_btStopStustee.OnLButtonUp(nFlags,CPoint((int)point.x,(int)point.y));
	m_btRedouble.OnLButtonUp(nFlags,CPoint((int)point.x,(int)point.y));

	if(m_bShowWnd)
		m_pControlWnd->OnLButtonUp(nFlags,point);
	if(m_bScoreShow)
		m_pGameScore->OnLButtonUp(nFlags,point);
	if(m_bShowOption)
		m_pGameOption->OnLButtonUp(nFlags,point);
	if(m_bShowSetCell)
		m_pSetCellScore->OnLButtonUp(nFlags,point);
	if(m_bShowPlay)
		m_pEndPlay->OnLButtonUp(nFlags,point);
	return ;
}

void TL_GBaseContainer::OnMouseMove(UINT nFlags, const hgePoint& point)
{
	hgeItemContainerEx::OnMouseMove(nFlags,point);
	//ȡ
	CPoint MousePoint;
	MousePoint.x=(int)point.x;
	MousePoint.y=(int)point.y;
	//
	CRect rcRePaint;
	bool bSetCard=false;
	bool bHandle=m_pHandCard->OnEventSetCursor(MousePoint,rcRePaint,bSetCard);

	if(bSetCard)
	{
		PlayGameSound("Common_Card_Set");
	}

	if(m_rcEmotion.TestPoint(point.x,point.y))
		m_pframebtnEmotion->OnMouseMove(nFlags,point);
	if(m_rcBugle.TestPoint(point.x,point.y))
		m_pframebtnBugle->OnMouseMove(nFlags,point);
	m_btStartStustee.OnMouseMove(nFlags,CPoint((int)point.x,(int)point.y));
	m_btStopStustee.OnMouseMove(nFlags,CPoint((int)point.x,(int)point.y));
	m_btChiHuCue.OnMouseMove(nFlags,CPoint((int)point.x,(int)point.y));
	m_btRedouble.OnMouseMove(nFlags,CPoint((int)point.x,(int)point.y));

	//if(m_btChiHuCue.GetState())
	//{
	//	if(m_pHandCard->OnInCardRect(CPoint((int)point.x,(int)point.y))||
	//		m_rcChiHuCue.PtInRect(CPoint((int)point.x,(int)point.y)))
	//	{
	//		m_bDrawTingCard=true;
	//	}
	//	else
	//	{
	//		m_bDrawTingCard=false;
	//	}
	//}

	if(m_bShowWnd)
		m_pControlWnd->OnMouseMove(nFlags,point);
	if(m_bScoreShow)
		m_pGameScore->OnMouseMove(nFlags,point);
	if(m_bShowOption)
		m_pGameOption->OnMouseMove(nFlags,point);
	if(m_bShowSetCell)
		m_pSetCellScore->OnMouseMove(nFlags,point);
}

void TL_GBaseContainer::OnRButtonDown(UINT nFlags, const hgePoint& point)
{
	m_RightButtonDown();
}
void TL_GBaseContainer::SetCellScore(LONGLONG lCellScore)
{
	if(lCellScore!=m_lCellScore)
	{
		m_lCellScore=lCellScore;
	}
}
void TL_GBaseContainer::PlayCutCard(BYTE cbCard,CPoint ptFrom,CPoint ptTo)
{
	m_cbCutCardData=cbCard;
	m_cbCutFromPoint.x=(float)ptFrom.x;
	m_cbCutFromPoint.y=(float)ptFrom.y;
	m_cbCutToPoint.x=(float)ptTo.x;
	m_cbCutToPoint.y=(float)ptTo.y;
	m_nCutStep=(ptTo.x-ptFrom.x)/10;
	m_bShowCutCard=true;
	m_nCutCardCount=0;
	m_cbCutType=0;
	SetStoped(m_nCutCardID,false);
	
}
//й
void TL_GBaseContainer::SetTrustee(WORD wTrusteeUser,bool bTrustee)
{
	//У 
	ASSERT(wTrusteeUser>=0&&wTrusteeUser<GAME_PLAYER);

	if(m_bTrustee[wTrusteeUser] !=bTrustee)	
	{
		//
		m_bTrustee[wTrusteeUser]=bTrustee;
	}
}
void TL_GBaseContainer::SetDiscUser(WORD wDiscUser)
{
	if(m_wDiscUser != wDiscUser)
	{
		//±
		m_wDiscUser=wDiscUser;
		//if( m_wDiscUser != INVALID_CHAIR )
		//	SetStoped(m_nDiscID,false);
		//else SetStoped(m_nDiscID,true);
	}
}
//ׯû
void TL_GBaseContainer::SetBankerUser(WORD wBankerUser)
{
	//û
	if (wBankerUser!=m_wBankerUser)
	{
		//ñ
		m_wBankerUser=wBankerUser;
	}

	return;
}
void TL_GBaseContainer::SetShowHead(bool bShowHead)
{
	m_bShowHead=bShowHead;
}
//ʱ
void TL_GBaseContainer::SetCurrentUser(WORD wCurrentUser)
{
	if (m_wCurrentUser != wCurrentUser)
	{
		//± 
		m_wCurrentUser=wCurrentUser;
	}
	return;
}
//˿˶
void TL_GBaseContainer::OnMoveCardItem( const tagMoveCardItem &MoveCardItem ,bool bShowItem)
{
	if( m_bCardMoving ) return;

	//Ƿ
	if( !m_bEnableAnimate )
	{
		//Ϣ
		OnActionFinish();
		return;
	}

	if(!bShowItem)
	{
		OnActionFinish();
		return;
	}

	m_bCardMoving = true;
	//ñ
	m_MoveCardItem = MoveCardItem;
	m_nStepCount = MOVE_STEP_COUNT;
	m_nXStep =(int)(MoveCardItem.ptTo.x-MoveCardItem.ptFrom.x)/m_nStepCount;
	m_nYStep =(int)(MoveCardItem.ptTo.y-MoveCardItem.ptFrom.y)/m_nStepCount;
	m_fScaleStep=(MoveCardItem.fScaleEnd-MoveCardItem.fScaleStart)/m_nStepCount;
	switch( MoveCardItem.wViewChairId )
	{
	case 0:
		m_enMoveDirection = Direction_North;
		break;
	case 1:
		m_enMoveDirection = Direction_South;
		break;
	}

//	SetStoped(m_nMoveCardID,false);
	m_bMoveCardID=true;
}

void TL_GBaseContainer::OnActionFinish()
{
	if(m_ActionFinish)
	{
		m_ActionFinish();
	}
}
//
void TL_GBaseContainer::EnableAnimate( bool bAnimate )
{
	m_bEnableAnimate = bAnimate;

	if( !m_bEnableAnimate && m_bCardMoving )
		StopMoveCard();
}

//,ͶϢ
bool TL_GBaseContainer::StopMoveCard()
{
	//ж
	if( !m_bCardMoving ) return false;

//	SetStoped( m_nMoveCardID,true );

	m_bMoveCardID=false;

	m_bCardMoving = false;

	//Ϣ
	OnActionFinish();

	return true;
}
//״̬־
void TL_GBaseContainer::SetStatusFlag(bool bOutCard, bool bWaitOther)
{
	//ñ
	m_bOutCard=bOutCard;
	m_bWaitOther=bWaitOther;

	return;
}
//Ϣ
void TL_GBaseContainer::SetUserAction(WORD wViewChairID, DWORD bUserAction,WORD wProvideUser,bool bZiMo)
{
	//ñ
	if (wViewChairID<GAME_PLAYER)
	{
		if(bUserAction==WIK_REPLACE)
			return ;
		m_cbUserAction[wViewChairID]=bUserAction;
		if(bUserAction==WIK_CHI_HU)
		{
			m_bGameChiHu=true;
		}
		m_bZiMo=bZiMo;
		if(bUserAction==WIK_LISTEN)
		{
			m_cbTingIndex[wViewChairID]=0;
			m_bShowTing[wViewChairID]=true;
			m_bTingCard[wViewChairID]=true;
			if(wViewChairID==1)
			{
				TL_SoundManager::Instance().StopSound("CommonBGM1");
				//SetStoped(m_nBGM1ID,true);
				TL_SoundManager::Instance().StopSound("CommonBGM2");
				//SetStoped(m_nBGM2ID,true);
				TL_SoundManager::Instance().StopSound("CommonBGM3");
				//SetStoped(m_nBGM3ID,true);
				if(m_bBackSound)
					TL_SoundManager::Instance().PlaySound("CommonBGMT");
			}
		}
		else if(bUserAction==WIK_CHI_HU&&!bZiMo)
		{
			m_ActionChiHu.ShowAnimate();
		}
		else
		{
			m_ActionBack.ShowAnimate();
		}
		SetStoped(m_nActionBackID,false);
	}
	else 
	{
		ZeroMemory(m_cbUserAction,sizeof(m_cbUserAction));
	}

	return;
}

void TL_GBaseContainer::SetHuaCount(WORD wChairID,BYTE cbCardCount)
{
	m_cbHuaCardCount[wChairID]=cbCardCount;
}
BYTE TL_GBaseContainer::GetHuaCount(WORD wChairID)
{
	return m_cbHuaCardCount[wChairID];
}
void TL_GBaseContainer::ShowScore()
{
	SetStoped(m_nUpDataID,false);
	m_pEndPlay->SetAllShow();
}
void TL_GBaseContainer::ResetDarw()
{
	//m_nDiscID=SetTimer(250,true);
	//SetStoped(m_nDiscID,true);
	m_nCutCardID=SetTimer(15,true);
	SetStoped(m_nCutCardID,true);
	m_nUpDataID=SetTimer(3000,true);
	//SetStoped(m_nUpDataID,true);
	m_nTingID[0]=SetTimer(1500,true);
	SetStoped(m_nTingID[0],true);
	m_nTingID[1]=SetTimer(1600,true);
	SetStoped(m_nTingID[1],true);
	m_nChiHuID=SetTimer(125,true);
	SetStoped(m_nChiHuID,true);
	m_nZiMoID=SetTimer(100,true);
	SetStoped(m_nZiMoID,true);
}
//Ϣ
void TL_GBaseContainer::SetOutCardInfo(WORD wViewChairID, BYTE cbCardData)
{
	//ñ
	m_cbCardData=cbCardData;
	m_wOutCardUser=wViewChairID;

	return;
}
void TL_GBaseContainer::SetTingInfo(CWHArray<tagTingInfo> &tCard)
{
	m_ArrayTingCard.RemoveAll();
	m_ArrayTingCard.Copy(tCard);
	m_bDrawTingCard=true;
}
void TL_GBaseContainer::UpDataTingInfo(CWHArray<tagTingInfo> &tCard)
{
	m_ArrayTingCard.RemoveAll();
	m_ArrayTingCard.Copy(tCard);
}
void TL_GBaseContainer::ReleaseTingInfo()
{
	//m_ArrayTingCard.RemoveAll();
	m_bDrawTingCard=false;
}
void TL_GBaseContainer::StopTing(WORD wChairID)
{
	m_bTingCard[wChairID]=false;
	m_bShowTing[wChairID]=false;
	m_cbTingIndex[wChairID]=0;
}
VOID TL_GBaseContainer::OnContinue(hgeItemBase *p)
{
	m_Continue();
	m_bGameEnd=false;
	m_bScoreShow=false;
	m_pGameScore->RestorationData();
}
void TL_GBaseContainer::SetUpScore(LONGLONG lUpScore)
{
	m_lUpScore=lUpScore;
}
void TL_GBaseContainer::SetFanShu(WORD wChairID,DWORD dwFanShu)
{
	m_dwFanShu[wChairID]=dwFanShu;
}
void TL_GBaseContainer::SetUserFanShu()
{
	if(m_dwFanShu[1]>0)
		m_dwMyFanShu=m_dwFanShu[1];
	if(m_dwFanShu[0]>0)
		m_dwOtherFanShu=m_dwFanShu[0];
}
void TL_GBaseContainer::ShowRedAnimate(WORD wChairID)
{
	if(wChairID==1)
	{
		m_MyRedFlash.ShowAnimate();
	}
	else
	{
		m_OtherRedFlash.ShowAnimate();
	}
}
void TL_GBaseContainer::SetFanCount(DWORD dwFanCount,bool bShowRedouble)
{
	m_dwFanCount=dwFanCount;
	m_bShowRedouble=bShowRedouble;
	m_btRedouble.SetShow(bShowRedouble);
}
VOID TL_GBaseContainer::OnEsc(hgeItemBase *p)
{
	m_Esc();
	//m_bGameEnd=false;
	//m_bScoreShow=false;
	//m_pGameScore->RestorationData();
}
VOID TL_GBaseContainer::OnStartTrustee(int n)
{
	if(n==100)
		m_Trustee();
}
VOID TL_GBaseContainer::OnStopTrustee(int n)
{
	if(n==110)
		m_Trustee();
}
VOID TL_GBaseContainer::OnRedouble(int n)
{
	m_Redouble(n);
}
VOID TL_GBaseContainer::OnChiHuCue(int n)
{
	m_bDrawTingCard=!m_bDrawTingCard;
}
VOID TL_GBaseContainer::OnOkButton(hgeItemBase *p)
{
	EnableAnimate(m_pGameOption->m_bEanbleAnimate);
	m_bPlaySound=m_pGameOption->m_bEnableSound;
	bool bTemp=m_bBackSound;
	m_bBackSound=m_pGameOption->m_bBackSound;
	m_pGameScore->SetPlaySound(m_bPlaySound);
	if(!m_bBackSound)
	{
		TL_SoundManager::Instance().StopSound("CommonBGM1");
//		SetStoped(m_nBGM1ID,true);
		TL_SoundManager::Instance().StopSound("CommonBGM2");
//		SetStoped(m_nBGM2ID,true);
		TL_SoundManager::Instance().StopSound("CommonBGM3");
//		SetStoped(m_nBGM3ID,true);
		TL_SoundManager::Instance().StopSound("CommonBGMT");
	}
	else if(!bTemp)
	{
		if(m_bGameStart)
		{
			srand( (unsigned)time( NULL ) );
			PlayBGMusic(rand()%3);
		}
	}
	
	//g_pGWindow->IsAllowLookon(0,m_pGameOption->m_bAllowLookon);
	m_bShowOption=false;
}
VOID TL_GBaseContainer::OnCancelButton(hgeItemBase *p)
{
	m_pGameOption->m_bEanbleAnimate=m_bEnableAnimate;
	m_pGameOption->m_bEnableSound=m_bPlaySound;
	m_pGameOption->m_bChechBox[0]=m_bPlaySound;
	m_pGameScore->SetPlaySound(m_bPlaySound);
	m_pGameOption->m_bBackSound=m_bBackSound;
	m_pGameOption->m_bChechBox[3]=m_bBackSound;
	m_pGameOption->m_bChechBox[2]=m_bEnableAnimate;
	m_bShowOption=false;
}
void TL_GBaseContainer::OnBtnPressed(hgeItemBase *pItemBase)
{
	if ( pItemBase == m_pframebtnEmotion)
	{
		g_pGWindow->OnFrameBtnPressed(FBI_EMOTION,0,0);
	}
	else if ( pItemBase == m_pframebtnBugle)
	{
		g_pGWindow->OnFrameBtnPressed(FBI_BUGLE,0,0);
	}
}