#pragma once

#include <math.h>

//////////////////////////////////////////////////////////////////////////
// 
class CGameClientView;
//////////////////////////////////////////////////////////////////////////
// ͼƬ
class CHgeImage
{
public:
	CHgeImage(void);
	virtual ~CHgeImage(void);

	// ڲ
private:
	HGE*								m_pHge;
	hgeSprite*							m_pImage;
	std::string							m_StrFile;

	// ͼƬ
private:
	float								m_fWidth;
	float								m_fHeight;
	float								m_fItemWidth;
	float								m_fItemHeight;

	// 
public:
	// ȡ
	float GetWidth(void) { return m_fWidth; }
	// ȡ
	float GetHeight(void) { return m_fHeight; }
	// ȡ
	float GetItemWidth(void) { return m_fItemWidth; }
	// ȡ
	float GetItemHeight(void) { return m_fItemHeight; }

	// ܺ
public:
	// װͼƬ
	bool LoadImage(const char *filename,bool bFile=true,int nxNum = 1, int nyNum = 1, DWORD size = 0, bool bMipmap = false);
	// жͼƬ
	void DestroyImage(void);
	//滻ͼƬ
	bool SetImage(const char *filename,bool bFile=true);
	// ͼƬ
	void DrawImage(float x, float y);
	// ͼƬ
	void DrawImage(float x, float y, float rot, float hscale = 1.0f, float vscale = 0.0f);
	//ͼƬ
	void DrawImage(float x, float y,float nDestWidth, float nDestHeight, float nXScr, float nYSrc);
	//ͼƬ
	void DrawImage(float x, float y, float rot,float nDestWidth, float nDestHeight, float nXScr, float nYSrc,float hscale=1.0f,float vscale=0.0f);
};
class CHgeButton
{
public:
	CHgeButton(void);
	virtual ~CHgeButton(void);

	// ڲ
private:
	HGE*								m_pHge;
	hgeSprite*							m_pImage;
	std::string								m_StrFile;
	bool								m_bShow;
	DWORD								m_dwMessage;
	bool								m_bState;
private:
	float								m_fWidth;
	float								m_fHeight;
	BYTE								m_cbButtonIndex;
	CRect								m_rcRect;
	CPoint								m_ptPoint;
public:
	FEvent_PInt							m_ButtonMessage;
	
public:
	// װͼƬ
	bool LoadButtonImage(const char *filename,DWORD Message);
	// жͼƬ
	void DestroyImage(void);
	//滻ͼƬ
	bool SetImage(const char *filename);
	//滻Ϣ
	void SetMessage(DWORD Message);
	//ťλ
	void SetPoint(CPoint point);
	//ʾť
	void SetShow(bool bShow);
	//ȡʾ
	bool GetShow(){return m_bShow;}
	//״̬
	void SetState(bool bState);
	//ȡ״̬
	bool GetState(){return m_bState;}
	//滭ť
	void DrawButton();
	//
	bool OnLButtonDown(UINT nFlags, CPoint Point);
	//
	bool OnLButtonUp(UINT nFlags, CPoint Point);
	//ƶ
	bool OnMouseMove(UINT nFlags, CPoint Point);
};
class CHgeButtonEx
{
public:
	CHgeButtonEx(void);
	virtual ~CHgeButtonEx(void);

	// ڲ
private:
	HGE*								m_pHge;
	hgeSprite*							m_pImage;
	HTEXTURE							m_Tex;
	std::string								m_StrFile;
	bool								m_bShow;
	DWORD								m_dwMessage;
	bool								m_bState;
private:
	float								m_fWidth;
	float								m_fHeight;
	BYTE								m_cbButtonIndex;
	CRect								m_rcRect;
	CPoint								m_ptPoint;
public:
	FEvent_PInt							m_ButtonMessage;

public:
	// װͼƬ
	bool LoadButtonImage(const char *filename,DWORD Message);
	// жͼƬ
	void DestroyImage(void);
	//滻Ϣ
	void SetMessage(DWORD Message);
	//ťλ
	void SetPoint(CPoint point);
	//ʾť
	void SetShow(bool bShow);
	//״̬
	void SetState(bool bState);
	//滭ť
	void DrawButton();
	//ײ
	bool IsCollided(CRect rcRect,CPoint Point);
	//
	bool OnLButtonDown(UINT nFlags, CPoint Point);
	//
	bool OnLButtonUp(UINT nFlags, CPoint Point);
	//ƶ
	bool OnMouseMove(UINT nFlags, CPoint Point);
};
//////////////////////////////////////////////////////////////////////////