#ifndef SICE_HEAD_FILE
#define SICE_HEAD_FILE
#pragma once

#include "Stdafx.h"
#include "Resource.h"
#include "DrawAnimate.h"

class CSiceContainer :
	public hgeItemContainer
{
private:
	MySprite		*m_pSiceOne;
	MySprite		*m_pSiceTwo;
	CDrawAnimate	*m_pSiceFrame;
protected:
	hgePoint		m_hSicePoint;
private:
	BYTE			m_cbSiceFirst;
	BYTE			m_cbSiceSecond;
	bool			m_bDrawSice;
	BYTE			m_cbDraw;
public:
	FEvent_Void       EventTest;
public:
	CSiceContainer(const tstring& strName);
public:
	~CSiceContainer(void);
public:
	void Init();
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	void Update(DWORD dwDelTick);
	void SetSicePoint(hgePoint hPoint);
	void SetSiceInfo(WORD wSice);
	void StopRender();
	void FrameStop();
};
#endif
