#include "StdAfx.h"
#include "Tableframesink.h"
#include "GameServerManager.h"
#include "AndroidUserItemSink.h"
//////////////////////////////////////////////////////////////////////////
//캯
CGameServiceManager::CGameServiceManager()
{
	m_GameServiceAttrib.wKindID = KIND_ID;
	m_GameServiceAttrib.wChairCount = GAME_PLAYER;
	m_GameServiceAttrib.wSupporType = GAME_GENRE_GOLD | GAME_GENRE_EDUCATE;
	m_GameServiceAttrib.cbDynamicJoin = FALSE;
	m_GameServiceAttrib.cbAndroidUser = TRUE;
	m_GameServiceAttrib.cbOffLineTrustee = FALSE;
	m_GameServiceAttrib.dwServerVersion = VERSION_SERVER;
	m_GameServiceAttrib.dwClientVersion = VERSION_CLIENT;
	lstrcpyn(m_GameServiceAttrib.szGameName, GAME_NAME, CountArray(m_GameServiceAttrib.szGameName));
	lstrcpyn(m_GameServiceAttrib.szDataBaseName, szTreasureDB, CountArray(m_GameServiceAttrib.szDataBaseName));


	lstrcpyn(m_GameServiceAttrib.szClientEXEName,TEXT("NewSparrowTwoPeople.exe"),CountArray(m_GameServiceAttrib.szClientEXEName));
	lstrcpyn(m_GameServiceAttrib.szServerDLLName,TEXT("SparrowTwoPeopleServer.DLL"),CountArray(m_GameServiceAttrib.szServerDLLName));
	return;
}

//
CGameServiceManager::~CGameServiceManager()
{
}

//ӿڲѯ
void *  CGameServiceManager::QueryInterface(const IID & Guid, DWORD dwQueryVer)
{
	QUERYINTERFACE(IGameServiceManager,Guid,dwQueryVer);
	QUERYINTERFACE_IUNKNOWNEX(IGameServiceManager,Guid,dwQueryVer);
	return NULL;
}

//Ϸ
void *  CGameServiceManager::CreateTableFrameSink(const IID & Guid, DWORD dwQueryVer)
{
	//
	CTableFrameSink * pTableFrameSink=NULL;
	try
	{
		pTableFrameSink=new CTableFrameSink();
		if (pTableFrameSink==NULL)
			throw TEXT("ʧ");
		void * pObject=pTableFrameSink->QueryInterface(Guid,dwQueryVer);
		if (pObject==NULL) 
			throw TEXT("ӿڲѯʧ");
		return pObject;
	}
	catch (...) {}

	//
	SafeDelete(pTableFrameSink);

	return NULL;
}

//
VOID *  CGameServiceManager::CreateAndroidUserItemSink(REFGUID Guid, DWORD dwQueryVer)
{
	//
	CAndroidUserItemSink * pAndroidUserItemSink=NULL;

	try
	{
		//
		pAndroidUserItemSink=new CAndroidUserItemSink();
		if (pAndroidUserItemSink==NULL) throw TEXT("ʧ");

		//ѯӿ
		void * pObject=pAndroidUserItemSink->QueryInterface(Guid,dwQueryVer);
		if (pObject==NULL) throw TEXT("ӿڲѯʧ");

		return pObject;
	}
	catch (...) {}

	//ɾ
	SafeDelete(pAndroidUserItemSink);

	return NULL;
}

//ȡ
bool  CGameServiceManager::GetServiceAttrib(tagGameServiceAttrib & GameServiceAttrib)
{
	GameServiceAttrib=m_GameServiceAttrib;
	return true;
}

//޸
bool  CGameServiceManager::RectifyParameter(tagGameServiceOption & pGameServiceOption)
{
	//Ч
	ASSERT(&pGameServiceOption!=NULL);
	if (&pGameServiceOption==NULL) return false;

	//Ԫ
	pGameServiceOption.lCellScore=__max(1L,pGameServiceOption.lCellScore);

	//
	if (pGameServiceOption.wServerType==GAME_GENRE_GOLD)
	{
		pGameServiceOption.lMinTableScore=__max(pGameServiceOption.lCellScore*32L,pGameServiceOption.lMinTableScore);
	}

	//(ԭĻ)
	if (pGameServiceOption.lRestrictScore!=0L)
	{
		pGameServiceOption.lRestrictScore=__max(pGameServiceOption.lRestrictScore,pGameServiceOption.lMinTableScore);
	}

	//
	if (pGameServiceOption.lRestrictScore!=0L)
	{
		pGameServiceOption.lRestrictScore=__max(pGameServiceOption.lRestrictScore,pGameServiceOption.lMinTableScore);
	}
	return true;
}
//
VOID * CGameServiceManager::CreateGameDataBaseEngineSink(REFGUID Guid, DWORD dwQueryVer)
{
	return NULL;
}



//////////////////////////////////////////////////////////////////////////

//
extern "C" __declspec(dllexport) void *  CreateGameServiceManager(const GUID & Guid, DWORD dwInterfaceVer)
{
	static CGameServiceManager GameServiceManager;
	return GameServiceManager.QueryInterface(Guid,dwInterfaceVer);
}

//////////////////////////////////////////////////////////////////////////
