#ifndef TABLE_FRAME_SINK_HEAD_FILE
#define TABLE_FRAME_SINK_HEAD_FILE

#pragma once

#include "Stdafx.h"
#include "GameLogic.h"
#include <fstream>
using namespace std;

//////////////////////////////////////////////////////////////////////////
//öٶ

//Ч
enum enEstimatKind
{
	EstimatKind_OutCard,			//Ч
	EstimatKind_GangCard,			//Ч
	EstimatKind_LaoCard,
};

struct tagHeapCardInfo
{
	WORD			wStartIndex;
	WORD			wRemoveCount;
};
struct tagTingInfo
{
	BYTE			cbCardData;
	DWORD			cbFan;
	BYTE			cbCardCount;
};
//////////////////////////////////////////////////////////////////////////

//Ϸ
class CTableFrameSink : public ITableFrameSink, public ITableUserAction
{
	enum GameState{ 
		gs_Free,	//Ϸûʼ
		gs_Playing, //Ϸʱ
		gs_WaitContinue,//мȴ
	} ;
	GameState m_GameState;
	//Ϸ
protected:
	LONG							m_lSiceCount;							//ӵ
	WORD							m_wBankerUser;							//ׯû
	WORD							m_wChengBaoChairID;						//аID
	LONGLONG						m_lGameScore[GAME_PLAYER];				//Ϸ÷
	BYTE							m_cbCardIndex[GAME_PLAYER][MAX_INDEX];	//û˿
	bool							m_bTrustee[GAME_PLAYER];				//Ƿй
	BYTE							m_cbListenStatus[GAME_PLAYER];			//״̬
	LONGLONG						m_lCellScore;
	BYTE							m_cbPlayerSitDown;
	bool							m_bSitDown[GAME_PLAYER];
	bool							m_bPlaySet;
	WORD							m_wSetCellChairID;
	bool							m_bSetCell;
	BYTE							m_cbPaiMianCard;
	BYTE							m_cbLaoYueCount;
	bool							m_bHaiDiTrue;
	bool							m_bKan[GAME_PLAYER];
protected:
	bool							m_bHearStatus[GAME_PLAYER];				//
	bool							m_bWillHearStatus[GAME_PLAYER];			//
	WORD							m_wHearUser;
protected:
	BYTE							m_cbHuaCardCount[GAME_PLAYER];			//Ƹ	ע⣺˱ǲĸǲûͳƽ
	BYTE							m_cbHuaCardData[GAME_PLAYER][8];		//һ  һģʵʱ,ڶʾ
	BYTE							m_cbHuaCardInfo[GAME_PLAYER][8];		//Ϣ  ˱ĻϢԼ㻨͵Ϣ
	WORD							m_wReplaceUser;							//û
	//Ϣ
protected:
	WORD							m_wOutCardUser;							//û
	WORD							m_wMyChairID;							//ԼID
	BYTE							m_cbOutCardData;						//˿
	BYTE							m_cbTempOutData[GAME_PLAYER];
	BYTE							m_cbOutCardCount;						//Ŀ
	BYTE							m_cbDiscardCount[GAME_PLAYER];			//Ŀ
	BYTE							m_cbDiscardCard[GAME_PLAYER][60];		//¼

	//Ϣ
protected: 
	BYTE							m_cbSendCardData;						//˿
	BYTE							m_cbSendCardCount;						//Ŀ
	BYTE							m_cbLeftCardCount;						//ʣĿ
	BYTE							m_cbRepertoryCard[MAX_REPERTORY];		//˿
	BYTE							m_cbEndLeftCount;						//ׯ
	bool                            m_bDelete;
protected:
	CWHArray<tagTingInfo>			m_ArrayTingCard[GAME_PLAYER];

	//
protected:
	WORD							m_wHeapHead;							//ͷ
	WORD							m_wHeapTail;							//β
	//BYTE							m_cbHeapCardInfo[GAME_PLAYER][2];		//Ϣ				
	tagHeapCardInfo					m_HeapCardInfo[GAME_PLAYER];

	//б
protected:
	WORD							m_wResumeUser;							//ԭû
	WORD							m_wCurrentUser;							//ǰû
	WORD							m_wProvideUser;							//Ӧû
	BYTE							m_cbProvideCard;						//Ӧ˿
	BYTE							m_cbGangOutCard;						//ܺ
	bool							m_bShow;

	//״̬
protected:
	bool							m_bSendStatus;							//״̬
	bool							m_bOutCardData;
	bool							m_bGangStatus;							//״̬
	bool							m_bQiangGang;
	bool							m_bEnjoinChiPeng[GAME_PLAYER];			//ֹ
	bool							m_bEnjoinPeng[GAME_PLAYER];
	BYTE							m_cbPengCard[GAME_PLAYER];
	WORD							m_wHaveGoodCardAndroidUser;
	BYTE							m_cbGoodCardIndex;
protected:
	bool							m_bEndGameStatus;
	bool							m_bDuiHuaStatus;
	bool							m_bHaiDiStatus;
	WORD							m_wEndChairID;
	BYTE							m_cbGameStartOver;
	BYTE							m_cbEndPlayData[10];
	BYTE							m_cbShowCardData[10];

	//û״̬
public:
	bool							m_bResponse[GAME_PLAYER];				//Ӧ־
	DWORD							m_cbUserAction[GAME_PLAYER];			//û
	BYTE							m_cbOperateCard[GAME_PLAYER][3];		//˿
	DWORD							m_cbPerformAction[GAME_PLAYER];			//ִж
	BYTE                            m_cbMingGangCount[GAME_PLAYER];         //ܸ
	BYTE                            m_cbAnGangCount[GAME_PLAYER];           //ܸ
	DWORD							m_dwFanShu[GAME_PLAYER];
	DWORD							m_dwRedoubleCount[GAME_PLAYER];

	//˿
protected:
	BYTE							m_cbWeaveItemCount[GAME_PLAYER];			//Ŀ
	tagWeaveItem					m_WeaveItemArray[GAME_PLAYER][MAX_WEAVE];	//˿

	//Ϣ
protected:
	BYTE							m_cbChiHuCard;							//Ժ˿
	DWORD							m_dwChiHuKind[GAME_PLAYER];				//Ժ
	CChiHuRight						m_ChiHuRight[GAME_PLAYER];				//ԺȨλ
	CChiHuRight						m_ChiHuHigh[GAME_PLAYER];
	CChiHuRight						m_ChiHuNew[GAME_PLAYER];
	bool							m_bManGuan;

	//
protected:
	CGameLogic						m_GameLogic;							//Ϸ߼
	ITableFrame						* m_pITableFrame;						//ܽӿ
	const tagGameServiceOption		* m_pGameServiceOption;					//ò

	//Ա
protected:
	static const WORD				m_wPlayerCount;							//Ϸ
	static const BYTE				m_GameStartMode;						//ʼģʽ

	//
public:
	//캯
	CTableFrameSink();
	//
	virtual ~CTableFrameSink();

	//ӿ
public:
	//ͷŶ
	virtual VOID  Release() { }
	//ӿڲѯ
	virtual void *  QueryInterface(const IID & Guid, DWORD dwQueryVer);

	//ӿ
public:
	//ʼ
	virtual bool Initialization(IUnknownEx * pIUnknownEx);
	//λ
	virtual void RepositionSink();

	//Ϣӿ
public:
	//ʼģʽ
	virtual BYTE GetGameStartMode();
	//Ϸ״̬
	virtual bool IsUserPlaying(WORD wChairID);

	//Ϸ¼
public:
	//Ϸʼ
	virtual bool  OnEventGameStart();
	//Ϸ
	virtual bool  OnEventGameConclude(WORD wChairID, IServerUserItem * pIServerUserItem, BYTE cbReason);
	//ͳ
	virtual bool  OnEventSendGameScene(WORD wChiarID, IServerUserItem * pIServerUserItem, BYTE cbGameStatus, bool bSendSecret);

	//¼ӿ
public:
	//ʱ¼
	virtual bool OnTimerMessage(DWORD wTimerID, WPARAM wBindParam);
	//¼
	virtual bool OnGameDataBase(WORD wRequestID, VOID * pData, WORD wDataSize);
	//ϷϢ
	virtual bool OnGameMessage(WORD wSubCmdID, VOID * pData, WORD wDataSize, IServerUserItem * pIServerUserItem);
	//Ϣ
	virtual bool OnFrameMessage(WORD wSubCmdID, VOID * pData, WORD wDataSize, IServerUserItem * pIServerUserItem);

	//û¼
public:
	//û
	virtual bool OnActionUserOffLine(WORD wChairID,IServerUserItem * pIServerUserItem) { return true; }
	//û
	virtual bool OnActionUserConnect(WORD wChairID,IServerUserItem * pIServerUserItem) { return true; }
	//û
	virtual bool OnActionUserSitDown(WORD wChairID,IServerUserItem * pIServerUserItem, bool bLookonUser);
	//û
	virtual bool OnActionUserStandUp(WORD wChairID,IServerUserItem * pIServerUserItem, bool bLookonUser);
	//ûͬ
	virtual bool OnActionUserOnReady(WORD wChairID,IServerUserItem * pIServerUserItem, void * pData, WORD wDataSize) { return true; }

	//ѯӿ
public:
	//ѯ޶
	virtual SCORE QueryConsumeQuota(IServerUserItem * pIServerUserItem){return 0;}
	//ٻ
	virtual SCORE QueryLessEnterScore(WORD wChairID, IServerUserItem * pIServerUserItem){return 0;}
	//¼
	virtual bool OnDataBaseMessage(WORD wRequestID, VOID * pData, WORD wDataSize){return false;}
	//¼
	virtual bool OnUserScroeNotify(WORD wChairID, IServerUserItem * pIServerUserItem, BYTE cbReason){return false;}
	//ѯǷ۷
	virtual bool QueryBuckleServiceCharge(WORD wChairID){return true;}
	//ӿ
public:
	//û
	virtual void SetGameBaseScore(LONG lBaseScore){}



	//Ϸ¼
protected:
	//û
	bool OnUserListenCard(WORD wChairID);
	//
	bool OnUserListenSet(WORD wChairID,bool bListen);
	//û
	bool OnUserOutCard(WORD wChairID, BYTE cbCardData);
	//û
	bool OnUserOperateCard(WORD wChairID, DWORD cbOperateCode, BYTE cbOperateCard[3]);
	bool OnSetCellScore(WORD wChairID,LONGLONG lCellScore);
	//û
	bool OnUserReplaceCard(WORD wChairID, BYTE cbCardData);
	bool OnUserRedouble(WORD wChairID, DWORD dwRedouble);
	bool OnUserShowThink(WORD wChairID,bool bShowThink);
	bool OnUserStartOver();
	//Ϸ
	bool OnGameEndPlay(bool bLiuJu);
	//Իѡ
	bool OnUserDuiHuaCard(WORD wChairID,BYTE cbCardData);
	//ȡԻ
	void GetDuiHuaCard(WORD wChairID,BYTE cbCardData[10]);
	//ȡ
	void GetHaiDiCard(WORD wChairID,BYTE cbCardData[10]);
	//ѡ
	bool OnUserHaiDiCard(WORD wChairID,BYTE cbCardData);
	//׼
	bool OnHaiDiContinue();

	//
protected:
	//Ͳ
	bool SendOperateNotify(bool bShow);
	//ɷ˿
	bool DispatchCardData(WORD wCurrentUser,bool bTail=false,bool bReplace=false);
	//Ӧж
	bool EstimateUserRespond(WORD wCenterUser, BYTE cbCenterCard, enEstimatKind EstimatKind,bool bShow);
	//
	BYTE CalScore( WORD wWinner, LONGLONG lScore[GAME_PLAYER] );
	//ϵͳƻȡ
	BYTE GetMagicIndex( BYTE cbFanCard );
	//ȡ
	BYTE GetDiscardCount( BYTE cbCardData );
	//ȡʣ
	BYTE GetResidualCount(BYTE cbTingCard);
	//Ϣ
	void UpdataTingInfo(WORD wChairID,BYTE cbProvideCard);
	//޸
	DWORD GetFanShu(WORD wChairID,BYTE cbCardData,BYTE cbType,bool bRedouble=false);
	DWORD GetFanShu(WORD wChairID,BYTE cbCardIndex[MAX_INDEX],BYTE cbCardData);
	//Ȩλ
	void FiltrateRight( WORD wWinner, CChiHuRight &chr ,CChiHuRight &chrhigh,CChiHuRight &chrnew);
	//Ȩλ
	void FiltrateRight( WORD wWinner, CChiHuRight &chr ,CChiHuRight &chrhigh,CChiHuRight &chrnew,bool bChiHu);
};

//////////////////////////////////////////////////////////////////////////

#endif
